/* this file is autogenerated, do not edit directly */
/*
Kalles Fraktaler 2
Copyright (C) 2013-2017 Karl Runmo
Copyright (C) 2017-2019 Claude Heiland-Allen

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <windows.h>
#include <stdint.h>
#include "../fraktal_sft/floatexp.h"
#include "formula.h"

template <typename T> T sgn(const T &a)
{
  return (a > 0) - (a < 0);
}

#if 0

static inline double d_add(const double a, const double b)
{
  return a + b;
}

static inline double d_addi(const double a, const int b)
{
  return a + b;
}

static inline double d_sub(const double a, const double b)
{
  return a - b;
}

static inline double d_isub(const int a, const double b)
{
  return a - b;
}

static inline double d_neg(const double a)
{
  return -a;
}

static inline double d_abs(const double a)
{
  return a < 0.0 ? -a : a;
}

static inline double d_sgn(const double a)
{
  return (a > 0.0) - (a < 0.0);
}

static inline double d_imul(const int a, const double b)
{
  return a * b;
}

static inline double d_muli(const double a, const int b)
{
  return a * b;
}

static inline double d_mul(const double a, const double b)
{
  return a * b;
}

static inline double d_pow(const double a, const int b)
{
  double r = 1.0;
  for (int i = 0; i < b; ++i)
  {
    r *= a;
  }
  return r;
}

static inline int d_cmp(const double a, const double b)
{
  return ((int)(a > b)) - ((int)(a < b));
}

static inline double d_diffabs(const double c, const double d)
{
  double cd = c + d;
  if (c >= 0.0)
  {
    if (cd >= 0.0)
    {
      return d;
    }
    else
    {
      return -d - 2.0 * c;
    }
  }
  else
  {
    if (cd > 0.0)
    {
      return d + 2.0 * c;
    }
    else
    {
      return -d;
    }
  }
}

static inline long double ld_add(const long double a, const long double b)
{
  return a + b;
}

static inline long double ld_addi(const long double a, const int b)
{
  return a + b;
}

static inline long double ld_sub(const long double a, const long double b)
{
  return a - b;
}

static inline long double ld_isub(const int a, const long double b)
{
  return a - b;
}

static inline long double ld_neg(const long double a)
{
  return -a;
}

static inline long double ld_abs(const long double a)
{
  return a < 0.0 ? -a : a;
}

static inline long double ld_sgn(const long double a)
{
  return (a > 0.0) - (a < 0.0);
}

static inline long double ld_imul(const int a, const long double b)
{
  return a * b;
}

static inline long double ld_muli(const long double a, const int b)
{
  return a * b;
}

static inline long double ld_mul(const long double a, const long double b)
{
  return a * b;
}

static inline long double ld_pow(const long double a, const int b)
{
  long double r = 1.0;
  for (int i = 0; i < b; ++i)
  {
    r *= a;
  }
  return r;
}

static inline int ld_cmp(const long double a, const long double b)
{
  return ((int)(a > b)) - ((int)(a < b));
}

static inline long double ld_diffabs(const long double c, const long double d)
{
  long double cd = c + d;
  if (c >= 0.0L)
  {
    if (cd >= 0.0L)
    {
      return d;
    }
    else
    {
      return - d - 2.0L * c;
    }
  }
  else
  {
    if (cd > 0.0L)
    {
      return d + 2.0L * c;
    }
    else
    {
      return -d;
    }
  }
}

static inline int64_t as_long(double d)
{
  union {
    double d;
    int64_t i;
  } u;
  u.d = d;
  return u.i;
}

static inline double as_double(int64_t i)
{
  union {
    double d;
    int64_t i;
  } u;
  u.i = i;
  return u.d;
}

static inline double fe_double(floatexp f)
{
  if (f.exp < -1020)
  {
    return 0.0;
  }
  if (f.exp > 1020)
  {
    return f.val / 0.0;
  }
  return as_double((as_long(f.val) & 0x800FFFFFFFFFFFFFLL) | ((f.exp + 1023) << 52));
}

static inline floatexp fe_floatexp(const double val, const int64_t exp)
{
  int64_t f_exp = ((as_long(val) & 0x7FF0000000000000LL) >> 52) - 1023;
  double f_val = as_double((as_long(val) & 0x800FFFFFFFFFFFFFLL) | 0x3FF0000000000000LL);
  floatexp fe(f_val, f_exp + exp, 0);
  return fe;
}

static inline floatexp fe_abs(const floatexp f)
{
  floatexp fe(d_abs(f.val), f.exp, 0);
  return fe;
}

static inline floatexp fe_sgn(const floatexp a)
{
  return floatexp((a.val > 0.0) - (a.val < 0.0));
}

static inline floatexp fe_neg(const floatexp f)
{
  floatexp fe(-f.val, f.exp, 0);
  return fe;
}

static inline floatexp fe_muli(const floatexp a, const int b)
{
  return fe_floatexp(a.val * b, a.exp);
}

static inline floatexp fe_imul(const int a, const floatexp b)
{
  return fe_floatexp(a * b.val, b.exp);
}

static inline floatexp fe_mul(const floatexp a, const floatexp b)
{
  return fe_floatexp(a.val * b.val, a.exp + b.exp);
}

static inline floatexp fe_mul_2si(const floatexp a, const int64_t b)
{
  floatexp fe(a.val, a.exp + b, 0);
  return fe;
}

static inline floatexp fe_div(const floatexp a, const floatexp b)
{
  return fe_floatexp(a.val / b.val, a.exp - b.exp);
}

static inline floatexp fe_div_2si(const floatexp a, const int64_t b)
{
  floatexp fe(a.val, a.exp - b, 0);
  return fe;
}

static inline floatexp fe_add(const floatexp a, const floatexp b)
{
  if (a.exp > b.exp)
  {
    floatexp c(b.val, b.exp - a.exp, 0);
    return fe_floatexp(a.val + fe_double(c), a.exp);
  }
  else
  {
    floatexp c(a.val, a.exp - b.exp, 0);
    return fe_floatexp(fe_double(c) + b.val, b.exp);
  }
}

static inline floatexp fe_addi(const floatexp a, const int b)
{
  return fe_add(a, fe_floatexp(double(b), 0));
}

static inline floatexp fe_sub(const floatexp a, const floatexp b)
{
  return fe_add(a, fe_neg(b));
}

static inline floatexp fe_isub(const int a, const floatexp b)
{
  return fe_addi(fe_neg(b), a);
}

static inline int fe_cmp(const floatexp a, const floatexp b)
{
  if (a.val > 0)
  {
    if (b.val <= 0)
    {
      return 1;
    }
    else if (a.exp > b.exp)
    {
      return 1;
    }
    else if (a.exp < b.exp)
    {
      return -1;
    }
    else
    {
      return d_cmp(a.val, b.val);
    }
  }
  else
  {
    if (b.val > 0)
    {
      return -1;
    }
    else if (a.exp > b.exp)
    {
      return -1;
    }
    else if (a.exp < b.exp)
    {
      return 1;
    }
    else
    {
      return d_cmp(a.val, b.val);
    }
  }
}

static inline floatexp fe_diffabs(const floatexp c, const floatexp d)
{
  floatexp cd = fe_add(c, d);
  if (c.val >= 0.0)
  {
    if (cd.val >= 0.0)
    {
      return d;
    }
    else
    {
      return fe_neg(fe_add(d, fe_mul_2si(c, 1)));
    }
  }
  else
  {
    if (cd.val > 0.0)
    {
      return fe_add(d, fe_mul_2si(c, 1));
    }
    else
    {
      return fe_neg(d);
    }
  }
}

static inline floatexp fe_pow(const floatexp a, int b)
{
  floatexp r = fe_floatexp(1.0, 0);
  for (int i = 0; i < b; ++i)
  {
    r = fe_mul(r, a);
  }
  return r;
}

typedef struct
{
  double re;
  double im;
} dcomplex;

static inline dcomplex dc_neg(const dcomplex a)
{
  dcomplex dc = { -a.re, -a.im };
  return dc;
}

static inline dcomplex dc_add(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re + b.re, a.im + b.im };
  return dc;
}

static inline dcomplex dc_addi(const dcomplex a, const int b)
{
  dcomplex dc = { a.re + b, a.im };
  return dc;
}

static inline dcomplex dc_sub(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re - b.re, a.im - b.im };
  return dc;
}

static inline dcomplex dc_isub(const int a, const dcomplex b)
{
  dcomplex dc = { a - b.re, - b.im };
  return dc;
}

static inline dcomplex dc_imul(const int a, const dcomplex b)
{
  dcomplex dc = { a * b.re, a * b.im };
  return dc;
}

static inline dcomplex dc_muli(const dcomplex a, const int b)
{
  dcomplex dc = { a.re * b, a.im * b };
  return dc;
}

static inline dcomplex dc_mul(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re * b.re - a.im * b.im, a.re * b.im + a.im * b.re };
  return dc;
}

static inline dcomplex dc_pow(const dcomplex a, const int b)
{
  dcomplex r = { 1.0, 0.0 };
  for (int i = 0; i < b; ++i)
  {
    r = dc_mul(r, a);
  }
  return r;
}

typedef struct
{
  long double re;
  long double im;
} ldcomplex;

static inline ldcomplex ldc_neg(const ldcomplex a)
{
  ldcomplex dc = { -a.re, -a.im };
  return dc;
}

static inline ldcomplex ldc_add(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re + b.re, a.im + b.im };
  return dc;
}

static inline ldcomplex ldc_addi(const ldcomplex a, const int b)
{
  ldcomplex ldc = { a.re + b, a.im };
  return ldc;
}

static inline ldcomplex ldc_sub(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re - b.re, a.im - b.im };
  return dc;
}

static inline ldcomplex ldc_isub(const int a, const ldcomplex b)
{
  ldcomplex dc = { a - b.re, - b.im };
  return dc;
}

static inline ldcomplex ldc_imul(const int a, const ldcomplex b)
{
  ldcomplex dc = { a * b.re, a * b.im };
  return dc;
}

static inline ldcomplex ldc_muli(const ldcomplex a, const int b)
{
  ldcomplex dc = { a.re * b, a.im * b };
  return dc;
}

static inline ldcomplex ldc_mul(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re * b.re - a.im * b.im, a.re * b.im + a.im * b.re };
  return dc;
}

static inline ldcomplex ldc_pow(const ldcomplex a, const int b)
{
  ldcomplex r = { 1.0, 0.0 };
  for (int i = 0; i < b; ++i)
  {
    r = ldc_mul(r, a);
  }
  return r;
}

typedef struct
{
  floatexp re;
  floatexp im;
} fecomplex;

static inline fecomplex fec_neg(const fecomplex a)
{
  fecomplex fec = { fe_neg(a.re), fe_neg(a.im) };
  return fec;
}

static inline fecomplex fec_add(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_add(a.re, b.re), fe_add(a.im, b.im) };
  return fec;
}

static inline fecomplex fec_addi(const fecomplex a, const int b)
{
  fecomplex fec = { fe_addi(a.re, b), a.im };
  return fec;
}

static inline fecomplex fec_sub(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_sub(a.re, b.re), fe_sub(a.im, b.im) };
  return fec;
}

static inline fecomplex fec_isub(const int a, const fecomplex b)
{
  fecomplex fec = { fe_isub(a, b.re), fe_neg(b.im) };
  return fec;
}

static inline fecomplex fec_imul(const int a, const fecomplex b)
{
  fecomplex fec = { fe_imul(a, b.re), fe_imul(a, b.im) };
  return fec;
}

static inline fecomplex fec_muli(const fecomplex a, const int b)
{
  fecomplex fec = { fe_muli(a.re, b), fe_muli(a.im, b) };
  return fec;
}

static inline fecomplex fec_mul(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_sub(fe_mul(a.re, b.re), fe_mul(a.im, b.im)), fe_add(fe_mul(a.re, b.im), fe_mul(a.im, b.re)) };
  return fec;
}

static inline fecomplex fec_pow(const fecomplex a, const int b)
{
  fecomplex r = { fe_floatexp(1.0, 0), fe_floatexp(0.0, 0) };
  for (int i = 0; i < b; ++i)
  {
    r = fec_mul(r, a);
  }
  return r;
}

static inline bool gezero(const double &x) { return x >= 0.0; }
static inline bool gtzero(const double &x) { return x >  0.0; }
static inline bool gezero(const long double &x) { return x >= 0.0; }
static inline bool gtzero(const long double &x) { return x >  0.0; }
static inline bool gezero(const floatexp &x) { return x.val >= 0.0; }
static inline bool gtzero(const floatexp &x) { return x.val >  0.0; }

static inline long double ConvertFromFixedFloat(const CFixedFloat &f)
{
  using std::ldexp;
  signed long int e = 0;
  long double l = mpfr_get_ld_2exp(&e, f.m_f.backend().data(), MPFR_RNDN);
  l = ldexp(l, e);
  return l;
}

#endif

static inline double mpfr_get(const mpfr_t x, const double &t, mpfr_rnd_t rnd)
{
  (void) t;
  return mpfr_get_d(x, rnd);
}

static inline long double mpfr_get(const mpfr_t x, const long double &t, mpfr_rnd_t rnd)
{
  (void) t;
  return mpfr_get_ld(x, rnd);
}

static inline floatexp mpfr_get(const mpfr_t x, const floatexp &t, mpfr_rnd_t rnd)
{
  (void) t;
  signed long int e = 0;
  double d = mpfr_get_d_2exp(&e, x, rnd);
  return floatexp(d, e);
}


static inline bool all(const int2 &i) {
  return (((i[0] && i[1])));
}

static inline bool any(const int2 &i) {
  return (((i[0] || i[1])));
}


static inline bool all(const int4 &i) {
  return (((i[0] && i[1]) && (i[2] && i[3])));
}

static inline bool any(const int4 &i) {
  return (((i[0] || i[1]) || (i[2] || i[3])));
}


static inline bool all(const int8 &i) {
  return (((i[0] && i[1]) && (i[2] && i[3])) &&
         ((i[4] && i[5]) && (i[6] && i[7])));
}

static inline bool any(const int8 &i) {
  return (((i[0] || i[1]) || (i[2] || i[3])) ||
         ((i[4] || i[5]) || (i[6] || i[7])));
}


static inline bool all(const int16 &i) {
  return (((i[0] && i[1]) && (i[2] && i[3])) &&
         ((i[4] && i[5]) && (i[6] && i[7]))) &&
         (((i[8] && i[9]) && (i[10] && i[11])) &&
         ((i[12] && i[13]) && (i[14] && i[15])));
}

static inline bool any(const int16 &i) {
  return (((i[0] || i[1]) || (i[2] || i[3])) ||
         ((i[4] || i[5]) || (i[6] || i[7]))) ||
         (((i[8] || i[9]) || (i[10] || i[11])) ||
         ((i[12] || i[13]) || (i[14] || i[15])));
}

template <typename T>
static inline T abs(const T &x) { return x < T(0.0) ? -x : x; }




#include "../fraktal_sft/CFixedFloat.h"
#include "../fraktal_sft/floatexp.h"
#include "../fraktal_sft/complex.h"

// hack for broadcasting in complex vector `op` complex scalar
#define C(double,doubleN) \
static inline complex<doubleN> operator+(const complex<double> &a, const complex<doubleN> &b) { return complex<doubleN>(a) + b; } \
static inline complex<doubleN> operator+(const complex<doubleN> &a, const complex<double> &b) { return a + complex<doubleN>(b); } \
static inline complex<doubleN> operator-(const complex<double> &a, const complex<doubleN> &b) { return complex<doubleN>(a) - b; } \
static inline complex<doubleN> operator-(const complex<doubleN> &a, const complex<double> &b) { return a - complex<doubleN>(b); } \
static inline complex<doubleN> operator*(const complex<double> &a, const complex<doubleN> &b) { return complex<doubleN>(a) * b; } \
static inline complex<doubleN> operator*(const complex<doubleN> &a, const complex<double> &b) { return a * complex<doubleN>(b); } \
static inline complex<doubleN> operator/(const complex<double> &a, const complex<doubleN> &b) { return complex<doubleN>(a) / b; } \
static inline complex<doubleN> operator/(const complex<doubleN> &a, const complex<double> &b) { return a / complex<doubleN>(b); }
C(double,double2)
C(double,double4)
C(double,double8)
C(double,double16)
C(double,long double)
C(long double,floatexp)
#undef C

#define FORMULA2(function,type,power) function ## _ ## type ## _ ## power
#define FORMULA(a,b,c) FORMULA2(a,b,c)

#ifdef PASS1 // reference



template <typename T>
bool FORMULA(reference,0,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_add(t1,Xr,Xi,MPFR_RNDN);
mpfr_sqr(t0,t1,MPFR_RNDN);
mpfr_sub(t1,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,7)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 7) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,8)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 8) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,9)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 9) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,10)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 10) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,1,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,1,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,1,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,1,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_sqr(t2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,2,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,2,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,2,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,2,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,3,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,3,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,3,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,3,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,4,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,4,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,4,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,4,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,5,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,6,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,7,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,8,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,9,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,10,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,11,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,12,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,13,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,14,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,15,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,16,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,17,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,18,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,19,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,20,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,21,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,22,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,23,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,24,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,25,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,26,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,27,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,28,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,29,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,30,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,31,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,32,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,33,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xi2,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t3,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_mul(t3,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xr2,t3,MPFR_RNDN);
mpfr_sub(t3,t2,t1,MPFR_RNDN);
mpfr_abs(t1,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi2,t1,MPFR_RNDN);
mpfr_sub(t1,t3,t2,MPFR_RNDN);
mpfr_abs(t2,Xr2,MPFR_RNDN);
mpfr_mul(t3,Xr2,t2,MPFR_RNDN);
mpfr_add(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t2,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t3,MPFR_RNDN);
mpfr_sub(t3,Ci,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,2,MPFR_RNDN);
mpfr_mul(t3,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t3,MPFR_RNDN);
mpfr_mul(t3,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,t2,MPFR_RNDN);
mpfr_set(Xin,t3,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,34,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,35,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,36,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,37,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,38,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,39,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr2,MPFR_RNDN);
mpfr_sqr(t1,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,40,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,3,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xr,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,3,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_add(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,3,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,41,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t2,2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,42,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,43,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,44,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = 2 * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,45,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,46,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,47,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,48,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,49,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,50,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,51,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_sub(t3,Xr2,Xi2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,52,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 52 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Ar,2,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_mul(t0,Ai,Xr2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,53,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 53 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_add(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Ar,2,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_mul(t0,Ai,Xr2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,54,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 54 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000004e-7;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,1,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t2,Xr,t1,MPFR_RNDN);
mpfr_add(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,Cr,t1,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,55,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 55 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000004e-6;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,Xr,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,1,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t3,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t0,2,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t4,Xr,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t4,MPFR_RNDN);
mpfr_add(t4,t3,t1,MPFR_RNDN);
mpfr_add(t1,t2,t4,MPFR_RNDN);
mpfr_add(t4,Cr,t1,MPFR_RNDN);
mpfr_set(Xrn,t4,MPFR_RNDN);
mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t2,Xi,t1,MPFR_RNDN);
mpfr_mul(t1,t4,t2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t3,Xi,t4,MPFR_RNDN);
mpfr_mul(t4,t2,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t4,1,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,t4,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t2,2,MPFR_RNDN);
mpfr_add(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,56,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 56 && m_nPower == 3)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000004e-6;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t2,1,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t2,2,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t4,t2,t3,MPFR_RNDN);
mpfr_add(t3,t0,t4,MPFR_RNDN);
mpfr_add(t4,t1,t3,MPFR_RNDN);
mpfr_add(t3,Cr,t4,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t1,t3,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t1,1,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t1,2,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t3,t2,MPFR_RNDN);
mpfr_add(t2,t4,t0,MPFR_RNDN);
mpfr_add(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,57,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 57 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000003e-5;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t1,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul(t4,Xi,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t4,MPFR_RNDN);
mpfr_add(t4,t2,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t4,1,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_mul(t4,Xi,Xr,MPFR_RNDN);
mpfr_abs(t2,t4,MPFR_RNDN);
mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_mul(t1,Xi,t4,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t5,Xr,t4,MPFR_RNDN);
mpfr_add(t4,t1,t5,MPFR_RNDN);
mpfr_mul(t5,t2,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t5,2,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t2,t5,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr,t5,MPFR_RNDN);
mpfr_mul(t5,t2,t1,MPFR_RNDN);
mpfr_add(t1,t4,t5,MPFR_RNDN);
mpfr_add(t5,t3,t1,MPFR_RNDN);
mpfr_add(t1,t0,t5,MPFR_RNDN);
mpfr_add(t5,Cr,t1,MPFR_RNDN);
mpfr_set(Xrn,t5,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t1,t5,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t0,Xi,t5,MPFR_RNDN);
mpfr_mul(t5,t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t3,Xi,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t4,Xr,t0,MPFR_RNDN);
mpfr_add(t0,t3,t4,MPFR_RNDN);
mpfr_mul(t4,t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t4,1,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_mul(t4,Xi,Xr,MPFR_RNDN);
mpfr_abs(t1,t4,MPFR_RNDN);
mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t4,MPFR_RNDN);
mpfr_mul(t4,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t4,2,MPFR_RNDN);
mpfr_mul(t4,Xi,Xr,MPFR_RNDN);
mpfr_abs(t1,t4,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t2,Xi,t4,MPFR_RNDN);
mpfr_mul(t4,t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t4,2,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t1,t4,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t6,Xr,t4,MPFR_RNDN);
mpfr_mul(t4,t1,t6,MPFR_RNDN);
mpfr_add(t6,t2,t4,MPFR_RNDN);
mpfr_add(t4,t3,t6,MPFR_RNDN);
mpfr_add(t6,t0,t4,MPFR_RNDN);
mpfr_add(t4,t5,t6,MPFR_RNDN);
mpfr_add(t6,Ci,t4,MPFR_RNDN);
mpfr_set(Xin,t6,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,58,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 58 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000003e-5;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_sqr(t1,Xi,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t4,t0,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t4,MPFR_RNDN);
mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t5,t3,t0,MPFR_RNDN);
mpfr_mul(t0,t4,t5,MPFR_RNDN);
mpfr_add(t5,t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t5,1,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t4,Xr,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t4,MPFR_RNDN);
mpfr_mul(t4,t5,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t4,4,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t6,t5,t3,MPFR_RNDN);
mpfr_mul(t3,t4,t6,MPFR_RNDN);
mpfr_add(t6,t1,t3,MPFR_RNDN);
mpfr_add(t3,t0,t6,MPFR_RNDN);
mpfr_add(t6,t2,t3,MPFR_RNDN);
mpfr_add(t3,Cr,t6,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t2,Xr,t6,MPFR_RNDN);
mpfr_mul(t6,Xi,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t2,2,MPFR_RNDN);
mpfr_neg(t6,t6,MPFR_RNDN);mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t0,Xr,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t2,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t0,2,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t4,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t1,2,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t5,t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t2,2,MPFR_RNDN);
mpfr_add(t2,t4,t5,MPFR_RNDN);
mpfr_add(t5,t3,t2,MPFR_RNDN);
mpfr_add(t2,t6,t5,MPFR_RNDN);
mpfr_add(t5,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t5,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,59,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 59 && m_nPower == 4)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000003e-5;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t2,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t4,t3,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t4,MPFR_RNDN);
mpfr_add(t4,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t4,3,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t3,t4,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t3,MPFR_RNDN);
mpfr_add(t3,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,t3,MPFR_RNDN);
mpfr_add(t3,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,1,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t3,3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t4,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t3,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t0,3,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul(t5,t0,t3,MPFR_RNDN);
mpfr_mul(t3,Xr,t5,MPFR_RNDN);
mpfr_add(t5,t4,t3,MPFR_RNDN);
mpfr_add(t3,t2,t5,MPFR_RNDN);
mpfr_add(t5,t1,t3,MPFR_RNDN);
mpfr_add(t3,Ci,t5,MPFR_RNDN);
mpfr_set(Xin,t3,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,60,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 60 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
mpfr_t t7; mpfr_init2(t7, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t2,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t3,Xr,t1,MPFR_RNDN);
mpfr_add(t1,t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t1,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,1,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t4,Xr,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t4,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_mul(t0,Xi,t4,MPFR_RNDN);
mpfr_abs(t4,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t5,Xi,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t6,Xr,t0,MPFR_RNDN);
mpfr_add(t0,t5,t6,MPFR_RNDN);
mpfr_mul(t6,t4,t0,MPFR_RNDN);
mpfr_add(t0,t1,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t0,3,MPFR_RNDN);
mpfr_neg(t6,t6,MPFR_RNDN);mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t4,Xi,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t1,3,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t5,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t5,MPFR_RNDN);
mpfr_add(t5,t4,t0,MPFR_RNDN);
mpfr_add(t0,t6,t5,MPFR_RNDN);
mpfr_add(t5,t2,t0,MPFR_RNDN);
mpfr_add(t0,t3,t5,MPFR_RNDN);
mpfr_add(t5,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t5,MPFR_RNDN);
mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_mul(t0,Xi,t5,MPFR_RNDN);
mpfr_abs(t5,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t3,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t5,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_mul(t5,Xr,t3,MPFR_RNDN);
mpfr_abs(t3,t5,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t2,Xi,t5,MPFR_RNDN);
mpfr_mul(t5,t3,t2,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t6,Xr,t3,MPFR_RNDN);
mpfr_mul(t3,t2,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t3,1,MPFR_RNDN);
mpfr_neg(t6,t6,MPFR_RNDN);mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_mul(t2,Xi,t3,MPFR_RNDN);
mpfr_abs(t3,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t4,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t2,3,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,t2,Xr,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t1,Xi,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul(t7,Xr,t3,MPFR_RNDN);
mpfr_add(t3,t1,t7,MPFR_RNDN);
mpfr_mul(t7,t2,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_mul(t2,Xi,t3,MPFR_RNDN);
mpfr_abs(t3,t2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t1,MPFR_RNDN);
mpfr_add(t1,t7,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t7,Xr,t1,MPFR_RNDN);
mpfr_abs(t1,t7,MPFR_RNDN);
mpfr_abs(t7,Xi,MPFR_RNDN);
mpfr_mul(t3,Xr,t7,MPFR_RNDN);
mpfr_mul(t7,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,t7,MPFR_RNDN);
mpfr_add(t7,t4,t3,MPFR_RNDN);
mpfr_add(t3,t6,t7,MPFR_RNDN);
mpfr_add(t7,t5,t3,MPFR_RNDN);
mpfr_add(t3,t0,t7,MPFR_RNDN);
mpfr_add(t7,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t7,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
mpfr_clear(t7);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,61,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 61 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
mpfr_t t7; mpfr_init2(t7, bits);
mpfr_t t8; mpfr_init2(t8, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t1,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t4,t3,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t4,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t1,t4,MPFR_RNDN);
mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t5,t4,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t5,MPFR_RNDN);
mpfr_add(t5,t0,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t5,1,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_mul(t5,Xi,Xr,MPFR_RNDN);
mpfr_abs(t0,t5,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t4,t5,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t4,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t0,t4,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t5,Xr,t4,MPFR_RNDN);
mpfr_mul(t4,Xi,t5,MPFR_RNDN);
mpfr_mul(t5,t0,t4,MPFR_RNDN);
mpfr_add(t4,t1,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t4,2,MPFR_RNDN);
mpfr_neg(t5,t5,MPFR_RNDN);mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_abs(t1,t4,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t4,MPFR_RNDN);
mpfr_mul(t4,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t4,MPFR_RNDN);
mpfr_mul(t4,Xi,Xr,MPFR_RNDN);
mpfr_abs(t1,t4,MPFR_RNDN);
mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t7,t4,t6,MPFR_RNDN);
mpfr_mul(t6,t1,t7,MPFR_RNDN);
mpfr_add(t7,t0,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t7,2,MPFR_RNDN);
mpfr_mul(t7,Xi,Xr,MPFR_RNDN);
mpfr_abs(t0,t7,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr,t7,MPFR_RNDN);
mpfr_mul(t7,Xi,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t7,MPFR_RNDN);
mpfr_mul_ui(t7,t1,4,MPFR_RNDN);
mpfr_neg(t7,t7,MPFR_RNDN);mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_mul(t8,t1,t4,MPFR_RNDN);
mpfr_mul(t4,t0,t8,MPFR_RNDN);
mpfr_add(t8,t7,t4,MPFR_RNDN);
mpfr_add(t4,t6,t8,MPFR_RNDN);
mpfr_add(t8,t5,t4,MPFR_RNDN);
mpfr_add(t4,t3,t8,MPFR_RNDN);
mpfr_add(t8,t2,t4,MPFR_RNDN);
mpfr_add(t4,Cr,t8,MPFR_RNDN);
mpfr_set(Xrn,t4,MPFR_RNDN);
mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_abs(t8,t4,MPFR_RNDN);
mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,t4,t2,MPFR_RNDN);
mpfr_mul(t2,t8,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t8,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t5,t3,t4,MPFR_RNDN);
mpfr_mul(t4,t8,t5,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t8,t5,MPFR_RNDN);
mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul(t6,t5,t3,MPFR_RNDN);
mpfr_mul(t3,t8,t6,MPFR_RNDN);
mpfr_add(t6,t4,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t6,1,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_mul(t6,Xi,Xr,MPFR_RNDN);
mpfr_abs(t4,t6,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_abs(t8,Xr,MPFR_RNDN);
mpfr_mul(t5,t6,t8,MPFR_RNDN);
mpfr_mul(t8,t4,t5,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t4,t5,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t6,Xr,t5,MPFR_RNDN);
mpfr_mul(t5,Xi,t6,MPFR_RNDN);
mpfr_mul(t6,t4,t5,MPFR_RNDN);
mpfr_add(t5,t8,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t5,2,MPFR_RNDN);
mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_abs(t8,t5,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t4,Xr,t5,MPFR_RNDN);
mpfr_mul(t5,Xi,t4,MPFR_RNDN);
mpfr_mul(t4,t8,t5,MPFR_RNDN);
mpfr_mul(t5,Xi,Xr,MPFR_RNDN);
mpfr_abs(t8,t5,MPFR_RNDN);
mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t0,t5,t7,MPFR_RNDN);
mpfr_mul(t7,t8,t0,MPFR_RNDN);
mpfr_add(t0,t4,t7,MPFR_RNDN);
mpfr_mul_ui(t7,t0,2,MPFR_RNDN);
mpfr_neg(t7,t7,MPFR_RNDN);mpfr_mul(t0,Xi,Xr,MPFR_RNDN);
mpfr_abs(t4,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t8,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t8,MPFR_RNDN);
mpfr_mul(t8,t4,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t8,4,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_sqr(t8,Xr,MPFR_RNDN);
mpfr_abs(t4,t8,MPFR_RNDN);
mpfr_sqr(t8,Xr,MPFR_RNDN);
mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_mul(t1,t8,t5,MPFR_RNDN);
mpfr_mul(t5,t4,t1,MPFR_RNDN);
mpfr_add(t1,t0,t5,MPFR_RNDN);
mpfr_add(t5,t7,t1,MPFR_RNDN);
mpfr_add(t1,t6,t5,MPFR_RNDN);
mpfr_add(t5,t3,t1,MPFR_RNDN);
mpfr_add(t1,t2,t5,MPFR_RNDN);
mpfr_add(t5,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t5,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
mpfr_clear(t7);
mpfr_clear(t8);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,62,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 62 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
mpfr_t t7; mpfr_init2(t7, bits);
mpfr_t t8; mpfr_init2(t8, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t3,1,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t4,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t4,MPFR_RNDN);
mpfr_mul(t4,t3,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t4,2,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t5,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t3,t5,MPFR_RNDN);
mpfr_mul(t5,t4,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t5,3,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t6,Xr,t3,MPFR_RNDN);
mpfr_mul(t3,t4,t6,MPFR_RNDN);
mpfr_mul(t6,t5,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t6,3,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_mul(t7,t5,t4,MPFR_RNDN);
mpfr_mul(t4,Xi,t7,MPFR_RNDN);
mpfr_mul(t7,t6,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t7,6,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t8,t6,t5,MPFR_RNDN);
mpfr_mul(t5,Xr,t8,MPFR_RNDN);
mpfr_mul(t8,t7,t5,MPFR_RNDN);
mpfr_add(t5,t4,t8,MPFR_RNDN);
mpfr_add(t8,t3,t5,MPFR_RNDN);
mpfr_add(t5,t0,t8,MPFR_RNDN);
mpfr_add(t8,t1,t5,MPFR_RNDN);
mpfr_add(t5,t2,t8,MPFR_RNDN);
mpfr_add(t8,Cr,t5,MPFR_RNDN);
mpfr_set(Xrn,t8,MPFR_RNDN);
mpfr_abs(t8,Xi,MPFR_RNDN);
mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t1,t5,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t1,MPFR_RNDN);
mpfr_mul(t1,t8,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_sqr(t8,Xi,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t0,t8,t5,MPFR_RNDN);
mpfr_mul(t5,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t2,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t0,1,MPFR_RNDN);
mpfr_neg(t5,t5,MPFR_RNDN);mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_abs(t8,Xr,MPFR_RNDN);
mpfr_mul(t3,t2,t8,MPFR_RNDN);
mpfr_mul(t8,Xi,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t8,MPFR_RNDN);
mpfr_mul_ui(t8,t3,3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t4,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t4,MPFR_RNDN);
mpfr_mul(t4,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t4,3,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t7,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t3,t7,MPFR_RNDN);
mpfr_mul(t7,t4,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t7,6,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_abs(t7,Xi,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t6,t4,t3,MPFR_RNDN);
mpfr_mul(t3,Xr,t6,MPFR_RNDN);
mpfr_mul(t6,t7,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t6,2,MPFR_RNDN);
mpfr_add(t6,t0,t3,MPFR_RNDN);
mpfr_add(t3,t2,t6,MPFR_RNDN);
mpfr_add(t6,t8,t3,MPFR_RNDN);
mpfr_add(t3,t5,t6,MPFR_RNDN);
mpfr_add(t6,t1,t3,MPFR_RNDN);
mpfr_add(t3,Ci,t6,MPFR_RNDN);
mpfr_set(Xin,t3,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
mpfr_clear(t7);
mpfr_clear(t8);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,63,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 63 && m_nPower == 5)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_sqr(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t3,4,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t4,Xr,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t4,MPFR_RNDN);
mpfr_mul(t4,Xi,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t4,4,MPFR_RNDN);
mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t6,t3,t5,MPFR_RNDN);
mpfr_mul(t5,t4,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t5,6,MPFR_RNDN);
mpfr_neg(t6,t6,MPFR_RNDN);mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_mul(t3,t5,t4,MPFR_RNDN);
mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_mul(t5,t3,t4,MPFR_RNDN);
mpfr_add(t4,t6,t5,MPFR_RNDN);
mpfr_add(t5,t1,t4,MPFR_RNDN);
mpfr_add(t4,t2,t5,MPFR_RNDN);
mpfr_add(t5,t0,t4,MPFR_RNDN);
mpfr_add(t4,Cr,t5,MPFR_RNDN);
mpfr_set(Xrn,t4,MPFR_RNDN);
mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_mul(t0,t4,t5,MPFR_RNDN);
mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_mul(t4,t0,t5,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t5,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t2,4,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr,t5,MPFR_RNDN);
mpfr_mul(t5,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t1,4,MPFR_RNDN);
mpfr_neg(t5,t5,MPFR_RNDN);mpfr_sqr(t1,Xi,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t3,t2,t6,MPFR_RNDN);
mpfr_mul(t6,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t6,6,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t2,t6,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t6,t2,t1,MPFR_RNDN);
mpfr_add(t1,t3,t6,MPFR_RNDN);
mpfr_add(t6,t5,t1,MPFR_RNDN);
mpfr_add(t1,t0,t6,MPFR_RNDN);
mpfr_add(t6,t4,t1,MPFR_RNDN);
mpfr_add(t1,Ci,t6,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,64,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 64 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
mpfr_t t7; mpfr_init2(t7, bits);
mpfr_t t8; mpfr_init2(t8, bits);
mpfr_t t9; mpfr_init2(t9, bits);
mpfr_t t10; mpfr_init2(t10, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_sqr(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_mul(t4,t0,t3,MPFR_RNDN);
mpfr_abs(t3,t4,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_mul(t5,t4,t0,MPFR_RNDN);
mpfr_abs(t0,t5,MPFR_RNDN);
mpfr_add(t5,t3,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t0,1,MPFR_RNDN);
mpfr_neg(t5,t5,MPFR_RNDN);mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t3,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t0,4,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t4,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t0,4,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t6,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t0,4,MPFR_RNDN);
mpfr_neg(t6,t6,MPFR_RNDN);mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t7,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t7,MPFR_RNDN);
mpfr_mul_ui(t7,t0,4,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t8,t0,t1,MPFR_RNDN);
mpfr_abs(t1,t8,MPFR_RNDN);
mpfr_abs(t8,Xr,MPFR_RNDN);
mpfr_mul(t0,Xr,t8,MPFR_RNDN);
mpfr_mul(t8,t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t8,6,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_sqr(t8,Xi,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t9,t8,t1,MPFR_RNDN);
mpfr_abs(t1,t9,MPFR_RNDN);
mpfr_abs(t9,Xi,MPFR_RNDN);
mpfr_mul(t8,Xi,t9,MPFR_RNDN);
mpfr_mul(t9,t1,t8,MPFR_RNDN);
mpfr_mul_ui(t8,t9,6,MPFR_RNDN);
mpfr_sqr(t9,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t10,t9,t1,MPFR_RNDN);
mpfr_abs(t1,t10,MPFR_RNDN);
mpfr_abs(t10,Xr,MPFR_RNDN);
mpfr_mul(t9,Xr,t10,MPFR_RNDN);
mpfr_mul(t10,t1,t9,MPFR_RNDN);
mpfr_add(t9,t8,t10,MPFR_RNDN);
mpfr_add(t10,t0,t9,MPFR_RNDN);
mpfr_add(t9,t7,t10,MPFR_RNDN);
mpfr_add(t10,t6,t9,MPFR_RNDN);
mpfr_add(t9,t4,t10,MPFR_RNDN);
mpfr_add(t10,t3,t9,MPFR_RNDN);
mpfr_add(t9,t5,t10,MPFR_RNDN);
mpfr_add(t10,t2,t9,MPFR_RNDN);
mpfr_add(t9,Cr,t10,MPFR_RNDN);
mpfr_set(Xrn,t9,MPFR_RNDN);
mpfr_sqr(t9,Xi,MPFR_RNDN);
mpfr_sqr(t10,Xi,MPFR_RNDN);
mpfr_mul(t2,t9,t10,MPFR_RNDN);
mpfr_abs(t10,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t9,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t5,Xr,t2,MPFR_RNDN);
mpfr_add(t2,t9,t5,MPFR_RNDN);
mpfr_mul(t5,t10,t2,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_sqr(t10,Xr,MPFR_RNDN);
mpfr_mul(t9,t2,t10,MPFR_RNDN);
mpfr_abs(t10,t9,MPFR_RNDN);
mpfr_abs(t9,Xr,MPFR_RNDN);
mpfr_mul(t2,Xi,t9,MPFR_RNDN);
mpfr_mul(t9,t10,t2,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_mul(t10,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t10,MPFR_RNDN);
mpfr_abs(t10,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,t10,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t2,4,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_mul(t10,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,Xi,t10,MPFR_RNDN);
mpfr_abs(t10,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t4,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,t10,t4,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_mul(t10,Xr,t4,MPFR_RNDN);
mpfr_mul(t4,Xi,t10,MPFR_RNDN);
mpfr_abs(t10,t4,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t6,Xi,t4,MPFR_RNDN);
mpfr_mul(t4,t10,t6,MPFR_RNDN);
mpfr_add(t6,t2,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t6,4,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_sqr(t6,Xi,MPFR_RNDN);
mpfr_mul(t2,t6,Xr,MPFR_RNDN);
mpfr_mul(t6,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,t6,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t10,Xi,t6,MPFR_RNDN);
mpfr_mul(t6,t2,t10,MPFR_RNDN);
mpfr_mul_ui(t10,t6,4,MPFR_RNDN);
mpfr_sqr(t6,Xi,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_mul(t7,t6,t2,MPFR_RNDN);
mpfr_abs(t2,t7,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t6,Xi,t7,MPFR_RNDN);
mpfr_abs(t7,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t7,MPFR_RNDN);
mpfr_add(t7,t6,t0,MPFR_RNDN);
mpfr_mul(t0,t2,t7,MPFR_RNDN);
mpfr_mul_ui(t7,t0,6,MPFR_RNDN);
mpfr_neg(t7,t7,MPFR_RNDN);mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_mul(t6,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t6,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t6,MPFR_RNDN);
mpfr_mul(t6,t2,t0,MPFR_RNDN);
mpfr_add(t0,t7,t6,MPFR_RNDN);
mpfr_add(t6,t10,t0,MPFR_RNDN);
mpfr_add(t0,t4,t6,MPFR_RNDN);
mpfr_add(t6,t3,t0,MPFR_RNDN);
mpfr_add(t0,t9,t6,MPFR_RNDN);
mpfr_add(t6,t5,t0,MPFR_RNDN);
mpfr_add(t0,Ci,t6,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
mpfr_clear(t7);
mpfr_clear(t8);
mpfr_clear(t9);
mpfr_clear(t10);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,65,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 65 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
mpfr_t t7; mpfr_init2(t7, bits);
mpfr_t t8; mpfr_init2(t8, bits);
mpfr_t t9; mpfr_init2(t9, bits);
mpfr_t t10; mpfr_init2(t10, bits);
mpfr_t t11; mpfr_init2(t11, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_mul(t0,Xi,t3,MPFR_RNDN);
mpfr_abs(t3,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t4,t0,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t4,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t4,MPFR_RNDN);
mpfr_abs(t4,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t5,t3,t0,MPFR_RNDN);
mpfr_mul(t0,t4,t5,MPFR_RNDN);
mpfr_add(t5,t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t5,1,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr,t5,MPFR_RNDN);
mpfr_abs(t5,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t4,Xr,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t4,MPFR_RNDN);
mpfr_mul(t4,t5,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t4,2,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_mul(t5,Xi,t4,MPFR_RNDN);
mpfr_abs(t4,t5,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t5,MPFR_RNDN);
mpfr_mul(t5,Xi,t3,MPFR_RNDN);
mpfr_mul(t3,t4,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t3,2,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_mul(t4,t3,Xr,MPFR_RNDN);
mpfr_abs(t3,t4,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t6,Xr,MPFR_RNDN);
mpfr_mul(t7,t4,t6,MPFR_RNDN);
mpfr_mul(t6,t3,t7,MPFR_RNDN);
mpfr_sqr(t7,Xr,MPFR_RNDN);
mpfr_mul(t3,Xi,t7,MPFR_RNDN);
mpfr_abs(t7,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t8,t3,t4,MPFR_RNDN);
mpfr_mul(t4,t7,t8,MPFR_RNDN);
mpfr_add(t8,t6,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t8,3,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_sqr(t8,Xi,MPFR_RNDN);
mpfr_mul(t6,t8,Xr,MPFR_RNDN);
mpfr_abs(t8,t6,MPFR_RNDN);
mpfr_sqr(t6,Xi,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t3,t6,t7,MPFR_RNDN);
mpfr_mul(t7,t8,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_mul(t8,Xi,t3,MPFR_RNDN);
mpfr_abs(t3,t8,MPFR_RNDN);
mpfr_sqr(t8,Xi,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t9,t8,t6,MPFR_RNDN);
mpfr_mul(t6,t3,t9,MPFR_RNDN);
mpfr_add(t9,t7,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t9,3,MPFR_RNDN);
mpfr_sqr(t9,Xr,MPFR_RNDN);
mpfr_mul(t7,Xi,t9,MPFR_RNDN);
mpfr_abs(t9,t7,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t7,MPFR_RNDN);
mpfr_mul(t7,Xi,t3,MPFR_RNDN);
mpfr_mul(t3,t9,t7,MPFR_RNDN);
mpfr_mul_ui(t7,t3,6,MPFR_RNDN);
mpfr_neg(t7,t7,MPFR_RNDN);mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_mul(t9,t3,Xr,MPFR_RNDN);
mpfr_abs(t3,t9,MPFR_RNDN);
mpfr_abs(t9,Xi,MPFR_RNDN);
mpfr_mul(t8,Xr,t9,MPFR_RNDN);
mpfr_mul(t9,Xi,t8,MPFR_RNDN);
mpfr_mul(t8,t3,t9,MPFR_RNDN);
mpfr_mul_ui(t9,t8,6,MPFR_RNDN);
mpfr_sqr(t8,Xr,MPFR_RNDN);
mpfr_mul(t3,Xr,t8,MPFR_RNDN);
mpfr_abs(t8,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t10,Xr,MPFR_RNDN);
mpfr_mul(t11,t3,t10,MPFR_RNDN);
mpfr_mul(t10,t8,t11,MPFR_RNDN);
mpfr_add(t11,t9,t10,MPFR_RNDN);
mpfr_add(t10,t7,t11,MPFR_RNDN);
mpfr_add(t11,t6,t10,MPFR_RNDN);
mpfr_add(t10,t4,t11,MPFR_RNDN);
mpfr_add(t11,t5,t10,MPFR_RNDN);
mpfr_add(t10,t1,t11,MPFR_RNDN);
mpfr_add(t11,t0,t10,MPFR_RNDN);
mpfr_add(t10,t2,t11,MPFR_RNDN);
mpfr_add(t11,Cr,t10,MPFR_RNDN);
mpfr_set(Xrn,t11,MPFR_RNDN);
mpfr_sqr(t11,Xi,MPFR_RNDN);
mpfr_mul(t10,Xi,t11,MPFR_RNDN);
mpfr_abs(t11,t10,MPFR_RNDN);
mpfr_sqr(t10,Xi,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t0,t10,t2,MPFR_RNDN);
mpfr_mul(t2,t11,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul(t11,Xi,t0,MPFR_RNDN);
mpfr_abs(t0,t11,MPFR_RNDN);
mpfr_sqr(t11,Xr,MPFR_RNDN);
mpfr_abs(t10,Xr,MPFR_RNDN);
mpfr_mul(t1,t11,t10,MPFR_RNDN);
mpfr_mul(t10,t0,t1,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t11,Xi,MPFR_RNDN);
mpfr_mul(t5,t0,t11,MPFR_RNDN);
mpfr_mul(t11,t1,t5,MPFR_RNDN);
mpfr_add(t5,t10,t11,MPFR_RNDN);
mpfr_mul_ui(t11,t5,1,MPFR_RNDN);
mpfr_neg(t11,t11,MPFR_RNDN);mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_mul(t10,Xi,t5,MPFR_RNDN);
mpfr_abs(t5,t10,MPFR_RNDN);
mpfr_abs(t10,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,t10,MPFR_RNDN);
mpfr_mul(t10,Xi,t1,MPFR_RNDN);
mpfr_mul(t1,t5,t10,MPFR_RNDN);
mpfr_sqr(t10,Xr,MPFR_RNDN);
mpfr_mul(t5,Xr,t10,MPFR_RNDN);
mpfr_abs(t10,t5,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t0,Xr,t5,MPFR_RNDN);
mpfr_mul(t5,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t10,t5,MPFR_RNDN);
mpfr_add(t5,t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t5,2,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_mul(t1,Xi,t5,MPFR_RNDN);
mpfr_abs(t5,t1,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_abs(t10,Xr,MPFR_RNDN);
mpfr_mul(t4,t1,t10,MPFR_RNDN);
mpfr_mul(t10,t5,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t10,3,MPFR_RNDN);
mpfr_sqr(t10,Xi,MPFR_RNDN);
mpfr_mul(t5,t10,Xr,MPFR_RNDN);
mpfr_abs(t10,t5,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t6,t5,t1,MPFR_RNDN);
mpfr_mul(t1,t10,t6,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_mul(t10,Xi,t6,MPFR_RNDN);
mpfr_abs(t6,t10,MPFR_RNDN);
mpfr_sqr(t10,Xi,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t7,t10,t5,MPFR_RNDN);
mpfr_mul(t5,t6,t7,MPFR_RNDN);
mpfr_add(t7,t1,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t7,3,MPFR_RNDN);
mpfr_neg(t5,t5,MPFR_RNDN);mpfr_sqr(t7,Xi,MPFR_RNDN);
mpfr_mul(t1,t7,Xr,MPFR_RNDN);
mpfr_abs(t7,t1,MPFR_RNDN);
mpfr_sqr(t1,Xi,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t10,t1,t6,MPFR_RNDN);
mpfr_mul(t6,t7,t10,MPFR_RNDN);
mpfr_mul_ui(t10,t6,3,MPFR_RNDN);
mpfr_sqr(t6,Xi,MPFR_RNDN);
mpfr_mul(t7,t6,Xr,MPFR_RNDN);
mpfr_abs(t6,t7,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr,t7,MPFR_RNDN);
mpfr_mul(t7,Xi,t1,MPFR_RNDN);
mpfr_mul(t1,t6,t7,MPFR_RNDN);
mpfr_sqr(t7,Xr,MPFR_RNDN);
mpfr_mul(t6,Xi,t7,MPFR_RNDN);
mpfr_abs(t7,t6,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t9,Xr,t6,MPFR_RNDN);
mpfr_mul(t6,Xi,t9,MPFR_RNDN);
mpfr_mul(t9,t7,t6,MPFR_RNDN);
mpfr_add(t6,t1,t9,MPFR_RNDN);
mpfr_mul_ui(t9,t6,6,MPFR_RNDN);
mpfr_neg(t9,t9,MPFR_RNDN);mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr,t6,MPFR_RNDN);
mpfr_abs(t6,t1,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_abs(t7,Xi,MPFR_RNDN);
mpfr_mul(t8,t1,t7,MPFR_RNDN);
mpfr_mul(t7,t6,t8,MPFR_RNDN);
mpfr_add(t8,t9,t7,MPFR_RNDN);
mpfr_add(t7,t10,t8,MPFR_RNDN);
mpfr_add(t8,t5,t7,MPFR_RNDN);
mpfr_add(t7,t4,t8,MPFR_RNDN);
mpfr_add(t8,t0,t7,MPFR_RNDN);
mpfr_add(t7,t11,t8,MPFR_RNDN);
mpfr_add(t8,t2,t7,MPFR_RNDN);
mpfr_add(t7,Ci,t8,MPFR_RNDN);
mpfr_set(Xin,t7,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
mpfr_clear(t7);
mpfr_clear(t8);
mpfr_clear(t9);
mpfr_clear(t10);
mpfr_clear(t11);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,66,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 66 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
mpfr_t t7; mpfr_init2(t7, bits);
mpfr_t t8; mpfr_init2(t8, bits);
mpfr_t t9; mpfr_init2(t9, bits);
mpfr_t t10; mpfr_init2(t10, bits);
mpfr_t t11; mpfr_init2(t11, bits);
mpfr_t t12; mpfr_init2(t12, bits);
mpfr_t t13; mpfr_init2(t13, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t4,t2,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t4,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t5,t4,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,t5,MPFR_RNDN);
mpfr_add(t5,t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t2,1,MPFR_RNDN);
mpfr_neg(t5,t5,MPFR_RNDN);mpfr_mul(t2,Xi,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t4,t2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t4,MPFR_RNDN);
mpfr_mul(t4,t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t4,2,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_mul(t4,Xi,Xr,MPFR_RNDN);
mpfr_abs(t1,t4,MPFR_RNDN);
mpfr_sqr(t4,Xi,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t6,t4,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t6,MPFR_RNDN);
mpfr_mul(t6,t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t6,2,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_abs(t1,t6,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t7,t6,t4,MPFR_RNDN);
mpfr_mul(t4,Xi,t7,MPFR_RNDN);
mpfr_mul(t7,t1,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t7,3,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_sqr(t7,Xi,MPFR_RNDN);
mpfr_abs(t1,t7,MPFR_RNDN);
mpfr_sqr(t7,Xr,MPFR_RNDN);
mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_mul(t8,t7,t6,MPFR_RNDN);
mpfr_mul(t6,Xi,t8,MPFR_RNDN);
mpfr_mul(t8,t1,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t8,3,MPFR_RNDN);
mpfr_sqr(t8,Xr,MPFR_RNDN);
mpfr_abs(t1,t8,MPFR_RNDN);
mpfr_sqr(t8,Xi,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t9,Xr,t7,MPFR_RNDN);
mpfr_mul(t7,t8,t9,MPFR_RNDN);
mpfr_mul(t9,t1,t7,MPFR_RNDN);
mpfr_mul_ui(t7,t9,3,MPFR_RNDN);
mpfr_neg(t7,t7,MPFR_RNDN);mpfr_sqr(t9,Xi,MPFR_RNDN);
mpfr_abs(t1,t9,MPFR_RNDN);
mpfr_sqr(t9,Xi,MPFR_RNDN);
mpfr_abs(t8,Xr,MPFR_RNDN);
mpfr_mul(t10,Xr,t8,MPFR_RNDN);
mpfr_mul(t8,t9,t10,MPFR_RNDN);
mpfr_mul(t10,t1,t8,MPFR_RNDN);
mpfr_mul_ui(t8,t10,3,MPFR_RNDN);
mpfr_mul(t10,Xi,Xr,MPFR_RNDN);
mpfr_abs(t1,t10,MPFR_RNDN);
mpfr_sqr(t10,Xr,MPFR_RNDN);
mpfr_abs(t9,Xr,MPFR_RNDN);
mpfr_mul(t11,t10,t9,MPFR_RNDN);
mpfr_mul(t9,Xi,t11,MPFR_RNDN);
mpfr_mul(t11,t1,t9,MPFR_RNDN);
mpfr_mul_ui(t9,t11,6,MPFR_RNDN);
mpfr_neg(t9,t9,MPFR_RNDN);mpfr_mul(t11,Xi,Xr,MPFR_RNDN);
mpfr_abs(t1,t11,MPFR_RNDN);
mpfr_sqr(t11,Xi,MPFR_RNDN);
mpfr_abs(t10,Xi,MPFR_RNDN);
mpfr_mul(t12,Xr,t10,MPFR_RNDN);
mpfr_mul(t10,t11,t12,MPFR_RNDN);
mpfr_mul(t12,t1,t10,MPFR_RNDN);
mpfr_mul_ui(t10,t12,6,MPFR_RNDN);
mpfr_sqr(t12,Xr,MPFR_RNDN);
mpfr_abs(t1,t12,MPFR_RNDN);
mpfr_sqr(t12,Xr,MPFR_RNDN);
mpfr_abs(t11,Xr,MPFR_RNDN);
mpfr_mul(t13,t12,t11,MPFR_RNDN);
mpfr_mul(t11,Xr,t13,MPFR_RNDN);
mpfr_mul(t13,t1,t11,MPFR_RNDN);
mpfr_add(t11,t10,t13,MPFR_RNDN);
mpfr_add(t13,t9,t11,MPFR_RNDN);
mpfr_add(t11,t8,t13,MPFR_RNDN);
mpfr_add(t13,t7,t11,MPFR_RNDN);
mpfr_add(t11,t6,t13,MPFR_RNDN);
mpfr_add(t13,t4,t11,MPFR_RNDN);
mpfr_add(t11,t2,t13,MPFR_RNDN);
mpfr_add(t13,t0,t11,MPFR_RNDN);
mpfr_add(t11,t5,t13,MPFR_RNDN);
mpfr_add(t13,t3,t11,MPFR_RNDN);
mpfr_add(t11,Cr,t13,MPFR_RNDN);
mpfr_set(Xrn,t11,MPFR_RNDN);
mpfr_sqr(t11,Xi,MPFR_RNDN);
mpfr_abs(t13,t11,MPFR_RNDN);
mpfr_sqr(t11,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t5,t11,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t5,MPFR_RNDN);
mpfr_mul(t5,t13,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t13,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t11,Xi,MPFR_RNDN);
mpfr_mul(t0,t3,t11,MPFR_RNDN);
mpfr_mul(t11,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t13,t11,MPFR_RNDN);
mpfr_sqr(t11,Xr,MPFR_RNDN);
mpfr_abs(t13,t11,MPFR_RNDN);
mpfr_sqr(t11,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t2,t11,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t2,MPFR_RNDN);
mpfr_mul(t2,t13,t3,MPFR_RNDN);
mpfr_add(t3,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t3,1,MPFR_RNDN);
mpfr_neg(t2,t2,MPFR_RNDN);mpfr_mul(t3,Xi,Xr,MPFR_RNDN);
mpfr_abs(t0,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t13,Xi,MPFR_RNDN);
mpfr_mul(t11,t3,t13,MPFR_RNDN);
mpfr_mul(t13,Xi,t11,MPFR_RNDN);
mpfr_sqr(t11,Xr,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t4,t11,t3,MPFR_RNDN);
mpfr_mul(t3,Xr,t4,MPFR_RNDN);
mpfr_add(t4,t13,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t3,2,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t0,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t13,Xr,MPFR_RNDN);
mpfr_mul(t11,t3,t13,MPFR_RNDN);
mpfr_mul(t13,Xi,t11,MPFR_RNDN);
mpfr_mul(t11,t0,t13,MPFR_RNDN);
mpfr_mul_ui(t13,t11,3,MPFR_RNDN);
mpfr_sqr(t11,Xi,MPFR_RNDN);
mpfr_abs(t0,t11,MPFR_RNDN);
mpfr_sqr(t11,Xr,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t6,t11,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t6,MPFR_RNDN);
mpfr_mul(t6,t0,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t0,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t11,Xi,MPFR_RNDN);
mpfr_mul(t7,Xr,t11,MPFR_RNDN);
mpfr_mul(t11,t3,t7,MPFR_RNDN);
mpfr_mul(t7,t0,t11,MPFR_RNDN);
mpfr_add(t11,t6,t7,MPFR_RNDN);
mpfr_mul_ui(t7,t11,3,MPFR_RNDN);
mpfr_neg(t7,t7,MPFR_RNDN);mpfr_sqr(t11,Xi,MPFR_RNDN);
mpfr_abs(t6,t11,MPFR_RNDN);
mpfr_sqr(t11,Xi,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t3,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t11,t3,MPFR_RNDN);
mpfr_mul(t3,t6,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t3,3,MPFR_RNDN);
mpfr_mul(t3,Xi,Xr,MPFR_RNDN);
mpfr_abs(t6,t3,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_abs(t11,Xr,MPFR_RNDN);
mpfr_mul(t8,Xr,t11,MPFR_RNDN);
mpfr_mul(t11,t3,t8,MPFR_RNDN);
mpfr_sqr(t8,Xr,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul(t9,t8,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t9,MPFR_RNDN);
mpfr_add(t9,t11,t3,MPFR_RNDN);
mpfr_mul(t3,t6,t9,MPFR_RNDN);
mpfr_mul_ui(t9,t3,6,MPFR_RNDN);
mpfr_neg(t9,t9,MPFR_RNDN);mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t6,t3,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t11,Xi,MPFR_RNDN);
mpfr_mul(t8,t3,t11,MPFR_RNDN);
mpfr_mul(t11,Xr,t8,MPFR_RNDN);
mpfr_mul(t8,t6,t11,MPFR_RNDN);
mpfr_add(t11,t9,t8,MPFR_RNDN);
mpfr_add(t8,t0,t11,MPFR_RNDN);
mpfr_add(t11,t7,t8,MPFR_RNDN);
mpfr_add(t8,t13,t11,MPFR_RNDN);
mpfr_add(t11,t4,t8,MPFR_RNDN);
mpfr_add(t8,t2,t11,MPFR_RNDN);
mpfr_add(t11,t5,t8,MPFR_RNDN);
mpfr_add(t8,Ci,t11,MPFR_RNDN);
mpfr_set(Xin,t8,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
mpfr_clear(t7);
mpfr_clear(t8);
mpfr_clear(t9);
mpfr_clear(t10);
mpfr_clear(t11);
mpfr_clear(t12);
mpfr_clear(t13);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,67,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 67 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
mpfr_t t7; mpfr_init2(t7, bits);
mpfr_t t8; mpfr_init2(t8, bits);
mpfr_t t9; mpfr_init2(t9, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xi,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t1,t3,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t3,t1,t0,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_sqr(t1,Xi,MPFR_RNDN);
mpfr_mul(t4,t0,t1,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_mul(t5,t1,t0,MPFR_RNDN);
mpfr_add(t0,t4,t5,MPFR_RNDN);
mpfr_mul(t5,t3,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t5,1,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t6,t4,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t6,MPFR_RNDN);
mpfr_mul(t6,t5,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t6,6,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_abs(t6,Xi,MPFR_RNDN);
mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t4,Xi,MPFR_RNDN);
mpfr_mul(t7,t3,t4,MPFR_RNDN);
mpfr_mul(t4,t5,t7,MPFR_RNDN);
mpfr_mul(t7,t6,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t7,6,MPFR_RNDN);
mpfr_abs(t7,Xi,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_abs(t5,Xr,MPFR_RNDN);
mpfr_mul(t3,t6,t5,MPFR_RNDN);
mpfr_mul(t5,Xr,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t5,MPFR_RNDN);
mpfr_mul(t5,t7,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t5,8,MPFR_RNDN);
mpfr_neg(t3,t3,MPFR_RNDN);mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_sqr(t7,Xi,MPFR_RNDN);
mpfr_abs(t6,Xr,MPFR_RNDN);
mpfr_mul(t8,Xr,t6,MPFR_RNDN);
mpfr_mul(t6,t7,t8,MPFR_RNDN);
mpfr_mul(t8,Xi,t6,MPFR_RNDN);
mpfr_mul(t6,t5,t8,MPFR_RNDN);
mpfr_mul_ui(t8,t6,8,MPFR_RNDN);
mpfr_abs(t6,Xr,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_sqr(t7,Xr,MPFR_RNDN);
mpfr_mul(t9,t5,t7,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t5,t9,t7,MPFR_RNDN);
mpfr_mul(t7,t6,t5,MPFR_RNDN);
mpfr_add(t5,t8,t7,MPFR_RNDN);
mpfr_add(t7,t3,t5,MPFR_RNDN);
mpfr_add(t5,t4,t7,MPFR_RNDN);
mpfr_add(t7,t1,t5,MPFR_RNDN);
mpfr_add(t5,t0,t7,MPFR_RNDN);
mpfr_add(t7,t2,t5,MPFR_RNDN);
mpfr_add(t5,Cr,t7,MPFR_RNDN);
mpfr_set(Xrn,t5,MPFR_RNDN);
mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_sqr(t7,Xi,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_mul(t0,t7,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t7,t0,t2,MPFR_RNDN);
mpfr_mul(t2,t5,t7,MPFR_RNDN);
mpfr_mul_ui(t7,t2,2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,t5,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_mul(t4,t2,t5,MPFR_RNDN);
mpfr_mul(t5,Xr,t4,MPFR_RNDN);
mpfr_mul(t4,Xi,t5,MPFR_RNDN);
mpfr_mul(t5,t0,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t5,4,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t3,Xr,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_mul(t3,Xi,t2,MPFR_RNDN);
mpfr_mul(t2,t5,t3,MPFR_RNDN);
mpfr_mul_ui(t3,t2,4,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_sqr(t5,Xi,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t8,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t5,t8,MPFR_RNDN);
mpfr_mul(t8,Xi,t0,MPFR_RNDN);
mpfr_mul(t0,t2,t8,MPFR_RNDN);
mpfr_mul_ui(t8,t0,4,MPFR_RNDN);
mpfr_neg(t8,t8,MPFR_RNDN);mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_abs(t6,Xr,MPFR_RNDN);
mpfr_mul(t9,t5,t6,MPFR_RNDN);
mpfr_mul(t6,t2,t9,MPFR_RNDN);
mpfr_mul(t9,t0,t6,MPFR_RNDN);
mpfr_mul_ui(t6,t9,12,MPFR_RNDN);
mpfr_neg(t6,t6,MPFR_RNDN);mpfr_abs(t9,Xi,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_mul(t5,t0,t2,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t0,t5,t2,MPFR_RNDN);
mpfr_mul(t2,t9,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t2,2,MPFR_RNDN);
mpfr_add(t2,t6,t0,MPFR_RNDN);
mpfr_add(t0,t8,t2,MPFR_RNDN);
mpfr_add(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t4,t2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t7,t2,MPFR_RNDN);
mpfr_add(t2,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
mpfr_clear(t7);
mpfr_clear(t8);
mpfr_clear(t9);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,68,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 68 && m_nPower == 6)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000002e-4;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
mpfr_t t4; mpfr_init2(t4, bits);
mpfr_t t5; mpfr_init2(t5, bits);
mpfr_t t6; mpfr_init2(t6, bits);
mpfr_t t7; mpfr_init2(t7, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_sqr(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,1,MPFR_RNDN);
mpfr_neg(t0,t0,MPFR_RNDN);mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_sqr(t2,Xr,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_mul(t1,t3,t2,MPFR_RNDN);
mpfr_mul(t2,Xi,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t2,5,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_mul(t4,t2,t3,MPFR_RNDN);
mpfr_abs(t3,Xr,MPFR_RNDN);
mpfr_mul(t2,Xr,t3,MPFR_RNDN);
mpfr_mul(t3,t4,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t3,5,MPFR_RNDN);
mpfr_sqr(t3,Xi,MPFR_RNDN);
mpfr_sqr(t4,Xr,MPFR_RNDN);
mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_mul(t6,t4,t5,MPFR_RNDN);
mpfr_mul(t5,t3,t6,MPFR_RNDN);
mpfr_mul(t6,Xi,t5,MPFR_RNDN);
mpfr_mul_ui(t5,t6,10,MPFR_RNDN);
mpfr_sqr(t6,Xi,MPFR_RNDN);
mpfr_sqr(t3,Xr,MPFR_RNDN);
mpfr_abs(t4,Xr,MPFR_RNDN);
mpfr_mul(t7,t3,t4,MPFR_RNDN);
mpfr_mul(t4,Xr,t7,MPFR_RNDN);
mpfr_mul(t7,t6,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t7,10,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_sqr(t7,Xr,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_mul(t3,t7,t6,MPFR_RNDN);
mpfr_abs(t6,Xr,MPFR_RNDN);
mpfr_mul(t7,t3,t6,MPFR_RNDN);
mpfr_mul(t6,Xr,t7,MPFR_RNDN);
mpfr_add(t7,t4,t6,MPFR_RNDN);
mpfr_add(t6,t5,t7,MPFR_RNDN);
mpfr_add(t7,t2,t6,MPFR_RNDN);
mpfr_add(t6,t1,t7,MPFR_RNDN);
mpfr_add(t7,t0,t6,MPFR_RNDN);
mpfr_add(t6,Cr,t7,MPFR_RNDN);
mpfr_set(Xrn,t6,MPFR_RNDN);
mpfr_sqr(t6,Xi,MPFR_RNDN);
mpfr_sqr(t7,Xi,MPFR_RNDN);
mpfr_mul(t0,t6,t7,MPFR_RNDN);
mpfr_abs(t7,Xr,MPFR_RNDN);
mpfr_mul(t6,t0,t7,MPFR_RNDN);
mpfr_mul(t7,Xi,t6,MPFR_RNDN);
mpfr_sqr(t6,Xi,MPFR_RNDN);
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t6,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t6,Xr,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t6,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_sqr(t1,Xr,MPFR_RNDN);
mpfr_mul(t2,t6,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t6,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t6,MPFR_RNDN);
mpfr_add(t6,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t6,5,MPFR_RNDN);
mpfr_sqr(t6,Xi,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_abs(t2,Xr,MPFR_RNDN);
mpfr_mul(t5,t0,t2,MPFR_RNDN);
mpfr_mul(t2,t6,t5,MPFR_RNDN);
mpfr_mul(t5,Xi,t2,MPFR_RNDN);
mpfr_sqr(t2,Xi,MPFR_RNDN);
mpfr_sqr(t6,Xr,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t4,t6,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t4,MPFR_RNDN);
mpfr_mul(t4,t2,t0,MPFR_RNDN);
mpfr_add(t0,t5,t4,MPFR_RNDN);
mpfr_mul_ui(t4,t0,10,MPFR_RNDN);
mpfr_neg(t4,t4,MPFR_RNDN);mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_sqr(t5,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,t5,MPFR_RNDN);
mpfr_abs(t5,Xi,MPFR_RNDN);
mpfr_mul(t0,t2,t5,MPFR_RNDN);
mpfr_mul(t5,Xr,t0,MPFR_RNDN);
mpfr_add(t0,t4,t5,MPFR_RNDN);
mpfr_add(t5,t1,t0,MPFR_RNDN);
mpfr_add(t0,t7,t5,MPFR_RNDN);
mpfr_add(t5,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t5,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
mpfr_clear(t4);
mpfr_clear(t5);
mpfr_clear(t6);
mpfr_clear(t7);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,69,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 69 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000004e-7;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sqr(t0,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,1,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,Cr,t2,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_sqr(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,Ai,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul(t0,Ar,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_add(t1,t2,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,70,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 70 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 1.0000000000000004e-7;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_add(t0,Xi2,Xr2,MPFR_RNDN);
mpfr_add(t1,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Ai,Xr2,MPFR_RNDN);
mpfr_mul(t0,Xi,Xr,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,Ar,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,2,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,71,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  if (m_nFractalType == 71 && m_nPower == 2)
  {
    m_nGlitchIter = m_nMaxIter + 1;
    int64_t nMaxIter = m_nMaxIter;
    int64_t i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      const double abs_val = double(Xrd * Xrd + Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= terminate){ \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 2) * exp(2 * A / X) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}



template <typename T>
bool reference
  ( const int m_nFractalType, const int m_nPower
  , T *m_dxr, T *m_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr, const CFixedFloat &Ci
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  )
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,0,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 3:
          return FORMULA(reference,0,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 4:
          return FORMULA(reference,0,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 5:
          return FORMULA(reference,0,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 6:
          return FORMULA(reference,0,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 7:
          return FORMULA(reference,0,7)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 8:
          return FORMULA(reference,0,8)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 9:
          return FORMULA(reference,0,9)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 10:
          return FORMULA(reference,0,10)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,1,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 3:
          return FORMULA(reference,1,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 4:
          return FORMULA(reference,1,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 5:
          return FORMULA(reference,1,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,2,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 3:
          return FORMULA(reference,2,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 4:
          return FORMULA(reference,2,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 5:
          return FORMULA(reference,2,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,3,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 3:
          return FORMULA(reference,3,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 4:
          return FORMULA(reference,3,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 5:
          return FORMULA(reference,3,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,4,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 3:
          return FORMULA(reference,4,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 4:
          return FORMULA(reference,4,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
        case 5:
          return FORMULA(reference,4,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,5,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,6,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,7,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,8,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,9,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,10,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,11,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,12,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,13,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,14,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,15,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,16,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,17,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,18,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,19,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,20,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,21,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,22,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,23,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,24,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,25,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,26,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,27,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,28,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,29,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,30,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,31,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,32,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,33,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,34,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,35,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,36,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,37,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,38,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,39,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,40,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,41,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 1: a * z^2 + z^3 + c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,42,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 2: a * z^2 - z^3 + c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,43,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 3: 2 * z^2 - z^3 + c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,44,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 4: a * z^2 + z^4 + c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,45,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 5: a * z^2 - z^4 + c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,46,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 6: a * z^2 + z^5 + c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,47,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 7: a * z^2 - z^5 + c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,48,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 8: a * z^2 + z^6 + c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,49,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // TheRedshiftRider 9: a * z^2 - z^6 + c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,50,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,51,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // General Quadratic Minus
    case 52:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,52,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // General Quadratic Plus
    case 53:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,53,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 2nd 1x1
    case 54:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,54,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 3rd 1x2
    case 55:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,55,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 3rd 2x1
    case 56:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,56,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 4th 1x3
    case 57:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,57,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 4th 2x2 (aka SimonBrot 4th)
    case 58:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,58,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 4th 3x1
    case 59:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,59,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 5th 1x4
    case 60:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,60,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 5th 2x3
    case 61:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,61,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 5th 3x2
    case 62:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,62,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 5th 4x1
    case 63:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,63,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 6th 1x5
    case 64:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,64,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 6th 2x4 (Simon's Mothbrot)
    case 65:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,65,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 6th 3x3 (aka SimonBrot 6th)
    case 66:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,66,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 6th 4x2
    case 67:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,67,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // Mothbrot 6th 5x1
    case 68:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,68,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // General Abs Quadratic Minus
    case 69:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,69,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // General Abs Quadratic Plus
    case 70:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,70,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
    // z^2 exp(2 a / z) + c
    case 71:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,71,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter
            , Cr, Ci
            , g_SeedR, g_SeedI
            , g_FactorAR, g_FactorAI
            , terminate
            , m_bGlitchLowTolerance
            );
      
      }
      break;
  
  }
  return false;
}

template bool reference<double>
  ( const int m_nFractalType, const int m_nPower
  , double *m_db_dxr, double *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  );
template bool reference<long double>
  ( const int m_nFractalType, const int m_nPower
  , long double *m_db_dxr, long double *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  );
template bool reference<floatexp>
  ( const int m_nFractalType, const int m_nPower
  , floatexp *m_db_dxr, floatexp *m_db_dxi, double *m_db_z
  , bool &m_bStop, int64_t &m_nRDone, int64_t &m_nGlitchIter, int64_t &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate
  , const bool m_bGlitchLowTolerance
  );

#endif

#ifdef PASS3 // perturbation



template <typename T>
bool FORMULA(perturbation,0,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*((Xxr*xi)+(Xi*xr)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((3*((((Xr2-Xi2)*xr)-(((2*Xxr)*Xi)*xi))+(Xr*(xr2-xi2))))+(xr*(xr2-(3*xi2))))+cr);
xin=(((3*((((Xr2-Xi2)*xi)+(((2*Xr)*xr)*Xxi))+(Xi*(xr2-xi2))))+(xi*((3*xr2)-xi2)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=((((((4*(X^3))*x)+((6*(X^2))*(x^2)))+((4*X)*(x^3)))+(x^4))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=(((((((5*(X^4))*x)+((10*(X^3))*(x^2)))+((10*(X^2))*(x^3)))+((5*X)*(x^4)))+(x^5))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=((((((((6*(X^5))*x)+((15*(X^4))*(x^2)))+((20*(X^3))*(x^3)))+((15*(X^2))*(x^4)))+((6*X)*(x^5)))+(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,7)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=(((((((((7*(X^6))*x)+((21*(X^5))*(x^2)))+((35*(X^4))*(x^3)))+((35*(X^3))*(x^4)))+((21*(X^2))*(x^5)))+((7*X)*(x^6)))+(x^7))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,8)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=((((((((((8*(X^7))*x)+((28*(X^6))*(x^2)))+((56*(X^5))*(x^3)))+((70*(X^4))*(x^4)))+((56*(X^3))*(x^5)))+((28*(X^2))*(x^6)))+((8*X)*(x^7)))+(x^8))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,9)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=(((((((((((9*(X^8))*x)+((36*(X^7))*(x^2)))+((84*(X^6))*(x^3)))+((126*(X^5))*(x^4)))+((126*(X^4))*(x^5)))+((84*(X^3))*(x^6)))+((36*(X^2))*(x^7)))+((9*X)*(x^8)))+(x^9))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,10)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=((((((((((((10*(X^9))*x)+((45*(X^8))*(x^2)))+((120*(X^7))*(x^3)))+((210*(X^6))*(x^4)))+((252*(X^5))*(x^5)))+((210*(X^4))*(x^6)))+((120*(X^3))*(x^7)))+((45*(X^2))*(x^8)))+((10*X)*(x^9)))+(x^10))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,1,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,1,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*Xr)*xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,1,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=((((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))-((((12*Xr)*Xr)*Xi)*xi))-((((6*Xr)*Xr)*xi)*xi))-((((12*Xr)*xr)*Xi)*Xi))-((((24*Xr)*xr)*Xi)*xi))-((((12*Xr)*xr)*xi)*xi))-((((6*xr)*xr)*Xi)*Xi))-((((12*xr)*xr)*Xi)*xi))-((((6*xr)*xr)*xi)*xi))+cr);
xin=((((4*((Xr*Xr)-(Xi*Xi)))*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+((4*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi))))*(((((2*xr)*Xr)+(xr*xr))-((2*xi)*Xi))-(xi*xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,1,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(((diffabs(Xr,xr)*(((((Xr*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+((((5*Xi)*Xi)*Xi)*Xi)))+(abs((Xr+xr))*(((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((20*Xi)*Xi)*Xi)*xi))+((((30*Xi)*Xi)*xi)*xi))+((((20*Xi)*xi)*xi)*xi))+((((5*xi)*xi)*xi)*xi))))+cr);
xin=(((diffabs(Xi,xi)*((((((5*Xr)*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+(((Xi*Xi)*Xi)*Xi)))+(abs((Xi+xi))*(((((((((((((((((((20*Xr)*Xr)*Xr)*xr)+((((30*Xr)*Xr)*xr)*xr))+((((20*Xr)*xr)*xr)*xr))+((((5*xr)*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,2,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi)))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,2,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(diffabs((Xr*((Xr*Xr)-((3*Xi)*Xi))),(((xr*(((3*Xr)*Xr)+(xr*xr)))+((3*Xr)*(((xr*xr)-((2*Xi)*xi))-(xi*xi))))-((3*xr)*(((Xi*Xi)+((2*Xi)*xi))+(xi*xi)))))+cr);
xin=(diffabs((Xi*(((3*Xr)*Xr)-(Xi*Xi))),((((3*Xi)*((((2*Xr)*xr)+(xr*xr))-(xi*xi)))+((3*xi)*(((Xr*Xr)+((2*Xr)*xr))+(xr*xr))))-(xi*(((3*Xi)*Xi)+(xi*xi)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,2,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2)))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,2,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,3,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi)))+cr);
xin=((((2*Xr)*xi)+((2*xr)*(Xi+xi)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,3,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((Xr*(Xr2-(3*Xi2))),(((xr*((3*Xr2)+xr2))+((3*Xr)*((xr2-((2*Xi)*xi))-xi2)))-((3*xr)*((Xi2+((2*Xi)*xi))+xi2))))+cr);
xin=(((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*(xi2+(3*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,3,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,3,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((((Xr2*Xr2)*Xr)-(((10*Xr2)*Xr)*Xi2))+(((5*Xr)*Xi2)*Xi2)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,4,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=(ci-(2*(((Xr*xi)+(xr*Xi))+(xr*xi))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,4,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((cr-(xr*((3*Xr2)+xr2)))+((3*Xr)*((xi2+((2*Xi)*xi))-xr2)))+((3*xr)*((Xi2+((2*Xi)*xi))+xi2)));
xin=(((((((((((6*Xr)*Xi)*xr)+((3*Xi)*xr2))-((3*Xi2)*xi))-((3*Xi)*xi2))+((3*Xr2)*xi))+(((6*Xr)*xr)*xi))+((3*xr2)*xi))-(xi2*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,4,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((((((((((((((-12*Xr2)*Xi)*xr)-(((12*Xr)*Xi)*xr2))+(((12*Xr)*Xi2)*xi))+(((12*Xr)*Xi)*xi2))-(((4*Xr2)*Xr)*xi))-(((12*Xr2)*xi)*xr))-(((12*Xr)*xi)*xr2))+(((4*Xr)*xi2)*xi))-(((4*xr2)*xr)*Xi))+(((4*xr)*Xi2)*Xi))+(((12*xr)*Xi2)*xi))+(((12*xr)*Xi)*xi2))-(((4*xr2)*xr)*xi))+(((4*xr)*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,4,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((((((((((((5*Xr2)*Xr2)*xr)+(((10*Xr2)*Xr)*xr2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xr2)*xr2))-((((20*Xr2)*Xr)*Xi)*xi))-(((10*Xr2)*Xr)*xi2))-(((30*Xr2)*xr)*Xi2))-((((60*Xr2)*xr)*Xi)*xi))-(((30*Xr2)*xr)*xi2))-(((30*Xr)*xr2)*Xi2))-((((60*Xr)*xr2)*Xi)*xi))-(((30*Xr)*xr2)*xi2))+((((20*Xr)*Xi2)*Xi)*xi))+(((30*Xr)*Xi2)*xi2))+((((20*Xr)*Xi)*xi2)*xi))+(((5*Xr)*xi2)*xi2))+((xr2*xr2)*xr))-(((10*xr2)*xr)*Xi2))-((((20*xr2)*xr)*Xi)*xi))-(((10*xr2)*xr)*xi2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*Xi2)*Xi)*xi))+(((30*xr)*Xi2)*xi2))+((((20*xr)*Xi)*xi2)*xi))+(((5*xr)*xi2)*xi2))+cr);
xin=(((((((((((((((((((((((((((((-20*Xi)*Xr2)*Xr)*xr)-(((30*Xi)*Xr2)*xr2))-((((20*Xi)*Xr)*xr2)*xr))-(((5*Xi)*xr2)*xr2))+(((30*Xi2)*Xr2)*xi))+(((30*Xi)*Xr2)*xi2))+((((20*Xi2)*Xi)*Xr)*xr))+((((60*Xi2)*Xr)*xr)*xi))+((((60*Xi)*Xr)*xr)*xi2))+(((10*Xi2)*Xi)*xr2))+(((30*Xi2)*xr2)*xi))+(((30*Xi)*xr2)*xi2))-(((5*Xi2)*Xi2)*xi))-(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*xi2)*xi))-(((5*Xi)*xi2)*xi2))-(((5*xi)*Xr2)*Xr2))-((((20*xi)*Xr2)*Xr)*xr))-(((30*xi)*Xr2)*xr2))-((((20*xi)*Xr)*xr2)*xr))-(((5*xi)*xr2)*xr2))+(((10*xi2)*xi)*Xr2))+((((20*xi2)*xi)*Xr)*xr))+(((10*xi2)*xi)*xr2))-((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,5,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=(((((Xr*xi)+(xr*Xi))+(xr*xi))*-2)+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,6,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,7,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,8,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,9,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,10,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(ci-diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2)))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,11,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((((((6*Xr)*((Xi*xr)+(xr*xi)))+((3*Xi)*(xr2-xi2)))+((3*xi)*(Xr2-Xi2)))+(xi*((3*xr2)-xi2)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,12,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*xr)*Xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,13,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,14,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((ci-(diffabs(((3*Xr2)-Xi2),(((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2))*Xi))-(abs(((((((3*Xr2)+((6*Xr)*xr))+(3*xr2))-Xi2)-((2*Xi)*xi))-xi2))*xi));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,15,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,16,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,17,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,18,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,19,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,20,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,21,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,22,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(ci-((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,23,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,24,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,25,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,26,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,27,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,28,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,29,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,30,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,31,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((-(Xi)*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))-(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,32,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((Xi*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))+(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,33,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((Xi2*diffabs(Xi2,(((2*xi)*Xi)+xi2)))-(((4*Xi)*Xr)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))-(Xr2*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-(Xi2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+(Xr2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+((((2*xi)*Xi)+xi2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((4*(((Xi*xr)+(xi*Xr))+(xi*xr)))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))-((((2*Xr)*xr)+xr2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((((2*xi)*Xi)+xi2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+((((2*Xr)*xr)+xr2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+cr);
xin=((((((((((2*Xr2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+(((2*Xr)*Xi)*diffabs(Xr2,(((2*Xr)*xr)+xr2))))-(((2*Xr)*Xi)*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-((2*Xi2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))+((2*(((2*Xr)*xr)+xr2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xr2+((2*Xr)*xr))+xr2))))-((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xi2+((2*xi)*Xi))+xi2))))-((2*(((2*xi)*Xi)+xi2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,34,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,35,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,36,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,37,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,38,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,39,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,40,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xi2*Xi))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xi2*Xi)))+((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr*Xi2)))-((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr*Xi2)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xi)))-((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xr)))+(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xr2*Xr)))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))+((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+cr);
xin=((((((((((((((((((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xi2*Xi))-(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xi2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr*Xi2)))-((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xi)))+((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr2*Xi)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr*Xi2)))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xr2*Xr)))+((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xr)))+((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,41,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=((((xr*((2*Xr)+xr))-(xi*(xi+(2*Xi))))-diffabs(Xr,xr))+cr);
xin=(((diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))*2)-diffabs(Xi,xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,42,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))+((3*X2)*x))+((3*X)*x2))+(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,43,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,44,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((2*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,45,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))+((4*(X^3))*x))+((6*(X^2))*x2))+(((4*X)*x2)*x))+(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,46,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))-((4*(X^3))*x))-((6*(X^2))*x2))-(((4*X)*x2)*x))-(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,47,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))+((5*(X^4))*x))+((10*(X^3))*x2))+(((10*(X^2))*x2)*x))+((5*X)*(x2^2)))+((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,48,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))-((5*(X^4))*x))-((10*(X^3))*x2))-(((10*(X^2))*x2)*x))-((5*X)*(x2^2)))-((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,49,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{const complex<V> x2 = x * x;
xn=((((((((A*(((2*X)*x)+x2))+((6*(X^5))*x))+((15*(X^4))*x2))+((20*(X^3))*(x2*x)))+((15*(X^2))*(x2^2)))+((6*X)*((x2*x2)*x)))+(x2^3))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,50,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=((((((((A*(((2*X)*x)+(x^2)))-((6*(X^5))*x))-((15*(X^4))*(x^2)))-((20*(X^3))*(x^3)))-((15*(X^2))*(x^4)))-((6*X)*(x^5)))-(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,51,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((Xr2-Xi2)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((Xr2+((2*Xr)*xr))+xr2)-Xi2)-((2*Xi)*xi))-xi2))))-(((2*Xr)*Xi)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi)))))-(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+cr);
xin=((((((Xr2-Xi2)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+(((2*Xr)*Xi)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))))+(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((Xr2-Xi2)+((2*Xr)*xr))+xr2)-((2*Xi)*xi))-xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,52,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 52 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=((((((2*xr)*Xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,53,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 53 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=((((((2*xr)*Xr)+(xr*xr))+((2*Xi)*xi))+(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,54,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 54 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((Xr*diffabs(Xr,xr))+((-1*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(xr*abs((Xr+xr))))));
xin=(ci+((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,55,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 55 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs(Xr)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr+xr))*(Xr*diffabs(Xr,xr)))+((-1*((abs(Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xr+xr)))))+((-2*((abs(Xi)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xi+xi)))))+(abs((Xr+xr))*(xr*diffabs(Xr,xr))))))));
xin=(ci+((abs(Xr)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(Xi+xi)))+((-1*((abs(Xi)*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xi+xi)))))+(2*((abs(Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xr+xr)))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,56,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 56 && m_nPower == 3)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+(((Xr*Xr)*diffabs(Xr,xr))+((-1*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((-2*(xi*(xr*abs((Xi+xi)))))+((2*(Xr*(xr*abs((Xr+xr)))))+((-2*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((xr*xr)*abs((Xr+xr)))))))));
xin=(ci+(((Xr*Xr)*diffabs(Xi,xi))+((-1*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((2*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((-2*(Xi*(xi*abs((Xi+xi)))))+((xr*xr)*abs((Xi+xi))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,57,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 57 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs((Xi*Xi))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((-1*((abs((Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))))))+((-2*((abs((Xi*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xi+xi))))))+(abs((Xr*Xr))*(xr*abs((Xr+xr)))))))))));
xin=(ci+((abs((Xr*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+((-1*((abs((Xi*Xi))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi))))))+((2*((abs((Xi*Xr))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((2*((abs((Xi*Xr))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr*Xr))*(xr*abs((Xi+xi)))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,58,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 58 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs(Xi)*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xi*Xi)+(xi*xi))))+((abs((Xr+xr))*((Xr*Xr)*diffabs(Xr,xr)))+((-1*((abs(Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xr*Xr)+(xr*xr))))+(abs((Xr+xr))*(diffabs(Xr,xr)*((Xi*Xi)+(xi*xi))))))))+((2*((abs(Xr)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xi*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xr,xr))))))))+((2*((abs(Xi)*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(Xi,xi))))))+((-4*((abs(Xi)*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(diffabs(Xi,xi)*(Xr+xr)))+((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(Xr,xr)))))))))))));
xin=(ci+((2*((abs(Xi)*((xr*xr)*abs((Xr+xr))))+((abs(Xr)*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs(Xr,xr)))))))+((-2*((abs(Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((xi*xi)*diffabs(Xi,xi))))))+((2*((abs(Xr)*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(Xi,xi))))))+((2*((abs(Xi)*((Xr*Xr)*diffabs(Xr,xr)))+((abs(Xr)*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs(Xr,xr)))+((Xr*Xr)*diffabs(Xi,xi)))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs(Xi,xi)))))+((2*((Xi*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((-2*((abs(Xi)*(((Xi*Xi)*diffabs(Xr,xr))+(Xi*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(Xi,xi))))))+((4*((abs(Xi)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xi,xi))))))+((-4*((abs(Xi)*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xi,xi))))))+(2*(abs((Xr+xr))*((xr*xr)*diffabs(Xi,xi)))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,59,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 59 && m_nPower == 4)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+((-3*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((3*(Xr*((xr*xr)*abs((Xr+xr)))))+((-3*(Xr*((xi*xi)*abs((Xr+xr)))))+((3*((Xr*Xr)*(xr*abs((Xr+xr)))))+((-3*((Xi*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((3*(Xi*((xi*xi)*abs((Xi+xi)))))+((-3*((Xi*Xi)*(xr*abs((Xr+xr)))))+((3*((Xi*Xi)*(xi*abs((Xi+xi)))))+((-3*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((-6*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*((xr*xr)*abs((Xr+xr))))))))))))))))));
xin=(ci+((Xr*((Xr*Xr)*diffabs(Xi,xi)))+((-1*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((3*(xi*((xr*xr)*abs((Xr+xr)))))+((-3*((xi*xi)*(xr*abs((Xi+xi)))))+((3*(Xr*((xr*xr)*abs((Xi+xi)))))+((-3*(Xr*((xi*xi)*abs((Xi+xi)))))+((3*((Xi*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-3*(((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xi*((xi*xi)*abs((Xr+xr))))))+((6*(Xr*(xi*(xr*abs((Xr+xr))))))+((-6*(Xi*(xi*(xr*abs((Xi+xi))))))+((6*(Xi*(Xr*(xr*abs((Xr+xr))))))+((-6*(Xi*(Xr*(xi*abs((Xi+xi))))))+(xr*((xr*xr)*abs((Xi+xi)))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,60,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 60 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))+((abs((Xr+xr))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((-1*((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))))+((-3*((abs(((Xi*Xi)*Xr))*(xr*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-3*((abs(((Xi*Xi)*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xr+xr))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))+((-1*((abs((Xi*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))))+((3*((abs((Xi*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi*(Xr*Xr)))*(xi*abs((Xi+xi))))+((abs((Xi+xi))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xi+xi))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,61,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 61 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-2*((abs((Xi*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xr*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xr*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))))+((-2*((abs((Xi*Xi))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xr*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(Xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xr*Xr))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((2*((abs((Xi*Xi))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-2*(abs((Xr*Xr))*(Xi*(Xr*diffabs(Xi,xi)))))+((2*(abs((Xi*Xi))*(Xi*(Xr*diffabs(Xi,xi)))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-4*((abs((Xi*Xr))*((Xi*(xr*abs((Xr+xr))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((4*((abs((Xi*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((2*((abs((Xi*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xr*Xr))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*Xr))*((xi*xi)*abs((Xr+xr))))+(abs((Xr+xr))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((2*(abs((Xr*Xr))*(Xr*(xr*abs((Xi+xi))))))+((-2*(abs((Xi*Xi))*(Xr*(xr*abs((Xi+xi))))))+((2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((2*((abs((Xr*Xr))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-2*((abs((Xi*Xi))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(Xi*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xi*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xr*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((-2*((abs((Xi*Xi))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-4*((abs((Xi*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((4*((abs((Xi*Xr))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xi+xi))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,62,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 62 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs(Xr)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xr,xr))))+((-1*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))+((2*((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))))+((-3*((abs(Xr)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xr,xr))))))+((3*((abs(Xi)*((xi*xi)*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xr*xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xr*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*((Xr*Xr)*(xr*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs(Xr,xr))))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs(Xi,xi)))))+((-3*(((Xi*Xi)*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((3*((abs(Xi)*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((Xi*((xr*xr)*abs((Xr+xr))))+(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr)))))))+((abs(Xr)*(Xi*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))+(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))))))+((6*((abs(Xi)*(Xi*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xi,xi)))))))+((-6*((abs(Xr)*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs(Xr,xr)))))))+((6*((abs(Xi)*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs(Xi,xi)))))))+((-6*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))))+((6*((abs(Xi)*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-12*((abs(Xi)*((Xi*(Xr*(xr*abs((Xr+xr)))))+(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xi,xi))))+(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xr,xr))))))))))))))))))))))));
xin=(ci+((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+((-1*((abs(Xr)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*diffabs(Xr,xr)))))))+((2*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(xi*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*((xr*xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs(Xr,xr))))))+((-3*((abs(Xi)*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs(Xi,xi))))))+((3*((abs(Xr)*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(Xi*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+((abs(Xr)*((Xi*Xi)*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xr,xr))))))))+((3*((abs(Xi)*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xi,xi))))))+((6*((abs(Xi)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xr*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xi,xi)))))))+((6*((abs(Xi)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs(Xr)*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xr,xr))))+((Xr*Xr)*(xr*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(Xi*(Xr*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xi)*(Xi*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xi,xi)))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,63,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 63 && m_nPower == 5)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xr+xr)))+((-4*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((4*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-4*((Xi*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((4*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+((-4*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((4*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-6*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*abs((Xr+xr))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((-12*((Xi*(xi*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))))+((12*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((-12*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((12*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((-12*(Xi*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((12*((Xi*Xi)*(xi*(xr*abs((Xi+xi))))))+((-12*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+((12*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))));
xin=(ci+((diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xi+xi)))+((4*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+((-4*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((4*(Xr*(xr*((xr*xr)*abs((Xi+xi))))))+((-4*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+((4*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-4*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+((4*(Xi*((Xi*Xi)*(xi*abs((Xi+xi))))))+((-6*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xi+xi)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*((xi*xi)*abs((Xi+xi))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xi+xi)))))+((12*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+((-12*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+((12*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+((-12*(Xi*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))+((12*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((-12*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((12*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((-12*(((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xi*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xi+xi)))))))+(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,64,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 64 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs(((Xi*Xi)*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs(((Xr*Xr)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((-1*((abs(Xi)*(Xi*(diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))+(((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi))))*(abs((((Xi*Xi)*(Xi*Xi))+((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi))))))+abs((((Xr*Xr)*(Xr*Xr))+((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xi+xi)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xr+xr)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xr+xr)))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xi,xi))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xi,xi))))+((-4*(abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xr,xr))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xr,xr))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xr+xr)))))))))))))))))))))))))))));
xin=(ci+((abs(((Xi*Xi)*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs(((Xr*Xr)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xi+xi)))+((4*(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((-4*(abs((Xr+xr))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xr+xr)))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xr+xr))))+(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xi+xi))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*((abs((Xi+xi))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr)))))))))))+((-4*(abs((Xr+xr))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xr,xr))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xi,xi)))))+((4*(abs((Xi+xi))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi+xi))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xi,xi))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xi+xi))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xi+xi)))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,65,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 65 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))))))+((-2*(abs((Xr*(Xr*Xr)))*(xi*(xr*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xr*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xr*(Xr*Xr)))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xi*((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xi+xi))))+((abs((Xi+xi))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xi+xi))))+((abs((Xi+xi))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xr+xr)))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*(xr*abs((Xi+xi))))+(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((2*((abs((Xi*(Xi*Xi)))*((Xi*(xr*abs((Xi+xi))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xr*(Xr*Xr)))*((Xi*(xr*abs((Xr+xr))))+(Xr*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))))+(Xr*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))+(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xr*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xr+xr))))+(abs((Xr+xr))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xr+xr))))+((abs((Xi+xi))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi+xi))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((6*((abs((Xi*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*Xr))*((Xi*(xr*abs((Xr+xr))))+(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi*(Xr*Xr)))*((Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr+xr))*((Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,66,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 66 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-1*((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-2*((abs((Xi*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-2*((abs((Xi*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(Xi*((Xi*Xi)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-3*(abs((Xr*Xr))*(xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((xi*xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*(abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-3*(abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*(abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xr*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xr+xr))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((6*((abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-6*(abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((6*((abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-6*((abs((Xi*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-1*((abs((Xi*Xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((2*((abs((Xi*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((3*((abs((Xr*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((xi*xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*((abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-6*((abs((Xi*Xr))*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((-6*((abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((6*((abs((Xi*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xi+xi))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((6*(abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((-6*((abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(((Xi*Xi)*(xr*abs((Xr+xr))))+(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-12*((abs((Xi*Xr))*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,67,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 67 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((((xi*xi)*(xi*xi))*abs((Xr*(Xr+xr))))+((abs(Xr)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-1*(((Xi*Xi)*((xr*xr)*(xr*xr)))+((xi*xi)*(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-2*(Xi*(xi*(((Xr*Xr)*(Xr*Xr))+((xr*xr)*(xr*xr))))))+((4*((abs(Xr)*(Xr*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*(Xr*((xi*xi)*(xr*(xr*xr)))))+((4*((abs(Xr)*(Xr*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))+((-4*(Xr*((Xr*Xr)*((xi*xi)*xr))))+((4*((abs(Xr)*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((-4*((Xi*Xi)*(Xr*(xr*((Xr*Xr)+(xr*xr))))))+((4*((abs(Xr)*(Xi*((Xi*Xi)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xi*diffabs(Xr,xr)))))))+((-6*((abs(Xr)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*((xr*xr)*diffabs(Xr,xr))))))))+((-6*((abs(Xr)*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*((xi*xi)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*((xi*xi)*diffabs(Xi,xi))))))+((-6*((Xi*(xi*((xi*xi)*(xi*xi))))+(((Xr*Xr)*((xi*xi)*(xr*xr)))+((abs(Xr)*((Xi*Xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*((xr*xr)*diffabs(Xr,xr))))))))+((6*((abs(Xi)*((Xi*Xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*((Xi*Xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xr,xr))))))))+((-6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi)))*(abs(Xi)+abs((Xi+xi)))))+((-6*((Xi*(((Xi*Xi)*(Xi*Xi))*xi))+((Xi*Xi)*((Xr*Xr)*(xr*xr)))))+((-8*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xr*(xi*((xi*xi)*abs((Xr+xr)))))+(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xr*(xi*((xi*xi)*diffabs(Xi,xi))))+(xi*((xi*xi)*(xr*diffabs(Xi,xi))))))))+((-8*((Xi*(Xr*(((Xr*Xr)*(xi*xr))+(xi*(xr*(xr*xr))))))+((abs(Xi)*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))))+((8*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xr)*(Xr*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*xi)*(xr*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*((Xr*Xr)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((-12*((Xi*((Xr*Xr)*(xi*(xr*xr))))+((abs(Xr)*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xr*diffabs(Xr,xr))))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi)))))))+((-15*((((Xi*Xi)*(Xi*Xi))*(xi*xi))+((Xi*Xi)*((xi*xi)*(xi*xi)))))+((-20*(Xi*((Xi*Xi)*(xi*(xi*xi)))))+((-24*((abs(Xi)*(((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))+(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+(abs((Xr+xr))*(((Xr*Xr)*(xi*(xr*diffabs(Xi,xi))))+(Xr*(xi*((xr*xr)*diffabs(Xi,xi))))))))+((24*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-24*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs(Xr)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((24*((abs(Xi)*(Xi*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))))+((abs((Xi+xi))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi))))))))+((-24*((abs(Xi)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))))+((24*((abs(Xi)*((Xi*Xi)*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(((xr*xr)*(xr*xr))*abs((Xr*(Xr+xr))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((2*((abs((Xi*(Xr+xr)))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))+((abs(Xi)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+((xi*xi)*(xi*xi)))))))))+((4*((abs(Xr)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(xi*((xi*xi)*(xr*diffabs(Xr,xr)))))))))+((4*((abs(Xi)*(xi*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-4*((abs(Xr)*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((4*((abs(Xi)*(Xr*(xi*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xr*((Xr*Xr)*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xr*(xi*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))))+((-4*((abs(Xi)*(Xr*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((4*((abs(Xr)*(Xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(Xi*(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((4*((Xi*(Xr*((Xr*Xr)*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((-4*((abs(Xi)*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((abs(Xr)*(Xi*((Xi*Xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xr*diffabs(Xr,xr)))))))))+((4*(abs((Xi+xi))*(Xi*((Xi*Xi)*(xr*diffabs(Xi,xi))))))+((-4*((Xi*((Xi*Xi)*(Xr*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((4*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+(abs((Xi+xi))*(Xi*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xi*(((Xi*Xi)*(xi*abs((Xr+xr))))+(xi*((xi*xi)*abs((Xr+xr))))))+(Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+(xr*((xr*xr)*abs((Xr+xr))))))))+(abs((Xr+xr))*((Xi*(((Xi*Xi)*(xi*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+(Xr*(((Xr*Xr)*(xr*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))))+((-12*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))))+((12*((abs(Xr)*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((-12*((abs(Xi)*(Xr*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((12*((abs(Xi)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xr*Xr)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-12*((abs(Xi)*((Xr*Xr)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs(Xr)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*((xi*xi)*(xr*diffabs(Xr,xr))))+((Xr*Xr)*((xi*xi)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xr*xr)*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xr,xr)))))))))+((12*((abs(Xi)*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(((Xi*Xi)*((xr*xr)*abs((Xr+xr))))+(Xi*((Xr*Xr)*(xr*abs((Xi+xi)))))))+((abs(Xr)*((Xi*Xi)*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*((Xi*Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*((Xi*Xi)*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xi*diffabs(Xi,xi)))))))+((-12*((abs(Xi)*((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi))))))+((-24*((abs(Xi)*(((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))+((Xi*(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr))))))+(Xr*((xi*xi)*(xr*abs((Xr+xr))))))))+(abs((Xr+xr))*(((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi))))+((Xi*(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))))+((-48*((abs(Xi)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(((xr*xr)*(xr*xr))*diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,68,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 68 && m_nPower == 6)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr)))+((-1*((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xi,xi)))+(xi*(((xi*xi)*(xi*xi))*abs((Xi+xi))))))+((-5*(xi*(((xr*xr)*(xr*xr))*abs((Xi+xi)))))+((5*((((Xr*Xr)*(Xr*Xr))*(xr*abs((Xr+xr))))+((Xr*(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+(((xi*xi)*(xi*xi))*(xr*abs((Xr+xr)))))))+((-5*((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi))+(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+(((Xr*Xr)*(Xr*Xr))*(xi*abs((Xi+xi))))))+((5*(((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr))))))+((-5*(((Xi*Xi)*(Xi*Xi))*(xi*abs((Xi+xi)))))+((-10*((xi*xi)*(xr*((xr*xr)*abs((Xr+xr))))))+((10*((Xr*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))+(xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))))+((-10*(((Xi*Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((10*(Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))))+((-10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xi+xi))))))+((-20*(Xr*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xr*(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-20*((Xi*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*(xr*abs((Xi+xi))))))))+((20*(Xi*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((-20*(Xi*(Xr*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*(Xr*(xi*((xi*xi)*abs((Xr+xr)))))))+((-20*(Xi*(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((20*(Xi*((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))))+((-30*(((Xr*Xr)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xr*((xi*xi)*((xr*xr)*abs((Xr+xr)))))))+((30*(Xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((-30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((30*(((Xi*Xi)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xr+xr))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xr+xr))))))+((-30*((Xi*Xi)*((Xr*Xr)*(xr*abs((Xr+xr))))))+((30*((Xi*Xi)*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-60*(Xi*(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+((60*(Xi*(Xr*((xi*xi)*(xr*abs((Xi+xi)))))))+((-60*(Xi*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((60*((Xi*Xi)*(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))))))))))))))));
xin=(ci+((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xr,xr)))+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi)))+((xi*(((xi*xi)*(xi*xi))*abs((Xr+xr))))+((5*((((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr))+(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+((((Xr*Xr)*(Xr*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((Xr*(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+((((xi*xi)*(xi*xi))*(xr*abs((Xi+xi))))+(xi*(((xr*xr)*(xr*xr))*abs((Xr+xr))))))))))+((-10*((xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((xi*xi)*(xr*((xr*xr)*abs((Xi+xi)))))))+((10*((Xr*Xr)*(xr*((xr*xr)*abs((Xi+xi))))))+((-10*((Xr*Xr)*(xi*((xi*xi)*abs((Xr+xr))))))+((10*(Xr*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((-10*(((Xi*Xi)*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((10*((Xi*Xi)*(xi*((xi*xi)*abs((Xr+xr))))))+((-10*((Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr))))))+((Xi*Xi)*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xr+xr))))))+((20*(Xr*(xi*(xr*((xr*xr)*abs((Xr+xr)))))))+((-20*(Xr*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((20*(Xr*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((-20*(Xi*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi))))))))+((-20*(Xi*(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((20*(Xi*((Xi*Xi)*(xi*(xr*abs((Xi+xi)))))))+((-20*(Xi*((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))))+((20*(Xi*((Xi*Xi)*(Xr*(xi*abs((Xi+xi)))))))+((-30*(Xr*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((30*((Xr*Xr)*(xi*((xr*xr)*abs((Xr+xr))))))+((-30*((Xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*(xr*abs((Xi+xi)))))))+((30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xr+xr))))))+((-30*(((Xi*Xi)*(xi*((xr*xr)*abs((Xr+xr)))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((30*((Xi*Xi)*((xi*xi)*(xr*abs((Xi+xi))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xi+xi))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xi+xi))))))+((-30*((Xi*Xi)*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-60*(((Xi*Xi)*(Xr*(xi*(xr*abs((Xr+xr))))))+(Xi*(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,69,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 69 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((-1*(xi*xi))+((2*(Xr*xr))+((-2*(Xi*xi))+(xr*xr)))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,70,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 70 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      using V = T;
      V dummy;
      (void) dummy;
{xrn=(cr+((xi*xi)+((2*((Xi*xi)+(Xr*xr)))+(xr*xr))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,71,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 71 && m_nPower == 2)
  {
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
      using V = T;
      V dummy;
      (void) dummy;
{xn=(((((x+(2*X))*x)*exp(((2*A)/Xx)))+(((2*(X^2))*sinh(((-(A)*x)/(Xx*X))))*exp(((A*(x+(2*X)))/(Xx*X)))))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool perturbation
  ( const int m_nFractalType, const int m_nPower
  , const T *m_dxr, const T *m_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr, T &xi
  , const T &cr, const T &ci
  )
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 3:
          return FORMULA(perturbation,0,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 4:
          return FORMULA(perturbation,0,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 5:
          return FORMULA(perturbation,0,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 6:
          return FORMULA(perturbation,0,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 7:
          return FORMULA(perturbation,0,7)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 8:
          return FORMULA(perturbation,0,8)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 9:
          return FORMULA(perturbation,0,9)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 10:
          return FORMULA(perturbation,0,10)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 3:
          return FORMULA(perturbation,1,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 4:
          return FORMULA(perturbation,1,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 5:
          return FORMULA(perturbation,1,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 3:
          return FORMULA(perturbation,2,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 4:
          return FORMULA(perturbation,2,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 5:
          return FORMULA(perturbation,2,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 3:
          return FORMULA(perturbation,3,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 4:
          return FORMULA(perturbation,3,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 5:
          return FORMULA(perturbation,3,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 3:
          return FORMULA(perturbation,4,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 4:
          return FORMULA(perturbation,4,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
        case 5:
          return FORMULA(perturbation,4,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 1: a * z^2 + z^3 + c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 2: a * z^2 - z^3 + c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 3: 2 * z^2 - z^3 + c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 4: a * z^2 + z^4 + c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 5: a * z^2 - z^4 + c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 6: a * z^2 + z^5 + c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 7: a * z^2 - z^5 + c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 8: a * z^2 + z^6 + c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // TheRedshiftRider 9: a * z^2 - z^6 + c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // General Quadratic Minus
    case 52:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,52,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // General Quadratic Plus
    case 53:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,53,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 2nd 1x1
    case 54:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,54,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 3rd 1x2
    case 55:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,55,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 3rd 2x1
    case 56:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,56,3)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 4th 1x3
    case 57:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,57,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 4th 2x2 (aka SimonBrot 4th)
    case 58:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,58,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 4th 3x1
    case 59:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,59,4)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 5th 1x4
    case 60:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,60,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 5th 2x3
    case 61:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,61,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 5th 3x2
    case 62:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,62,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 5th 4x1
    case 63:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,63,5)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 6th 1x5
    case 64:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,64,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 6th 2x4 (Simon's Mothbrot)
    case 65:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,65,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 6th 3x3 (aka SimonBrot 6th)
    case 66:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,66,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 6th 4x2
    case 67:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,67,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // Mothbrot 6th 5x1
    case 68:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,68,6)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // General Abs Quadratic Minus
    case 69:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,69,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // General Abs Quadratic Plus
    case 70:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,70,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
    // z^2 exp(2 a / z) + c
    case 71:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,71,2)
            ( m_nFractalType, m_nPower
            , m_dxr, m_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            );
      
      }
      break;
  
  }
  return false;
}

template bool perturbation<double>
  ( const int m_nFractalType, const int m_nPower
  , const double *m_dxr, const double *m_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double &xr, double &xi
  , const double &cr, const double &ci
  );
template bool perturbation<long double>
  ( const int m_nFractalType, const int m_nPower
  , const long double *m_dxr, const long double *m_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , long double &xr, long double &xi
  , const long double &cr, const long double &ci
  );
template bool perturbation<floatexp>
  ( const int m_nFractalType, const int m_nPower
  , const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , floatexp &xr, floatexp &xi
  , const floatexp &cr, const floatexp &ci
  );

#endif

#ifdef PASS4 // perturbation with derivatives



template <typename T>
bool FORMULA(perturbation,0,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        if (type_0_power_2_pixel_has_glitched(cr, ci, xr, xi, Xr, Xi, dr / h, di / h, e, h)) // FIXME matrix derivatives
        {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

        }

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

{drn=((2*((Xxr*dr)-(Xxi*di)))+dr0);
din=((2*((Xxi*dr)+(Xxr*di)))+di0);
}

{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*((Xxr*xi)+(Xi*xr)))+ci);
}


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

{drn=((((3*(Xxr2-Xxi2))*dr)-((6*(Xxi*Xxr))*di))+dr0);
din=((((3*(Xxr2-Xxi2))*di)+((6*(Xxi*Xxr))*dr))+di0);
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((3*((((Xr2-Xi2)*xr)-(((2*Xxr)*Xi)*xi))+(Xr*(xr2-xi2))))+(xr*(xr2-(3*xi2))))+cr);
xin=(((3*((((Xr2-Xi2)*xi)+(((2*Xr)*xr)*Xxi))+(Xi*(xr2-xi2))))+(xi*((3*xr2)-xi2)))+ci);
}


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((4*d)*(Xx^3))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((4*(X^3))*x)+((6*(X^2))*(x^2)))+((4*X)*(x^3)))+(x^4))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((5*d)*(Xx^4))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((5*(X^4))*x)+((10*(X^3))*(x^2)))+((10*(X^2))*(x^3)))+((5*X)*(x^4)))+(x^5))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((6*d)*(Xx^5))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((6*(X^5))*x)+((15*(X^4))*(x^2)))+((20*(X^3))*(x^3)))+((15*(X^2))*(x^4)))+((6*X)*(x^5)))+(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,7)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((7*d)*(Xx^6))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((((7*(X^6))*x)+((21*(X^5))*(x^2)))+((35*(X^4))*(x^3)))+((35*(X^3))*(x^4)))+((21*(X^2))*(x^5)))+((7*X)*(x^6)))+(x^7))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,8)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((8*d)*(Xx^7))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((((8*(X^7))*x)+((28*(X^6))*(x^2)))+((56*(X^5))*(x^3)))+((70*(X^4))*(x^4)))+((56*(X^3))*(x^5)))+((28*(X^2))*(x^6)))+((8*X)*(x^7)))+(x^8))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,9)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((9*d)*(Xx^8))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((((((9*(X^8))*x)+((36*(X^7))*(x^2)))+((84*(X^6))*(x^3)))+((126*(X^5))*(x^4)))+((126*(X^4))*(x^5)))+((84*(X^3))*(x^6)))+((36*(X^2))*(x^7)))+((9*X)*(x^8)))+(x^9))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,10)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((10*d)*(Xx^9))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((((((10*(X^9))*x)+((45*(X^8))*(x^2)))+((120*(X^7))*(x^3)))+((210*(X^6))*(x^4)))+((252*(X^5))*(x^5)))+((210*(X^4))*(x^6)))+((120*(X^3))*(x^7)))+((45*(X^2))*(x^8)))+((10*X)*(x^9)))+(x^10))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,1,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba));
dybn=((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb));
}

{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,1,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+daa)));
dxbn=((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+dab)));
dyan=((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+dba)));
dybn=((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*Xr)*xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,1,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+daa))));
dxbn=((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+dab))));
dyan=((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba))));
dybn=((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb))));
}

{xrn=((((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))-((((12*Xr)*Xr)*Xi)*xi))-((((6*Xr)*Xr)*xi)*xi))-((((12*Xr)*xr)*Xi)*Xi))-((((24*Xr)*xr)*Xi)*xi))-((((12*Xr)*xr)*xi)*xi))-((((6*xr)*xr)*Xi)*Xi))-((((12*xr)*xr)*Xi)*xi))-((((6*xr)*xr)*xi)*xi))+cr);
xin=((((4*((Xr*Xr)-(Xi*Xi)))*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+((4*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi))))*(((((2*xr)*Xr)+(xr*xr))-((2*xi)*Xi))-(xi*xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,1,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+daa)))));
dxbn=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+dab)))));
dyan=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+dba)))));
dybn=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+dbb)))));
}

{xrn=(((diffabs(Xr,xr)*(((((Xr*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+((((5*Xi)*Xi)*Xi)*Xi)))+(abs((Xr+xr))*(((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((20*Xi)*Xi)*Xi)*xi))+((((30*Xi)*Xi)*xi)*xi))+((((20*Xi)*xi)*xi)*xi))+((((5*xi)*xi)*xi)*xi))))+cr);
xin=(((diffabs(Xi,xi)*((((((5*Xr)*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+(((Xi*Xi)*Xi)*Xi)))+(abs((Xi+xi))*(((((((((((((((((((20*Xr)*Xr)*Xr)*xr)+((((30*Xr)*Xr)*xr)*xr))+((((20*Xr)*xr)*xr)*xr))+((((5*xr)*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,2,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba));
dybn=((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb));
}

{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi)))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,2,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa)));
dxbn=((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab)));
dyan=((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{xrn=(diffabs((Xr*((Xr*Xr)-((3*Xi)*Xi))),(((xr*(((3*Xr)*Xr)+(xr*xr)))+((3*Xr)*(((xr*xr)-((2*Xi)*xi))-(xi*xi))))-((3*xr)*(((Xi*Xi)+((2*Xi)*xi))+(xi*xi)))))+cr);
xin=(diffabs((Xi*(((3*Xr)*Xr)-(Xi*Xi))),((((3*Xi)*((((2*Xr)*xr)+(xr*xr))-(xi*xi)))+((3*xi)*(((Xr*Xr)+((2*Xr)*xr))+(xr*xr))))-(xi*(((3*Xi)*Xi)+(xi*xi)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,2,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2)))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,2,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,3,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((2*(Xxi*dxa))+((2*(Xxr*dya))+dba));
dybn=((2*(Xxi*dxb))+((2*(Xxr*dyb))+dbb));
}

{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi)))+cr);
xin=((((2*Xr)*xi)+((2*xr)*(Xi+xi)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,3,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa)));
dxbn=((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab)));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((Xr*(Xr2-(3*Xi2))),(((xr*((3*Xr2)+xr2))+((3*Xr)*((xr2-((2*Xi)*xi))-xi2)))-((3*xr)*((Xi2+((2*Xi)*xi))+xi2))))+cr);
xin=(((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*(xi2+(3*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,3,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,3,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((((Xr2*Xr2)*Xr)-(((10*Xr2)*Xr)*Xi2))+(((5*Xr)*Xi2)*Xi2)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,4,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((-2*(Xxi*dya))+((2*(Xxr*dxa))+daa));
dxbn=((-2*(Xxi*dyb))+((2*(Xxr*dxb))+dab));
dyan=((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba));
dybn=((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=(ci-(2*(((Xr*xi)+(xr*Xi))+(xr*xi))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,4,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((-6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((-6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((cr-(xr*((3*Xr2)+xr2)))+((3*Xr)*((xi2+((2*Xi)*xi))-xr2)))+((3*xr)*((Xi2+((2*Xi)*xi))+xi2)));
xin=(((((((((((6*Xr)*Xi)*xr)+((3*Xi)*xr2))-((3*Xi2)*xi))-((3*Xi)*xi2))+((3*Xr2)*xi))+(((6*Xr)*xr)*xi))+((3*xr2)*xi))-(xi2*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,4,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+dba))));
dybn=((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((((((((((((((-12*Xr2)*Xi)*xr)-(((12*Xr)*Xi)*xr2))+(((12*Xr)*Xi2)*xi))+(((12*Xr)*Xi)*xi2))-(((4*Xr2)*Xr)*xi))-(((12*Xr2)*xi)*xr))-(((12*Xr)*xi)*xr2))+(((4*Xr)*xi2)*xi))-(((4*xr2)*xr)*Xi))+(((4*xr)*Xi2)*Xi))+(((12*xr)*Xi2)*xi))+(((12*xr)*Xi)*xi2))-(((4*xr2)*xr)*xi))+(((4*xr)*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,4,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab)))));
dyan=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((((((((((((5*Xr2)*Xr2)*xr)+(((10*Xr2)*Xr)*xr2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xr2)*xr2))-((((20*Xr2)*Xr)*Xi)*xi))-(((10*Xr2)*Xr)*xi2))-(((30*Xr2)*xr)*Xi2))-((((60*Xr2)*xr)*Xi)*xi))-(((30*Xr2)*xr)*xi2))-(((30*Xr)*xr2)*Xi2))-((((60*Xr)*xr2)*Xi)*xi))-(((30*Xr)*xr2)*xi2))+((((20*Xr)*Xi2)*Xi)*xi))+(((30*Xr)*Xi2)*xi2))+((((20*Xr)*Xi)*xi2)*xi))+(((5*Xr)*xi2)*xi2))+((xr2*xr2)*xr))-(((10*xr2)*xr)*Xi2))-((((20*xr2)*xr)*Xi)*xi))-(((10*xr2)*xr)*xi2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*Xi2)*Xi)*xi))+(((30*xr)*Xi2)*xi2))+((((20*xr)*Xi)*xi2)*xi))+(((5*xr)*xi2)*xi2))+cr);
xin=(((((((((((((((((((((((((((((-20*Xi)*Xr2)*Xr)*xr)-(((30*Xi)*Xr2)*xr2))-((((20*Xi)*Xr)*xr2)*xr))-(((5*Xi)*xr2)*xr2))+(((30*Xi2)*Xr2)*xi))+(((30*Xi)*Xr2)*xi2))+((((20*Xi2)*Xi)*Xr)*xr))+((((60*Xi2)*Xr)*xr)*xi))+((((60*Xi)*Xr)*xr)*xi2))+(((10*Xi2)*Xi)*xr2))+(((30*Xi2)*xr2)*xi))+(((30*Xi)*xr2)*xi2))-(((5*Xi2)*Xi2)*xi))-(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*xi2)*xi))-(((5*Xi)*xi2)*xi2))-(((5*xi)*Xr2)*Xr2))-((((20*xi)*Xr2)*Xr)*xr))-(((30*xi)*Xr2)*xr2))-((((20*xi)*Xr)*xr2)*xr))-(((5*xi)*xr2)*xr2))+(((10*xi2)*xi)*Xr2))+((((20*xi2)*xi)*Xr)*xr))+(((10*xi2)*xi)*xr2))-((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,5,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba));
dybn=((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=(((((Xr*xi)+(xr*Xi))+(xr*xi))*-2)+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,6,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=(dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya))));
dybn=(dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,7,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=(dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa))));
dybn=(dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,8,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=(dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya))));
dybn=(dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,9,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=(dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa))));
dybn=(dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,10,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=((-3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((-3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(ci-diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2)))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,11,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((((((6*Xr)*((Xi*xr)+(xr*xi)))+((3*Xi)*(xr2-xi2)))+((3*xi)*(Xr2-Xi2)))+(xi*((3*xr2)-xi2)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,12,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((-1*(Xxi*(Xxi*(dya*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dya)))+((3*(Xxr*(Xxr*(dya*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxa)))+dba))));
dybn=((-1*(Xxi*(Xxi*(dyb*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dyb)))+((3*(Xxr*(Xxr*(dyb*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxb)))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*xr)*Xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,13,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,14,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=(dba+((2*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dya)))));
dybn=(dbb+((2*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dyb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((ci-(diffabs(((3*Xr2)-Xi2),(((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2))*Xi))-(abs(((((((3*Xr2)+((6*Xr)*xr))+(3*xr2))-Xi2)-((2*Xi)*xi))-xi2))*xi));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,15,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxr*(Xxr*(Xxr*dxa))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxa)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+daa))));
dxbn=((4*(Xxr*(Xxr*(Xxr*dxb))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxb)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,16,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,17,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,18,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxa))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))+daa))));
dxbn=((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxb))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,19,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dya))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dyb))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,20,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa))));
dxbn=((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab))));
dyan=((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba))));
dybn=((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,21,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,22,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(ci-((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi)));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,23,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab))));
dyan=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,24,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab))));
dyan=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,25,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab))));
dyan=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,26,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab))));
dyan=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,27,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya)))))));
dybn=(dbb+((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,28,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya)))))));
dybn=(dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,29,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,30,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dya)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dya))))))));
dybn=(dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dyb)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dyb))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,31,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa)))))));
dxbn=((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab)))))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya)))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((-(Xi)*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))-(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,32,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa)))))));
dxbn=((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab)))))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((Xi*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))+(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,33,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(abs((Xxr*Xxr))*(Xxr*dxa)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxa)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dya)))+((2*(abs((Xxi*Xxi))*(Xxi*dya)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa))))))))))));
dxbn=((2*(abs((Xxr*Xxr))*(Xxr*dxb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxb)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dyb)))+((2*(abs((Xxi*Xxi))*(Xxi*dyb)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab))))))))))));
dyan=((2*(abs((Xxr*Xxr))*(Xxr*dya)))+((-2*(abs((Xxi*Xxi))*(Xxr*dya)))+((2*(abs((Xxr*Xxr))*(Xxi*dxa)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxa)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi)))))))+dba))))))))))));
dybn=((2*(abs((Xxr*Xxr))*(Xxr*dyb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dyb)))+((2*(abs((Xxr*Xxr))*(Xxi*dxb)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxb)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi)))))))+dbb))))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((Xi2*diffabs(Xi2,(((2*xi)*Xi)+xi2)))-(((4*Xi)*Xr)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))-(Xr2*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-(Xi2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+(Xr2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+((((2*xi)*Xi)+xi2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((4*(((Xi*xr)+(xi*Xr))+(xi*xr)))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))-((((2*Xr)*xr)+xr2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((((2*xi)*Xi)+xi2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+((((2*Xr)*xr)+xr2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+cr);
xin=((((((((((2*Xr2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+(((2*Xr)*Xi)*diffabs(Xr2,(((2*Xr)*xr)+xr2))))-(((2*Xr)*Xi)*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-((2*Xi2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))+((2*(((2*Xr)*xr)+xr2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xr2+((2*Xr)*xr))+xr2))))-((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xi2+((2*xi)*Xi))+xi2))))-((2*(((2*xi)*Xi)+xi2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,34,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,35,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,36,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,37,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,38,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,39,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,40,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dya))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dya))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxa))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxa))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxa))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa))))))))))))))))))))))));
dxbn=((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dyb))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dyb))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxb))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxb))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab))))))))))))))))))))))));
dyan=((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dya))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dya))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+dba))))))))))))))))))))))));
dybn=((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dyb))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dyb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+dbb))))))))))))))))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xi2*Xi))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xi2*Xi)))+((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr*Xi2)))-((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr*Xi2)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xi)))-((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xr)))+(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xr2*Xr)))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))+((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+cr);
xin=((((((((((((((((((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xi2*Xi))-(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xi2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr*Xi2)))-((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xi)))+((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr2*Xi)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr*Xi2)))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xr2*Xr)))+((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xr)))+((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,41,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(daa+((2*(Xxr*dxa))+((-2*(Xxi*dya))+(-1*(dxa*sgn(Xxr))))));
dxbn=(dab+((2*(Xxr*dxb))+((-2*(Xxi*dyb))+(-1*(dxb*sgn(Xxr))))));
dyan=(dba+((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+(-1*(dya*sgn(Xxi))))));
dybn=(dbb+((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+(-1*(dyb*sgn(Xxi))))));
}

{xrn=((((xr*((2*Xr)+xr))-(xi*(xi+(2*Xi))))-diffabs(Xr,xr))+cr);
xin=(((diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))*2)-diffabs(Xi,xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,42,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=((((A*(2*X))+(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))+((3*X2)*x))+((3*X)*x2))+(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,43,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=((((A*(2*X))-(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,44,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=((((4*X)-(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((2*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,45,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+(4*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))+((4*(X^3))*x))+((6*(X^2))*x2))+(((4*X)*x2)*x))+(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,46,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-(4*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))-((4*(X^3))*x))-((6*(X^2))*x2))-(((4*X)*x2)*x))-(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,47,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+((5*X2)*X))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))+((5*(X^4))*x))+((10*(X^3))*x2))+(((10*(X^2))*x2)*x))+((5*X)*(x2^2)))+((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,48,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-((5*X2)*X))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))-((5*(X^4))*x))-((10*(X^3))*x2))-(((10*(X^2))*x2)*x))-((5*X)*(x2^2)))-((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,49,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+((6*X2)*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((((A*(((2*X)*x)+x2))+((6*(X^5))*x))+((15*(X^4))*x2))+((20*(X^3))*(x2*x)))+((15*(X^2))*(x2^2)))+((6*X)*((x2*x2)*x)))+(x2^3))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,50,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-((6*X2)*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((A*(((2*X)*x)+(x^2)))-((6*(X^5))*x))-((15*(X^4))*(x^2)))-((20*(X^3))*(x^3)))-((15*(X^2))*(x^4)))-((6*X)*(x^5)))-(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,51,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(Xxr*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxa)))+((-2*(Xxi*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dya)))+((2*(Xxi*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa))))))))));
dxbn=((2*(Xxr*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxb)))+((-2*(Xxi*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dyb)))+((2*(Xxi*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab))))))))));
dyan=((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))))))))));
dybn=((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((Xr2-Xi2)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((Xr2+((2*Xr)*xr))+xr2)-Xi2)-((2*Xi)*xi))-xi2))))-(((2*Xr)*Xi)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi)))))-(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+cr);
xin=((((((Xr2-Xi2)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+(((2*Xr)*Xi)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))))+(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((Xr2-Xi2)+((2*Xr)*xr))+xr2)-((2*Xi)*xi))-xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,52,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 52 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(((-2*(Xxi*dya))+(2*(Xxr*dxa)))+daa);
dxbn=(((-2*(Xxi*dyb))+(2*(Xxr*dxb)))+dab);
dyan=(((2*(Xxi*(dxa*g_FactorAR)))+((2*(Xxr*(dxa*g_FactorAI)))+(2*(Xxr*(dya*g_FactorAR)))))+dba);
dybn=(((2*(Xxi*(dxb*g_FactorAR)))+((2*(Xxr*(dxb*g_FactorAI)))+(2*(Xxr*(dyb*g_FactorAR)))))+dbb);
}

{xrn=((((((2*xr)*Xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,53,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 53 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(((2*(Xxi*dya))+(2*(Xxr*dxa)))+daa);
dxbn=(((2*(Xxi*dyb))+(2*(Xxr*dxb)))+dab);
dyan=(((2*(Xxi*(dxa*g_FactorAR)))+((2*(Xxr*(dxa*g_FactorAI)))+(2*(Xxr*(dya*g_FactorAR)))))+dba);
dybn=(((2*(Xxi*(dxb*g_FactorAR)))+((2*(Xxr*(dxb*g_FactorAI)))+(2*(Xxr*(dyb*g_FactorAR)))))+dbb);
}

{xrn=((((((2*xr)*Xr)+(xr*xr))+((2*Xi)*xi))+(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,54,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 54 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(daa+((Xxr*(dxa*sgn(Xxr)))+((dxa*abs(Xxr))+(-1*((Xxi*(dya*sgn(Xxi)))+(dya*abs(Xxi)))))));
dxbn=(dab+((Xxr*(dxb*sgn(Xxr)))+((dxb*abs(Xxr))+(-1*((Xxi*(dyb*sgn(Xxi)))+(dyb*abs(Xxi)))))));
dyan=(dba+((Xxi*(dxa*sgn(Xxr)))+((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr))))));
dybn=(dbb+((Xxi*(dxb*sgn(Xxr)))+((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr))))));
}

{xrn=(cr+((Xr*diffabs(Xr,xr))+((-1*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(xr*abs((Xr+xr))))));
xin=(ci+((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,55,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 55 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(daa+((abs(Xxr)*(dxa*abs(Xxr)))+((-1*(abs(Xxi)*(dxa*abs(Xxi))))+((-2*(sgn(Xxi)*((Xxi*(dya*abs(Xxr)))+(Xxr*(dya*abs(Xxi))))))+((2*(sgn(Xxr)*(Xxr*(dxa*abs(Xxr)))))+(-2*((sgn(Xxr)*(Xxi*(dxa*abs(Xxi))))+(abs(Xxi)*(dya*abs(Xxr))))))))));
dxbn=(dab+((abs(Xxr)*(dxb*abs(Xxr)))+((-1*(abs(Xxi)*(dxb*abs(Xxi))))+((-2*(sgn(Xxi)*((Xxi*(dyb*abs(Xxr)))+(Xxr*(dyb*abs(Xxi))))))+((2*(sgn(Xxr)*(Xxr*(dxb*abs(Xxr)))))+(-2*((sgn(Xxr)*(Xxi*(dxb*abs(Xxi))))+(abs(Xxi)*(dyb*abs(Xxr))))))))));
dyan=(dba+((-1*(abs(Xxi)*(dya*abs(Xxi))))+((2*((abs(Xxi)*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*(dxa*abs(Xxr)))+(Xxr*(dxa*abs(Xxi))))))))+((-2*(sgn(Xxi)*(Xxi*(dya*abs(Xxi)))))+(abs(Xxr)*(dya*abs(Xxr)))))));
dybn=(dbb+((-1*(abs(Xxi)*(dyb*abs(Xxi))))+((2*((abs(Xxi)*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*(dxb*abs(Xxr)))+(Xxr*(dxb*abs(Xxi))))))))+((-2*(sgn(Xxi)*(Xxi*(dyb*abs(Xxi)))))+(abs(Xxr)*(dyb*abs(Xxr)))))));
}

{xrn=(cr+((abs(Xr)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr+xr))*(Xr*diffabs(Xr,xr)))+((-1*((abs(Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xr+xr)))))+((-2*((abs(Xi)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xi+xi)))))+(abs((Xr+xr))*(xr*diffabs(Xr,xr))))))));
xin=(ci+((abs(Xr)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(Xi+xi)))+((-1*((abs(Xi)*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xi+xi)))))+(2*((abs(Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xr+xr)))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,56,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 56 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(((Xxr*Xxr)*(dxa*sgn(Xxr)))+((-1*((Xxi*Xxi)*(dxa*sgn(Xxr))))+((-2*(Xxr*(dya*abs(Xxi))))+((2*(Xxr*(dxa*abs(Xxr))))+((-2*(Xxi*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr))))))+daa)))));
dxbn=(((Xxr*Xxr)*(dxb*sgn(Xxr)))+((-1*((Xxi*Xxi)*(dxb*sgn(Xxr))))+((-2*(Xxr*(dyb*abs(Xxi))))+((2*(Xxr*(dxb*abs(Xxr))))+((-2*(Xxi*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dab)))));
dyan=(((Xxr*Xxr)*(dya*sgn(Xxi)))+((-1*((Xxi*Xxi)*(dya*sgn(Xxi))))+((2*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((-2*(Xxi*(dya*abs(Xxi))))+((2*(Xxi*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr)))))+dba)))));
dybn=(((Xxr*Xxr)*(dyb*sgn(Xxi)))+((-1*((Xxi*Xxi)*(dyb*sgn(Xxi))))+((2*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((-2*(Xxi*(dyb*abs(Xxi))))+((2*(Xxi*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr)))))+dbb)))));
}

{xrn=(cr+(((Xr*Xr)*diffabs(Xr,xr))+((-1*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((-2*(xi*(xr*abs((Xi+xi)))))+((2*(Xr*(xr*abs((Xr+xr)))))+((-2*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((xr*xr)*abs((Xr+xr)))))))));
xin=(ci+(((Xr*Xr)*diffabs(Xi,xi))+((-1*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((2*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((-2*(Xi*(xi*abs((Xi+xi)))))+((xr*xr)*abs((Xi+xi))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,57,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 57 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(daa+((abs((Xxi*Xxi))*(dya*abs(Xxi)))+((abs((Xxr*Xxr))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dya*abs((Xxi*Xxi)))))+((sgn(Xxr)*(Xxr*(dxa*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dya*abs((Xxr*Xxr)))))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*Xxi))))))))+((-2*((abs((Xxi*Xxr))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+(sgn(Xxi)*((Xxr*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((2*((sgn(Xxr)*sgn(Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dya*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs(Xxr)))+(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*(dxa*abs(Xxi)))))))))+((2*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dya*abs(Xxi)))))+(-1*(abs((Xxr*Xxr))*(dya*abs(Xxi))))))))))))));
dxbn=(dab+((abs((Xxi*Xxi))*(dyb*abs(Xxi)))+((abs((Xxr*Xxr))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dyb*abs((Xxi*Xxi)))))+((sgn(Xxr)*(Xxr*(dxb*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dyb*abs((Xxr*Xxr)))))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*Xxi))))))))+((-2*((abs((Xxi*Xxr))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+(sgn(Xxi)*((Xxr*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((2*((sgn(Xxr)*sgn(Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dyb*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs(Xxr)))+(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*(dxb*abs(Xxi)))))))))+((2*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dyb*abs(Xxi)))))+(-1*(abs((Xxr*Xxr))*(dyb*abs(Xxi))))))))))))));
dyan=(dba+((abs((Xxr*Xxr))*(dxa*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dya*abs((Xxr*Xxr)))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dya*abs((Xxi*Xxi)))))+(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*Xxi))))))))+((-2*(abs((Xxi*Xxr))*(dya*abs(Xxi))))+((2*((abs((Xxi*Xxr))*(dxa*abs(Xxr)))+((sgn(Xxi)*(sgn(Xxr)*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*(Xxi*(dya*abs((Xxi*Xxr)))))+(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dya*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dya*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*(Xxr*(dxa*abs(Xxr))))+((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxi)))))))+(abs((Xxr*Xxr))*(dya*abs(Xxr)))))))))))));
dybn=(dbb+((abs((Xxr*Xxr))*(dxb*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxr*Xxr)))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxi*Xxi)))))+(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*Xxi))))))))+((-2*(abs((Xxi*Xxr))*(dyb*abs(Xxi))))+((2*((abs((Xxi*Xxr))*(dxb*abs(Xxr)))+((sgn(Xxi)*(sgn(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*(Xxi*(dyb*abs((Xxi*Xxr)))))+(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dyb*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dyb*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*(Xxr*(dxb*abs(Xxr))))+((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxi)))))))+(abs((Xxr*Xxr))*(dyb*abs(Xxr)))))))))))));
}

{xrn=(cr+((abs((Xi*Xi))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((-1*((abs((Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))))))+((-2*((abs((Xi*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xi+xi))))))+(abs((Xr*Xr))*(xr*abs((Xr+xr)))))))))));
xin=(ci+((abs((Xr*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+((-1*((abs((Xi*Xi))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi))))))+((2*((abs((Xi*Xr))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((2*((abs((Xi*Xr))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr*Xr))*(xr*abs((Xi+xi)))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,58,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 58 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*(abs(Xxr)*(Xxr*(dxa*abs(Xxr)))))+((-2*((abs(Xxi)*(Xxr*(dxa*abs(Xxi))))+(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-2*((abs(Xxr)*(Xxi*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((2*((abs(Xxi)*(Xxi*(dya*abs(Xxi))))+(sgn(Xxi)*((Xxi*Xxi)*(dya*abs(Xxi))))))+((-4*((abs(Xxi)*((Xxi*(dxa*abs(Xxr)))+(Xxr*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxi))))))))+daa))))));
dxbn=((2*(abs(Xxr)*(Xxr*(dxb*abs(Xxr)))))+((-2*((abs(Xxi)*(Xxr*(dxb*abs(Xxi))))+(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-2*((abs(Xxr)*(Xxi*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((2*((abs(Xxi)*(Xxi*(dyb*abs(Xxi))))+(sgn(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxi))))))+((-4*((abs(Xxi)*((Xxi*(dxb*abs(Xxr)))+(Xxr*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxi))))))))+dab))))));
dyan=((2*(abs(Xxr)*(Xxr*(dya*abs(Xxr)))))+((-2*(abs(Xxi)*(Xxr*(dya*abs(Xxi)))))+((2*((abs(Xxr)*(Xxi*(dxa*abs(Xxr))))+(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))))+((-2*(abs(Xxi)*(Xxi*(dxa*abs(Xxi)))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((-2*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxi))))))+((4*(abs(Xxi)*(Xxr*(dxa*abs(Xxr)))))+((-4*((abs(Xxi)*(Xxi*(dya*abs(Xxr))))+(sgn(Xxi)*(Xxi*(Xxr*(dya*abs(Xxi)))))))+((4*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+dba)))))))));
dybn=((2*(abs(Xxr)*(Xxr*(dyb*abs(Xxr)))))+((-2*(abs(Xxi)*(Xxr*(dyb*abs(Xxi)))))+((2*((abs(Xxr)*(Xxi*(dxb*abs(Xxr))))+(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((-2*(abs(Xxi)*(Xxi*(dxb*abs(Xxi)))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((-2*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxi))))))+((4*(abs(Xxi)*(Xxr*(dxb*abs(Xxr)))))+((-4*((abs(Xxi)*(Xxi*(dyb*abs(Xxr))))+(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxi)))))))+((4*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dbb)))))))));
}

{xrn=(cr+((abs(Xi)*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xi*Xi)+(xi*xi))))+((abs((Xr+xr))*((Xr*Xr)*diffabs(Xr,xr)))+((-1*((abs(Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xr*Xr)+(xr*xr))))+(abs((Xr+xr))*(diffabs(Xr,xr)*((Xi*Xi)+(xi*xi))))))))+((2*((abs(Xr)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xi*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xr,xr))))))))+((2*((abs(Xi)*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(Xi,xi))))))+((-4*((abs(Xi)*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(diffabs(Xi,xi)*(Xr+xr)))+((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(Xr,xr)))))))))))));
xin=(ci+((2*((abs(Xi)*((xr*xr)*abs((Xr+xr))))+((abs(Xr)*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs(Xr,xr)))))))+((-2*((abs(Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((xi*xi)*diffabs(Xi,xi))))))+((2*((abs(Xr)*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(Xi,xi))))))+((2*((abs(Xi)*((Xr*Xr)*diffabs(Xr,xr)))+((abs(Xr)*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs(Xr,xr)))+((Xr*Xr)*diffabs(Xi,xi)))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs(Xi,xi)))))+((2*((Xi*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((-2*((abs(Xi)*(((Xi*Xi)*diffabs(Xr,xr))+(Xi*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(Xi,xi))))))+((4*((abs(Xi)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xi,xi))))))+((-4*((abs(Xi)*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xi,xi))))))+(2*(abs((Xr+xr))*((xr*xr)*diffabs(Xi,xi)))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,59,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 59 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((Xxi*((Xxi*Xxi)*(dya*sgn(Xxi))))+((Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))+((-3*((Xxr*Xxr)*(dya*abs(Xxi))))+((3*(((Xxi*Xxi)*(dya*abs(Xxi)))+((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-3*(((Xxi*Xxi)*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((-6*(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+daa))))));
dxbn=((Xxi*((Xxi*Xxi)*(dyb*sgn(Xxi))))+((Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))+((-3*((Xxr*Xxr)*(dyb*abs(Xxi))))+((3*(((Xxi*Xxi)*(dyb*abs(Xxi)))+((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-3*(((Xxi*Xxi)*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((-6*(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dab))))));
dyan=((Xxr*((Xxr*Xxr)*(dya*sgn(Xxi))))+((-1*(Xxi*((Xxi*Xxi)*(dxa*sgn(Xxr)))))+((3*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((-3*((Xxi*Xxi)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((3*(Xxi*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((-3*((Xxi*Xxi)*(Xxr*(dya*sgn(Xxi)))))+((-6*(Xxi*(Xxr*(dya*abs(Xxi)))))+((6*(Xxi*(Xxr*(dxa*abs(Xxr)))))+dba))))))));
dybn=((Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi))))+((-1*(Xxi*((Xxi*Xxi)*(dxb*sgn(Xxr)))))+((3*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((-3*((Xxi*Xxi)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((3*(Xxi*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((-3*((Xxi*Xxi)*(Xxr*(dyb*sgn(Xxi)))))+((-6*(Xxi*(Xxr*(dyb*abs(Xxi)))))+((6*(Xxi*(Xxr*(dxb*abs(Xxr)))))+dbb))))))));
}

{xrn=(cr+((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+((-3*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((3*(Xr*((xr*xr)*abs((Xr+xr)))))+((-3*(Xr*((xi*xi)*abs((Xr+xr)))))+((3*((Xr*Xr)*(xr*abs((Xr+xr)))))+((-3*((Xi*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((3*(Xi*((xi*xi)*abs((Xi+xi)))))+((-3*((Xi*Xi)*(xr*abs((Xr+xr)))))+((3*((Xi*Xi)*(xi*abs((Xi+xi)))))+((-3*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((-6*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*((xr*xr)*abs((Xr+xr))))))))))))))))));
xin=(ci+((Xr*((Xr*Xr)*diffabs(Xi,xi)))+((-1*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((3*(xi*((xr*xr)*abs((Xr+xr)))))+((-3*((xi*xi)*(xr*abs((Xi+xi)))))+((3*(Xr*((xr*xr)*abs((Xi+xi)))))+((-3*(Xr*((xi*xi)*abs((Xi+xi)))))+((3*((Xi*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-3*(((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xi*((xi*xi)*abs((Xr+xr))))))+((6*(Xr*(xi*(xr*abs((Xr+xr))))))+((-6*(Xi*(xi*(xr*abs((Xi+xi))))))+((6*(Xi*(Xr*(xr*abs((Xr+xr))))))+((-6*(Xi*(Xr*(xi*abs((Xi+xi))))))+(xr*((xr*xr)*abs((Xi+xi)))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,60,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 60 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(daa+((abs((Xxi*(Xxi*Xxi)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((abs((Xxr*(Xxr*Xxr)))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dya*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxi*(dxa*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dxa*abs((Xxr*(Xxr*Xxr)))))))+((-1*(sgn(Xxi)*(Xxi*(dya*abs((Xxr*(Xxr*Xxr)))))))+((-3*(abs((Xxi*(Xxr*Xxr)))*(dya*abs(Xxr))))+((3*(abs(((Xxi*Xxi)*Xxr))*(dya*abs(Xxi))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxa*abs(Xxr)))+((abs((Xxi*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*((Xxr*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxr*(dxa*abs(((Xxi*Xxi)*Xxr)))))))))+((3*((sgn(Xxi)*(Xxi*(dya*abs(((Xxi*Xxi)*Xxr)))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-3*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*((Xxi*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*((Xxi*Xxi)*(dya*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+(-1*(abs((Xxr*(Xxr*Xxr)))*(dya*abs(Xxi)))))))))))))))))));
dxbn=(dab+((abs((Xxi*(Xxi*Xxi)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((abs((Xxr*(Xxr*Xxr)))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxi*(dxb*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dxb*abs((Xxr*(Xxr*Xxr)))))))+((-1*(sgn(Xxi)*(Xxi*(dyb*abs((Xxr*(Xxr*Xxr)))))))+((-3*(abs((Xxi*(Xxr*Xxr)))*(dyb*abs(Xxr))))+((3*(abs(((Xxi*Xxi)*Xxr))*(dyb*abs(Xxi))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxb*abs(Xxr)))+((abs((Xxi*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*((Xxr*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxr*(dxb*abs(((Xxi*Xxi)*Xxr)))))))))+((3*((sgn(Xxi)*(Xxi*(dyb*abs(((Xxi*Xxi)*Xxr)))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-3*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*((Xxi*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*((Xxi*Xxi)*(dyb*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+(-1*(abs((Xxr*(Xxr*Xxr)))*(dyb*abs(Xxi)))))))))))))))))));
dyan=(dba+((abs((Xxi*(Xxi*Xxi)))*(dya*abs(Xxi)))+((abs((Xxr*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*((Xxi*(dya*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dya*abs((Xxr*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxr*(Xxr*Xxr))))))+((-1*((abs((Xxi*(Xxi*Xxi)))*(dxa*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dya*abs(Xxr)))+(abs((Xxi*(Xxr*Xxr)))*(dya*abs(Xxi)))))+((3*(abs((Xxi*(Xxr*Xxr)))*(dxa*abs(Xxr))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxa*abs(Xxi)))+(sgn(Xxi)*(Xxr*(dya*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*((Xxr*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((-3*((sgn(Xxi)*((Xxi*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(dxa*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxa*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((-6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+(abs((Xxr*(Xxr*Xxr)))*(dya*abs(Xxr)))))))))))))))))));
dybn=(dbb+((abs((Xxi*(Xxi*Xxi)))*(dyb*abs(Xxi)))+((abs((Xxr*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*((Xxi*(dyb*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dyb*abs((Xxr*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxr*(Xxr*Xxr))))))+((-1*((abs((Xxi*(Xxi*Xxi)))*(dxb*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dyb*abs(Xxr)))+(abs((Xxi*(Xxr*Xxr)))*(dyb*abs(Xxi)))))+((3*(abs((Xxi*(Xxr*Xxr)))*(dxb*abs(Xxr))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxb*abs(Xxi)))+(sgn(Xxi)*(Xxr*(dyb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*((Xxr*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((-3*((sgn(Xxi)*((Xxi*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(dxb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxb*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((-6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+(abs((Xxr*(Xxr*Xxr)))*(dyb*abs(Xxr)))))))))))))))))));
}

{xrn=(cr+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))+((abs((Xr+xr))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((-1*((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))))+((-3*((abs(((Xi*Xi)*Xr))*(xr*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-3*((abs(((Xi*Xi)*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xr+xr))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))+((-1*((abs((Xi*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))))+((3*((abs((Xi*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi*(Xr*Xr)))*(xi*abs((Xi+xi))))+((abs((Xi+xi))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xi+xi))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,61,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 61 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dxa*abs((Xxr*Xxr))))))+((-1*(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dxa*abs((Xxi*Xxi)))))))+((-2*(abs((Xxr*Xxr))*(Xxr*(dya*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxr*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxr*(dxa*abs(Xxr))))))+((-2*((abs((Xxi*Xxi))*(Xxr*(dxa*abs(Xxr))))+(sgn(Xxi)*(((Xxr*Xxr)*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dya*abs(Xxr)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dya*abs(Xxr)))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dxa*abs(Xxi)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dxa*abs(Xxi)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxr*Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((2*(sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))))+((-4*(abs((Xxi*Xxr))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+((4*(abs((Xxi*Xxr))*(Xxi*(dya*abs(Xxi)))))+((-4*((abs((Xxi*Xxr))*(Xxi*(dxa*abs(Xxr))))+((sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((4*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+daa)))))))))))))))))))));
dxbn=((sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dxb*abs((Xxr*Xxr))))))+((-1*(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dxb*abs((Xxi*Xxi)))))))+((-2*(abs((Xxr*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxr*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxr*(dxb*abs(Xxr))))))+((-2*((abs((Xxi*Xxi))*(Xxr*(dxb*abs(Xxr))))+(sgn(Xxi)*(((Xxr*Xxr)*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dyb*abs(Xxr)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dyb*abs(Xxr)))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dxb*abs(Xxi)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dxb*abs(Xxi)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxr*Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((2*(sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))))+((-4*(abs((Xxi*Xxr))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+((4*(abs((Xxi*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((-4*((abs((Xxi*Xxr))*(Xxi*(dxb*abs(Xxr))))+((sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((4*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+dab)))))))))))))))))))));
dyan=((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))+((-1*(sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dya*abs((Xxi*Xxi)))))))+((2*(abs((Xxr*Xxr))*(Xxr*(dya*abs(Xxr)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dya*abs(Xxr)))))+((2*(abs((Xxr*Xxr))*(Xxr*(dxa*abs(Xxi)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dxa*abs(Xxi)))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dya*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxi*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxi*(dxa*abs(Xxr))))))+((-2*(abs((Xxi*Xxi))*(Xxi*(dxa*abs(Xxr)))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxr*Xxr)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*Xxi))))))))+((2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-2*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+((2*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))))+((-2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))))+((-4*(abs((Xxi*Xxr))*(Xxr*(dya*abs(Xxi)))))+((4*(abs((Xxi*Xxr))*(Xxr*(dxa*abs(Xxr)))))+((-4*((abs((Xxi*Xxr))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(sgn(Xxi)*((Xxi*(Xxr*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((4*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+dba)))))))))))))))))))));
dybn=((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))+((-1*(sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dyb*abs((Xxi*Xxi)))))))+((2*(abs((Xxr*Xxr))*(Xxr*(dyb*abs(Xxr)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dyb*abs(Xxr)))))+((2*(abs((Xxr*Xxr))*(Xxr*(dxb*abs(Xxi)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dxb*abs(Xxi)))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxi*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxi*(dxb*abs(Xxr))))))+((-2*(abs((Xxi*Xxi))*(Xxi*(dxb*abs(Xxr)))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxr*Xxr)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*Xxi))))))))+((2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-2*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+((2*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))))+((-2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))))+((-4*(abs((Xxi*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((4*(abs((Xxi*Xxr))*(Xxr*(dxb*abs(Xxr)))))+((-4*((abs((Xxi*Xxr))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(sgn(Xxi)*((Xxi*(Xxr*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((4*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+dbb)))))))))))))))))))));
}

{xrn=(cr+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-2*((abs((Xi*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xr*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xr*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))))+((-2*((abs((Xi*Xi))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xr*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(Xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xr*Xr))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((2*((abs((Xi*Xi))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-2*(abs((Xr*Xr))*(Xi*(Xr*diffabs(Xi,xi)))))+((2*(abs((Xi*Xi))*(Xi*(Xr*diffabs(Xi,xi)))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-4*((abs((Xi*Xr))*((Xi*(xr*abs((Xr+xr))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((4*((abs((Xi*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((2*((abs((Xi*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xr*Xr))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*Xr))*((xi*xi)*abs((Xr+xr))))+(abs((Xr+xr))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((2*(abs((Xr*Xr))*(Xr*(xr*abs((Xi+xi))))))+((-2*(abs((Xi*Xi))*(Xr*(xr*abs((Xi+xi))))))+((2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((2*((abs((Xr*Xr))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-2*((abs((Xi*Xi))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(Xi*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xi*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xr*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((-2*((abs((Xi*Xi))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-4*((abs((Xi*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((4*((abs((Xi*Xr))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xi+xi))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,62,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 62 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((-2*(sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((-6*((abs(Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dya*abs(Xxr)))))))+((6*(abs(Xxi)*(Xxi*(Xxr*(dya*abs(Xxi))))))+((-6*(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((6*((abs(Xxi)*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxr)*(((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+daa)))))))))));
dxbn=((-2*(sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((-6*((abs(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dyb*abs(Xxr)))))))+((6*(abs(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((-6*(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((6*((abs(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxr)*(((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dab)))))))))));
dyan=((2*((sgn(Xxi)*((Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dya*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dya*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dya*abs(Xxi)))))+((6*((abs(Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr)))))))+((-6*((abs(Xxi)*(Xxi*(Xxr*(dxa*abs(Xxi)))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((6*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-6*((abs(Xxi)*((Xxi*Xxi)*(dxa*abs(Xxr))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dya*abs(Xxr))))))+dba))))))))));
dybn=((2*((sgn(Xxi)*((Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dyb*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxi)))))+((6*((abs(Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr)))))))+((-6*((abs(Xxi)*(Xxi*(Xxr*(dxb*abs(Xxi)))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((6*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-6*((abs(Xxi)*((Xxi*Xxi)*(dxb*abs(Xxr))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxr))))))+dbb))))))))));
}

{xrn=(cr+((abs(Xr)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xr,xr))))+((-1*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))+((2*((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))))+((-3*((abs(Xr)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xr,xr))))))+((3*((abs(Xi)*((xi*xi)*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xr*xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xr*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*((Xr*Xr)*(xr*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs(Xr,xr))))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs(Xi,xi)))))+((-3*(((Xi*Xi)*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((3*((abs(Xi)*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((Xi*((xr*xr)*abs((Xr+xr))))+(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr)))))))+((abs(Xr)*(Xi*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))+(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))))))+((6*((abs(Xi)*(Xi*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xi,xi)))))))+((-6*((abs(Xr)*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs(Xr,xr)))))))+((6*((abs(Xi)*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs(Xi,xi)))))))+((-6*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))))+((6*((abs(Xi)*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-12*((abs(Xi)*((Xi*(Xr*(xr*abs((Xr+xr)))))+(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xi,xi))))+(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xr,xr))))))))))))))))))))))));
xin=(ci+((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+((-1*((abs(Xr)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*diffabs(Xr,xr)))))))+((2*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(xi*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*((xr*xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs(Xr,xr))))))+((-3*((abs(Xi)*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs(Xi,xi))))))+((3*((abs(Xr)*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(Xi*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+((abs(Xr)*((Xi*Xi)*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xr,xr))))))))+((3*((abs(Xi)*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xi,xi))))))+((6*((abs(Xi)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xr*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xi,xi)))))))+((6*((abs(Xi)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs(Xr)*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xr,xr))))+((Xr*Xr)*(xr*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(Xi*(Xr*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xi)*(Xi*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xi,xi)))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,63,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 63 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(((dxa*sgn(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((-4*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))+((4*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-4*(Xxi*(Xxr*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((4*(Xxi*((Xxi*Xxi)*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((-12*(Xxi*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+((12*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))+((-12*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))+daa)))))))));
dxbn=(((dxb*sgn(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((-4*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((4*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-4*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((4*(Xxi*((Xxi*Xxi)*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((-12*(Xxi*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+((12*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))+((-12*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))+dab)))))))));
dyan=(((dya*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((4*((Xxi*(((Xxi*Xxi)*(dya*abs(Xxi)))+(Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))))+(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-4*(Xxi*((Xxi*Xxi)*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dya*sgn(Xxi)))))+((-12*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))+((12*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-12*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+dba)))))));
dybn=(((dyb*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((4*((Xxi*(((Xxi*Xxi)*(dyb*abs(Xxi)))+(Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))))+(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-4*(Xxi*((Xxi*Xxi)*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*sgn(Xxi)))))+((-12*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((12*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-12*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dbb)))))));
}

{xrn=(cr+((diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xr+xr)))+((-4*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((4*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-4*((Xi*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((4*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+((-4*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((4*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-6*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*abs((Xr+xr))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((-12*((Xi*(xi*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))))+((12*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((-12*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((12*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((-12*(Xi*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((12*((Xi*Xi)*(xi*(xr*abs((Xi+xi))))))+((-12*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+((12*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))));
xin=(ci+((diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xi+xi)))+((4*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+((-4*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((4*(Xr*(xr*((xr*xr)*abs((Xi+xi))))))+((-4*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+((4*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-4*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+((4*(Xi*((Xi*Xi)*(xi*abs((Xi+xi))))))+((-6*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xi+xi)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*((xi*xi)*abs((Xi+xi))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xi+xi)))))+((12*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+((-12*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+((12*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+((-12*(Xi*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))+((12*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((-12*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((12*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((-12*(((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xi*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xi+xi)))))))+(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,64,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 64 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=(daa+(((dxa*abs(Xxr))*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))+((sgn(Xxr)*(Xxr*(dxa*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-1*((abs(((Xxi*Xxi)*(Xxi*Xxi)))*(dya*abs(Xxi)))+(sgn(Xxi)*(Xxi*(dya*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dya*abs(Xxr))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dya*abs(Xxr))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxa*abs(Xxi))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxa*abs(Xxi))))+((-4*(sgn(Xxi)*(Xxr*(dya*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxr*(dya*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))))+((4*(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-4*(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((6*(abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dya*abs(Xxi))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dxa*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxa*abs(((Xxi*Xxi)*(Xxr*Xxr))))))))+((6*(sgn(Xxi)*(Xxi*(dya*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+(-1*(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dya*abs(Xxi))))))))))))))))))))))))))));
dxbn=(dab+(((dxb*abs(Xxr))*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))+((sgn(Xxr)*(Xxr*(dxb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-1*((abs(((Xxi*Xxi)*(Xxi*Xxi)))*(dyb*abs(Xxi)))+(sgn(Xxi)*(Xxi*(dyb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dyb*abs(Xxr))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dyb*abs(Xxr))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxb*abs(Xxi))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxb*abs(Xxi))))+((-4*(sgn(Xxi)*(Xxr*(dyb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxr*(dyb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))))+((4*(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-4*(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((6*(abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dyb*abs(Xxi))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dxb*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxb*abs(((Xxi*Xxi)*(Xxr*Xxr))))))))+((6*(sgn(Xxi)*(Xxi*(dyb*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+(-1*(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dyb*abs(Xxi))))))))))))))))))))))))))));
dyan=(dba+((abs(((Xxi*Xxi)*(Xxi*Xxi)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dya*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxa*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dya*abs(Xxi))))+((4*((abs((Xxi*((Xxi*Xxi)*Xxr)))*(dya*abs(Xxi)))+(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxa*abs(Xxr)))))+((-4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxa*abs(Xxr))))+((4*(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((-4*(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi))))))+((-4*(sgn(Xxi)*(Xxi*(dya*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxi*(dya*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*((((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-4*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dya*abs(((Xxi*Xxi)*(Xxr*Xxr))))))+(sgn(Xxr)*(Xxi*(dxa*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((12*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))))+(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dya*abs(Xxr)))))))))))))))))))))))));
dybn=(dbb+((abs(((Xxi*Xxi)*(Xxi*Xxi)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dyb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dyb*abs(Xxi))))+((4*((abs((Xxi*((Xxi*Xxi)*Xxr)))*(dyb*abs(Xxi)))+(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxb*abs(Xxr)))))+((-4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxb*abs(Xxr))))+((4*(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((-4*(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi))))))+((-4*(sgn(Xxi)*(Xxi*(dyb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxi*(dyb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*((((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-4*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dyb*abs(((Xxi*Xxi)*(Xxr*Xxr))))))+(sgn(Xxr)*(Xxi*(dxb*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((12*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))))+(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dyb*abs(Xxr)))))))))))))))))))))))));
}

{xrn=(cr+((abs(((Xi*Xi)*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs(((Xr*Xr)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((-1*((abs(Xi)*(Xi*(diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))+(((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi))))*(abs((((Xi*Xi)*(Xi*Xi))+((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi))))))+abs((((Xr*Xr)*(Xr*Xr))+((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xi+xi)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xr+xr)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xr+xr)))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xi,xi))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xi,xi))))+((-4*(abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xr,xr))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xr,xr))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xr+xr)))))))))))))))))))))))))))));
xin=(ci+((abs(((Xi*Xi)*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs(((Xr*Xr)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xi+xi)))+((4*(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((-4*(abs((Xr+xr))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xr+xr)))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xr+xr))))+(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xi+xi))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*((abs((Xi+xi))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr)))))))))))+((-4*(abs((Xr+xr))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xr,xr))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xi,xi)))))+((4*(abs((Xi+xi))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi+xi))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xi,xi))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xi+xi))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xi+xi)))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,65,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 65 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((sgn(Xxi)*((Xxr*Xxr)*(dya*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxr*(Xxr*Xxr))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs((Xxi*(Xxi*Xxi))))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxr*(Xxr*Xxr))))))))+((-2*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxi)))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxr))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*(dya*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((2*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(dxa*abs(Xxr)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxr*(Xxr*Xxr))))))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((-3*((sgn(Xxi)*(((Xxr*Xxr)*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*(Xxr*Xxr)))))+(((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr))))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr))))))))+((-3*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxr)))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxr*(dya*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxa*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxi))))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dya*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxi))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxr)))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxa*abs(Xxi))))+(sgn(Xxi)*(Xxi*(Xxr*(dya*abs(((Xxi*Xxi)*Xxr))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+(sgn(Xxr)*((Xxi*(Xxr*(dxa*abs((Xxi*(Xxr*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))))+((12*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((-12*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+daa))))))))))))))))))))))));
dxbn=((sgn(Xxi)*((Xxr*Xxr)*(dyb*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxr*(Xxr*Xxr))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs((Xxi*(Xxi*Xxi))))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxr*(Xxr*Xxr))))))))+((-2*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxi)))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxr))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*(dyb*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((2*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(dxb*abs(Xxr)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxr*(Xxr*Xxr))))))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((-3*((sgn(Xxi)*(((Xxr*Xxr)*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*(Xxr*Xxr)))))+(((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr))))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr))))))))+((-3*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxr)))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxi))))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dyb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxi))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxr)))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxb*abs(Xxi))))+(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(((Xxi*Xxi)*Xxr))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+(sgn(Xxr)*((Xxi*(Xxr*(dxb*abs((Xxi*(Xxr*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))))+((12*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((-12*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+dab))))))))))))))))))))))));
dyan=((sgn(Xxi)*((Xxr*Xxr)*(dya*abs((Xxr*(Xxr*Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxi*(Xxi*Xxi))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs((Xxr*(Xxr*Xxr))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dya*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dxa*abs(Xxr))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxi))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((abs((Xxr*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxr))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*(Xxi*Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxr*(Xxr*Xxr)))))))))))+((-3*(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(((Xxi*Xxi)*Xxr))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr))))))+(sgn(Xxr)*(((Xxr*Xxr)*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi))))))))+((-3*((sgn(Xxi)*(((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr)))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((3*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr))))))+((-3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi))))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dya*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxi))))))+((6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxr)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxa*abs(Xxi))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxr))))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxi*(dya*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxa*abs(Xxr))))+((abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxi))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*(Xxr*Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(((Xxi*Xxi)*Xxr))))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+(((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))*(sgn(Xxi)+sgn(Xxr))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+dba))))))))))))))))))));
dybn=((sgn(Xxi)*((Xxr*Xxr)*(dyb*abs((Xxr*(Xxr*Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxi*(Xxi*Xxi))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs((Xxr*(Xxr*Xxr))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dyb*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dxb*abs(Xxr))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxi))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((abs((Xxr*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxr))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*(Xxi*Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxr*(Xxr*Xxr)))))))))))+((-3*(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(((Xxi*Xxi)*Xxr))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr))))))+(sgn(Xxr)*(((Xxr*Xxr)*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi))))))))+((-3*((sgn(Xxi)*(((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr)))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((3*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr))))))+((-3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi))))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dyb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxi))))))+((6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxr)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxb*abs(Xxi))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxr))))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxb*abs(Xxr))))+((abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxi))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*(Xxr*Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(((Xxi*Xxi)*Xxr))))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+(((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))*(sgn(Xxi)+sgn(Xxr))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+dbb))))))))))))))))))));
}

{xrn=(cr+((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))))))+((-2*(abs((Xr*(Xr*Xr)))*(xi*(xr*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xr*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xr*(Xr*Xr)))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xi*((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xi+xi))))+((abs((Xi+xi))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xi+xi))))+((abs((Xi+xi))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xr+xr)))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*(xr*abs((Xi+xi))))+(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((2*((abs((Xi*(Xi*Xi)))*((Xi*(xr*abs((Xi+xi))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xr*(Xr*Xr)))*((Xi*(xr*abs((Xr+xr))))+(Xr*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))))+(Xr*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))+(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xr*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xr+xr))))+(abs((Xr+xr))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xr+xr))))+((abs((Xi+xi))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi+xi))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((6*((abs((Xi*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*Xr))*((Xi*(xr*abs((Xr+xr))))+(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi*(Xr*Xr)))*((Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr+xr))*((Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,66,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 66 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxr*Xxr))))))+((-1*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxi*Xxi))))))))+((-2*(sgn(Xxi)*((Xxr*((Xxr*Xxr)*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))))+((2*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))+((-3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dya*abs(Xxi)))))+((3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dxa*abs(Xxr))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))))+((3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dya*abs(Xxi))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs((Xxi*Xxi))))))))+((-3*((abs((Xxi*Xxi))*((Xxi*Xxi)*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxa*abs(Xxr)))))+((-3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxr*Xxr)))))))+((3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxi*Xxi)))))))+((-6*((abs((Xxi*Xxr))*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dya*abs(Xxr)))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dya*abs(Xxr))))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxi))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dxa*abs(Xxi))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+((sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((6*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dya*abs(Xxi))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxr))))))+daa)))))))))))))))))))))))))));
dxbn=((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxr*Xxr))))))+((-1*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxi*Xxi))))))))+((-2*(sgn(Xxi)*((Xxr*((Xxr*Xxr)*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))))+((2*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))+((-3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dxb*abs(Xxr))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))))+((3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxi))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs((Xxi*Xxi))))))))+((-3*((abs((Xxi*Xxi))*((Xxi*Xxi)*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxb*abs(Xxr)))))+((-3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxr*Xxr)))))))+((3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxi*Xxi)))))))+((-6*((abs((Xxi*Xxr))*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxr)))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dyb*abs(Xxr))))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxi))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dxb*abs(Xxi))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+((sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((6*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dab)))))))))))))))))))))))))));
dyan=((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxi*Xxi))))))+((-1*((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxr*Xxr))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr)))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi)))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi)))+(Xxi*(((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dya*abs(Xxr)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dya*abs(Xxr)))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((3*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxr*Xxr)))))))+((-3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxi*Xxi))))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dya*abs(Xxr)))))+((-3*(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((-3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxr*Xxr)))))))+((3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxi*Xxi)))))))+((-6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dya*abs(Xxi)))))+((6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dya*abs(Xxi))))))+((6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dya*abs(Xxi)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxr)))))))+((-6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dxa*abs(Xxr)))))+(sgn(Xxi)*((Xxi*((Xxr*Xxr)*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dya*abs(Xxi))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxr))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+dba))))))))))))))))))))))))))));
dybn=((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxi*Xxi))))))+((-1*((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxr*Xxr))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr)))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi)))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi)))+(Xxi*(((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((3*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxr*Xxr)))))))+((-3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxi*Xxi))))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dyb*abs(Xxr)))))+((-3*(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((-3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxr*Xxr)))))))+((3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxi*Xxi)))))))+((-6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dyb*abs(Xxi)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxr)))))))+((-6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dxb*abs(Xxr)))))+(sgn(Xxi)*((Xxi*((Xxr*Xxr)*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxi))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxr))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+dbb))))))))))))))))))))))))))));
}

{xrn=(cr+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-1*((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-2*((abs((Xi*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-2*((abs((Xi*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(Xi*((Xi*Xi)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-3*(abs((Xr*Xr))*(xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((xi*xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*(abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-3*(abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*(abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xr*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xr+xr))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((6*((abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-6*(abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((6*((abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-6*((abs((Xi*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-1*((abs((Xi*Xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((2*((abs((Xi*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((3*((abs((Xr*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((xi*xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*((abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-6*((abs((Xi*Xr))*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((-6*((abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((6*((abs((Xi*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xi+xi))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((6*(abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((-6*((abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(((Xi*Xi)*(xr*abs((Xr+xr))))+(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-12*((abs((Xi*Xr))*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,67,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 67 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((-2*(sgn(Xxi)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-2*(sgn(Xxi)*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-4*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*dxa))))+((4*(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr))))))+((-4*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*dya)))+((-8*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((-12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((12*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi))))))+((-12*(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((12*((abs(Xxi)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))+(sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((-12*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-24*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((24*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+daa)))))))))))))))));
dxbn=((-2*(sgn(Xxi)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-2*(sgn(Xxi)*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-4*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*dxb))))+((4*(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr))))))+((-4*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*dyb)))+((-8*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((-12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((12*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((-12*(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((12*((abs(Xxi)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))+(sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((-12*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-24*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((24*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+dab)))))))))))))))));
dyan=((2*((sgn(Xxi)*((dya*abs(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))+(sgn(Xxr)*((dxa*abs(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+((-4*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))+(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))))+((4*(abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))+((8*(abs(Xxi)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-8*(sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-8*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+((12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-12*((abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))+(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))))+((12*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+((-12*((sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-24*(abs(Xxi)*(((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dya*abs(Xxr)))))))+dba)))))))))))));
dybn=((2*((sgn(Xxi)*((dyb*abs(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))+(sgn(Xxr)*((dxb*abs(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((-4*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))))+((4*(abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))+((8*(abs(Xxi)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-8*(sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-8*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+((12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-12*((abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))+(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))))+((12*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+((-12*((sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-24*(abs(Xxi)*(((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+dbb)))))))))))));
}

{xrn=(cr+((((xi*xi)*(xi*xi))*abs((Xr*(Xr+xr))))+((abs(Xr)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-1*(((Xi*Xi)*((xr*xr)*(xr*xr)))+((xi*xi)*(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-2*(Xi*(xi*(((Xr*Xr)*(Xr*Xr))+((xr*xr)*(xr*xr))))))+((4*((abs(Xr)*(Xr*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*(Xr*((xi*xi)*(xr*(xr*xr)))))+((4*((abs(Xr)*(Xr*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))+((-4*(Xr*((Xr*Xr)*((xi*xi)*xr))))+((4*((abs(Xr)*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((-4*((Xi*Xi)*(Xr*(xr*((Xr*Xr)+(xr*xr))))))+((4*((abs(Xr)*(Xi*((Xi*Xi)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xi*diffabs(Xr,xr)))))))+((-6*((abs(Xr)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*((xr*xr)*diffabs(Xr,xr))))))))+((-6*((abs(Xr)*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*((xi*xi)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*((xi*xi)*diffabs(Xi,xi))))))+((-6*((Xi*(xi*((xi*xi)*(xi*xi))))+(((Xr*Xr)*((xi*xi)*(xr*xr)))+((abs(Xr)*((Xi*Xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*((xr*xr)*diffabs(Xr,xr))))))))+((6*((abs(Xi)*((Xi*Xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*((Xi*Xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xr,xr))))))))+((-6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi)))*(abs(Xi)+abs((Xi+xi)))))+((-6*((Xi*(((Xi*Xi)*(Xi*Xi))*xi))+((Xi*Xi)*((Xr*Xr)*(xr*xr)))))+((-8*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xr*(xi*((xi*xi)*abs((Xr+xr)))))+(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xr*(xi*((xi*xi)*diffabs(Xi,xi))))+(xi*((xi*xi)*(xr*diffabs(Xi,xi))))))))+((-8*((Xi*(Xr*(((Xr*Xr)*(xi*xr))+(xi*(xr*(xr*xr))))))+((abs(Xi)*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))))+((8*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xr)*(Xr*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*xi)*(xr*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*((Xr*Xr)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((-12*((Xi*((Xr*Xr)*(xi*(xr*xr))))+((abs(Xr)*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xr*diffabs(Xr,xr))))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi)))))))+((-15*((((Xi*Xi)*(Xi*Xi))*(xi*xi))+((Xi*Xi)*((xi*xi)*(xi*xi)))))+((-20*(Xi*((Xi*Xi)*(xi*(xi*xi)))))+((-24*((abs(Xi)*(((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))+(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+(abs((Xr+xr))*(((Xr*Xr)*(xi*(xr*diffabs(Xi,xi))))+(Xr*(xi*((xr*xr)*diffabs(Xi,xi))))))))+((24*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-24*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs(Xr)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((24*((abs(Xi)*(Xi*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))))+((abs((Xi+xi))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi))))))))+((-24*((abs(Xi)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))))+((24*((abs(Xi)*((Xi*Xi)*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(((xr*xr)*(xr*xr))*abs((Xr*(Xr+xr))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((2*((abs((Xi*(Xr+xr)))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))+((abs(Xi)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+((xi*xi)*(xi*xi)))))))))+((4*((abs(Xr)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(xi*((xi*xi)*(xr*diffabs(Xr,xr)))))))))+((4*((abs(Xi)*(xi*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-4*((abs(Xr)*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((4*((abs(Xi)*(Xr*(xi*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xr*((Xr*Xr)*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xr*(xi*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))))+((-4*((abs(Xi)*(Xr*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((4*((abs(Xr)*(Xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(Xi*(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((4*((Xi*(Xr*((Xr*Xr)*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((-4*((abs(Xi)*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((abs(Xr)*(Xi*((Xi*Xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xr*diffabs(Xr,xr)))))))))+((4*(abs((Xi+xi))*(Xi*((Xi*Xi)*(xr*diffabs(Xi,xi))))))+((-4*((Xi*((Xi*Xi)*(Xr*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((4*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+(abs((Xi+xi))*(Xi*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xi*(((Xi*Xi)*(xi*abs((Xr+xr))))+(xi*((xi*xi)*abs((Xr+xr))))))+(Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+(xr*((xr*xr)*abs((Xr+xr))))))))+(abs((Xr+xr))*((Xi*(((Xi*Xi)*(xi*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+(Xr*(((Xr*Xr)*(xr*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))))+((-12*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))))+((12*((abs(Xr)*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((-12*((abs(Xi)*(Xr*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((12*((abs(Xi)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xr*Xr)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-12*((abs(Xi)*((Xr*Xr)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs(Xr)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*((xi*xi)*(xr*diffabs(Xr,xr))))+((Xr*Xr)*((xi*xi)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xr*xr)*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xr,xr)))))))))+((12*((abs(Xi)*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(((Xi*Xi)*((xr*xr)*abs((Xr+xr))))+(Xi*((Xr*Xr)*(xr*abs((Xi+xi)))))))+((abs(Xr)*((Xi*Xi)*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*((Xi*Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*((Xi*Xi)*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xi*diffabs(Xi,xi)))))))+((-12*((abs(Xi)*((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi))))))+((-24*((abs(Xi)*(((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))+((Xi*(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr))))))+(Xr*((xi*xi)*(xr*abs((Xr+xr))))))))+(abs((Xr+xr))*(((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi))))+((Xi*(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))))+((-48*((abs(Xi)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(((xr*xr)*(xr*xr))*diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,68,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 68 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*sgn(Xxr))))+((-1*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*sgn(Xxi)))))+((-5*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi))))+((5*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr))))+((-5*((((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))+(Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*sgn(Xxi))))))+((5*(((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr)))))+((-10*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))))+((10*(Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((20*(Xxi*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((30*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+daa))))))))))));
dxbn=((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*sgn(Xxr))))+((-1*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*sgn(Xxi)))))+((-5*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi))))+((5*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr))))+((-5*((((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))+(Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*sgn(Xxi))))))+((5*(((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr)))))+((-10*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))))+((10*(Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((20*(Xxi*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((30*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+dab))))))))))));
dyan=((Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*sgn(Xxr))))+((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*sgn(Xxi))))+((5*((((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*sgn(Xxr))))+(((Xxr*Xxr)*(Xxr*Xxr))*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-10*((Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dya*sgn(Xxi)))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))+((20*(Xxi*(((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-20*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+dba))))))));
dybn=((Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*sgn(Xxr))))+((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*sgn(Xxi))))+((5*((((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*sgn(Xxr))))+(((Xxr*Xxr)*(Xxr*Xxr))*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-10*((Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi)))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((20*(Xxi*(((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-20*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dbb))))))));
}

{xrn=(cr+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr)))+((-1*((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xi,xi)))+(xi*(((xi*xi)*(xi*xi))*abs((Xi+xi))))))+((-5*(xi*(((xr*xr)*(xr*xr))*abs((Xi+xi)))))+((5*((((Xr*Xr)*(Xr*Xr))*(xr*abs((Xr+xr))))+((Xr*(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+(((xi*xi)*(xi*xi))*(xr*abs((Xr+xr)))))))+((-5*((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi))+(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+(((Xr*Xr)*(Xr*Xr))*(xi*abs((Xi+xi))))))+((5*(((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr))))))+((-5*(((Xi*Xi)*(Xi*Xi))*(xi*abs((Xi+xi)))))+((-10*((xi*xi)*(xr*((xr*xr)*abs((Xr+xr))))))+((10*((Xr*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))+(xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))))+((-10*(((Xi*Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((10*(Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))))+((-10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xi+xi))))))+((-20*(Xr*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xr*(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-20*((Xi*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*(xr*abs((Xi+xi))))))))+((20*(Xi*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((-20*(Xi*(Xr*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*(Xr*(xi*((xi*xi)*abs((Xr+xr)))))))+((-20*(Xi*(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((20*(Xi*((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))))+((-30*(((Xr*Xr)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xr*((xi*xi)*((xr*xr)*abs((Xr+xr)))))))+((30*(Xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((-30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((30*(((Xi*Xi)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xr+xr))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xr+xr))))))+((-30*((Xi*Xi)*((Xr*Xr)*(xr*abs((Xr+xr))))))+((30*((Xi*Xi)*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-60*(Xi*(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+((60*(Xi*(Xr*((xi*xi)*(xr*abs((Xi+xi)))))))+((-60*(Xi*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((60*((Xi*Xi)*(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))))))))))))))));
xin=(ci+((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xr,xr)))+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi)))+((xi*(((xi*xi)*(xi*xi))*abs((Xr+xr))))+((5*((((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr))+(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+((((Xr*Xr)*(Xr*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((Xr*(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+((((xi*xi)*(xi*xi))*(xr*abs((Xi+xi))))+(xi*(((xr*xr)*(xr*xr))*abs((Xr+xr))))))))))+((-10*((xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((xi*xi)*(xr*((xr*xr)*abs((Xi+xi)))))))+((10*((Xr*Xr)*(xr*((xr*xr)*abs((Xi+xi))))))+((-10*((Xr*Xr)*(xi*((xi*xi)*abs((Xr+xr))))))+((10*(Xr*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((-10*(((Xi*Xi)*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((10*((Xi*Xi)*(xi*((xi*xi)*abs((Xr+xr))))))+((-10*((Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr))))))+((Xi*Xi)*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xr+xr))))))+((20*(Xr*(xi*(xr*((xr*xr)*abs((Xr+xr)))))))+((-20*(Xr*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((20*(Xr*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((-20*(Xi*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi))))))))+((-20*(Xi*(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((20*(Xi*((Xi*Xi)*(xi*(xr*abs((Xi+xi)))))))+((-20*(Xi*((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))))+((20*(Xi*((Xi*Xi)*(Xr*(xi*abs((Xi+xi)))))))+((-30*(Xr*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((30*((Xr*Xr)*(xi*((xr*xr)*abs((Xr+xr))))))+((-30*((Xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*(xr*abs((Xi+xi)))))))+((30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xr+xr))))))+((-30*(((Xi*Xi)*(xi*((xr*xr)*abs((Xr+xr)))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((30*((Xi*Xi)*((xi*xi)*(xr*abs((Xi+xi))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xi+xi))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xi+xi))))))+((-30*((Xi*Xi)*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-60*(((Xi*Xi)*(Xr*(xi*(xr*abs((Xr+xr))))))+(Xi*(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))))))))))))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,69,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 69 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((-2*(Xxi*dya))+((2*(Xxr*dxa))+daa));
dxbn=((-2*(Xxi*dyb))+((2*(Xxr*dxb))+dab));
dyan=((2*((g_FactorAI*(Xxr*dxa))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxa*sgn(Xxr)))+(Xxr*(dya*sgn(Xxr))))))))+dba);
dybn=((2*((g_FactorAI*(Xxr*dxb))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxb*sgn(Xxr)))+(Xxr*(dyb*sgn(Xxr))))))))+dbb);
}

{xrn=(cr+((-1*(xi*xi))+((2*(Xr*xr))+((-2*(Xi*xi))+(xr*xr)))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,70,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 70 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dxa = Jxa0, dxb = Jxb0, dya = Jya0, dyb = Jyb0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T dxan, dxbn, dyan, dybn;


      using V = T;
      V dummy;
      (void) dummy;

{dxan=((2*((Xxi*dya)+(Xxr*dxa)))+daa);
dxbn=((2*((Xxi*dyb)+(Xxr*dxb)))+dab);
dyan=((2*((g_FactorAI*(Xxr*dxa))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxa*sgn(Xxr)))+(Xxr*(dya*sgn(Xxr))))))))+dba);
dybn=((2*((g_FactorAI*(Xxr*dxb))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxb*sgn(Xxr)))+(Xxr*(dyb*sgn(Xxr))))))))+dbb);
}

{xrn=(cr+((xi*xi)+((2*((Xi*xi)+(Xr*xr)))+(xr*xr))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dxa; Jxb0 = dxb; Jya0 = dya; Jyb0 = dyb;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,71,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &Jxa0, T &Jxb0, T &Jya0, T &Jyb0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 71 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const T Ar = g_FactorAR;
    const T Ai = g_FactorAI;
    const complex<T> A = { Ar, Ai };
    const complex<T> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr = xr0;
    T xi = xi0;

    T dr = Jxa0, di = Jya0;
    const T dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      const T Xxr2 = Xxr * Xxr;
      const T Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      T xrn, xin;


      T drn, din;


      using V = T;
      V dummy;
      (void) dummy;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=((((2*(Xx-A))*exp(((2*A)/Xx)))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((x+(2*X))*x)*exp(((2*A)/Xx)))+(((2*(X^2))*sinh(((-(A)*x)/(Xx*X))))*exp(((A*(x+(2*X)))/(Xx*X)))))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename T>
bool perturbation
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr, T &xi
  , const T &cr, const T &ci
  , T &Jxa, T &Jxb, T &Jya, T &Jyb
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 3:
          return FORMULA(perturbation,0,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 4:
          return FORMULA(perturbation,0,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 5:
          return FORMULA(perturbation,0,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 6:
          return FORMULA(perturbation,0,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 7:
          return FORMULA(perturbation,0,7)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 8:
          return FORMULA(perturbation,0,8)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 9:
          return FORMULA(perturbation,0,9)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 10:
          return FORMULA(perturbation,0,10)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 3:
          return FORMULA(perturbation,1,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 4:
          return FORMULA(perturbation,1,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 5:
          return FORMULA(perturbation,1,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 3:
          return FORMULA(perturbation,2,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 4:
          return FORMULA(perturbation,2,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 5:
          return FORMULA(perturbation,2,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 3:
          return FORMULA(perturbation,3,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 4:
          return FORMULA(perturbation,3,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 5:
          return FORMULA(perturbation,3,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 3:
          return FORMULA(perturbation,4,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 4:
          return FORMULA(perturbation,4,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
        case 5:
          return FORMULA(perturbation,4,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 1: a * z^2 + z^3 + c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 2: a * z^2 - z^3 + c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 3: 2 * z^2 - z^3 + c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 4: a * z^2 + z^4 + c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 5: a * z^2 - z^4 + c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 6: a * z^2 + z^5 + c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 7: a * z^2 - z^5 + c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 8: a * z^2 + z^6 + c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // TheRedshiftRider 9: a * z^2 - z^6 + c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // General Quadratic Minus
    case 52:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,52,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // General Quadratic Plus
    case 53:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,53,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 2nd 1x1
    case 54:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,54,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 3rd 1x2
    case 55:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,55,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 3rd 2x1
    case 56:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,56,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 4th 1x3
    case 57:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,57,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 4th 2x2 (aka SimonBrot 4th)
    case 58:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,58,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 4th 3x1
    case 59:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,59,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 5th 1x4
    case 60:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,60,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 5th 2x3
    case 61:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,61,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 5th 3x2
    case 62:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,62,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 5th 4x1
    case 63:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,63,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 6th 1x5
    case 64:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,64,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 6th 2x4 (Simon's Mothbrot)
    case 65:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,65,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 6th 3x3 (aka SimonBrot 6th)
    case 66:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,66,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 6th 4x2
    case 67:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,67,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // Mothbrot 6th 5x1
    case 68:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,68,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // General Abs Quadratic Minus
    case 69:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,69,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // General Abs Quadratic Plus
    case 70:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,70,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
    // z^2 exp(2 a / z) + c
    case 71:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,71,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , Jxa, Jxb, Jya, Jyb
            , e, h
            , daa, dab, dba, dbb
            );
      
      }
      break;
  
  }
  return false;
}

template bool perturbation<double>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double &xr0, double &xi0
  , const double &cr, const double &ci
  , double &Jxa0, double &Jxb0, double &Jya0, double &Jyb0
  , const double &e, const double &h
  , const double &daa, const double &dab, const double &dba, const double &dbb
  );
template bool perturbation<long double>
  ( int m_nFractalType, int m_nPower
  , const long double *m_db_dxr, const long double *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , long double &xr0, long double &xi0
  , const long double &cr, const long double &ci
  , long double &Jxa0, long double &Jxb0, long double &Jya0, long double &Jyb0
  , const long double &e, const long double &h
  , const long double &daa, const long double &dab, const long double &dba, const long double &dbb
  );
template bool perturbation<floatexp>
  ( int m_nFractalType, int m_nPower
  , const floatexp *m_db_dxr, const floatexp *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , floatexp &xr0, floatexp &xi0
  , const floatexp &cr, const floatexp &ci
  , floatexp &Jxa0, floatexp &Jxb0, floatexp &Jya0, floatexp &Jyb0
  , const floatexp &e, const floatexp &h
  , const floatexp &daa, const floatexp &dab, const floatexp &dba, const floatexp &dbb
  );

#endif

#ifdef PASS5 // perturbation with SIMD



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*((Xxr*xi)+(Xi*xr)))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*((Xxr*xi)+(Xi*xr)))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((3*((((Xr2-Xi2)*xr)-(((2*Xxr)*Xi)*xi))+(Xr*(xr2-xi2))))+(xr*(xr2-(3*xi2))))+cr);
xin=(((3*((((Xr2-Xi2)*xi)+(((2*Xr)*xr)*Xxi))+(Xi*(xr2-xi2))))+(xi*((3*xr2)-xi2)))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((3*((((Xr2-Xi2)*xr)-(((2*Xxr)*Xi)*xi))+(Xr*(xr2-xi2))))+(xr*(xr2-(3*xi2))))+cr);
xin=(((3*((((Xr2-Xi2)*xi)+(((2*Xr)*xr)*Xxi))+(Xi*(xr2-xi2))))+(xi*((3*xr2)-xi2)))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((4*(X^3))*x)+((6*(X^2))*(x^2)))+((4*X)*(x^3)))+(x^4))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((4*(X^3))*x)+((6*(X^2))*(x^2)))+((4*X)*(x^3)))+(x^4))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((5*(X^4))*x)+((10*(X^3))*(x^2)))+((10*(X^2))*(x^3)))+((5*X)*(x^4)))+(x^5))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((5*(X^4))*x)+((10*(X^3))*(x^2)))+((10*(X^2))*(x^3)))+((5*X)*(x^4)))+(x^5))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((6*(X^5))*x)+((15*(X^4))*(x^2)))+((20*(X^3))*(x^3)))+((15*(X^2))*(x^4)))+((6*X)*(x^5)))+(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((6*(X^5))*x)+((15*(X^4))*(x^2)))+((20*(X^3))*(x^3)))+((15*(X^2))*(x^4)))+((6*X)*(x^5)))+(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,7)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((((7*(X^6))*x)+((21*(X^5))*(x^2)))+((35*(X^4))*(x^3)))+((35*(X^3))*(x^4)))+((21*(X^2))*(x^5)))+((7*X)*(x^6)))+(x^7))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((((7*(X^6))*x)+((21*(X^5))*(x^2)))+((35*(X^4))*(x^3)))+((35*(X^3))*(x^4)))+((21*(X^2))*(x^5)))+((7*X)*(x^6)))+(x^7))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,8)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((((8*(X^7))*x)+((28*(X^6))*(x^2)))+((56*(X^5))*(x^3)))+((70*(X^4))*(x^4)))+((56*(X^3))*(x^5)))+((28*(X^2))*(x^6)))+((8*X)*(x^7)))+(x^8))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((((8*(X^7))*x)+((28*(X^6))*(x^2)))+((56*(X^5))*(x^3)))+((70*(X^4))*(x^4)))+((56*(X^3))*(x^5)))+((28*(X^2))*(x^6)))+((8*X)*(x^7)))+(x^8))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,9)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((((((9*(X^8))*x)+((36*(X^7))*(x^2)))+((84*(X^6))*(x^3)))+((126*(X^5))*(x^4)))+((126*(X^4))*(x^5)))+((84*(X^3))*(x^6)))+((36*(X^2))*(x^7)))+((9*X)*(x^8)))+(x^9))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((((((9*(X^8))*x)+((36*(X^7))*(x^2)))+((84*(X^6))*(x^3)))+((126*(X^5))*(x^4)))+((126*(X^4))*(x^5)))+((84*(X^3))*(x^6)))+((36*(X^2))*(x^7)))+((9*X)*(x^8)))+(x^9))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,10)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((((((10*(X^9))*x)+((45*(X^8))*(x^2)))+((120*(X^7))*(x^3)))+((210*(X^6))*(x^4)))+((252*(X^5))*(x^5)))+((210*(X^4))*(x^6)))+((120*(X^3))*(x^7)))+((45*(X^2))*(x^8)))+((10*X)*(x^9)))+(x^10))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((((((10*(X^9))*x)+((45*(X^8))*(x^2)))+((120*(X^7))*(x^3)))+((210*(X^6))*(x^4)))+((252*(X^5))*(x^5)))+((210*(X^4))*(x^6)))+((120*(X^3))*(x^7)))+((45*(X^2))*(x^8)))+((10*X)*(x^9)))+(x^10))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,1,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,1,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*Xr)*xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*Xr)*xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,1,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=((((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))-((((12*Xr)*Xr)*Xi)*xi))-((((6*Xr)*Xr)*xi)*xi))-((((12*Xr)*xr)*Xi)*Xi))-((((24*Xr)*xr)*Xi)*xi))-((((12*Xr)*xr)*xi)*xi))-((((6*xr)*xr)*Xi)*Xi))-((((12*xr)*xr)*Xi)*xi))-((((6*xr)*xr)*xi)*xi))+cr);
xin=((((4*((Xr*Xr)-(Xi*Xi)))*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+((4*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi))))*(((((2*xr)*Xr)+(xr*xr))-((2*xi)*Xi))-(xi*xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=((((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))-((((12*Xr)*Xr)*Xi)*xi))-((((6*Xr)*Xr)*xi)*xi))-((((12*Xr)*xr)*Xi)*Xi))-((((24*Xr)*xr)*Xi)*xi))-((((12*Xr)*xr)*xi)*xi))-((((6*xr)*xr)*Xi)*Xi))-((((12*xr)*xr)*Xi)*xi))-((((6*xr)*xr)*xi)*xi))+cr);
xin=((((4*((Xr*Xr)-(Xi*Xi)))*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+((4*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi))))*(((((2*xr)*Xr)+(xr*xr))-((2*xi)*Xi))-(xi*xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,1,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(((diffabs(Xr,xr)*(((((Xr*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+((((5*Xi)*Xi)*Xi)*Xi)))+(abs((Xr+xr))*(((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((20*Xi)*Xi)*Xi)*xi))+((((30*Xi)*Xi)*xi)*xi))+((((20*Xi)*xi)*xi)*xi))+((((5*xi)*xi)*xi)*xi))))+cr);
xin=(((diffabs(Xi,xi)*((((((5*Xr)*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+(((Xi*Xi)*Xi)*Xi)))+(abs((Xi+xi))*(((((((((((((((((((20*Xr)*Xr)*Xr)*xr)+((((30*Xr)*Xr)*xr)*xr))+((((20*Xr)*xr)*xr)*xr))+((((5*xr)*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(((diffabs(Xr,xr)*(((((Xr*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+((((5*Xi)*Xi)*Xi)*Xi)))+(abs((Xr+xr))*(((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((20*Xi)*Xi)*Xi)*xi))+((((30*Xi)*Xi)*xi)*xi))+((((20*Xi)*xi)*xi)*xi))+((((5*xi)*xi)*xi)*xi))))+cr);
xin=(((diffabs(Xi,xi)*((((((5*Xr)*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+(((Xi*Xi)*Xi)*Xi)))+(abs((Xi+xi))*(((((((((((((((((((20*Xr)*Xr)*Xr)*xr)+((((30*Xr)*Xr)*xr)*xr))+((((20*Xr)*xr)*xr)*xr))+((((5*xr)*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,2,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi)))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi)))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,2,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(diffabs((Xr*((Xr*Xr)-((3*Xi)*Xi))),(((xr*(((3*Xr)*Xr)+(xr*xr)))+((3*Xr)*(((xr*xr)-((2*Xi)*xi))-(xi*xi))))-((3*xr)*(((Xi*Xi)+((2*Xi)*xi))+(xi*xi)))))+cr);
xin=(diffabs((Xi*(((3*Xr)*Xr)-(Xi*Xi))),((((3*Xi)*((((2*Xr)*xr)+(xr*xr))-(xi*xi)))+((3*xi)*(((Xr*Xr)+((2*Xr)*xr))+(xr*xr))))-(xi*(((3*Xi)*Xi)+(xi*xi)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(diffabs((Xr*((Xr*Xr)-((3*Xi)*Xi))),(((xr*(((3*Xr)*Xr)+(xr*xr)))+((3*Xr)*(((xr*xr)-((2*Xi)*xi))-(xi*xi))))-((3*xr)*(((Xi*Xi)+((2*Xi)*xi))+(xi*xi)))))+cr);
xin=(diffabs((Xi*(((3*Xr)*Xr)-(Xi*Xi))),((((3*Xi)*((((2*Xr)*xr)+(xr*xr))-(xi*xi)))+((3*xi)*(((Xr*Xr)+((2*Xr)*xr))+(xr*xr))))-(xi*(((3*Xi)*Xi)+(xi*xi)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,2,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2)))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2)))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,2,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2)))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2)))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,3,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi)))+cr);
xin=((((2*Xr)*xi)+((2*xr)*(Xi+xi)))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi)))+cr);
xin=((((2*Xr)*xi)+((2*xr)*(Xi+xi)))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,3,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((Xr*(Xr2-(3*Xi2))),(((xr*((3*Xr2)+xr2))+((3*Xr)*((xr2-((2*Xi)*xi))-xi2)))-((3*xr)*((Xi2+((2*Xi)*xi))+xi2))))+cr);
xin=(((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*(xi2+(3*Xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((Xr*(Xr2-(3*Xi2))),(((xr*((3*Xr2)+xr2))+((3*Xr)*((xr2-((2*Xi)*xi))-xi2)))-((3*xr)*((Xi2+((2*Xi)*xi))+xi2))))+cr);
xin=(((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*(xi2+(3*Xi2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,3,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,3,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((((Xr2*Xr2)*Xr)-(((10*Xr2)*Xr)*Xi2))+(((5*Xr)*Xi2)*Xi2)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((((Xr2*Xr2)*Xr)-(((10*Xr2)*Xr)*Xi2))+(((5*Xr)*Xi2)*Xi2)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,4,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=(ci-(2*(((Xr*xi)+(xr*Xi))+(xr*xi))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=(ci-(2*(((Xr*xi)+(xr*Xi))+(xr*xi))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,4,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((cr-(xr*((3*Xr2)+xr2)))+((3*Xr)*((xi2+((2*Xi)*xi))-xr2)))+((3*xr)*((Xi2+((2*Xi)*xi))+xi2)));
xin=(((((((((((6*Xr)*Xi)*xr)+((3*Xi)*xr2))-((3*Xi2)*xi))-((3*Xi)*xi2))+((3*Xr2)*xi))+(((6*Xr)*xr)*xi))+((3*xr2)*xi))-(xi2*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((cr-(xr*((3*Xr2)+xr2)))+((3*Xr)*((xi2+((2*Xi)*xi))-xr2)))+((3*xr)*((Xi2+((2*Xi)*xi))+xi2)));
xin=(((((((((((6*Xr)*Xi)*xr)+((3*Xi)*xr2))-((3*Xi2)*xi))-((3*Xi)*xi2))+((3*Xr2)*xi))+(((6*Xr)*xr)*xi))+((3*xr2)*xi))-(xi2*xi))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,4,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((((((((((((((-12*Xr2)*Xi)*xr)-(((12*Xr)*Xi)*xr2))+(((12*Xr)*Xi2)*xi))+(((12*Xr)*Xi)*xi2))-(((4*Xr2)*Xr)*xi))-(((12*Xr2)*xi)*xr))-(((12*Xr)*xi)*xr2))+(((4*Xr)*xi2)*xi))-(((4*xr2)*xr)*Xi))+(((4*xr)*Xi2)*Xi))+(((12*xr)*Xi2)*xi))+(((12*xr)*Xi)*xi2))-(((4*xr2)*xr)*xi))+(((4*xr)*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((((((((((((((-12*Xr2)*Xi)*xr)-(((12*Xr)*Xi)*xr2))+(((12*Xr)*Xi2)*xi))+(((12*Xr)*Xi)*xi2))-(((4*Xr2)*Xr)*xi))-(((12*Xr2)*xi)*xr))-(((12*Xr)*xi)*xr2))+(((4*Xr)*xi2)*xi))-(((4*xr2)*xr)*Xi))+(((4*xr)*Xi2)*Xi))+(((12*xr)*Xi2)*xi))+(((12*xr)*Xi)*xi2))-(((4*xr2)*xr)*xi))+(((4*xr)*xi2)*xi))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,4,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((((((((((((5*Xr2)*Xr2)*xr)+(((10*Xr2)*Xr)*xr2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xr2)*xr2))-((((20*Xr2)*Xr)*Xi)*xi))-(((10*Xr2)*Xr)*xi2))-(((30*Xr2)*xr)*Xi2))-((((60*Xr2)*xr)*Xi)*xi))-(((30*Xr2)*xr)*xi2))-(((30*Xr)*xr2)*Xi2))-((((60*Xr)*xr2)*Xi)*xi))-(((30*Xr)*xr2)*xi2))+((((20*Xr)*Xi2)*Xi)*xi))+(((30*Xr)*Xi2)*xi2))+((((20*Xr)*Xi)*xi2)*xi))+(((5*Xr)*xi2)*xi2))+((xr2*xr2)*xr))-(((10*xr2)*xr)*Xi2))-((((20*xr2)*xr)*Xi)*xi))-(((10*xr2)*xr)*xi2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*Xi2)*Xi)*xi))+(((30*xr)*Xi2)*xi2))+((((20*xr)*Xi)*xi2)*xi))+(((5*xr)*xi2)*xi2))+cr);
xin=(((((((((((((((((((((((((((((-20*Xi)*Xr2)*Xr)*xr)-(((30*Xi)*Xr2)*xr2))-((((20*Xi)*Xr)*xr2)*xr))-(((5*Xi)*xr2)*xr2))+(((30*Xi2)*Xr2)*xi))+(((30*Xi)*Xr2)*xi2))+((((20*Xi2)*Xi)*Xr)*xr))+((((60*Xi2)*Xr)*xr)*xi))+((((60*Xi)*Xr)*xr)*xi2))+(((10*Xi2)*Xi)*xr2))+(((30*Xi2)*xr2)*xi))+(((30*Xi)*xr2)*xi2))-(((5*Xi2)*Xi2)*xi))-(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*xi2)*xi))-(((5*Xi)*xi2)*xi2))-(((5*xi)*Xr2)*Xr2))-((((20*xi)*Xr2)*Xr)*xr))-(((30*xi)*Xr2)*xr2))-((((20*xi)*Xr)*xr2)*xr))-(((5*xi)*xr2)*xr2))+(((10*xi2)*xi)*Xr2))+((((20*xi2)*xi)*Xr)*xr))+(((10*xi2)*xi)*xr2))-((xi2*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((((((((((((5*Xr2)*Xr2)*xr)+(((10*Xr2)*Xr)*xr2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xr2)*xr2))-((((20*Xr2)*Xr)*Xi)*xi))-(((10*Xr2)*Xr)*xi2))-(((30*Xr2)*xr)*Xi2))-((((60*Xr2)*xr)*Xi)*xi))-(((30*Xr2)*xr)*xi2))-(((30*Xr)*xr2)*Xi2))-((((60*Xr)*xr2)*Xi)*xi))-(((30*Xr)*xr2)*xi2))+((((20*Xr)*Xi2)*Xi)*xi))+(((30*Xr)*Xi2)*xi2))+((((20*Xr)*Xi)*xi2)*xi))+(((5*Xr)*xi2)*xi2))+((xr2*xr2)*xr))-(((10*xr2)*xr)*Xi2))-((((20*xr2)*xr)*Xi)*xi))-(((10*xr2)*xr)*xi2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*Xi2)*Xi)*xi))+(((30*xr)*Xi2)*xi2))+((((20*xr)*Xi)*xi2)*xi))+(((5*xr)*xi2)*xi2))+cr);
xin=(((((((((((((((((((((((((((((-20*Xi)*Xr2)*Xr)*xr)-(((30*Xi)*Xr2)*xr2))-((((20*Xi)*Xr)*xr2)*xr))-(((5*Xi)*xr2)*xr2))+(((30*Xi2)*Xr2)*xi))+(((30*Xi)*Xr2)*xi2))+((((20*Xi2)*Xi)*Xr)*xr))+((((60*Xi2)*Xr)*xr)*xi))+((((60*Xi)*Xr)*xr)*xi2))+(((10*Xi2)*Xi)*xr2))+(((30*Xi2)*xr2)*xi))+(((30*Xi)*xr2)*xi2))-(((5*Xi2)*Xi2)*xi))-(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*xi2)*xi))-(((5*Xi)*xi2)*xi2))-(((5*xi)*Xr2)*Xr2))-((((20*xi)*Xr2)*Xr)*xr))-(((30*xi)*Xr2)*xr2))-((((20*xi)*Xr)*xr2)*xr))-(((5*xi)*xr2)*xr2))+(((10*xi2)*xi)*Xr2))+((((20*xi2)*xi)*Xr)*xr))+(((10*xi2)*xi)*xr2))-((xi2*xi2)*xi))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,5,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=(((((Xr*xi)+(xr*Xi))+(xr*xi))*-2)+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=(((((Xr*xi)+(xr*Xi))+(xr*xi))*-2)+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,6,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,7,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,8,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,9,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,10,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(ci-diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2)))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(ci-diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2)))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,11,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((((((6*Xr)*((Xi*xr)+(xr*xi)))+((3*Xi)*(xr2-xi2)))+((3*xi)*(Xr2-Xi2)))+(xi*((3*xr2)-xi2)))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((((((6*Xr)*((Xi*xr)+(xr*xi)))+((3*Xi)*(xr2-xi2)))+((3*xi)*(Xr2-Xi2)))+(xi*((3*xr2)-xi2)))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,12,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*xr)*Xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*xr)*Xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,13,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,14,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((ci-(diffabs(((3*Xr2)-Xi2),(((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2))*Xi))-(abs(((((((3*Xr2)+((6*Xr)*xr))+(3*xr2))-Xi2)-((2*Xi)*xi))-xi2))*xi));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((ci-(diffabs(((3*Xr2)-Xi2),(((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2))*Xi))-(abs(((((((3*Xr2)+((6*Xr)*xr))+(3*xr2))-Xi2)-((2*Xi)*xi))-xi2))*xi));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,15,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,16,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,17,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,18,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,19,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,20,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,21,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,22,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(ci-((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi)));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(ci-((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi)));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,23,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,24,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,25,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,26,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,27,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,28,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,29,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,30,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,31,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((-(Xi)*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))-(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((-(Xi)*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))-(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,32,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((Xi*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))+(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((Xi*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))+(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,33,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((Xi2*diffabs(Xi2,(((2*xi)*Xi)+xi2)))-(((4*Xi)*Xr)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))-(Xr2*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-(Xi2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+(Xr2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+((((2*xi)*Xi)+xi2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((4*(((Xi*xr)+(xi*Xr))+(xi*xr)))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))-((((2*Xr)*xr)+xr2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((((2*xi)*Xi)+xi2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+((((2*Xr)*xr)+xr2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+cr);
xin=((((((((((2*Xr2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+(((2*Xr)*Xi)*diffabs(Xr2,(((2*Xr)*xr)+xr2))))-(((2*Xr)*Xi)*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-((2*Xi2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))+((2*(((2*Xr)*xr)+xr2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xr2+((2*Xr)*xr))+xr2))))-((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xi2+((2*xi)*Xi))+xi2))))-((2*(((2*xi)*Xi)+xi2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((Xi2*diffabs(Xi2,(((2*xi)*Xi)+xi2)))-(((4*Xi)*Xr)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))-(Xr2*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-(Xi2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+(Xr2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+((((2*xi)*Xi)+xi2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((4*(((Xi*xr)+(xi*Xr))+(xi*xr)))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))-((((2*Xr)*xr)+xr2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((((2*xi)*Xi)+xi2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+((((2*Xr)*xr)+xr2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+cr);
xin=((((((((((2*Xr2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+(((2*Xr)*Xi)*diffabs(Xr2,(((2*Xr)*xr)+xr2))))-(((2*Xr)*Xi)*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-((2*Xi2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))+((2*(((2*Xr)*xr)+xr2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xr2+((2*Xr)*xr))+xr2))))-((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xi2+((2*xi)*Xi))+xi2))))-((2*(((2*xi)*Xi)+xi2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,34,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,35,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,36,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,37,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,38,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,39,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,40,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xi2*Xi))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xi2*Xi)))+((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr*Xi2)))-((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr*Xi2)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xi)))-((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xr)))+(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xr2*Xr)))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))+((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+cr);
xin=((((((((((((((((((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xi2*Xi))-(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xi2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr*Xi2)))-((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xi)))+((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr2*Xi)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr*Xi2)))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xr2*Xr)))+((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xr)))+((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xi2*Xi))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xi2*Xi)))+((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr*Xi2)))-((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr*Xi2)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xi)))-((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xr)))+(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xr2*Xr)))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))+((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+cr);
xin=((((((((((((((((((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xi2*Xi))-(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xi2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr*Xi2)))-((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xi)))+((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr2*Xi)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr*Xi2)))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xr2*Xr)))+((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xr)))+((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,41,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=((((xr*((2*Xr)+xr))-(xi*(xi+(2*Xi))))-diffabs(Xr,xr))+cr);
xin=(((diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))*2)-diffabs(Xi,xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=((((xr*((2*Xr)+xr))-(xi*(xi+(2*Xi))))-diffabs(Xr,xr))+cr);
xin=(((diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))*2)-diffabs(Xi,xi))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,42,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))+((3*X2)*x))+((3*X)*x2))+(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))+((3*X2)*x))+((3*X)*x2))+(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,43,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,44,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((2*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((2*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,45,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))+((4*(X^3))*x))+((6*(X^2))*x2))+(((4*X)*x2)*x))+(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))+((4*(X^3))*x))+((6*(X^2))*x2))+(((4*X)*x2)*x))+(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,46,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))-((4*(X^3))*x))-((6*(X^2))*x2))-(((4*X)*x2)*x))-(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))-((4*(X^3))*x))-((6*(X^2))*x2))-(((4*X)*x2)*x))-(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,47,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))+((5*(X^4))*x))+((10*(X^3))*x2))+(((10*(X^2))*x2)*x))+((5*X)*(x2^2)))+((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))+((5*(X^4))*x))+((10*(X^3))*x2))+(((10*(X^2))*x2)*x))+((5*X)*(x2^2)))+((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,48,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))-((5*(X^4))*x))-((10*(X^3))*x2))-(((10*(X^2))*x2)*x))-((5*X)*(x2^2)))-((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))-((5*(X^4))*x))-((10*(X^3))*x2))-(((10*(X^2))*x2)*x))-((5*X)*(x2^2)))-((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,49,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=((((((((A*(((2*X)*x)+x2))+((6*(X^5))*x))+((15*(X^4))*x2))+((20*(X^3))*(x2*x)))+((15*(X^2))*(x2^2)))+((6*X)*((x2*x2)*x)))+(x2^3))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{const complex<V> x2 = x * x;
xn=((((((((A*(((2*X)*x)+x2))+((6*(X^5))*x))+((15*(X^4))*x2))+((20*(X^3))*(x2*x)))+((15*(X^2))*(x2^2)))+((6*X)*((x2*x2)*x)))+(x2^3))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,50,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((A*(((2*X)*x)+(x^2)))-((6*(X^5))*x))-((15*(X^4))*(x^2)))-((20*(X^3))*(x^3)))-((15*(X^2))*(x^4)))-((6*X)*(x^5)))-(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((A*(((2*X)*x)+(x^2)))-((6*(X^5))*x))-((15*(X^4))*(x^2)))-((20*(X^3))*(x^3)))-((15*(X^2))*(x^4)))-((6*X)*(x^5)))-(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,51,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((Xr2-Xi2)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((Xr2+((2*Xr)*xr))+xr2)-Xi2)-((2*Xi)*xi))-xi2))))-(((2*Xr)*Xi)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi)))))-(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+cr);
xin=((((((Xr2-Xi2)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+(((2*Xr)*Xi)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))))+(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((Xr2-Xi2)+((2*Xr)*xr))+xr2)-((2*Xi)*xi))-xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((Xr2-Xi2)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((Xr2+((2*Xr)*xr))+xr2)-Xi2)-((2*Xi)*xi))-xi2))))-(((2*Xr)*Xi)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi)))))-(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+cr);
xin=((((((Xr2-Xi2)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+(((2*Xr)*Xi)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))))+(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((Xr2-Xi2)+((2*Xr)*xr))+xr2)-((2*Xi)*xi))-xi2))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,52,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 52 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=((((((2*xr)*Xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=((((((2*xr)*Xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,53,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 53 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=((((((2*xr)*Xr)+(xr*xr))+((2*Xi)*xi))+(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=((((((2*xr)*Xr)+(xr*xr))+((2*Xi)*xi))+(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,54,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 54 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((Xr*diffabs(Xr,xr))+((-1*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(xr*abs((Xr+xr))))));
xin=(ci+((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((Xr*diffabs(Xr,xr))+((-1*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(xr*abs((Xr+xr))))));
xin=(ci+((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,55,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 55 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs(Xr)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr+xr))*(Xr*diffabs(Xr,xr)))+((-1*((abs(Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xr+xr)))))+((-2*((abs(Xi)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xi+xi)))))+(abs((Xr+xr))*(xr*diffabs(Xr,xr))))))));
xin=(ci+((abs(Xr)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(Xi+xi)))+((-1*((abs(Xi)*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xi+xi)))))+(2*((abs(Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xr+xr)))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs(Xr)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr+xr))*(Xr*diffabs(Xr,xr)))+((-1*((abs(Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xr+xr)))))+((-2*((abs(Xi)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xi+xi)))))+(abs((Xr+xr))*(xr*diffabs(Xr,xr))))))));
xin=(ci+((abs(Xr)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(Xi+xi)))+((-1*((abs(Xi)*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xi+xi)))))+(2*((abs(Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xr+xr)))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,56,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 56 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+(((Xr*Xr)*diffabs(Xr,xr))+((-1*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((-2*(xi*(xr*abs((Xi+xi)))))+((2*(Xr*(xr*abs((Xr+xr)))))+((-2*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((xr*xr)*abs((Xr+xr)))))))));
xin=(ci+(((Xr*Xr)*diffabs(Xi,xi))+((-1*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((2*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((-2*(Xi*(xi*abs((Xi+xi)))))+((xr*xr)*abs((Xi+xi))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+(((Xr*Xr)*diffabs(Xr,xr))+((-1*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((-2*(xi*(xr*abs((Xi+xi)))))+((2*(Xr*(xr*abs((Xr+xr)))))+((-2*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((xr*xr)*abs((Xr+xr)))))))));
xin=(ci+(((Xr*Xr)*diffabs(Xi,xi))+((-1*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((2*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((-2*(Xi*(xi*abs((Xi+xi)))))+((xr*xr)*abs((Xi+xi))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,57,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 57 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs((Xi*Xi))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((-1*((abs((Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))))))+((-2*((abs((Xi*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xi+xi))))))+(abs((Xr*Xr))*(xr*abs((Xr+xr)))))))))));
xin=(ci+((abs((Xr*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+((-1*((abs((Xi*Xi))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi))))))+((2*((abs((Xi*Xr))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((2*((abs((Xi*Xr))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr*Xr))*(xr*abs((Xi+xi)))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs((Xi*Xi))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((-1*((abs((Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))))))+((-2*((abs((Xi*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xi+xi))))))+(abs((Xr*Xr))*(xr*abs((Xr+xr)))))))))));
xin=(ci+((abs((Xr*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+((-1*((abs((Xi*Xi))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi))))))+((2*((abs((Xi*Xr))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((2*((abs((Xi*Xr))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr*Xr))*(xr*abs((Xi+xi)))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,58,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 58 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs(Xi)*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xi*Xi)+(xi*xi))))+((abs((Xr+xr))*((Xr*Xr)*diffabs(Xr,xr)))+((-1*((abs(Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xr*Xr)+(xr*xr))))+(abs((Xr+xr))*(diffabs(Xr,xr)*((Xi*Xi)+(xi*xi))))))))+((2*((abs(Xr)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xi*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xr,xr))))))))+((2*((abs(Xi)*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(Xi,xi))))))+((-4*((abs(Xi)*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(diffabs(Xi,xi)*(Xr+xr)))+((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(Xr,xr)))))))))))));
xin=(ci+((2*((abs(Xi)*((xr*xr)*abs((Xr+xr))))+((abs(Xr)*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs(Xr,xr)))))))+((-2*((abs(Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((xi*xi)*diffabs(Xi,xi))))))+((2*((abs(Xr)*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(Xi,xi))))))+((2*((abs(Xi)*((Xr*Xr)*diffabs(Xr,xr)))+((abs(Xr)*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs(Xr,xr)))+((Xr*Xr)*diffabs(Xi,xi)))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs(Xi,xi)))))+((2*((Xi*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((-2*((abs(Xi)*(((Xi*Xi)*diffabs(Xr,xr))+(Xi*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(Xi,xi))))))+((4*((abs(Xi)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xi,xi))))))+((-4*((abs(Xi)*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xi,xi))))))+(2*(abs((Xr+xr))*((xr*xr)*diffabs(Xi,xi)))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs(Xi)*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xi*Xi)+(xi*xi))))+((abs((Xr+xr))*((Xr*Xr)*diffabs(Xr,xr)))+((-1*((abs(Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xr*Xr)+(xr*xr))))+(abs((Xr+xr))*(diffabs(Xr,xr)*((Xi*Xi)+(xi*xi))))))))+((2*((abs(Xr)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xi*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xr,xr))))))))+((2*((abs(Xi)*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(Xi,xi))))))+((-4*((abs(Xi)*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(diffabs(Xi,xi)*(Xr+xr)))+((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(Xr,xr)))))))))))));
xin=(ci+((2*((abs(Xi)*((xr*xr)*abs((Xr+xr))))+((abs(Xr)*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs(Xr,xr)))))))+((-2*((abs(Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((xi*xi)*diffabs(Xi,xi))))))+((2*((abs(Xr)*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(Xi,xi))))))+((2*((abs(Xi)*((Xr*Xr)*diffabs(Xr,xr)))+((abs(Xr)*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs(Xr,xr)))+((Xr*Xr)*diffabs(Xi,xi)))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs(Xi,xi)))))+((2*((Xi*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((-2*((abs(Xi)*(((Xi*Xi)*diffabs(Xr,xr))+(Xi*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(Xi,xi))))))+((4*((abs(Xi)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xi,xi))))))+((-4*((abs(Xi)*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xi,xi))))))+(2*(abs((Xr+xr))*((xr*xr)*diffabs(Xi,xi)))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,59,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 59 && m_nPower == 4)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+((-3*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((3*(Xr*((xr*xr)*abs((Xr+xr)))))+((-3*(Xr*((xi*xi)*abs((Xr+xr)))))+((3*((Xr*Xr)*(xr*abs((Xr+xr)))))+((-3*((Xi*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((3*(Xi*((xi*xi)*abs((Xi+xi)))))+((-3*((Xi*Xi)*(xr*abs((Xr+xr)))))+((3*((Xi*Xi)*(xi*abs((Xi+xi)))))+((-3*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((-6*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*((xr*xr)*abs((Xr+xr))))))))))))))))));
xin=(ci+((Xr*((Xr*Xr)*diffabs(Xi,xi)))+((-1*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((3*(xi*((xr*xr)*abs((Xr+xr)))))+((-3*((xi*xi)*(xr*abs((Xi+xi)))))+((3*(Xr*((xr*xr)*abs((Xi+xi)))))+((-3*(Xr*((xi*xi)*abs((Xi+xi)))))+((3*((Xi*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-3*(((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xi*((xi*xi)*abs((Xr+xr))))))+((6*(Xr*(xi*(xr*abs((Xr+xr))))))+((-6*(Xi*(xi*(xr*abs((Xi+xi))))))+((6*(Xi*(Xr*(xr*abs((Xr+xr))))))+((-6*(Xi*(Xr*(xi*abs((Xi+xi))))))+(xr*((xr*xr)*abs((Xi+xi)))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+((-3*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((3*(Xr*((xr*xr)*abs((Xr+xr)))))+((-3*(Xr*((xi*xi)*abs((Xr+xr)))))+((3*((Xr*Xr)*(xr*abs((Xr+xr)))))+((-3*((Xi*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((3*(Xi*((xi*xi)*abs((Xi+xi)))))+((-3*((Xi*Xi)*(xr*abs((Xr+xr)))))+((3*((Xi*Xi)*(xi*abs((Xi+xi)))))+((-3*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((-6*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*((xr*xr)*abs((Xr+xr))))))))))))))))));
xin=(ci+((Xr*((Xr*Xr)*diffabs(Xi,xi)))+((-1*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((3*(xi*((xr*xr)*abs((Xr+xr)))))+((-3*((xi*xi)*(xr*abs((Xi+xi)))))+((3*(Xr*((xr*xr)*abs((Xi+xi)))))+((-3*(Xr*((xi*xi)*abs((Xi+xi)))))+((3*((Xi*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-3*(((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xi*((xi*xi)*abs((Xr+xr))))))+((6*(Xr*(xi*(xr*abs((Xr+xr))))))+((-6*(Xi*(xi*(xr*abs((Xi+xi))))))+((6*(Xi*(Xr*(xr*abs((Xr+xr))))))+((-6*(Xi*(Xr*(xi*abs((Xi+xi))))))+(xr*((xr*xr)*abs((Xi+xi)))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,60,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 60 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))+((abs((Xr+xr))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((-1*((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))))+((-3*((abs(((Xi*Xi)*Xr))*(xr*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-3*((abs(((Xi*Xi)*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xr+xr))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))+((-1*((abs((Xi*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))))+((3*((abs((Xi*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi*(Xr*Xr)))*(xi*abs((Xi+xi))))+((abs((Xi+xi))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xi+xi))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))+((abs((Xr+xr))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((-1*((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))))+((-3*((abs(((Xi*Xi)*Xr))*(xr*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-3*((abs(((Xi*Xi)*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xr+xr))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))+((-1*((abs((Xi*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))))+((3*((abs((Xi*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi*(Xr*Xr)))*(xi*abs((Xi+xi))))+((abs((Xi+xi))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xi+xi))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,61,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 61 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-2*((abs((Xi*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xr*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xr*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))))+((-2*((abs((Xi*Xi))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xr*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(Xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xr*Xr))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((2*((abs((Xi*Xi))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-2*(abs((Xr*Xr))*(Xi*(Xr*diffabs(Xi,xi)))))+((2*(abs((Xi*Xi))*(Xi*(Xr*diffabs(Xi,xi)))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-4*((abs((Xi*Xr))*((Xi*(xr*abs((Xr+xr))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((4*((abs((Xi*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((2*((abs((Xi*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xr*Xr))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*Xr))*((xi*xi)*abs((Xr+xr))))+(abs((Xr+xr))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((2*(abs((Xr*Xr))*(Xr*(xr*abs((Xi+xi))))))+((-2*(abs((Xi*Xi))*(Xr*(xr*abs((Xi+xi))))))+((2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((2*((abs((Xr*Xr))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-2*((abs((Xi*Xi))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(Xi*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xi*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xr*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((-2*((abs((Xi*Xi))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-4*((abs((Xi*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((4*((abs((Xi*Xr))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xi+xi))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-2*((abs((Xi*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xr*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xr*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))))+((-2*((abs((Xi*Xi))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xr*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(Xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xr*Xr))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((2*((abs((Xi*Xi))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-2*(abs((Xr*Xr))*(Xi*(Xr*diffabs(Xi,xi)))))+((2*(abs((Xi*Xi))*(Xi*(Xr*diffabs(Xi,xi)))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-4*((abs((Xi*Xr))*((Xi*(xr*abs((Xr+xr))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((4*((abs((Xi*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((2*((abs((Xi*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xr*Xr))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*Xr))*((xi*xi)*abs((Xr+xr))))+(abs((Xr+xr))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((2*(abs((Xr*Xr))*(Xr*(xr*abs((Xi+xi))))))+((-2*(abs((Xi*Xi))*(Xr*(xr*abs((Xi+xi))))))+((2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((2*((abs((Xr*Xr))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-2*((abs((Xi*Xi))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(Xi*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xi*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xr*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((-2*((abs((Xi*Xi))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-4*((abs((Xi*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((4*((abs((Xi*Xr))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xi+xi))))))))))))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,62,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 62 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs(Xr)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xr,xr))))+((-1*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))+((2*((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))))+((-3*((abs(Xr)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xr,xr))))))+((3*((abs(Xi)*((xi*xi)*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xr*xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xr*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*((Xr*Xr)*(xr*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs(Xr,xr))))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs(Xi,xi)))))+((-3*(((Xi*Xi)*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((3*((abs(Xi)*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((Xi*((xr*xr)*abs((Xr+xr))))+(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr)))))))+((abs(Xr)*(Xi*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))+(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))))))+((6*((abs(Xi)*(Xi*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xi,xi)))))))+((-6*((abs(Xr)*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs(Xr,xr)))))))+((6*((abs(Xi)*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs(Xi,xi)))))))+((-6*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))))+((6*((abs(Xi)*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-12*((abs(Xi)*((Xi*(Xr*(xr*abs((Xr+xr)))))+(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xi,xi))))+(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xr,xr))))))))))))))))))))))));
xin=(ci+((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+((-1*((abs(Xr)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*diffabs(Xr,xr)))))))+((2*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(xi*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*((xr*xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs(Xr,xr))))))+((-3*((abs(Xi)*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs(Xi,xi))))))+((3*((abs(Xr)*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(Xi*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+((abs(Xr)*((Xi*Xi)*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xr,xr))))))))+((3*((abs(Xi)*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xi,xi))))))+((6*((abs(Xi)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xr*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xi,xi)))))))+((6*((abs(Xi)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs(Xr)*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xr,xr))))+((Xr*Xr)*(xr*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(Xi*(Xr*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xi)*(Xi*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xi,xi)))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs(Xr)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xr,xr))))+((-1*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))+((2*((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))))+((-3*((abs(Xr)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xr,xr))))))+((3*((abs(Xi)*((xi*xi)*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xr*xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xr*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*((Xr*Xr)*(xr*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs(Xr,xr))))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs(Xi,xi)))))+((-3*(((Xi*Xi)*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((3*((abs(Xi)*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((Xi*((xr*xr)*abs((Xr+xr))))+(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr)))))))+((abs(Xr)*(Xi*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))+(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))))))+((6*((abs(Xi)*(Xi*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xi,xi)))))))+((-6*((abs(Xr)*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs(Xr,xr)))))))+((6*((abs(Xi)*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs(Xi,xi)))))))+((-6*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))))+((6*((abs(Xi)*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-12*((abs(Xi)*((Xi*(Xr*(xr*abs((Xr+xr)))))+(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xi,xi))))+(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xr,xr))))))))))))))))))))))));
xin=(ci+((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+((-1*((abs(Xr)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*diffabs(Xr,xr)))))))+((2*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(xi*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*((xr*xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs(Xr,xr))))))+((-3*((abs(Xi)*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs(Xi,xi))))))+((3*((abs(Xr)*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(Xi*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+((abs(Xr)*((Xi*Xi)*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xr,xr))))))))+((3*((abs(Xi)*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xi,xi))))))+((6*((abs(Xi)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xr*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xi,xi)))))))+((6*((abs(Xi)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs(Xr)*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xr,xr))))+((Xr*Xr)*(xr*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(Xi*(Xr*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xi)*(Xi*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xi,xi)))))))))))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,63,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 63 && m_nPower == 5)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xr+xr)))+((-4*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((4*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-4*((Xi*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((4*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+((-4*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((4*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-6*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*abs((Xr+xr))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((-12*((Xi*(xi*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))))+((12*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((-12*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((12*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((-12*(Xi*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((12*((Xi*Xi)*(xi*(xr*abs((Xi+xi))))))+((-12*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+((12*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))));
xin=(ci+((diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xi+xi)))+((4*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+((-4*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((4*(Xr*(xr*((xr*xr)*abs((Xi+xi))))))+((-4*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+((4*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-4*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+((4*(Xi*((Xi*Xi)*(xi*abs((Xi+xi))))))+((-6*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xi+xi)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*((xi*xi)*abs((Xi+xi))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xi+xi)))))+((12*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+((-12*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+((12*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+((-12*(Xi*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))+((12*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((-12*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((12*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((-12*(((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xi*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xi+xi)))))))+(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xr+xr)))+((-4*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((4*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-4*((Xi*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((4*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+((-4*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((4*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-6*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*abs((Xr+xr))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((-12*((Xi*(xi*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))))+((12*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((-12*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((12*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((-12*(Xi*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((12*((Xi*Xi)*(xi*(xr*abs((Xi+xi))))))+((-12*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+((12*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))));
xin=(ci+((diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xi+xi)))+((4*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+((-4*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((4*(Xr*(xr*((xr*xr)*abs((Xi+xi))))))+((-4*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+((4*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-4*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+((4*(Xi*((Xi*Xi)*(xi*abs((Xi+xi))))))+((-6*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xi+xi)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*((xi*xi)*abs((Xi+xi))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xi+xi)))))+((12*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+((-12*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+((12*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+((-12*(Xi*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))+((12*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((-12*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((12*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((-12*(((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xi*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xi+xi)))))))+(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,64,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 64 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs(((Xi*Xi)*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs(((Xr*Xr)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((-1*((abs(Xi)*(Xi*(diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))+(((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi))))*(abs((((Xi*Xi)*(Xi*Xi))+((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi))))))+abs((((Xr*Xr)*(Xr*Xr))+((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xi+xi)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xr+xr)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xr+xr)))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xi,xi))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xi,xi))))+((-4*(abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xr,xr))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xr,xr))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xr+xr)))))))))))))))))))))))))))));
xin=(ci+((abs(((Xi*Xi)*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs(((Xr*Xr)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xi+xi)))+((4*(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((-4*(abs((Xr+xr))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xr+xr)))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xr+xr))))+(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xi+xi))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*((abs((Xi+xi))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr)))))))))))+((-4*(abs((Xr+xr))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xr,xr))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xi,xi)))))+((4*(abs((Xi+xi))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi+xi))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xi,xi))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xi+xi))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xi+xi)))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs(((Xi*Xi)*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs(((Xr*Xr)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((-1*((abs(Xi)*(Xi*(diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))+(((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi))))*(abs((((Xi*Xi)*(Xi*Xi))+((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi))))))+abs((((Xr*Xr)*(Xr*Xr))+((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xi+xi)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xr+xr)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xr+xr)))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xi,xi))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xi,xi))))+((-4*(abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xr,xr))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xr,xr))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xr+xr)))))))))))))))))))))))))))));
xin=(ci+((abs(((Xi*Xi)*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs(((Xr*Xr)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xi+xi)))+((4*(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((-4*(abs((Xr+xr))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xr+xr)))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xr+xr))))+(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xi+xi))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*((abs((Xi+xi))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr)))))))))))+((-4*(abs((Xr+xr))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xr,xr))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xi,xi)))))+((4*(abs((Xi+xi))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi+xi))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xi,xi))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xi+xi))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xi+xi)))))))))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,65,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 65 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))))))+((-2*(abs((Xr*(Xr*Xr)))*(xi*(xr*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xr*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xr*(Xr*Xr)))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xi*((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xi+xi))))+((abs((Xi+xi))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xi+xi))))+((abs((Xi+xi))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xr+xr)))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*(xr*abs((Xi+xi))))+(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((2*((abs((Xi*(Xi*Xi)))*((Xi*(xr*abs((Xi+xi))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xr*(Xr*Xr)))*((Xi*(xr*abs((Xr+xr))))+(Xr*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))))+(Xr*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))+(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xr*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xr+xr))))+(abs((Xr+xr))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xr+xr))))+((abs((Xi+xi))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi+xi))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((6*((abs((Xi*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*Xr))*((Xi*(xr*abs((Xr+xr))))+(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi*(Xr*Xr)))*((Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr+xr))*((Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))))))+((-2*(abs((Xr*(Xr*Xr)))*(xi*(xr*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xr*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xr*(Xr*Xr)))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xi*((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xi+xi))))+((abs((Xi+xi))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xi+xi))))+((abs((Xi+xi))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xr+xr)))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*(xr*abs((Xi+xi))))+(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((2*((abs((Xi*(Xi*Xi)))*((Xi*(xr*abs((Xi+xi))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xr*(Xr*Xr)))*((Xi*(xr*abs((Xr+xr))))+(Xr*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))))+(Xr*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))+(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xr*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xr+xr))))+(abs((Xr+xr))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xr+xr))))+((abs((Xi+xi))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi+xi))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((6*((abs((Xi*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*Xr))*((Xi*(xr*abs((Xr+xr))))+(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi*(Xr*Xr)))*((Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr+xr))*((Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,66,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 66 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-1*((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-2*((abs((Xi*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-2*((abs((Xi*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(Xi*((Xi*Xi)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-3*(abs((Xr*Xr))*(xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((xi*xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*(abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-3*(abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*(abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xr*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xr+xr))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((6*((abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-6*(abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((6*((abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-6*((abs((Xi*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-1*((abs((Xi*Xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((2*((abs((Xi*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((3*((abs((Xr*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((xi*xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*((abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-6*((abs((Xi*Xr))*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((-6*((abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((6*((abs((Xi*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xi+xi))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((6*(abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((-6*((abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(((Xi*Xi)*(xr*abs((Xr+xr))))+(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-12*((abs((Xi*Xr))*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-1*((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-2*((abs((Xi*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-2*((abs((Xi*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(Xi*((Xi*Xi)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-3*(abs((Xr*Xr))*(xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((xi*xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*(abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-3*(abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*(abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xr*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xr+xr))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((6*((abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-6*(abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((6*((abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-6*((abs((Xi*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-1*((abs((Xi*Xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((2*((abs((Xi*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((3*((abs((Xr*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((xi*xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*((abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-6*((abs((Xi*Xr))*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((-6*((abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((6*((abs((Xi*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xi+xi))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((6*(abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((-6*((abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(((Xi*Xi)*(xr*abs((Xr+xr))))+(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-12*((abs((Xi*Xr))*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,67,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 67 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((((xi*xi)*(xi*xi))*abs((Xr*(Xr+xr))))+((abs(Xr)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-1*(((Xi*Xi)*((xr*xr)*(xr*xr)))+((xi*xi)*(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-2*(Xi*(xi*(((Xr*Xr)*(Xr*Xr))+((xr*xr)*(xr*xr))))))+((4*((abs(Xr)*(Xr*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*(Xr*((xi*xi)*(xr*(xr*xr)))))+((4*((abs(Xr)*(Xr*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))+((-4*(Xr*((Xr*Xr)*((xi*xi)*xr))))+((4*((abs(Xr)*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((-4*((Xi*Xi)*(Xr*(xr*((Xr*Xr)+(xr*xr))))))+((4*((abs(Xr)*(Xi*((Xi*Xi)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xi*diffabs(Xr,xr)))))))+((-6*((abs(Xr)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*((xr*xr)*diffabs(Xr,xr))))))))+((-6*((abs(Xr)*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*((xi*xi)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*((xi*xi)*diffabs(Xi,xi))))))+((-6*((Xi*(xi*((xi*xi)*(xi*xi))))+(((Xr*Xr)*((xi*xi)*(xr*xr)))+((abs(Xr)*((Xi*Xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*((xr*xr)*diffabs(Xr,xr))))))))+((6*((abs(Xi)*((Xi*Xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*((Xi*Xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xr,xr))))))))+((-6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi)))*(abs(Xi)+abs((Xi+xi)))))+((-6*((Xi*(((Xi*Xi)*(Xi*Xi))*xi))+((Xi*Xi)*((Xr*Xr)*(xr*xr)))))+((-8*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xr*(xi*((xi*xi)*abs((Xr+xr)))))+(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xr*(xi*((xi*xi)*diffabs(Xi,xi))))+(xi*((xi*xi)*(xr*diffabs(Xi,xi))))))))+((-8*((Xi*(Xr*(((Xr*Xr)*(xi*xr))+(xi*(xr*(xr*xr))))))+((abs(Xi)*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))))+((8*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xr)*(Xr*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*xi)*(xr*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*((Xr*Xr)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((-12*((Xi*((Xr*Xr)*(xi*(xr*xr))))+((abs(Xr)*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xr*diffabs(Xr,xr))))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi)))))))+((-15*((((Xi*Xi)*(Xi*Xi))*(xi*xi))+((Xi*Xi)*((xi*xi)*(xi*xi)))))+((-20*(Xi*((Xi*Xi)*(xi*(xi*xi)))))+((-24*((abs(Xi)*(((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))+(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+(abs((Xr+xr))*(((Xr*Xr)*(xi*(xr*diffabs(Xi,xi))))+(Xr*(xi*((xr*xr)*diffabs(Xi,xi))))))))+((24*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-24*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs(Xr)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((24*((abs(Xi)*(Xi*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))))+((abs((Xi+xi))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi))))))))+((-24*((abs(Xi)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))))+((24*((abs(Xi)*((Xi*Xi)*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(((xr*xr)*(xr*xr))*abs((Xr*(Xr+xr))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((2*((abs((Xi*(Xr+xr)))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))+((abs(Xi)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+((xi*xi)*(xi*xi)))))))))+((4*((abs(Xr)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(xi*((xi*xi)*(xr*diffabs(Xr,xr)))))))))+((4*((abs(Xi)*(xi*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-4*((abs(Xr)*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((4*((abs(Xi)*(Xr*(xi*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xr*((Xr*Xr)*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xr*(xi*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))))+((-4*((abs(Xi)*(Xr*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((4*((abs(Xr)*(Xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(Xi*(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((4*((Xi*(Xr*((Xr*Xr)*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((-4*((abs(Xi)*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((abs(Xr)*(Xi*((Xi*Xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xr*diffabs(Xr,xr)))))))))+((4*(abs((Xi+xi))*(Xi*((Xi*Xi)*(xr*diffabs(Xi,xi))))))+((-4*((Xi*((Xi*Xi)*(Xr*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((4*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+(abs((Xi+xi))*(Xi*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xi*(((Xi*Xi)*(xi*abs((Xr+xr))))+(xi*((xi*xi)*abs((Xr+xr))))))+(Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+(xr*((xr*xr)*abs((Xr+xr))))))))+(abs((Xr+xr))*((Xi*(((Xi*Xi)*(xi*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+(Xr*(((Xr*Xr)*(xr*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))))+((-12*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))))+((12*((abs(Xr)*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((-12*((abs(Xi)*(Xr*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((12*((abs(Xi)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xr*Xr)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-12*((abs(Xi)*((Xr*Xr)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs(Xr)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*((xi*xi)*(xr*diffabs(Xr,xr))))+((Xr*Xr)*((xi*xi)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xr*xr)*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xr,xr)))))))))+((12*((abs(Xi)*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(((Xi*Xi)*((xr*xr)*abs((Xr+xr))))+(Xi*((Xr*Xr)*(xr*abs((Xi+xi)))))))+((abs(Xr)*((Xi*Xi)*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*((Xi*Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*((Xi*Xi)*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xi*diffabs(Xi,xi)))))))+((-12*((abs(Xi)*((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi))))))+((-24*((abs(Xi)*(((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))+((Xi*(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr))))))+(Xr*((xi*xi)*(xr*abs((Xr+xr))))))))+(abs((Xr+xr))*(((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi))))+((Xi*(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))))+((-48*((abs(Xi)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(((xr*xr)*(xr*xr))*diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((((xi*xi)*(xi*xi))*abs((Xr*(Xr+xr))))+((abs(Xr)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-1*(((Xi*Xi)*((xr*xr)*(xr*xr)))+((xi*xi)*(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-2*(Xi*(xi*(((Xr*Xr)*(Xr*Xr))+((xr*xr)*(xr*xr))))))+((4*((abs(Xr)*(Xr*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*(Xr*((xi*xi)*(xr*(xr*xr)))))+((4*((abs(Xr)*(Xr*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))+((-4*(Xr*((Xr*Xr)*((xi*xi)*xr))))+((4*((abs(Xr)*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((-4*((Xi*Xi)*(Xr*(xr*((Xr*Xr)+(xr*xr))))))+((4*((abs(Xr)*(Xi*((Xi*Xi)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xi*diffabs(Xr,xr)))))))+((-6*((abs(Xr)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*((xr*xr)*diffabs(Xr,xr))))))))+((-6*((abs(Xr)*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*((xi*xi)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*((xi*xi)*diffabs(Xi,xi))))))+((-6*((Xi*(xi*((xi*xi)*(xi*xi))))+(((Xr*Xr)*((xi*xi)*(xr*xr)))+((abs(Xr)*((Xi*Xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*((xr*xr)*diffabs(Xr,xr))))))))+((6*((abs(Xi)*((Xi*Xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*((Xi*Xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xr,xr))))))))+((-6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi)))*(abs(Xi)+abs((Xi+xi)))))+((-6*((Xi*(((Xi*Xi)*(Xi*Xi))*xi))+((Xi*Xi)*((Xr*Xr)*(xr*xr)))))+((-8*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xr*(xi*((xi*xi)*abs((Xr+xr)))))+(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xr*(xi*((xi*xi)*diffabs(Xi,xi))))+(xi*((xi*xi)*(xr*diffabs(Xi,xi))))))))+((-8*((Xi*(Xr*(((Xr*Xr)*(xi*xr))+(xi*(xr*(xr*xr))))))+((abs(Xi)*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))))+((8*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xr)*(Xr*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*xi)*(xr*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*((Xr*Xr)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((-12*((Xi*((Xr*Xr)*(xi*(xr*xr))))+((abs(Xr)*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xr*diffabs(Xr,xr))))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi)))))))+((-15*((((Xi*Xi)*(Xi*Xi))*(xi*xi))+((Xi*Xi)*((xi*xi)*(xi*xi)))))+((-20*(Xi*((Xi*Xi)*(xi*(xi*xi)))))+((-24*((abs(Xi)*(((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))+(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+(abs((Xr+xr))*(((Xr*Xr)*(xi*(xr*diffabs(Xi,xi))))+(Xr*(xi*((xr*xr)*diffabs(Xi,xi))))))))+((24*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-24*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs(Xr)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((24*((abs(Xi)*(Xi*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))))+((abs((Xi+xi))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi))))))))+((-24*((abs(Xi)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))))+((24*((abs(Xi)*((Xi*Xi)*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(((xr*xr)*(xr*xr))*abs((Xr*(Xr+xr))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((2*((abs((Xi*(Xr+xr)))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))+((abs(Xi)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+((xi*xi)*(xi*xi)))))))))+((4*((abs(Xr)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(xi*((xi*xi)*(xr*diffabs(Xr,xr)))))))))+((4*((abs(Xi)*(xi*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-4*((abs(Xr)*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((4*((abs(Xi)*(Xr*(xi*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xr*((Xr*Xr)*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xr*(xi*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))))+((-4*((abs(Xi)*(Xr*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((4*((abs(Xr)*(Xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(Xi*(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((4*((Xi*(Xr*((Xr*Xr)*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((-4*((abs(Xi)*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((abs(Xr)*(Xi*((Xi*Xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xr*diffabs(Xr,xr)))))))))+((4*(abs((Xi+xi))*(Xi*((Xi*Xi)*(xr*diffabs(Xi,xi))))))+((-4*((Xi*((Xi*Xi)*(Xr*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((4*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+(abs((Xi+xi))*(Xi*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xi*(((Xi*Xi)*(xi*abs((Xr+xr))))+(xi*((xi*xi)*abs((Xr+xr))))))+(Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+(xr*((xr*xr)*abs((Xr+xr))))))))+(abs((Xr+xr))*((Xi*(((Xi*Xi)*(xi*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+(Xr*(((Xr*Xr)*(xr*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))))+((-12*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))))+((12*((abs(Xr)*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((-12*((abs(Xi)*(Xr*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((12*((abs(Xi)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xr*Xr)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-12*((abs(Xi)*((Xr*Xr)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs(Xr)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*((xi*xi)*(xr*diffabs(Xr,xr))))+((Xr*Xr)*((xi*xi)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xr*xr)*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xr,xr)))))))))+((12*((abs(Xi)*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(((Xi*Xi)*((xr*xr)*abs((Xr+xr))))+(Xi*((Xr*Xr)*(xr*abs((Xi+xi)))))))+((abs(Xr)*((Xi*Xi)*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*((Xi*Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*((Xi*Xi)*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xi*diffabs(Xi,xi)))))))+((-12*((abs(Xi)*((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi))))))+((-24*((abs(Xi)*(((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))+((Xi*(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr))))))+(Xr*((xi*xi)*(xr*abs((Xr+xr))))))))+(abs((Xr+xr))*(((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi))))+((Xi*(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))))+((-48*((abs(Xi)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(((xr*xr)*(xr*xr))*diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,68,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 68 && m_nPower == 6)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr)))+((-1*((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xi,xi)))+(xi*(((xi*xi)*(xi*xi))*abs((Xi+xi))))))+((-5*(xi*(((xr*xr)*(xr*xr))*abs((Xi+xi)))))+((5*((((Xr*Xr)*(Xr*Xr))*(xr*abs((Xr+xr))))+((Xr*(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+(((xi*xi)*(xi*xi))*(xr*abs((Xr+xr)))))))+((-5*((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi))+(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+(((Xr*Xr)*(Xr*Xr))*(xi*abs((Xi+xi))))))+((5*(((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr))))))+((-5*(((Xi*Xi)*(Xi*Xi))*(xi*abs((Xi+xi)))))+((-10*((xi*xi)*(xr*((xr*xr)*abs((Xr+xr))))))+((10*((Xr*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))+(xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))))+((-10*(((Xi*Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((10*(Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))))+((-10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xi+xi))))))+((-20*(Xr*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xr*(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-20*((Xi*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*(xr*abs((Xi+xi))))))))+((20*(Xi*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((-20*(Xi*(Xr*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*(Xr*(xi*((xi*xi)*abs((Xr+xr)))))))+((-20*(Xi*(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((20*(Xi*((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))))+((-30*(((Xr*Xr)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xr*((xi*xi)*((xr*xr)*abs((Xr+xr)))))))+((30*(Xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((-30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((30*(((Xi*Xi)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xr+xr))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xr+xr))))))+((-30*((Xi*Xi)*((Xr*Xr)*(xr*abs((Xr+xr))))))+((30*((Xi*Xi)*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-60*(Xi*(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+((60*(Xi*(Xr*((xi*xi)*(xr*abs((Xi+xi)))))))+((-60*(Xi*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((60*((Xi*Xi)*(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))))))))))))))));
xin=(ci+((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xr,xr)))+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi)))+((xi*(((xi*xi)*(xi*xi))*abs((Xr+xr))))+((5*((((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr))+(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+((((Xr*Xr)*(Xr*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((Xr*(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+((((xi*xi)*(xi*xi))*(xr*abs((Xi+xi))))+(xi*(((xr*xr)*(xr*xr))*abs((Xr+xr))))))))))+((-10*((xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((xi*xi)*(xr*((xr*xr)*abs((Xi+xi)))))))+((10*((Xr*Xr)*(xr*((xr*xr)*abs((Xi+xi))))))+((-10*((Xr*Xr)*(xi*((xi*xi)*abs((Xr+xr))))))+((10*(Xr*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((-10*(((Xi*Xi)*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((10*((Xi*Xi)*(xi*((xi*xi)*abs((Xr+xr))))))+((-10*((Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr))))))+((Xi*Xi)*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xr+xr))))))+((20*(Xr*(xi*(xr*((xr*xr)*abs((Xr+xr)))))))+((-20*(Xr*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((20*(Xr*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((-20*(Xi*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi))))))))+((-20*(Xi*(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((20*(Xi*((Xi*Xi)*(xi*(xr*abs((Xi+xi)))))))+((-20*(Xi*((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))))+((20*(Xi*((Xi*Xi)*(Xr*(xi*abs((Xi+xi)))))))+((-30*(Xr*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((30*((Xr*Xr)*(xi*((xr*xr)*abs((Xr+xr))))))+((-30*((Xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*(xr*abs((Xi+xi)))))))+((30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xr+xr))))))+((-30*(((Xi*Xi)*(xi*((xr*xr)*abs((Xr+xr)))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((30*((Xi*Xi)*((xi*xi)*(xr*abs((Xi+xi))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xi+xi))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xi+xi))))))+((-30*((Xi*Xi)*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-60*(((Xi*Xi)*(Xr*(xi*(xr*abs((Xr+xr))))))+(Xi*(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr)))+((-1*((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xi,xi)))+(xi*(((xi*xi)*(xi*xi))*abs((Xi+xi))))))+((-5*(xi*(((xr*xr)*(xr*xr))*abs((Xi+xi)))))+((5*((((Xr*Xr)*(Xr*Xr))*(xr*abs((Xr+xr))))+((Xr*(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+(((xi*xi)*(xi*xi))*(xr*abs((Xr+xr)))))))+((-5*((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi))+(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+(((Xr*Xr)*(Xr*Xr))*(xi*abs((Xi+xi))))))+((5*(((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr))))))+((-5*(((Xi*Xi)*(Xi*Xi))*(xi*abs((Xi+xi)))))+((-10*((xi*xi)*(xr*((xr*xr)*abs((Xr+xr))))))+((10*((Xr*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))+(xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))))+((-10*(((Xi*Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((10*(Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))))+((-10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xi+xi))))))+((-20*(Xr*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xr*(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-20*((Xi*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*(xr*abs((Xi+xi))))))))+((20*(Xi*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((-20*(Xi*(Xr*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*(Xr*(xi*((xi*xi)*abs((Xr+xr)))))))+((-20*(Xi*(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((20*(Xi*((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))))+((-30*(((Xr*Xr)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xr*((xi*xi)*((xr*xr)*abs((Xr+xr)))))))+((30*(Xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((-30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((30*(((Xi*Xi)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xr+xr))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xr+xr))))))+((-30*((Xi*Xi)*((Xr*Xr)*(xr*abs((Xr+xr))))))+((30*((Xi*Xi)*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-60*(Xi*(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+((60*(Xi*(Xr*((xi*xi)*(xr*abs((Xi+xi)))))))+((-60*(Xi*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((60*((Xi*Xi)*(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))))))))))))))));
xin=(ci+((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xr,xr)))+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi)))+((xi*(((xi*xi)*(xi*xi))*abs((Xr+xr))))+((5*((((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr))+(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+((((Xr*Xr)*(Xr*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((Xr*(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+((((xi*xi)*(xi*xi))*(xr*abs((Xi+xi))))+(xi*(((xr*xr)*(xr*xr))*abs((Xr+xr))))))))))+((-10*((xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((xi*xi)*(xr*((xr*xr)*abs((Xi+xi)))))))+((10*((Xr*Xr)*(xr*((xr*xr)*abs((Xi+xi))))))+((-10*((Xr*Xr)*(xi*((xi*xi)*abs((Xr+xr))))))+((10*(Xr*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((-10*(((Xi*Xi)*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((10*((Xi*Xi)*(xi*((xi*xi)*abs((Xr+xr))))))+((-10*((Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr))))))+((Xi*Xi)*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xr+xr))))))+((20*(Xr*(xi*(xr*((xr*xr)*abs((Xr+xr)))))))+((-20*(Xr*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((20*(Xr*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((-20*(Xi*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi))))))))+((-20*(Xi*(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((20*(Xi*((Xi*Xi)*(xi*(xr*abs((Xi+xi)))))))+((-20*(Xi*((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))))+((20*(Xi*((Xi*Xi)*(Xr*(xi*abs((Xi+xi)))))))+((-30*(Xr*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((30*((Xr*Xr)*(xi*((xr*xr)*abs((Xr+xr))))))+((-30*((Xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*(xr*abs((Xi+xi)))))))+((30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xr+xr))))))+((-30*(((Xi*Xi)*(xi*((xr*xr)*abs((Xr+xr)))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((30*((Xi*Xi)*((xi*xi)*(xr*abs((Xi+xi))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xi+xi))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xi+xi))))))+((-30*((Xi*Xi)*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-60*(((Xi*Xi)*(Xr*(xi*(xr*abs((Xr+xr))))))+(Xi*(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))))))))))))));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,69,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 69 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((-1*(xi*xi))+((2*(Xr*xr))+((-2*(Xi*xi))+(xr*xr)))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((-1*(xi*xi))+((2*(Xr*xr))+((-2*(Xi*xi))+(xr*xr)))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,70,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 70 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(cr+((xi*xi)+((2*((Xi*xi)+(Xr*xr)))+(xr*xr))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(cr+((xi*xi)+((2*((Xi*xi)+(Xr*xr)))+(xr*xr))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,71,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  )
{
  if (m_nFractalType == 71 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr0, xi0}, Xx = {Xxr, Xxi};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((x+(2*X))*x)*exp(((2*A)/Xx)))+(((2*(X^2))*sinh(((-(A)*x)/(Xx*X))))*exp(((A*(x+(2*X)))/(Xx*X)))))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k];
        Xxi = Xi + xi0[k];
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi}, x = {xr0[k], xi0[k]}, Xx = {Xxr, Xxi}, c = { cr0[k], ci0[k] };
      complex<double> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((x+(2*X))*x)*exp(((2*A)/Xx)))+(((2*(X^2))*sinh(((-(A)*x)/(Xx*X))))*exp(((A*(x+(2*X)))/(Xx*X)))))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool perturbation
  ( const int m_nFractalType, const int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal, doubleN &test1, doubleN &test2, doubleN &phase, intN &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr, doubleN &xi
  , const doubleN &cr, const doubleN &ci
  , const int64_t chunksize
  )
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 3:
          return FORMULA(perturbation,0,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 4:
          return FORMULA(perturbation,0,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 5:
          return FORMULA(perturbation,0,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 6:
          return FORMULA(perturbation,0,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 7:
          return FORMULA(perturbation,0,7)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 8:
          return FORMULA(perturbation,0,8)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 9:
          return FORMULA(perturbation,0,9)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 10:
          return FORMULA(perturbation,0,10)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 3:
          return FORMULA(perturbation,1,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 4:
          return FORMULA(perturbation,1,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 5:
          return FORMULA(perturbation,1,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 3:
          return FORMULA(perturbation,2,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 4:
          return FORMULA(perturbation,2,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 5:
          return FORMULA(perturbation,2,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 3:
          return FORMULA(perturbation,3,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 4:
          return FORMULA(perturbation,3,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 5:
          return FORMULA(perturbation,3,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 3:
          return FORMULA(perturbation,4,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 4:
          return FORMULA(perturbation,4,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
        case 5:
          return FORMULA(perturbation,4,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 1: a * z^2 + z^3 + c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 2: a * z^2 - z^3 + c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 3: 2 * z^2 - z^3 + c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 4: a * z^2 + z^4 + c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 5: a * z^2 - z^4 + c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 6: a * z^2 + z^5 + c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 7: a * z^2 - z^5 + c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 8: a * z^2 + z^6 + c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // TheRedshiftRider 9: a * z^2 - z^6 + c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // General Quadratic Minus
    case 52:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,52,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // General Quadratic Plus
    case 53:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,53,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 2nd 1x1
    case 54:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,54,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 3rd 1x2
    case 55:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,55,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 3rd 2x1
    case 56:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,56,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 4th 1x3
    case 57:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,57,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 4th 2x2 (aka SimonBrot 4th)
    case 58:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,58,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 4th 3x1
    case 59:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,59,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 5th 1x4
    case 60:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,60,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 5th 2x3
    case 61:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,61,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 5th 3x2
    case 62:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,62,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 5th 4x1
    case 63:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,63,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 6th 1x5
    case 64:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,64,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 6th 2x4 (Simon's Mothbrot)
    case 65:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,65,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 6th 3x3 (aka SimonBrot 6th)
    case 66:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,66,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 6th 4x2
    case 67:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,67,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // Mothbrot 6th 5x1
    case 68:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,68,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // General Abs Quadratic Minus
    case 69:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,69,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // General Abs Quadratic Plus
    case 70:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,70,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
    // z^2 exp(2 a / z) + c
    case 71:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,71,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal, test1, test2, phase, bGlitch
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr, xi
            , cr, ci
            , chunksize
            );
      
      }
      break;
  
  }
  return false;
}

// explicit template instantiation

#if KF_SIMD >= 1
template bool perturbation<int2, double2>
  ( const int m_nFractalType, const int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int2 &antal, double2 &test1, double2 &test2, double2 &phase, int2 &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const int2 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double2 &xr, double2 &xi
  , const double2 &cr, const double2 &ci
  , const int64_t chunksize
  );
#endif

#if KF_SIMD >= 2
template bool perturbation<int4, double4>
  ( const int m_nFractalType, const int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int4 &antal, double4 &test1, double4 &test2, double4 &phase, int4 &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const int4 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double4 &xr, double4 &xi
  , const double4 &cr, const double4 &ci
  , const int64_t chunksize
  );
#endif

#if KF_SIMD >= 3
template bool perturbation<int8, double8>
  ( const int m_nFractalType, const int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int8 &antal, double8 &test1, double8 &test2, double8 &phase, int8 &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const int8 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double8 &xr, double8 &xi
  , const double8 &cr, const double8 &ci
  , const int64_t chunksize
  );
#endif

#if KF_SIMD >= 4
template bool perturbation<int16, double16>
  ( const int m_nFractalType, const int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int16 &antal, double16 &test1, double16 &test2, double16 &phase, int16 &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const int16 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double16 &xr, double16 &xi
  , const double16 &cr, const double16 &ci
  , const int64_t chunksize
  );
#endif

#endif

#ifdef PASSA // perturbation with SIMD and derivatives



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{drn=((2*((Xxr*dr)-(Xxi*di)))+dr0);
din=((2*((Xxi*dr)+(Xxr*di)))+di0);
}

{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*((Xxr*xi)+(Xi*xr)))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

#ifdef KF_USE_TYPE_0_POWER_2_HAS_GLITCHED
        if (type_0_power_2_pixel_has_glitched(cr, ci, xr, xi, Xr, Xi, dxa0[k] / h, dya0[k] / h, e, h)) // FIXME matrix derivatives
        {
#endif

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

#ifdef KF_USE_TYPE_0_POWER_2_HAS_GLITCHED
        }
#endif

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

{drn=((2*((Xxr*dr)-(Xxi*di)))+dr0);
din=((2*((Xxi*dr)+(Xxr*di)))+di0);
}

{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*((Xxr*xi)+(Xi*xr)))+ci);
}

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{drn=((((3*(Xxr2-Xxi2))*dr)-((6*(Xxi*Xxr))*di))+dr0);
din=((((3*(Xxr2-Xxi2))*di)+((6*(Xxi*Xxr))*dr))+di0);
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((3*((((Xr2-Xi2)*xr)-(((2*Xxr)*Xi)*xi))+(Xr*(xr2-xi2))))+(xr*(xr2-(3*xi2))))+cr);
xin=(((3*((((Xr2-Xi2)*xi)+(((2*Xr)*xr)*Xxi))+(Xi*(xr2-xi2))))+(xi*((3*xr2)-xi2)))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

{drn=((((3*(Xxr2-Xxi2))*dr)-((6*(Xxi*Xxr))*di))+dr0);
din=((((3*(Xxr2-Xxi2))*di)+((6*(Xxi*Xxr))*dr))+di0);
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((3*((((Xr2-Xi2)*xr)-(((2*Xxr)*Xi)*xi))+(Xr*(xr2-xi2))))+(xr*(xr2-(3*xi2))))+cr);
xin=(((3*((((Xr2-Xi2)*xi)+(((2*Xr)*xr)*Xxi))+(Xi*(xr2-xi2))))+(xi*((3*xr2)-xi2)))+ci);
}

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{dn=(((4*d)*(Xx^3))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((4*(X^3))*x)+((6*(X^2))*(x^2)))+((4*X)*(x^3)))+(x^4))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{dn=(((4*d)*(Xx^3))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((4*(X^3))*x)+((6*(X^2))*(x^2)))+((4*X)*(x^3)))+(x^4))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{dn=(((5*d)*(Xx^4))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((5*(X^4))*x)+((10*(X^3))*(x^2)))+((10*(X^2))*(x^3)))+((5*X)*(x^4)))+(x^5))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{dn=(((5*d)*(Xx^4))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((5*(X^4))*x)+((10*(X^3))*(x^2)))+((10*(X^2))*(x^3)))+((5*X)*(x^4)))+(x^5))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{dn=(((6*d)*(Xx^5))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((6*(X^5))*x)+((15*(X^4))*(x^2)))+((20*(X^3))*(x^3)))+((15*(X^2))*(x^4)))+((6*X)*(x^5)))+(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{dn=(((6*d)*(Xx^5))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((6*(X^5))*x)+((15*(X^4))*(x^2)))+((20*(X^3))*(x^3)))+((15*(X^2))*(x^4)))+((6*X)*(x^5)))+(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,7)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{dn=(((7*d)*(Xx^6))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((((7*(X^6))*x)+((21*(X^5))*(x^2)))+((35*(X^4))*(x^3)))+((35*(X^3))*(x^4)))+((21*(X^2))*(x^5)))+((7*X)*(x^6)))+(x^7))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{dn=(((7*d)*(Xx^6))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((((7*(X^6))*x)+((21*(X^5))*(x^2)))+((35*(X^4))*(x^3)))+((35*(X^3))*(x^4)))+((21*(X^2))*(x^5)))+((7*X)*(x^6)))+(x^7))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,8)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{dn=(((8*d)*(Xx^7))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((((8*(X^7))*x)+((28*(X^6))*(x^2)))+((56*(X^5))*(x^3)))+((70*(X^4))*(x^4)))+((56*(X^3))*(x^5)))+((28*(X^2))*(x^6)))+((8*X)*(x^7)))+(x^8))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{dn=(((8*d)*(Xx^7))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((((8*(X^7))*x)+((28*(X^6))*(x^2)))+((56*(X^5))*(x^3)))+((70*(X^4))*(x^4)))+((56*(X^3))*(x^5)))+((28*(X^2))*(x^6)))+((8*X)*(x^7)))+(x^8))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,9)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{dn=(((9*d)*(Xx^8))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((((((9*(X^8))*x)+((36*(X^7))*(x^2)))+((84*(X^6))*(x^3)))+((126*(X^5))*(x^4)))+((126*(X^4))*(x^5)))+((84*(X^3))*(x^6)))+((36*(X^2))*(x^7)))+((9*X)*(x^8)))+(x^9))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{dn=(((9*d)*(Xx^8))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((((((9*(X^8))*x)+((36*(X^7))*(x^2)))+((84*(X^6))*(x^3)))+((126*(X^5))*(x^4)))+((126*(X^4))*(x^5)))+((84*(X^3))*(x^6)))+((36*(X^2))*(x^7)))+((9*X)*(x^8)))+(x^9))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,10)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{dn=(((10*d)*(Xx^9))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((((((10*(X^9))*x)+((45*(X^8))*(x^2)))+((120*(X^7))*(x^3)))+((210*(X^6))*(x^4)))+((252*(X^5))*(x^5)))+((210*(X^4))*(x^6)))+((120*(X^3))*(x^7)))+((45*(X^2))*(x^8)))+((10*X)*(x^9)))+(x^10))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{dn=(((10*d)*(Xx^9))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((((((10*(X^9))*x)+((45*(X^8))*(x^2)))+((120*(X^7))*(x^3)))+((210*(X^6))*(x^4)))+((252*(X^5))*(x^5)))+((210*(X^4))*(x^6)))+((120*(X^3))*(x^7)))+((45*(X^2))*(x^8)))+((10*X)*(x^9)))+(x^10))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,1,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba));
dybn=((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb));
}

{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba));
dybn=((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb));
}

{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,1,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+daa)));
dxbn=((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+dab)));
dyan=((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+dba)));
dybn=((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*Xr)*xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+daa)));
dxbn=((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+dab)));
dyan=((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+dba)));
dybn=((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*Xr)*xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,1,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+daa))));
dxbn=((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+dab))));
dyan=((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba))));
dybn=((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb))));
}

{xrn=((((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))-((((12*Xr)*Xr)*Xi)*xi))-((((6*Xr)*Xr)*xi)*xi))-((((12*Xr)*xr)*Xi)*Xi))-((((24*Xr)*xr)*Xi)*xi))-((((12*Xr)*xr)*xi)*xi))-((((6*xr)*xr)*Xi)*Xi))-((((12*xr)*xr)*Xi)*xi))-((((6*xr)*xr)*xi)*xi))+cr);
xin=((((4*((Xr*Xr)-(Xi*Xi)))*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+((4*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi))))*(((((2*xr)*Xr)+(xr*xr))-((2*xi)*Xi))-(xi*xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+daa))));
dxbn=((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+dab))));
dyan=((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba))));
dybn=((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb))));
}

{xrn=((((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))-((((12*Xr)*Xr)*Xi)*xi))-((((6*Xr)*Xr)*xi)*xi))-((((12*Xr)*xr)*Xi)*Xi))-((((24*Xr)*xr)*Xi)*xi))-((((12*Xr)*xr)*xi)*xi))-((((6*xr)*xr)*Xi)*Xi))-((((12*xr)*xr)*Xi)*xi))-((((6*xr)*xr)*xi)*xi))+cr);
xin=((((4*((Xr*Xr)-(Xi*Xi)))*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+((4*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi))))*(((((2*xr)*Xr)+(xr*xr))-((2*xi)*Xi))-(xi*xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,1,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+daa)))));
dxbn=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+dab)))));
dyan=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+dba)))));
dybn=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+dbb)))));
}

{xrn=(((diffabs(Xr,xr)*(((((Xr*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+((((5*Xi)*Xi)*Xi)*Xi)))+(abs((Xr+xr))*(((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((20*Xi)*Xi)*Xi)*xi))+((((30*Xi)*Xi)*xi)*xi))+((((20*Xi)*xi)*xi)*xi))+((((5*xi)*xi)*xi)*xi))))+cr);
xin=(((diffabs(Xi,xi)*((((((5*Xr)*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+(((Xi*Xi)*Xi)*Xi)))+(abs((Xi+xi))*(((((((((((((((((((20*Xr)*Xr)*Xr)*xr)+((((30*Xr)*Xr)*xr)*xr))+((((20*Xr)*xr)*xr)*xr))+((((5*xr)*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+daa)))));
dxbn=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+dab)))));
dyan=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+dba)))));
dybn=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+dbb)))));
}

{xrn=(((diffabs(Xr,xr)*(((((Xr*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+((((5*Xi)*Xi)*Xi)*Xi)))+(abs((Xr+xr))*(((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((20*Xi)*Xi)*Xi)*xi))+((((30*Xi)*Xi)*xi)*xi))+((((20*Xi)*xi)*xi)*xi))+((((5*xi)*xi)*xi)*xi))))+cr);
xin=(((diffabs(Xi,xi)*((((((5*Xr)*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+(((Xi*Xi)*Xi)*Xi)))+(abs((Xi+xi))*(((((((((((((((((((20*Xr)*Xr)*Xr)*xr)+((((30*Xr)*Xr)*xr)*xr))+((((20*Xr)*xr)*xr)*xr))+((((5*xr)*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,2,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba));
dybn=((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb));
}

{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi)))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba));
dybn=((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb));
}

{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi)))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,2,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa)));
dxbn=((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab)));
dyan=((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{xrn=(diffabs((Xr*((Xr*Xr)-((3*Xi)*Xi))),(((xr*(((3*Xr)*Xr)+(xr*xr)))+((3*Xr)*(((xr*xr)-((2*Xi)*xi))-(xi*xi))))-((3*xr)*(((Xi*Xi)+((2*Xi)*xi))+(xi*xi)))))+cr);
xin=(diffabs((Xi*(((3*Xr)*Xr)-(Xi*Xi))),((((3*Xi)*((((2*Xr)*xr)+(xr*xr))-(xi*xi)))+((3*xi)*(((Xr*Xr)+((2*Xr)*xr))+(xr*xr))))-(xi*(((3*Xi)*Xi)+(xi*xi)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa)));
dxbn=((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab)));
dyan=((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{xrn=(diffabs((Xr*((Xr*Xr)-((3*Xi)*Xi))),(((xr*(((3*Xr)*Xr)+(xr*xr)))+((3*Xr)*(((xr*xr)-((2*Xi)*xi))-(xi*xi))))-((3*xr)*(((Xi*Xi)+((2*Xi)*xi))+(xi*xi)))))+cr);
xin=(diffabs((Xi*(((3*Xr)*Xr)-(Xi*Xi))),((((3*Xi)*((((2*Xr)*xr)+(xr*xr))-(xi*xi)))+((3*xi)*(((Xr*Xr)+((2*Xr)*xr))+(xr*xr))))-(xi*(((3*Xi)*Xi)+(xi*xi)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,2,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2)))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2)))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,2,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2)))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2)))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,3,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((2*(Xxi*dxa))+((2*(Xxr*dya))+dba));
dybn=((2*(Xxi*dxb))+((2*(Xxr*dyb))+dbb));
}

{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi)))+cr);
xin=((((2*Xr)*xi)+((2*xr)*(Xi+xi)))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((2*(Xxi*dxa))+((2*(Xxr*dya))+dba));
dybn=((2*(Xxi*dxb))+((2*(Xxr*dyb))+dbb));
}

{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi)))+cr);
xin=((((2*Xr)*xi)+((2*xr)*(Xi+xi)))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,3,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa)));
dxbn=((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab)));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((Xr*(Xr2-(3*Xi2))),(((xr*((3*Xr2)+xr2))+((3*Xr)*((xr2-((2*Xi)*xi))-xi2)))-((3*xr)*((Xi2+((2*Xi)*xi))+xi2))))+cr);
xin=(((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*(xi2+(3*Xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa)));
dxbn=((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab)));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((Xr*(Xr2-(3*Xi2))),(((xr*((3*Xr2)+xr2))+((3*Xr)*((xr2-((2*Xi)*xi))-xi2)))-((3*xr)*((Xi2+((2*Xi)*xi))+xi2))))+cr);
xin=(((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*(xi2+(3*Xi2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,3,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,3,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((((Xr2*Xr2)*Xr)-(((10*Xr2)*Xr)*Xi2))+(((5*Xr)*Xi2)*Xi2)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((((Xr2*Xr2)*Xr)-(((10*Xr2)*Xr)*Xi2))+(((5*Xr)*Xi2)*Xi2)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,4,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((-2*(Xxi*dya))+((2*(Xxr*dxa))+daa));
dxbn=((-2*(Xxi*dyb))+((2*(Xxr*dxb))+dab));
dyan=((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba));
dybn=((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=(ci-(2*(((Xr*xi)+(xr*Xi))+(xr*xi))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((-2*(Xxi*dya))+((2*(Xxr*dxa))+daa));
dxbn=((-2*(Xxi*dyb))+((2*(Xxr*dxb))+dab));
dyan=((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba));
dybn=((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=(ci-(2*(((Xr*xi)+(xr*Xi))+(xr*xi))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,4,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((-6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((-6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((cr-(xr*((3*Xr2)+xr2)))+((3*Xr)*((xi2+((2*Xi)*xi))-xr2)))+((3*xr)*((Xi2+((2*Xi)*xi))+xi2)));
xin=(((((((((((6*Xr)*Xi)*xr)+((3*Xi)*xr2))-((3*Xi2)*xi))-((3*Xi)*xi2))+((3*Xr2)*xi))+(((6*Xr)*xr)*xi))+((3*xr2)*xi))-(xi2*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((-6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((-6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((cr-(xr*((3*Xr2)+xr2)))+((3*Xr)*((xi2+((2*Xi)*xi))-xr2)))+((3*xr)*((Xi2+((2*Xi)*xi))+xi2)));
xin=(((((((((((6*Xr)*Xi)*xr)+((3*Xi)*xr2))-((3*Xi2)*xi))-((3*Xi)*xi2))+((3*Xr2)*xi))+(((6*Xr)*xr)*xi))+((3*xr2)*xi))-(xi2*xi))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,4,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+dba))));
dybn=((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((((((((((((((-12*Xr2)*Xi)*xr)-(((12*Xr)*Xi)*xr2))+(((12*Xr)*Xi2)*xi))+(((12*Xr)*Xi)*xi2))-(((4*Xr2)*Xr)*xi))-(((12*Xr2)*xi)*xr))-(((12*Xr)*xi)*xr2))+(((4*Xr)*xi2)*xi))-(((4*xr2)*xr)*Xi))+(((4*xr)*Xi2)*Xi))+(((12*xr)*Xi2)*xi))+(((12*xr)*Xi)*xi2))-(((4*xr2)*xr)*xi))+(((4*xr)*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+dba))));
dybn=((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((((((((((((((-12*Xr2)*Xi)*xr)-(((12*Xr)*Xi)*xr2))+(((12*Xr)*Xi2)*xi))+(((12*Xr)*Xi)*xi2))-(((4*Xr2)*Xr)*xi))-(((12*Xr2)*xi)*xr))-(((12*Xr)*xi)*xr2))+(((4*Xr)*xi2)*xi))-(((4*xr2)*xr)*Xi))+(((4*xr)*Xi2)*Xi))+(((12*xr)*Xi2)*xi))+(((12*xr)*Xi)*xi2))-(((4*xr2)*xr)*xi))+(((4*xr)*xi2)*xi))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,4,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab)))));
dyan=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((((((((((((5*Xr2)*Xr2)*xr)+(((10*Xr2)*Xr)*xr2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xr2)*xr2))-((((20*Xr2)*Xr)*Xi)*xi))-(((10*Xr2)*Xr)*xi2))-(((30*Xr2)*xr)*Xi2))-((((60*Xr2)*xr)*Xi)*xi))-(((30*Xr2)*xr)*xi2))-(((30*Xr)*xr2)*Xi2))-((((60*Xr)*xr2)*Xi)*xi))-(((30*Xr)*xr2)*xi2))+((((20*Xr)*Xi2)*Xi)*xi))+(((30*Xr)*Xi2)*xi2))+((((20*Xr)*Xi)*xi2)*xi))+(((5*Xr)*xi2)*xi2))+((xr2*xr2)*xr))-(((10*xr2)*xr)*Xi2))-((((20*xr2)*xr)*Xi)*xi))-(((10*xr2)*xr)*xi2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*Xi2)*Xi)*xi))+(((30*xr)*Xi2)*xi2))+((((20*xr)*Xi)*xi2)*xi))+(((5*xr)*xi2)*xi2))+cr);
xin=(((((((((((((((((((((((((((((-20*Xi)*Xr2)*Xr)*xr)-(((30*Xi)*Xr2)*xr2))-((((20*Xi)*Xr)*xr2)*xr))-(((5*Xi)*xr2)*xr2))+(((30*Xi2)*Xr2)*xi))+(((30*Xi)*Xr2)*xi2))+((((20*Xi2)*Xi)*Xr)*xr))+((((60*Xi2)*Xr)*xr)*xi))+((((60*Xi)*Xr)*xr)*xi2))+(((10*Xi2)*Xi)*xr2))+(((30*Xi2)*xr2)*xi))+(((30*Xi)*xr2)*xi2))-(((5*Xi2)*Xi2)*xi))-(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*xi2)*xi))-(((5*Xi)*xi2)*xi2))-(((5*xi)*Xr2)*Xr2))-((((20*xi)*Xr2)*Xr)*xr))-(((30*xi)*Xr2)*xr2))-((((20*xi)*Xr)*xr2)*xr))-(((5*xi)*xr2)*xr2))+(((10*xi2)*xi)*Xr2))+((((20*xi2)*xi)*Xr)*xr))+(((10*xi2)*xi)*xr2))-((xi2*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab)))));
dyan=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((((((((((((5*Xr2)*Xr2)*xr)+(((10*Xr2)*Xr)*xr2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xr2)*xr2))-((((20*Xr2)*Xr)*Xi)*xi))-(((10*Xr2)*Xr)*xi2))-(((30*Xr2)*xr)*Xi2))-((((60*Xr2)*xr)*Xi)*xi))-(((30*Xr2)*xr)*xi2))-(((30*Xr)*xr2)*Xi2))-((((60*Xr)*xr2)*Xi)*xi))-(((30*Xr)*xr2)*xi2))+((((20*Xr)*Xi2)*Xi)*xi))+(((30*Xr)*Xi2)*xi2))+((((20*Xr)*Xi)*xi2)*xi))+(((5*Xr)*xi2)*xi2))+((xr2*xr2)*xr))-(((10*xr2)*xr)*Xi2))-((((20*xr2)*xr)*Xi)*xi))-(((10*xr2)*xr)*xi2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*Xi2)*Xi)*xi))+(((30*xr)*Xi2)*xi2))+((((20*xr)*Xi)*xi2)*xi))+(((5*xr)*xi2)*xi2))+cr);
xin=(((((((((((((((((((((((((((((-20*Xi)*Xr2)*Xr)*xr)-(((30*Xi)*Xr2)*xr2))-((((20*Xi)*Xr)*xr2)*xr))-(((5*Xi)*xr2)*xr2))+(((30*Xi2)*Xr2)*xi))+(((30*Xi)*Xr2)*xi2))+((((20*Xi2)*Xi)*Xr)*xr))+((((60*Xi2)*Xr)*xr)*xi))+((((60*Xi)*Xr)*xr)*xi2))+(((10*Xi2)*Xi)*xr2))+(((30*Xi2)*xr2)*xi))+(((30*Xi)*xr2)*xi2))-(((5*Xi2)*Xi2)*xi))-(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*xi2)*xi))-(((5*Xi)*xi2)*xi2))-(((5*xi)*Xr2)*Xr2))-((((20*xi)*Xr2)*Xr)*xr))-(((30*xi)*Xr2)*xr2))-((((20*xi)*Xr)*xr2)*xr))-(((5*xi)*xr2)*xr2))+(((10*xi2)*xi)*Xr2))+((((20*xi2)*xi)*Xr)*xr))+(((10*xi2)*xi)*xr2))-((xi2*xi2)*xi))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,5,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba));
dybn=((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=(((((Xr*xi)+(xr*Xi))+(xr*xi))*-2)+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba));
dybn=((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=(((((Xr*xi)+(xr*Xi))+(xr*xi))*-2)+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,6,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=(dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya))));
dybn=(dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=(dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya))));
dybn=(dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,7,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=(dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa))));
dybn=(dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=(dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa))));
dybn=(dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,8,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=(dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya))));
dybn=(dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=(dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya))));
dybn=(dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,9,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=(dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa))));
dybn=(dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=(dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa))));
dybn=(dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb))));
}

{const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,10,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=((-3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((-3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(ci-diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2)))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=((-3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((-3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(ci-diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2)))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,11,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((((((6*Xr)*((Xi*xr)+(xr*xi)))+((3*Xi)*(xr2-xi2)))+((3*xi)*(Xr2-Xi2)))+(xi*((3*xr2)-xi2)))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((((((6*Xr)*((Xi*xr)+(xr*xi)))+((3*Xi)*(xr2-xi2)))+((3*xi)*(Xr2-Xi2)))+(xi*((3*xr2)-xi2)))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,12,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((-1*(Xxi*(Xxi*(dya*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dya)))+((3*(Xxr*(Xxr*(dya*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxa)))+dba))));
dybn=((-1*(Xxi*(Xxi*(dyb*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dyb)))+((3*(Xxr*(Xxr*(dyb*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxb)))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*xr)*Xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((-1*(Xxi*(Xxi*(dya*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dya)))+((3*(Xxr*(Xxr*(dya*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxa)))+dba))));
dybn=((-1*(Xxi*(Xxi*(dyb*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dyb)))+((3*(Xxr*(Xxr*(dyb*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxb)))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*xr)*Xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,13,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,14,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=(dba+((2*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dya)))));
dybn=(dbb+((2*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dyb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((ci-(diffabs(((3*Xr2)-Xi2),(((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2))*Xi))-(abs(((((((3*Xr2)+((6*Xr)*xr))+(3*xr2))-Xi2)-((2*Xi)*xi))-xi2))*xi));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=(dba+((2*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dya)))));
dybn=(dbb+((2*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dyb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((ci-(diffabs(((3*Xr2)-Xi2),(((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2))*Xi))-(abs(((((((3*Xr2)+((6*Xr)*xr))+(3*xr2))-Xi2)-((2*Xi)*xi))-xi2))*xi));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,15,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxr*(Xxr*(Xxr*dxa))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxa)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+daa))));
dxbn=((4*(Xxr*(Xxr*(Xxr*dxb))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxb)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxr*(Xxr*(Xxr*dxa))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxa)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+daa))));
dxbn=((4*(Xxr*(Xxr*(Xxr*dxb))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxb)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,16,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,17,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,18,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxa))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))+daa))));
dxbn=((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxb))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxa))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))+daa))));
dxbn=((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxb))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,19,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dya))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dyb))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dya))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dyb))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,20,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa))));
dxbn=((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab))));
dyan=((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba))));
dybn=((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa))));
dxbn=((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab))));
dyan=((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba))));
dybn=((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,21,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,22,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(ci-((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi)));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(ci-((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi)));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,23,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab))));
dyan=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab))));
dyan=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,24,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab))));
dyan=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab))));
dyan=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,25,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab))));
dyan=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab))));
dyan=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,26,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab))));
dyan=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab))));
dyan=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,27,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya)))))));
dybn=(dbb+((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya)))))));
dybn=(dbb+((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,28,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya)))))));
dybn=(dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya)))))));
dybn=(dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,29,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,30,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dya)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dya))))))));
dybn=(dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dyb)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dyb))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dya)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dya))))))));
dybn=(dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dyb)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dyb))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,31,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa)))))));
dxbn=((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab)))))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya)))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((-(Xi)*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))-(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa)))))));
dxbn=((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab)))))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya)))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((-(Xi)*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))-(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,32,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa)))))));
dxbn=((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab)))))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((Xi*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))+(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa)))))));
dxbn=((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab)))))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((Xi*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))+(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,33,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(abs((Xxr*Xxr))*(Xxr*dxa)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxa)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dya)))+((2*(abs((Xxi*Xxi))*(Xxi*dya)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa))))))))))));
dxbn=((2*(abs((Xxr*Xxr))*(Xxr*dxb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxb)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dyb)))+((2*(abs((Xxi*Xxi))*(Xxi*dyb)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab))))))))))));
dyan=((2*(abs((Xxr*Xxr))*(Xxr*dya)))+((-2*(abs((Xxi*Xxi))*(Xxr*dya)))+((2*(abs((Xxr*Xxr))*(Xxi*dxa)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxa)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi)))))))+dba))))))))))));
dybn=((2*(abs((Xxr*Xxr))*(Xxr*dyb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dyb)))+((2*(abs((Xxr*Xxr))*(Xxi*dxb)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxb)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi)))))))+dbb))))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((Xi2*diffabs(Xi2,(((2*xi)*Xi)+xi2)))-(((4*Xi)*Xr)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))-(Xr2*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-(Xi2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+(Xr2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+((((2*xi)*Xi)+xi2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((4*(((Xi*xr)+(xi*Xr))+(xi*xr)))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))-((((2*Xr)*xr)+xr2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((((2*xi)*Xi)+xi2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+((((2*Xr)*xr)+xr2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+cr);
xin=((((((((((2*Xr2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+(((2*Xr)*Xi)*diffabs(Xr2,(((2*Xr)*xr)+xr2))))-(((2*Xr)*Xi)*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-((2*Xi2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))+((2*(((2*Xr)*xr)+xr2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xr2+((2*Xr)*xr))+xr2))))-((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xi2+((2*xi)*Xi))+xi2))))-((2*(((2*xi)*Xi)+xi2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(abs((Xxr*Xxr))*(Xxr*dxa)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxa)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dya)))+((2*(abs((Xxi*Xxi))*(Xxi*dya)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa))))))))))));
dxbn=((2*(abs((Xxr*Xxr))*(Xxr*dxb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxb)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dyb)))+((2*(abs((Xxi*Xxi))*(Xxi*dyb)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab))))))))))));
dyan=((2*(abs((Xxr*Xxr))*(Xxr*dya)))+((-2*(abs((Xxi*Xxi))*(Xxr*dya)))+((2*(abs((Xxr*Xxr))*(Xxi*dxa)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxa)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi)))))))+dba))))))))))));
dybn=((2*(abs((Xxr*Xxr))*(Xxr*dyb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dyb)))+((2*(abs((Xxr*Xxr))*(Xxi*dxb)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxb)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi)))))))+dbb))))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((Xi2*diffabs(Xi2,(((2*xi)*Xi)+xi2)))-(((4*Xi)*Xr)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))-(Xr2*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-(Xi2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+(Xr2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+((((2*xi)*Xi)+xi2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((4*(((Xi*xr)+(xi*Xr))+(xi*xr)))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))-((((2*Xr)*xr)+xr2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((((2*xi)*Xi)+xi2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+((((2*Xr)*xr)+xr2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+cr);
xin=((((((((((2*Xr2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+(((2*Xr)*Xi)*diffabs(Xr2,(((2*Xr)*xr)+xr2))))-(((2*Xr)*Xi)*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-((2*Xi2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))+((2*(((2*Xr)*xr)+xr2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xr2+((2*Xr)*xr))+xr2))))-((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xi2+((2*xi)*Xi))+xi2))))-((2*(((2*xi)*Xi)+xi2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,34,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,35,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,36,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,37,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,38,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,39,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,40,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dya))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dya))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxa))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxa))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxa))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa))))))))))))))))))))))));
dxbn=((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dyb))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dyb))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxb))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxb))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab))))))))))))))))))))))));
dyan=((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dya))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dya))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+dba))))))))))))))))))))))));
dybn=((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dyb))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dyb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+dbb))))))))))))))))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xi2*Xi))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xi2*Xi)))+((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr*Xi2)))-((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr*Xi2)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xi)))-((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xr)))+(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xr2*Xr)))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))+((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+cr);
xin=((((((((((((((((((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xi2*Xi))-(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xi2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr*Xi2)))-((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xi)))+((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr2*Xi)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr*Xi2)))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xr2*Xr)))+((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xr)))+((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dya))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dya))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxa))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxa))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxa))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa))))))))))))))))))))))));
dxbn=((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dyb))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dyb))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxb))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxb))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab))))))))))))))))))))))));
dyan=((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dya))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dya))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+dba))))))))))))))))))))))));
dybn=((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dyb))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dyb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+dbb))))))))))))))))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((((((((((((((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xi2*Xi))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xi2*Xi)))+((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr*Xi2)))-((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr*Xi2)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xi)))-((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xr)))+(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xr2*Xr)))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))+((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+cr);
xin=((((((((((((((((((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xi2*Xi))-(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xi2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr*Xi2)))-((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xi)))+((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr2*Xi)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr*Xi2)))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xr2*Xr)))+((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xr)))+((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,41,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(daa+((2*(Xxr*dxa))+((-2*(Xxi*dya))+(-1*(dxa*sgn(Xxr))))));
dxbn=(dab+((2*(Xxr*dxb))+((-2*(Xxi*dyb))+(-1*(dxb*sgn(Xxr))))));
dyan=(dba+((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+(-1*(dya*sgn(Xxi))))));
dybn=(dbb+((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+(-1*(dyb*sgn(Xxi))))));
}

{xrn=((((xr*((2*Xr)+xr))-(xi*(xi+(2*Xi))))-diffabs(Xr,xr))+cr);
xin=(((diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))*2)-diffabs(Xi,xi))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(daa+((2*(Xxr*dxa))+((-2*(Xxi*dya))+(-1*(dxa*sgn(Xxr))))));
dxbn=(dab+((2*(Xxr*dxb))+((-2*(Xxi*dyb))+(-1*(dxb*sgn(Xxr))))));
dyan=(dba+((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+(-1*(dya*sgn(Xxi))))));
dybn=(dbb+((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+(-1*(dyb*sgn(Xxi))))));
}

{xrn=((((xr*((2*Xr)+xr))-(xi*(xi+(2*Xi))))-diffabs(Xr,xr))+cr);
xin=(((diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))*2)-diffabs(Xi,xi))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,42,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=((((A*(2*X))+(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))+((3*X2)*x))+((3*X)*x2))+(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=((((A*(2*X))+(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))+((3*X2)*x))+((3*X)*x2))+(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,43,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=((((A*(2*X))-(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=((((A*(2*X))-(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,44,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=((((4*X)-(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((2*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=((((4*X)-(3*X2))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<T> X2 = X * X;
const complex<V> x2 = x * x;
xn=(((((2*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,45,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+(4*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))+((4*(X^3))*x))+((6*(X^2))*x2))+(((4*X)*x2)*x))+(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+(4*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))+((4*(X^3))*x))+((6*(X^2))*x2))+(((4*X)*x2)*x))+(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,46,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-(4*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))-((4*(X^3))*x))-((6*(X^2))*x2))-(((4*X)*x2)*x))-(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-(4*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))-((4*(X^3))*x))-((6*(X^2))*x2))-(((4*X)*x2)*x))-(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,47,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+((5*X2)*X))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))+((5*(X^4))*x))+((10*(X^3))*x2))+(((10*(X^2))*x2)*x))+((5*X)*(x2^2)))+((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+((5*X2)*X))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))+((5*(X^4))*x))+((10*(X^3))*x2))+(((10*(X^2))*x2)*x))+((5*X)*(x2^2)))+((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,48,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-((5*X2)*X))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))-((5*(X^4))*x))-((10*(X^3))*x2))-(((10*(X^2))*x2)*x))-((5*X)*(x2^2)))-((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-((5*X2)*X))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))-((5*(X^4))*x))-((10*(X^3))*x2))-(((10*(X^2))*x2)*x))-((5*X)*(x2^2)))-((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,49,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+((6*X2)*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((((A*(((2*X)*x)+x2))+((6*(X^5))*x))+((15*(X^4))*x2))+((20*(X^3))*(x2*x)))+((15*(X^2))*(x2^2)))+((6*X)*((x2*x2)*x)))+(x2^3))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)+((6*X2)*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{const complex<V> x2 = x * x;
xn=((((((((A*(((2*X)*x)+x2))+((6*(X^5))*x))+((15*(X^4))*x2))+((20*(X^3))*(x2*x)))+((15*(X^2))*(x2^2)))+((6*X)*((x2*x2)*x)))+(x2^3))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,50,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-((6*X2)*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((A*(((2*X)*x)+(x^2)))-((6*(X^5))*x))-((15*(X^4))*(x^2)))-((20*(X^3))*(x^3)))-((15*(X^2))*(x^4)))-((6*X)*(x^5)))-(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{const complex<T> X2 = X * X;
dn=(((((A*2)-((6*X2)*X2))*X)*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((A*(((2*X)*x)+(x^2)))-((6*(X^5))*x))-((15*(X^4))*(x^2)))-((20*(X^3))*(x^3)))-((15*(X^2))*(x^4)))-((6*X)*(x^5)))-(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,51,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(Xxr*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxa)))+((-2*(Xxi*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dya)))+((2*(Xxi*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa))))))))));
dxbn=((2*(Xxr*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxb)))+((-2*(Xxi*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dyb)))+((2*(Xxi*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab))))))))));
dyan=((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))))))))));
dybn=((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((Xr2-Xi2)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((Xr2+((2*Xr)*xr))+xr2)-Xi2)-((2*Xi)*xi))-xi2))))-(((2*Xr)*Xi)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi)))))-(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+cr);
xin=((((((Xr2-Xi2)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+(((2*Xr)*Xi)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))))+(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((Xr2-Xi2)+((2*Xr)*xr))+xr2)-((2*Xi)*xi))-xi2))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxa)))+((-2*(Xxi*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dya)))+((2*(Xxi*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa))))))))));
dxbn=((2*(Xxr*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxb)))+((-2*(Xxi*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dyb)))+((2*(Xxi*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab))))))))));
dyan=((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))))))))));
dybn=((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((Xr2-Xi2)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((Xr2+((2*Xr)*xr))+xr2)-Xi2)-((2*Xi)*xi))-xi2))))-(((2*Xr)*Xi)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi)))))-(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+cr);
xin=((((((Xr2-Xi2)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+(((2*Xr)*Xi)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))))+(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((Xr2-Xi2)+((2*Xr)*xr))+xr2)-((2*Xi)*xi))-xi2))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,52,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 52 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(((-2*(Xxi*dya))+(2*(Xxr*dxa)))+daa);
dxbn=(((-2*(Xxi*dyb))+(2*(Xxr*dxb)))+dab);
dyan=(((2*(Xxi*(dxa*g_FactorAR)))+((2*(Xxr*(dxa*g_FactorAI)))+(2*(Xxr*(dya*g_FactorAR)))))+dba);
dybn=(((2*(Xxi*(dxb*g_FactorAR)))+((2*(Xxr*(dxb*g_FactorAI)))+(2*(Xxr*(dyb*g_FactorAR)))))+dbb);
}

{xrn=((((((2*xr)*Xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(((-2*(Xxi*dya))+(2*(Xxr*dxa)))+daa);
dxbn=(((-2*(Xxi*dyb))+(2*(Xxr*dxb)))+dab);
dyan=(((2*(Xxi*(dxa*g_FactorAR)))+((2*(Xxr*(dxa*g_FactorAI)))+(2*(Xxr*(dya*g_FactorAR)))))+dba);
dybn=(((2*(Xxi*(dxb*g_FactorAR)))+((2*(Xxr*(dxb*g_FactorAI)))+(2*(Xxr*(dyb*g_FactorAR)))))+dbb);
}

{xrn=((((((2*xr)*Xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,53,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 53 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(((2*(Xxi*dya))+(2*(Xxr*dxa)))+daa);
dxbn=(((2*(Xxi*dyb))+(2*(Xxr*dxb)))+dab);
dyan=(((2*(Xxi*(dxa*g_FactorAR)))+((2*(Xxr*(dxa*g_FactorAI)))+(2*(Xxr*(dya*g_FactorAR)))))+dba);
dybn=(((2*(Xxi*(dxb*g_FactorAR)))+((2*(Xxr*(dxb*g_FactorAI)))+(2*(Xxr*(dyb*g_FactorAR)))))+dbb);
}

{xrn=((((((2*xr)*Xr)+(xr*xr))+((2*Xi)*xi))+(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(((2*(Xxi*dya))+(2*(Xxr*dxa)))+daa);
dxbn=(((2*(Xxi*dyb))+(2*(Xxr*dxb)))+dab);
dyan=(((2*(Xxi*(dxa*g_FactorAR)))+((2*(Xxr*(dxa*g_FactorAI)))+(2*(Xxr*(dya*g_FactorAR)))))+dba);
dybn=(((2*(Xxi*(dxb*g_FactorAR)))+((2*(Xxr*(dxb*g_FactorAI)))+(2*(Xxr*(dyb*g_FactorAR)))))+dbb);
}

{xrn=((((((2*xr)*Xr)+(xr*xr))+((2*Xi)*xi))+(xi*xi))+cr);
xin=((((2*Ar)*(((Xr*xi)+(xr*Xi))+(xr*xi)))+(Ai*(((2*xr)*Xr)+(xr*xr))))+ci);
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,54,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 54 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(daa+((Xxr*(dxa*sgn(Xxr)))+((dxa*abs(Xxr))+(-1*((Xxi*(dya*sgn(Xxi)))+(dya*abs(Xxi)))))));
dxbn=(dab+((Xxr*(dxb*sgn(Xxr)))+((dxb*abs(Xxr))+(-1*((Xxi*(dyb*sgn(Xxi)))+(dyb*abs(Xxi)))))));
dyan=(dba+((Xxi*(dxa*sgn(Xxr)))+((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr))))));
dybn=(dbb+((Xxi*(dxb*sgn(Xxr)))+((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr))))));
}

{xrn=(cr+((Xr*diffabs(Xr,xr))+((-1*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(xr*abs((Xr+xr))))));
xin=(ci+((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(daa+((Xxr*(dxa*sgn(Xxr)))+((dxa*abs(Xxr))+(-1*((Xxi*(dya*sgn(Xxi)))+(dya*abs(Xxi)))))));
dxbn=(dab+((Xxr*(dxb*sgn(Xxr)))+((dxb*abs(Xxr))+(-1*((Xxi*(dyb*sgn(Xxi)))+(dyb*abs(Xxi)))))));
dyan=(dba+((Xxi*(dxa*sgn(Xxr)))+((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr))))));
dybn=(dbb+((Xxi*(dxb*sgn(Xxr)))+((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr))))));
}

{xrn=(cr+((Xr*diffabs(Xr,xr))+((-1*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(xr*abs((Xr+xr))))));
xin=(ci+((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,55,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 55 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(daa+((abs(Xxr)*(dxa*abs(Xxr)))+((-1*(abs(Xxi)*(dxa*abs(Xxi))))+((-2*(sgn(Xxi)*((Xxi*(dya*abs(Xxr)))+(Xxr*(dya*abs(Xxi))))))+((2*(sgn(Xxr)*(Xxr*(dxa*abs(Xxr)))))+(-2*((sgn(Xxr)*(Xxi*(dxa*abs(Xxi))))+(abs(Xxi)*(dya*abs(Xxr))))))))));
dxbn=(dab+((abs(Xxr)*(dxb*abs(Xxr)))+((-1*(abs(Xxi)*(dxb*abs(Xxi))))+((-2*(sgn(Xxi)*((Xxi*(dyb*abs(Xxr)))+(Xxr*(dyb*abs(Xxi))))))+((2*(sgn(Xxr)*(Xxr*(dxb*abs(Xxr)))))+(-2*((sgn(Xxr)*(Xxi*(dxb*abs(Xxi))))+(abs(Xxi)*(dyb*abs(Xxr))))))))));
dyan=(dba+((-1*(abs(Xxi)*(dya*abs(Xxi))))+((2*((abs(Xxi)*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*(dxa*abs(Xxr)))+(Xxr*(dxa*abs(Xxi))))))))+((-2*(sgn(Xxi)*(Xxi*(dya*abs(Xxi)))))+(abs(Xxr)*(dya*abs(Xxr)))))));
dybn=(dbb+((-1*(abs(Xxi)*(dyb*abs(Xxi))))+((2*((abs(Xxi)*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*(dxb*abs(Xxr)))+(Xxr*(dxb*abs(Xxi))))))))+((-2*(sgn(Xxi)*(Xxi*(dyb*abs(Xxi)))))+(abs(Xxr)*(dyb*abs(Xxr)))))));
}

{xrn=(cr+((abs(Xr)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr+xr))*(Xr*diffabs(Xr,xr)))+((-1*((abs(Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xr+xr)))))+((-2*((abs(Xi)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xi+xi)))))+(abs((Xr+xr))*(xr*diffabs(Xr,xr))))))));
xin=(ci+((abs(Xr)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(Xi+xi)))+((-1*((abs(Xi)*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xi+xi)))))+(2*((abs(Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xr+xr)))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(daa+((abs(Xxr)*(dxa*abs(Xxr)))+((-1*(abs(Xxi)*(dxa*abs(Xxi))))+((-2*(sgn(Xxi)*((Xxi*(dya*abs(Xxr)))+(Xxr*(dya*abs(Xxi))))))+((2*(sgn(Xxr)*(Xxr*(dxa*abs(Xxr)))))+(-2*((sgn(Xxr)*(Xxi*(dxa*abs(Xxi))))+(abs(Xxi)*(dya*abs(Xxr))))))))));
dxbn=(dab+((abs(Xxr)*(dxb*abs(Xxr)))+((-1*(abs(Xxi)*(dxb*abs(Xxi))))+((-2*(sgn(Xxi)*((Xxi*(dyb*abs(Xxr)))+(Xxr*(dyb*abs(Xxi))))))+((2*(sgn(Xxr)*(Xxr*(dxb*abs(Xxr)))))+(-2*((sgn(Xxr)*(Xxi*(dxb*abs(Xxi))))+(abs(Xxi)*(dyb*abs(Xxr))))))))));
dyan=(dba+((-1*(abs(Xxi)*(dya*abs(Xxi))))+((2*((abs(Xxi)*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*(dxa*abs(Xxr)))+(Xxr*(dxa*abs(Xxi))))))))+((-2*(sgn(Xxi)*(Xxi*(dya*abs(Xxi)))))+(abs(Xxr)*(dya*abs(Xxr)))))));
dybn=(dbb+((-1*(abs(Xxi)*(dyb*abs(Xxi))))+((2*((abs(Xxi)*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*(dxb*abs(Xxr)))+(Xxr*(dxb*abs(Xxi))))))))+((-2*(sgn(Xxi)*(Xxi*(dyb*abs(Xxi)))))+(abs(Xxr)*(dyb*abs(Xxr)))))));
}

{xrn=(cr+((abs(Xr)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr+xr))*(Xr*diffabs(Xr,xr)))+((-1*((abs(Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xr+xr)))))+((-2*((abs(Xi)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xi+xi)))))+(abs((Xr+xr))*(xr*diffabs(Xr,xr))))))));
xin=(ci+((abs(Xr)*((Xi*diffabs(Xr,xr))+(xi*abs((Xr+xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(Xi+xi)))+((-1*((abs(Xi)*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs(Xi,xi)*(Xi+xi)))))+(2*((abs(Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(Xr+xr)))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,56,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 56 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(((Xxr*Xxr)*(dxa*sgn(Xxr)))+((-1*((Xxi*Xxi)*(dxa*sgn(Xxr))))+((-2*(Xxr*(dya*abs(Xxi))))+((2*(Xxr*(dxa*abs(Xxr))))+((-2*(Xxi*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr))))))+daa)))));
dxbn=(((Xxr*Xxr)*(dxb*sgn(Xxr)))+((-1*((Xxi*Xxi)*(dxb*sgn(Xxr))))+((-2*(Xxr*(dyb*abs(Xxi))))+((2*(Xxr*(dxb*abs(Xxr))))+((-2*(Xxi*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dab)))));
dyan=(((Xxr*Xxr)*(dya*sgn(Xxi)))+((-1*((Xxi*Xxi)*(dya*sgn(Xxi))))+((2*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((-2*(Xxi*(dya*abs(Xxi))))+((2*(Xxi*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr)))))+dba)))));
dybn=(((Xxr*Xxr)*(dyb*sgn(Xxi)))+((-1*((Xxi*Xxi)*(dyb*sgn(Xxi))))+((2*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((-2*(Xxi*(dyb*abs(Xxi))))+((2*(Xxi*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr)))))+dbb)))));
}

{xrn=(cr+(((Xr*Xr)*diffabs(Xr,xr))+((-1*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((-2*(xi*(xr*abs((Xi+xi)))))+((2*(Xr*(xr*abs((Xr+xr)))))+((-2*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((xr*xr)*abs((Xr+xr)))))))));
xin=(ci+(((Xr*Xr)*diffabs(Xi,xi))+((-1*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((2*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((-2*(Xi*(xi*abs((Xi+xi)))))+((xr*xr)*abs((Xi+xi))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(((Xxr*Xxr)*(dxa*sgn(Xxr)))+((-1*((Xxi*Xxi)*(dxa*sgn(Xxr))))+((-2*(Xxr*(dya*abs(Xxi))))+((2*(Xxr*(dxa*abs(Xxr))))+((-2*(Xxi*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr))))))+daa)))));
dxbn=(((Xxr*Xxr)*(dxb*sgn(Xxr)))+((-1*((Xxi*Xxi)*(dxb*sgn(Xxr))))+((-2*(Xxr*(dyb*abs(Xxi))))+((2*(Xxr*(dxb*abs(Xxr))))+((-2*(Xxi*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dab)))));
dyan=(((Xxr*Xxr)*(dya*sgn(Xxi)))+((-1*((Xxi*Xxi)*(dya*sgn(Xxi))))+((2*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((-2*(Xxi*(dya*abs(Xxi))))+((2*(Xxi*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr)))))+dba)))));
dybn=(((Xxr*Xxr)*(dyb*sgn(Xxi)))+((-1*((Xxi*Xxi)*(dyb*sgn(Xxi))))+((2*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((-2*(Xxi*(dyb*abs(Xxi))))+((2*(Xxi*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr)))))+dbb)))));
}

{xrn=(cr+(((Xr*Xr)*diffabs(Xr,xr))+((-1*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((-2*(xi*(xr*abs((Xi+xi)))))+((2*(Xr*(xr*abs((Xr+xr)))))+((-2*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((xr*xr)*abs((Xr+xr)))))))));
xin=(ci+(((Xr*Xr)*diffabs(Xi,xi))+((-1*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((2*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((-2*(Xi*(xi*abs((Xi+xi)))))+((xr*xr)*abs((Xi+xi))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,57,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 57 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(daa+((abs((Xxi*Xxi))*(dya*abs(Xxi)))+((abs((Xxr*Xxr))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dya*abs((Xxi*Xxi)))))+((sgn(Xxr)*(Xxr*(dxa*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dya*abs((Xxr*Xxr)))))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*Xxi))))))))+((-2*((abs((Xxi*Xxr))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+(sgn(Xxi)*((Xxr*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((2*((sgn(Xxr)*sgn(Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dya*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs(Xxr)))+(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*(dxa*abs(Xxi)))))))))+((2*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dya*abs(Xxi)))))+(-1*(abs((Xxr*Xxr))*(dya*abs(Xxi))))))))))))));
dxbn=(dab+((abs((Xxi*Xxi))*(dyb*abs(Xxi)))+((abs((Xxr*Xxr))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dyb*abs((Xxi*Xxi)))))+((sgn(Xxr)*(Xxr*(dxb*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dyb*abs((Xxr*Xxr)))))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*Xxi))))))))+((-2*((abs((Xxi*Xxr))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+(sgn(Xxi)*((Xxr*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((2*((sgn(Xxr)*sgn(Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dyb*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs(Xxr)))+(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*(dxb*abs(Xxi)))))))))+((2*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dyb*abs(Xxi)))))+(-1*(abs((Xxr*Xxr))*(dyb*abs(Xxi))))))))))))));
dyan=(dba+((abs((Xxr*Xxr))*(dxa*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dya*abs((Xxr*Xxr)))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dya*abs((Xxi*Xxi)))))+(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*Xxi))))))))+((-2*(abs((Xxi*Xxr))*(dya*abs(Xxi))))+((2*((abs((Xxi*Xxr))*(dxa*abs(Xxr)))+((sgn(Xxi)*(sgn(Xxr)*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*(Xxi*(dya*abs((Xxi*Xxr)))))+(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dya*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dya*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*(Xxr*(dxa*abs(Xxr))))+((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxi)))))))+(abs((Xxr*Xxr))*(dya*abs(Xxr)))))))))))));
dybn=(dbb+((abs((Xxr*Xxr))*(dxb*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxr*Xxr)))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxi*Xxi)))))+(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*Xxi))))))))+((-2*(abs((Xxi*Xxr))*(dyb*abs(Xxi))))+((2*((abs((Xxi*Xxr))*(dxb*abs(Xxr)))+((sgn(Xxi)*(sgn(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*(Xxi*(dyb*abs((Xxi*Xxr)))))+(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dyb*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dyb*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*(Xxr*(dxb*abs(Xxr))))+((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxi)))))))+(abs((Xxr*Xxr))*(dyb*abs(Xxr)))))))))))));
}

{xrn=(cr+((abs((Xi*Xi))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((-1*((abs((Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))))))+((-2*((abs((Xi*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xi+xi))))))+(abs((Xr*Xr))*(xr*abs((Xr+xr)))))))))));
xin=(ci+((abs((Xr*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+((-1*((abs((Xi*Xi))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi))))))+((2*((abs((Xi*Xr))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((2*((abs((Xi*Xr))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr*Xr))*(xr*abs((Xi+xi)))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(daa+((abs((Xxi*Xxi))*(dya*abs(Xxi)))+((abs((Xxr*Xxr))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dya*abs((Xxi*Xxi)))))+((sgn(Xxr)*(Xxr*(dxa*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dya*abs((Xxr*Xxr)))))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*Xxi))))))))+((-2*((abs((Xxi*Xxr))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+(sgn(Xxi)*((Xxr*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((2*((sgn(Xxr)*sgn(Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dya*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs(Xxr)))+(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*(dxa*abs(Xxi)))))))))+((2*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dya*abs(Xxi)))))+(-1*(abs((Xxr*Xxr))*(dya*abs(Xxi))))))))))))));
dxbn=(dab+((abs((Xxi*Xxi))*(dyb*abs(Xxi)))+((abs((Xxr*Xxr))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dyb*abs((Xxi*Xxi)))))+((sgn(Xxr)*(Xxr*(dxb*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxi*(dyb*abs((Xxr*Xxr)))))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*Xxi))))))))+((-2*((abs((Xxi*Xxr))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+(sgn(Xxi)*((Xxr*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((2*((sgn(Xxr)*sgn(Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dyb*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs(Xxr)))+(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*(dxb*abs(Xxi)))))))))+((2*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dyb*abs(Xxi)))))+(-1*(abs((Xxr*Xxr))*(dyb*abs(Xxi))))))))))))));
dyan=(dba+((abs((Xxr*Xxr))*(dxa*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dya*abs((Xxr*Xxr)))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dya*abs((Xxi*Xxi)))))+(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*Xxi))))))))+((-2*(abs((Xxi*Xxr))*(dya*abs(Xxi))))+((2*((abs((Xxi*Xxr))*(dxa*abs(Xxr)))+((sgn(Xxi)*(sgn(Xxr)*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*(Xxi*(dya*abs((Xxi*Xxr)))))+(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dya*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dya*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*(Xxr*(dxa*abs(Xxr))))+((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxi)))))))+(abs((Xxr*Xxr))*(dya*abs(Xxr)))))))))))));
dybn=(dbb+((abs((Xxr*Xxr))*(dxb*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxr*Xxr)))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxr*Xxr)))))+((-1*((abs((Xxi*Xxi))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxi*Xxi)))))+(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*Xxi))))))))+((-2*(abs((Xxi*Xxr))*(dyb*abs(Xxi))))+((2*((abs((Xxi*Xxr))*(dxb*abs(Xxr)))+((sgn(Xxi)*(sgn(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*(Xxi*(dyb*abs((Xxi*Xxr)))))+(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*(dyb*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dyb*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*(Xxr*(dxb*abs(Xxr))))+((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxi)))))))+(abs((Xxr*Xxr))*(dyb*abs(Xxr)))))))))))));
}

{xrn=(cr+((abs((Xi*Xi))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((-1*((abs((Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))))))+((-2*((abs((Xi*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xi+xi))))))+(abs((Xr*Xr))*(xr*abs((Xr+xr)))))))))));
xin=(ci+((abs((Xr*Xr))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xr+xr)))+((abs((Xr+xr))*(diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))*(Xi+xi)))+((-1*((abs((Xi*Xi))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xr+xr)))+(abs((Xr+xr))*(diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))*(Xi+xi))))))+((2*((abs((Xi*Xr))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((2*((abs((Xi*Xr))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+((-2*((abs((Xi*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr*Xr))*(xr*abs((Xi+xi)))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,58,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 58 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*(abs(Xxr)*(Xxr*(dxa*abs(Xxr)))))+((-2*((abs(Xxi)*(Xxr*(dxa*abs(Xxi))))+(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-2*((abs(Xxr)*(Xxi*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((2*((abs(Xxi)*(Xxi*(dya*abs(Xxi))))+(sgn(Xxi)*((Xxi*Xxi)*(dya*abs(Xxi))))))+((-4*((abs(Xxi)*((Xxi*(dxa*abs(Xxr)))+(Xxr*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxi))))))))+daa))))));
dxbn=((2*(abs(Xxr)*(Xxr*(dxb*abs(Xxr)))))+((-2*((abs(Xxi)*(Xxr*(dxb*abs(Xxi))))+(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-2*((abs(Xxr)*(Xxi*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((2*((abs(Xxi)*(Xxi*(dyb*abs(Xxi))))+(sgn(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxi))))))+((-4*((abs(Xxi)*((Xxi*(dxb*abs(Xxr)))+(Xxr*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxi))))))))+dab))))));
dyan=((2*(abs(Xxr)*(Xxr*(dya*abs(Xxr)))))+((-2*(abs(Xxi)*(Xxr*(dya*abs(Xxi)))))+((2*((abs(Xxr)*(Xxi*(dxa*abs(Xxr))))+(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))))+((-2*(abs(Xxi)*(Xxi*(dxa*abs(Xxi)))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((-2*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxi))))))+((4*(abs(Xxi)*(Xxr*(dxa*abs(Xxr)))))+((-4*((abs(Xxi)*(Xxi*(dya*abs(Xxr))))+(sgn(Xxi)*(Xxi*(Xxr*(dya*abs(Xxi)))))))+((4*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+dba)))))))));
dybn=((2*(abs(Xxr)*(Xxr*(dyb*abs(Xxr)))))+((-2*(abs(Xxi)*(Xxr*(dyb*abs(Xxi)))))+((2*((abs(Xxr)*(Xxi*(dxb*abs(Xxr))))+(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((-2*(abs(Xxi)*(Xxi*(dxb*abs(Xxi)))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((-2*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxi))))))+((4*(abs(Xxi)*(Xxr*(dxb*abs(Xxr)))))+((-4*((abs(Xxi)*(Xxi*(dyb*abs(Xxr))))+(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxi)))))))+((4*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dbb)))))))));
}

{xrn=(cr+((abs(Xi)*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xi*Xi)+(xi*xi))))+((abs((Xr+xr))*((Xr*Xr)*diffabs(Xr,xr)))+((-1*((abs(Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xr*Xr)+(xr*xr))))+(abs((Xr+xr))*(diffabs(Xr,xr)*((Xi*Xi)+(xi*xi))))))))+((2*((abs(Xr)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xi*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xr,xr))))))))+((2*((abs(Xi)*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(Xi,xi))))))+((-4*((abs(Xi)*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(diffabs(Xi,xi)*(Xr+xr)))+((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(Xr,xr)))))))))))));
xin=(ci+((2*((abs(Xi)*((xr*xr)*abs((Xr+xr))))+((abs(Xr)*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs(Xr,xr)))))))+((-2*((abs(Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((xi*xi)*diffabs(Xi,xi))))))+((2*((abs(Xr)*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(Xi,xi))))))+((2*((abs(Xi)*((Xr*Xr)*diffabs(Xr,xr)))+((abs(Xr)*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs(Xr,xr)))+((Xr*Xr)*diffabs(Xi,xi)))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs(Xi,xi)))))+((2*((Xi*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((-2*((abs(Xi)*(((Xi*Xi)*diffabs(Xr,xr))+(Xi*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(Xi,xi))))))+((4*((abs(Xi)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xi,xi))))))+((-4*((abs(Xi)*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xi,xi))))))+(2*(abs((Xr+xr))*((xr*xr)*diffabs(Xi,xi)))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(abs(Xxr)*(Xxr*(dxa*abs(Xxr)))))+((-2*((abs(Xxi)*(Xxr*(dxa*abs(Xxi))))+(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-2*((abs(Xxr)*(Xxi*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((2*((abs(Xxi)*(Xxi*(dya*abs(Xxi))))+(sgn(Xxi)*((Xxi*Xxi)*(dya*abs(Xxi))))))+((-4*((abs(Xxi)*((Xxi*(dxa*abs(Xxr)))+(Xxr*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxi))))))))+daa))))));
dxbn=((2*(abs(Xxr)*(Xxr*(dxb*abs(Xxr)))))+((-2*((abs(Xxi)*(Xxr*(dxb*abs(Xxi))))+(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-2*((abs(Xxr)*(Xxi*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((2*((abs(Xxi)*(Xxi*(dyb*abs(Xxi))))+(sgn(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxi))))))+((-4*((abs(Xxi)*((Xxi*(dxb*abs(Xxr)))+(Xxr*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxi))))))))+dab))))));
dyan=((2*(abs(Xxr)*(Xxr*(dya*abs(Xxr)))))+((-2*(abs(Xxi)*(Xxr*(dya*abs(Xxi)))))+((2*((abs(Xxr)*(Xxi*(dxa*abs(Xxr))))+(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))))+((-2*(abs(Xxi)*(Xxi*(dxa*abs(Xxi)))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((-2*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxi))))))+((4*(abs(Xxi)*(Xxr*(dxa*abs(Xxr)))))+((-4*((abs(Xxi)*(Xxi*(dya*abs(Xxr))))+(sgn(Xxi)*(Xxi*(Xxr*(dya*abs(Xxi)))))))+((4*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+dba)))))))));
dybn=((2*(abs(Xxr)*(Xxr*(dyb*abs(Xxr)))))+((-2*(abs(Xxi)*(Xxr*(dyb*abs(Xxi)))))+((2*((abs(Xxr)*(Xxi*(dxb*abs(Xxr))))+(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((-2*(abs(Xxi)*(Xxi*(dxb*abs(Xxi)))))+((2*(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((-2*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxi))))))+((4*(abs(Xxi)*(Xxr*(dxb*abs(Xxr)))))+((-4*((abs(Xxi)*(Xxi*(dyb*abs(Xxr))))+(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxi)))))))+((4*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dbb)))))))));
}

{xrn=(cr+((abs(Xi)*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xi*Xi)+(xi*xi))))+((abs((Xr+xr))*((Xr*Xr)*diffabs(Xr,xr)))+((-1*((abs(Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs(Xi,xi)*((Xr*Xr)+(xr*xr))))+(abs((Xr+xr))*(diffabs(Xr,xr)*((Xi*Xi)+(xi*xi))))))))+((2*((abs(Xr)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xi*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xr,xr))))))))+((2*((abs(Xi)*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(Xi,xi))))))+((-4*((abs(Xi)*((Xi*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(diffabs(Xi,xi)*(Xr+xr)))+((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(Xr,xr)))))))))))));
xin=(ci+((2*((abs(Xi)*((xr*xr)*abs((Xr+xr))))+((abs(Xr)*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs(Xr,xr)))))))+((-2*((abs(Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((xi*xi)*diffabs(Xi,xi))))))+((2*((abs(Xr)*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs(Xr,xr))))))+((-2*((abs(Xi)*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(Xi,xi))))))+((2*((abs(Xi)*((Xr*Xr)*diffabs(Xr,xr)))+((abs(Xr)*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs(Xr,xr)))+((Xr*Xr)*diffabs(Xi,xi)))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs(Xi,xi)))))+((2*((Xi*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((-2*((abs(Xi)*(((Xi*Xi)*diffabs(Xr,xr))+(Xi*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(Xi,xi))))))+((4*((abs(Xi)*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs(Xi,xi))))))+((-4*((abs(Xi)*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs(Xi,xi))))))+(2*(abs((Xr+xr))*((xr*xr)*diffabs(Xi,xi)))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,59,4)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 59 && m_nPower == 4)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((Xxi*((Xxi*Xxi)*(dya*sgn(Xxi))))+((Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))+((-3*((Xxr*Xxr)*(dya*abs(Xxi))))+((3*(((Xxi*Xxi)*(dya*abs(Xxi)))+((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-3*(((Xxi*Xxi)*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((-6*(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+daa))))));
dxbn=((Xxi*((Xxi*Xxi)*(dyb*sgn(Xxi))))+((Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))+((-3*((Xxr*Xxr)*(dyb*abs(Xxi))))+((3*(((Xxi*Xxi)*(dyb*abs(Xxi)))+((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-3*(((Xxi*Xxi)*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((-6*(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dab))))));
dyan=((Xxr*((Xxr*Xxr)*(dya*sgn(Xxi))))+((-1*(Xxi*((Xxi*Xxi)*(dxa*sgn(Xxr)))))+((3*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((-3*((Xxi*Xxi)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((3*(Xxi*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((-3*((Xxi*Xxi)*(Xxr*(dya*sgn(Xxi)))))+((-6*(Xxi*(Xxr*(dya*abs(Xxi)))))+((6*(Xxi*(Xxr*(dxa*abs(Xxr)))))+dba))))))));
dybn=((Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi))))+((-1*(Xxi*((Xxi*Xxi)*(dxb*sgn(Xxr)))))+((3*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((-3*((Xxi*Xxi)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((3*(Xxi*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((-3*((Xxi*Xxi)*(Xxr*(dyb*sgn(Xxi)))))+((-6*(Xxi*(Xxr*(dyb*abs(Xxi)))))+((6*(Xxi*(Xxr*(dxb*abs(Xxr)))))+dbb))))))));
}

{xrn=(cr+((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+((-3*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((3*(Xr*((xr*xr)*abs((Xr+xr)))))+((-3*(Xr*((xi*xi)*abs((Xr+xr)))))+((3*((Xr*Xr)*(xr*abs((Xr+xr)))))+((-3*((Xi*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((3*(Xi*((xi*xi)*abs((Xi+xi)))))+((-3*((Xi*Xi)*(xr*abs((Xr+xr)))))+((3*((Xi*Xi)*(xi*abs((Xi+xi)))))+((-3*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((-6*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*((xr*xr)*abs((Xr+xr))))))))))))))))));
xin=(ci+((Xr*((Xr*Xr)*diffabs(Xi,xi)))+((-1*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((3*(xi*((xr*xr)*abs((Xr+xr)))))+((-3*((xi*xi)*(xr*abs((Xi+xi)))))+((3*(Xr*((xr*xr)*abs((Xi+xi)))))+((-3*(Xr*((xi*xi)*abs((Xi+xi)))))+((3*((Xi*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-3*(((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xi*((xi*xi)*abs((Xr+xr))))))+((6*(Xr*(xi*(xr*abs((Xr+xr))))))+((-6*(Xi*(xi*(xr*abs((Xi+xi))))))+((6*(Xi*(Xr*(xr*abs((Xr+xr))))))+((-6*(Xi*(Xr*(xi*abs((Xi+xi))))))+(xr*((xr*xr)*abs((Xi+xi)))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxi*((Xxi*Xxi)*(dya*sgn(Xxi))))+((Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))+((-3*((Xxr*Xxr)*(dya*abs(Xxi))))+((3*(((Xxi*Xxi)*(dya*abs(Xxi)))+((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-3*(((Xxi*Xxi)*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((-6*(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+daa))))));
dxbn=((Xxi*((Xxi*Xxi)*(dyb*sgn(Xxi))))+((Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))+((-3*((Xxr*Xxr)*(dyb*abs(Xxi))))+((3*(((Xxi*Xxi)*(dyb*abs(Xxi)))+((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-3*(((Xxi*Xxi)*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((-6*(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dab))))));
dyan=((Xxr*((Xxr*Xxr)*(dya*sgn(Xxi))))+((-1*(Xxi*((Xxi*Xxi)*(dxa*sgn(Xxr)))))+((3*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((-3*((Xxi*Xxi)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((3*(Xxi*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((-3*((Xxi*Xxi)*(Xxr*(dya*sgn(Xxi)))))+((-6*(Xxi*(Xxr*(dya*abs(Xxi)))))+((6*(Xxi*(Xxr*(dxa*abs(Xxr)))))+dba))))))));
dybn=((Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi))))+((-1*(Xxi*((Xxi*Xxi)*(dxb*sgn(Xxr)))))+((3*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((-3*((Xxi*Xxi)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((3*(Xxi*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((-3*((Xxi*Xxi)*(Xxr*(dyb*sgn(Xxi)))))+((-6*(Xxi*(Xxr*(dyb*abs(Xxi)))))+((6*(Xxi*(Xxr*(dxb*abs(Xxr)))))+dbb))))))));
}

{xrn=(cr+((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+((-3*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((3*(Xr*((xr*xr)*abs((Xr+xr)))))+((-3*(Xr*((xi*xi)*abs((Xr+xr)))))+((3*((Xr*Xr)*(xr*abs((Xr+xr)))))+((-3*((Xi*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((3*(Xi*((xi*xi)*abs((Xi+xi)))))+((-3*((Xi*Xi)*(xr*abs((Xr+xr)))))+((3*((Xi*Xi)*(xi*abs((Xi+xi)))))+((-3*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((-6*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*((xr*xr)*abs((Xr+xr))))))))))))))))));
xin=(ci+((Xr*((Xr*Xr)*diffabs(Xi,xi)))+((-1*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((3*(xi*((xr*xr)*abs((Xr+xr)))))+((-3*((xi*xi)*(xr*abs((Xi+xi)))))+((3*(Xr*((xr*xr)*abs((Xi+xi)))))+((-3*(Xr*((xi*xi)*abs((Xi+xi)))))+((3*((Xi*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-3*(((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xi*((xi*xi)*abs((Xr+xr))))))+((6*(Xr*(xi*(xr*abs((Xr+xr))))))+((-6*(Xi*(xi*(xr*abs((Xi+xi))))))+((6*(Xi*(Xr*(xr*abs((Xr+xr))))))+((-6*(Xi*(Xr*(xi*abs((Xi+xi))))))+(xr*((xr*xr)*abs((Xi+xi)))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,60,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 60 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(daa+((abs((Xxi*(Xxi*Xxi)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((abs((Xxr*(Xxr*Xxr)))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dya*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxi*(dxa*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dxa*abs((Xxr*(Xxr*Xxr)))))))+((-1*(sgn(Xxi)*(Xxi*(dya*abs((Xxr*(Xxr*Xxr)))))))+((-3*(abs((Xxi*(Xxr*Xxr)))*(dya*abs(Xxr))))+((3*(abs(((Xxi*Xxi)*Xxr))*(dya*abs(Xxi))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxa*abs(Xxr)))+((abs((Xxi*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*((Xxr*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxr*(dxa*abs(((Xxi*Xxi)*Xxr)))))))))+((3*((sgn(Xxi)*(Xxi*(dya*abs(((Xxi*Xxi)*Xxr)))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-3*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*((Xxi*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*((Xxi*Xxi)*(dya*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+(-1*(abs((Xxr*(Xxr*Xxr)))*(dya*abs(Xxi)))))))))))))))))));
dxbn=(dab+((abs((Xxi*(Xxi*Xxi)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((abs((Xxr*(Xxr*Xxr)))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxi*(dxb*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dxb*abs((Xxr*(Xxr*Xxr)))))))+((-1*(sgn(Xxi)*(Xxi*(dyb*abs((Xxr*(Xxr*Xxr)))))))+((-3*(abs((Xxi*(Xxr*Xxr)))*(dyb*abs(Xxr))))+((3*(abs(((Xxi*Xxi)*Xxr))*(dyb*abs(Xxi))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxb*abs(Xxr)))+((abs((Xxi*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*((Xxr*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxr*(dxb*abs(((Xxi*Xxi)*Xxr)))))))))+((3*((sgn(Xxi)*(Xxi*(dyb*abs(((Xxi*Xxi)*Xxr)))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-3*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*((Xxi*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*((Xxi*Xxi)*(dyb*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+(-1*(abs((Xxr*(Xxr*Xxr)))*(dyb*abs(Xxi)))))))))))))))))));
dyan=(dba+((abs((Xxi*(Xxi*Xxi)))*(dya*abs(Xxi)))+((abs((Xxr*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*((Xxi*(dya*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dya*abs((Xxr*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxr*(Xxr*Xxr))))))+((-1*((abs((Xxi*(Xxi*Xxi)))*(dxa*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dya*abs(Xxr)))+(abs((Xxi*(Xxr*Xxr)))*(dya*abs(Xxi)))))+((3*(abs((Xxi*(Xxr*Xxr)))*(dxa*abs(Xxr))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxa*abs(Xxi)))+(sgn(Xxi)*(Xxr*(dya*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*((Xxr*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((-3*((sgn(Xxi)*((Xxi*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(dxa*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxa*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((-6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+(abs((Xxr*(Xxr*Xxr)))*(dya*abs(Xxr)))))))))))))))))));
dybn=(dbb+((abs((Xxi*(Xxi*Xxi)))*(dyb*abs(Xxi)))+((abs((Xxr*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*((Xxi*(dyb*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dyb*abs((Xxr*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxr*(Xxr*Xxr))))))+((-1*((abs((Xxi*(Xxi*Xxi)))*(dxb*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dyb*abs(Xxr)))+(abs((Xxi*(Xxr*Xxr)))*(dyb*abs(Xxi)))))+((3*(abs((Xxi*(Xxr*Xxr)))*(dxb*abs(Xxr))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxb*abs(Xxi)))+(sgn(Xxi)*(Xxr*(dyb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*((Xxr*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((-3*((sgn(Xxi)*((Xxi*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(dxb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxb*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((-6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+(abs((Xxr*(Xxr*Xxr)))*(dyb*abs(Xxr)))))))))))))))))));
}

{xrn=(cr+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))+((abs((Xr+xr))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((-1*((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))))+((-3*((abs(((Xi*Xi)*Xr))*(xr*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-3*((abs(((Xi*Xi)*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xr+xr))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))+((-1*((abs((Xi*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))))+((3*((abs((Xi*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi*(Xr*Xr)))*(xi*abs((Xi+xi))))+((abs((Xi+xi))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xi+xi))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(daa+((abs((Xxi*(Xxi*Xxi)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((abs((Xxr*(Xxr*Xxr)))*(dxa*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dya*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxi*(dxa*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dxa*abs((Xxr*(Xxr*Xxr)))))))+((-1*(sgn(Xxi)*(Xxi*(dya*abs((Xxr*(Xxr*Xxr)))))))+((-3*(abs((Xxi*(Xxr*Xxr)))*(dya*abs(Xxr))))+((3*(abs(((Xxi*Xxi)*Xxr))*(dya*abs(Xxi))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxa*abs(Xxr)))+((abs((Xxi*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*((Xxr*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxr*(dxa*abs(((Xxi*Xxi)*Xxr)))))))))+((3*((sgn(Xxi)*(Xxi*(dya*abs(((Xxi*Xxi)*Xxr)))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-3*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*((Xxi*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*((Xxi*Xxi)*(dya*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+(-1*(abs((Xxr*(Xxr*Xxr)))*(dya*abs(Xxi)))))))))))))))))));
dxbn=(dab+((abs((Xxi*(Xxi*Xxi)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((abs((Xxr*(Xxr*Xxr)))*(dxb*abs(Xxr)))+((sgn(Xxi)*(Xxr*(dyb*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxi*(dxb*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dxb*abs((Xxr*(Xxr*Xxr)))))))+((-1*(sgn(Xxi)*(Xxi*(dyb*abs((Xxr*(Xxr*Xxr)))))))+((-3*(abs((Xxi*(Xxr*Xxr)))*(dyb*abs(Xxr))))+((3*(abs(((Xxi*Xxi)*Xxr))*(dyb*abs(Xxi))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxb*abs(Xxr)))+((abs((Xxi*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*((Xxr*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxr*(dxb*abs(((Xxi*Xxi)*Xxr)))))))))+((3*((sgn(Xxi)*(Xxi*(dyb*abs(((Xxi*Xxi)*Xxr)))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-3*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*((Xxi*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*((Xxi*Xxi)*(dyb*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+(-1*(abs((Xxr*(Xxr*Xxr)))*(dyb*abs(Xxi)))))))))))))))))));
dyan=(dba+((abs((Xxi*(Xxi*Xxi)))*(dya*abs(Xxi)))+((abs((Xxr*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*((Xxi*(dya*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dya*abs((Xxr*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxa*abs((Xxr*(Xxr*Xxr))))))+((-1*((abs((Xxi*(Xxi*Xxi)))*(dxa*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dya*abs(Xxr)))+(abs((Xxi*(Xxr*Xxr)))*(dya*abs(Xxi)))))+((3*(abs((Xxi*(Xxr*Xxr)))*(dxa*abs(Xxr))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxa*abs(Xxi)))+(sgn(Xxi)*(Xxr*(dya*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*((Xxr*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((-3*((sgn(Xxi)*((Xxi*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(dxa*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxa*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((-6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+(abs((Xxr*(Xxr*Xxr)))*(dya*abs(Xxr)))))))))))))))))));
dybn=(dbb+((abs((Xxi*(Xxi*Xxi)))*(dyb*abs(Xxi)))+((abs((Xxr*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*((Xxi*(dyb*abs((Xxi*(Xxi*Xxi)))))+(Xxr*(dyb*abs((Xxr*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxb*abs((Xxr*(Xxr*Xxr))))))+((-1*((abs((Xxi*(Xxi*Xxi)))*(dxb*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dyb*abs(Xxr)))+(abs((Xxi*(Xxr*Xxr)))*(dyb*abs(Xxi)))))+((3*(abs((Xxi*(Xxr*Xxr)))*(dxb*abs(Xxr))))+((-3*((abs(((Xxi*Xxi)*Xxr))*(dxb*abs(Xxi)))+(sgn(Xxi)*(Xxr*(dyb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*((Xxr*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((-3*((sgn(Xxi)*((Xxi*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(dxb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))))+(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxb*abs(Xxr))))+((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((-6*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((6*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+(abs((Xxr*(Xxr*Xxr)))*(dyb*abs(Xxr)))))))))))))))))));
}

{xrn=(cr+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))+((abs((Xr+xr))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((-1*((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))))+((-3*((abs(((Xi*Xi)*Xr))*(xr*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-3*((abs(((Xi*Xi)*Xr))*(Xr*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xr+xr))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+((Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))+((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*(Xi+xi)))+((-1*((abs((Xi*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*(Xr+xr)))))+((3*((abs((Xi*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((abs((Xi*(Xr*Xr)))*(xi*abs((Xi+xi))))+((abs((Xi+xi))*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xi*diffabs(Xr,xr))+(Xr*diffabs(Xi,xi))))+((abs((Xi*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+(abs((Xr*(Xr*Xr)))*(xr*abs((Xi+xi))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,61,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 61 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dxa*abs((Xxr*Xxr))))))+((-1*(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dxa*abs((Xxi*Xxi)))))))+((-2*(abs((Xxr*Xxr))*(Xxr*(dya*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxr*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxr*(dxa*abs(Xxr))))))+((-2*((abs((Xxi*Xxi))*(Xxr*(dxa*abs(Xxr))))+(sgn(Xxi)*(((Xxr*Xxr)*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dya*abs(Xxr)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dya*abs(Xxr)))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dxa*abs(Xxi)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dxa*abs(Xxi)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxr*Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((2*(sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))))+((-4*(abs((Xxi*Xxr))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+((4*(abs((Xxi*Xxr))*(Xxi*(dya*abs(Xxi)))))+((-4*((abs((Xxi*Xxr))*(Xxi*(dxa*abs(Xxr))))+((sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((4*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+daa)))))))))))))))))))));
dxbn=((sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dxb*abs((Xxr*Xxr))))))+((-1*(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dxb*abs((Xxi*Xxi)))))))+((-2*(abs((Xxr*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxr*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxr*(dxb*abs(Xxr))))))+((-2*((abs((Xxi*Xxi))*(Xxr*(dxb*abs(Xxr))))+(sgn(Xxi)*(((Xxr*Xxr)*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dyb*abs(Xxr)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dyb*abs(Xxr)))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dxb*abs(Xxi)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dxb*abs(Xxi)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxr*Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((2*(sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))))+((-4*(abs((Xxi*Xxr))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+((4*(abs((Xxi*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((-4*((abs((Xxi*Xxr))*(Xxi*(dxb*abs(Xxr))))+((sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((4*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+dab)))))))))))))))))))));
dyan=((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))+((-1*(sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dya*abs((Xxi*Xxi)))))))+((2*(abs((Xxr*Xxr))*(Xxr*(dya*abs(Xxr)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dya*abs(Xxr)))))+((2*(abs((Xxr*Xxr))*(Xxr*(dxa*abs(Xxi)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dxa*abs(Xxi)))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dya*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxi*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxi*(dxa*abs(Xxr))))))+((-2*(abs((Xxi*Xxi))*(Xxi*(dxa*abs(Xxr)))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxr*Xxr)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*Xxi))))))))+((2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-2*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+((2*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))))+((-2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))))+((-4*(abs((Xxi*Xxr))*(Xxr*(dya*abs(Xxi)))))+((4*(abs((Xxi*Xxr))*(Xxr*(dxa*abs(Xxr)))))+((-4*((abs((Xxi*Xxr))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(sgn(Xxi)*((Xxi*(Xxr*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((4*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+dba)))))))))))))))))))));
dybn=((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))+((-1*(sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dyb*abs((Xxi*Xxi)))))))+((2*(abs((Xxr*Xxr))*(Xxr*(dyb*abs(Xxr)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dyb*abs(Xxr)))))+((2*(abs((Xxr*Xxr))*(Xxr*(dxb*abs(Xxi)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dxb*abs(Xxi)))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxi*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxi*(dxb*abs(Xxr))))))+((-2*(abs((Xxi*Xxi))*(Xxi*(dxb*abs(Xxr)))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxr*Xxr)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*Xxi))))))))+((2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-2*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+((2*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))))+((-2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))))+((-4*(abs((Xxi*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((4*(abs((Xxi*Xxr))*(Xxr*(dxb*abs(Xxr)))))+((-4*((abs((Xxi*Xxr))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(sgn(Xxi)*((Xxi*(Xxr*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((4*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+dbb)))))))))))))))))))));
}

{xrn=(cr+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-2*((abs((Xi*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xr*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xr*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))))+((-2*((abs((Xi*Xi))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xr*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(Xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xr*Xr))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((2*((abs((Xi*Xi))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-2*(abs((Xr*Xr))*(Xi*(Xr*diffabs(Xi,xi)))))+((2*(abs((Xi*Xi))*(Xi*(Xr*diffabs(Xi,xi)))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-4*((abs((Xi*Xr))*((Xi*(xr*abs((Xr+xr))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((4*((abs((Xi*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((2*((abs((Xi*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xr*Xr))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*Xr))*((xi*xi)*abs((Xr+xr))))+(abs((Xr+xr))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((2*(abs((Xr*Xr))*(Xr*(xr*abs((Xi+xi))))))+((-2*(abs((Xi*Xi))*(Xr*(xr*abs((Xi+xi))))))+((2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((2*((abs((Xr*Xr))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-2*((abs((Xi*Xi))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(Xi*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xi*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xr*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((-2*((abs((Xi*Xi))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-4*((abs((Xi*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((4*((abs((Xi*Xr))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xi+xi))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dxa*abs((Xxr*Xxr))))))+((-1*(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dxa*abs((Xxi*Xxi)))))))+((-2*(abs((Xxr*Xxr))*(Xxr*(dya*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxr*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxr*(dxa*abs(Xxr))))))+((-2*((abs((Xxi*Xxi))*(Xxr*(dxa*abs(Xxr))))+(sgn(Xxi)*(((Xxr*Xxr)*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dya*abs(Xxr)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dya*abs(Xxr)))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dxa*abs(Xxi)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dxa*abs(Xxi)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxr*Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((2*(sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))))+((-4*(abs((Xxi*Xxr))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+((4*(abs((Xxi*Xxr))*(Xxi*(dya*abs(Xxi)))))+((-4*((abs((Xxi*Xxr))*(Xxi*(dxa*abs(Xxr))))+((sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((4*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+daa)))))))))))))))))))));
dxbn=((sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dxb*abs((Xxr*Xxr))))))+((-1*(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dxb*abs((Xxi*Xxi)))))))+((-2*(abs((Xxr*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxr*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxr*(dxb*abs(Xxr))))))+((-2*((abs((Xxi*Xxi))*(Xxr*(dxb*abs(Xxr))))+(sgn(Xxi)*(((Xxr*Xxr)*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dyb*abs(Xxr)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dyb*abs(Xxr)))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dxb*abs(Xxi)))))+((2*(abs((Xxi*Xxi))*(Xxi*(dxb*abs(Xxi)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxr*Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*Xxi)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((2*(sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*Xxr))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))))+((-4*(abs((Xxi*Xxr))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+((4*(abs((Xxi*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((-4*((abs((Xxi*Xxr))*(Xxi*(dxb*abs(Xxr))))+((sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((4*((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+dab)))))))))))))))))))));
dyan=((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))+((-1*(sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dya*abs((Xxi*Xxi)))))))+((2*(abs((Xxr*Xxr))*(Xxr*(dya*abs(Xxr)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dya*abs(Xxr)))))+((2*(abs((Xxr*Xxr))*(Xxr*(dxa*abs(Xxi)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dxa*abs(Xxi)))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dya*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxi*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxi*(dxa*abs(Xxr))))))+((-2*(abs((Xxi*Xxi))*(Xxi*(dxa*abs(Xxr)))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxr*Xxr)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*Xxi))))))))+((2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-2*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+((2*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))))+((-2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))))+((-4*(abs((Xxi*Xxr))*(Xxr*(dya*abs(Xxi)))))+((4*(abs((Xxi*Xxr))*(Xxr*(dxa*abs(Xxr)))))+((-4*((abs((Xxi*Xxr))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(sgn(Xxi)*((Xxi*(Xxr*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((4*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+dba)))))))))))))))))))));
dybn=((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*Xxi))))+((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))+((-1*(sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxr*Xxr))))+((Xxr*Xxr)*(dyb*abs((Xxi*Xxi)))))))+((2*(abs((Xxr*Xxr))*(Xxr*(dyb*abs(Xxr)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dyb*abs(Xxr)))))+((2*(abs((Xxr*Xxr))*(Xxr*(dxb*abs(Xxi)))))+((-2*(abs((Xxi*Xxi))*(Xxr*(dxb*abs(Xxi)))))+((2*((sgn(Xxi)*(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((-2*(abs((Xxr*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((2*((abs((Xxi*Xxi))*(Xxi*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*(Xxi*(dxb*abs(Xxr))))))+((-2*(abs((Xxi*Xxi))*(Xxi*(dxb*abs(Xxr)))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxr*Xxr)))))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*Xxi))))))))+((2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-2*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxi*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+((2*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))))+((-2*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))))+((-4*(abs((Xxi*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((4*(abs((Xxi*Xxr))*(Xxr*(dxb*abs(Xxr)))))+((-4*((abs((Xxi*Xxr))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(sgn(Xxi)*((Xxi*(Xxr*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((4*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+dbb)))))))))))))))))))));
}

{xrn=(cr+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-2*((abs((Xi*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xr*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xr*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))))+((-2*((abs((Xi*Xi))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xr*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*(abs((Xi*Xi))*(Xi*(xr*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*(abs((Xi+xi))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-2*((abs((Xr*Xr))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((2*((abs((Xi*Xi))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-2*(abs((Xr*Xr))*(Xi*(Xr*diffabs(Xi,xi)))))+((2*(abs((Xi*Xi))*(Xi*(Xr*diffabs(Xi,xi)))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-4*((abs((Xi*Xr))*((Xi*(xr*abs((Xr+xr))))+((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr)))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((4*((abs((Xi*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-1*((abs((Xi*Xi))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+(((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))+(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((2*((abs((Xi*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xr*Xr))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*Xr))*((xi*xi)*abs((Xr+xr))))+(abs((Xr+xr))*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((2*(abs((Xr*Xr))*(Xr*(xr*abs((Xi+xi))))))+((-2*(abs((Xi*Xi))*(Xr*(xr*abs((Xi+xi))))))+((2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-2*(abs((Xi+xi))*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((2*((abs((Xr*Xr))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-2*((abs((Xi*Xi))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((2*((abs((Xi*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xr*Xr))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-2*((abs((Xi*Xi))*(Xi*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((2*(abs((Xi*Xi))*(Xi*(xi*abs((Xi+xi))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((2*((abs((Xr*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((-2*((abs((Xi*Xi))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+(abs((Xr+xr))*(((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(Xi*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-4*((abs((Xi*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((4*((abs((Xi*Xr))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-4*((abs((Xi*Xr))*((Xi*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr)))+(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*((xr*xr)*abs((Xi+xi))))))))))))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,62,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 62 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((-2*(sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((-6*((abs(Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dya*abs(Xxr)))))))+((6*(abs(Xxi)*(Xxi*(Xxr*(dya*abs(Xxi))))))+((-6*(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((6*((abs(Xxi)*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxr)*(((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+daa)))))))))));
dxbn=((-2*(sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((-6*((abs(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dyb*abs(Xxr)))))))+((6*(abs(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((-6*(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((6*((abs(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxr)*(((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dab)))))))))));
dyan=((2*((sgn(Xxi)*((Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dya*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dya*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dya*abs(Xxi)))))+((6*((abs(Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr)))))))+((-6*((abs(Xxi)*(Xxi*(Xxr*(dxa*abs(Xxi)))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((6*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-6*((abs(Xxi)*((Xxi*Xxi)*(dxa*abs(Xxr))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dya*abs(Xxr))))))+dba))))))))));
dybn=((2*((sgn(Xxi)*((Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dyb*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxi)))))+((6*((abs(Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr)))))))+((-6*((abs(Xxi)*(Xxi*(Xxr*(dxb*abs(Xxi)))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((6*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-6*((abs(Xxi)*((Xxi*Xxi)*(dxb*abs(Xxr))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxr))))))+dbb))))))))));
}

{xrn=(cr+((abs(Xr)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xr,xr))))+((-1*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))+((2*((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))))+((-3*((abs(Xr)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xr,xr))))))+((3*((abs(Xi)*((xi*xi)*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xr*xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xr*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*((Xr*Xr)*(xr*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs(Xr,xr))))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs(Xi,xi)))))+((-3*(((Xi*Xi)*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((3*((abs(Xi)*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((Xi*((xr*xr)*abs((Xr+xr))))+(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr)))))))+((abs(Xr)*(Xi*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))+(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))))))+((6*((abs(Xi)*(Xi*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xi,xi)))))))+((-6*((abs(Xr)*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs(Xr,xr)))))))+((6*((abs(Xi)*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs(Xi,xi)))))))+((-6*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))))+((6*((abs(Xi)*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-12*((abs(Xi)*((Xi*(Xr*(xr*abs((Xr+xr)))))+(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xi,xi))))+(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xr,xr))))))))))))))))))))))));
xin=(ci+((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+((-1*((abs(Xr)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*diffabs(Xr,xr)))))))+((2*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(xi*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*((xr*xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs(Xr,xr))))))+((-3*((abs(Xi)*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs(Xi,xi))))))+((3*((abs(Xr)*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(Xi*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+((abs(Xr)*((Xi*Xi)*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xr,xr))))))))+((3*((abs(Xi)*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xi,xi))))))+((6*((abs(Xi)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xr*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xi,xi)))))))+((6*((abs(Xi)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs(Xr)*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xr,xr))))+((Xr*Xr)*(xr*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(Xi*(Xr*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xi)*(Xi*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xi,xi)))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((-2*(sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((-6*((abs(Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dya*abs(Xxr)))))))+((6*(abs(Xxi)*(Xxi*(Xxr*(dya*abs(Xxi))))))+((-6*(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((6*((abs(Xxi)*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxr)*(((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dxa*abs(Xxr))))))+daa)))))))))));
dxbn=((-2*(sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((-6*((abs(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dyb*abs(Xxr)))))))+((6*(abs(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((-6*(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((6*((abs(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxr)*(((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dab)))))))))));
dyan=((2*((sgn(Xxi)*((Xxi*((Xxi*Xxi)*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dya*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dya*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dya*abs(Xxi)))))+((6*((abs(Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dxa*abs(Xxr)))))))+((-6*((abs(Xxi)*(Xxi*(Xxr*(dxa*abs(Xxi)))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((6*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-6*((abs(Xxi)*((Xxi*Xxi)*(dxa*abs(Xxr))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dya*abs(Xxr))))))+dba))))))))));
dybn=((2*((sgn(Xxi)*((Xxi*((Xxi*Xxi)*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs(Xxr)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((-3*((abs(Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))+(abs(Xxr)*((Xxi*Xxi)*(dyb*abs(Xxr))))))+((3*(abs(Xxi)*((Xxi*Xxi)*(dyb*abs(Xxi)))))+((6*((abs(Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))+(abs(Xxr)*(Xxi*(Xxr*(dxb*abs(Xxr)))))))+((-6*((abs(Xxi)*(Xxi*(Xxr*(dxb*abs(Xxi)))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((6*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-6*((abs(Xxi)*((Xxi*Xxi)*(dxb*abs(Xxr))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))+((-12*(abs(Xxi)*(Xxi*(Xxr*(dyb*abs(Xxr))))))+dbb))))))))));
}

{xrn=(cr+((abs(Xr)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xr,xr))))+((-1*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))+((2*((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))))+((-3*((abs(Xr)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xr,xr))))))+((3*((abs(Xi)*((xi*xi)*(xr*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xr*xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xr*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*((Xr*Xr)*(xr*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs(Xr,xr))))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs(Xi,xi)))))+((-3*(((Xi*Xi)*(Xr*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((3*((abs(Xi)*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((Xi*((xr*xr)*abs((Xr+xr))))+(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr)))))))+((abs(Xr)*(Xi*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))+(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))))))+((6*((abs(Xi)*(Xi*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xi,xi)))))))+((-6*((abs(Xr)*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs(Xr,xr)))))))+((6*((abs(Xi)*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs(Xi,xi)))))))+((-6*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))))+((6*((abs(Xi)*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-12*((abs(Xi)*((Xi*(Xr*(xr*abs((Xr+xr)))))+(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xi,xi))))+(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xr,xr))))))))))))))))))))))));
xin=(ci+((abs(Xi)*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+((-1*((abs(Xr)*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*diffabs(Xr,xr)))))))+((2*((abs(Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(xi*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*((xr*xr)*diffabs(Xi,xi))))))+((3*((abs(Xr)*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs(Xr,xr))))))+((-3*((abs(Xi)*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs(Xi,xi))))))+((3*((abs(Xr)*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs(Xr,xr))))))+((-3*((abs(Xi)*(Xi*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((xi*xi)*diffabs(Xr,xr))))))))+((3*((abs(Xi)*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs(Xr)*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*((xi*xi)*diffabs(Xi,xi))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))))))+((-3*((abs(Xi)*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+((abs(Xr)*((Xi*Xi)*(xi*abs((Xr+xr)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs(Xr,xr))))))))+((3*((abs(Xi)*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs(Xi,xi))))))+((-6*((abs(Xi)*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs(Xi,xi))))))+((6*((abs(Xi)*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xr*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((xi*xi)*diffabs(Xi,xi)))))))+((6*((abs(Xi)*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs(Xr)*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*(Xr*(xr*diffabs(Xr,xr))))+((Xr*Xr)*(xr*diffabs(Xi,xi))))))))+((-6*((abs(Xi)*(((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+(Xi*(Xr*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(Xi*(Xr*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xi)*(Xi*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(xr*((xr*xr)*diffabs(Xi,xi)))))))))))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,63,5)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 63 && m_nPower == 5)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(((dxa*sgn(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((-4*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))+((4*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-4*(Xxi*(Xxr*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((4*(Xxi*((Xxi*Xxi)*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((-12*(Xxi*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+((12*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))+((-12*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))+daa)))))))));
dxbn=(((dxb*sgn(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((-4*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((4*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-4*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((4*(Xxi*((Xxi*Xxi)*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((-12*(Xxi*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+((12*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))+((-12*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))+dab)))))))));
dyan=(((dya*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((4*((Xxi*(((Xxi*Xxi)*(dya*abs(Xxi)))+(Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))))+(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-4*(Xxi*((Xxi*Xxi)*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dya*sgn(Xxi)))))+((-12*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))+((12*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-12*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+dba)))))));
dybn=(((dyb*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((4*((Xxi*(((Xxi*Xxi)*(dyb*abs(Xxi)))+(Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))))+(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-4*(Xxi*((Xxi*Xxi)*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*sgn(Xxi)))))+((-12*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((12*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-12*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dbb)))))));
}

{xrn=(cr+((diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xr+xr)))+((-4*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((4*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-4*((Xi*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((4*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+((-4*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((4*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-6*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*abs((Xr+xr))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((-12*((Xi*(xi*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))))+((12*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((-12*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((12*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((-12*(Xi*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((12*((Xi*Xi)*(xi*(xr*abs((Xi+xi))))))+((-12*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+((12*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))));
xin=(ci+((diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xi+xi)))+((4*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+((-4*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((4*(Xr*(xr*((xr*xr)*abs((Xi+xi))))))+((-4*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+((4*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-4*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+((4*(Xi*((Xi*Xi)*(xi*abs((Xi+xi))))))+((-6*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xi+xi)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*((xi*xi)*abs((Xi+xi))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xi+xi)))))+((12*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+((-12*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+((12*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+((-12*(Xi*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))+((12*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((-12*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((12*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((-12*(((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xi*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xi+xi)))))))+(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(((dxa*sgn(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((-4*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))+((4*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-4*(Xxi*(Xxr*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((4*(Xxi*((Xxi*Xxi)*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((-12*(Xxi*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+((12*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))+((-12*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))+daa)))))))));
dxbn=(((dxb*sgn(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((-4*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((4*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-4*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((4*(Xxi*((Xxi*Xxi)*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((-12*(Xxi*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+((12*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))+((-12*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))+dab)))))))));
dyan=(((dya*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((4*((Xxi*(((Xxi*Xxi)*(dya*abs(Xxi)))+(Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))))+(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-4*(Xxi*((Xxi*Xxi)*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dya*sgn(Xxi)))))+((-12*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi)))))+((12*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-12*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+dba)))))));
dybn=(((dyb*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr))))+((4*((Xxi*(((Xxi*Xxi)*(dyb*abs(Xxi)))+(Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))))+(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-4*(Xxi*((Xxi*Xxi)*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr))))))+((-6*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*sgn(Xxi)))))+((-12*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((12*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-12*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dbb)))))));
}

{xrn=(cr+((diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xr+xr)))+((-4*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((4*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-4*((Xi*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((4*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+((-4*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((4*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-6*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*abs((Xr+xr))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((-12*((Xi*(xi*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))))+((12*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((-12*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((12*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((-12*(Xi*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((12*((Xi*Xi)*(xi*(xr*abs((Xi+xi))))))+((-12*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+((12*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))));
xin=(ci+((diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr))))+((((xi*xi)*(xi*xi))*abs((Xi+xi)))+((4*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+((-4*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((4*(Xr*(xr*((xr*xr)*abs((Xi+xi))))))+((-4*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+((4*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((-4*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+((4*(Xi*((Xi*Xi)*(xi*abs((Xi+xi))))))+((-6*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((6*((Xr*Xr)*((xr*xr)*abs((Xi+xi)))))+((-6*(((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((Xr*Xr)*((xi*xi)*abs((Xi+xi))))))+((6*((Xi*Xi)*((xi*xi)*abs((Xi+xi)))))+((12*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+((-12*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+((12*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+((-12*(Xi*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi)))))))+((12*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((-12*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((12*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((-12*(((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xi*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((-24*(Xi*(Xr*(xi*(xr*abs((Xi+xi)))))))+(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,64,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 64 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=(daa+(((dxa*abs(Xxr))*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))+((sgn(Xxr)*(Xxr*(dxa*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-1*((abs(((Xxi*Xxi)*(Xxi*Xxi)))*(dya*abs(Xxi)))+(sgn(Xxi)*(Xxi*(dya*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dya*abs(Xxr))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dya*abs(Xxr))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxa*abs(Xxi))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxa*abs(Xxi))))+((-4*(sgn(Xxi)*(Xxr*(dya*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxr*(dya*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))))+((4*(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-4*(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((6*(abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dya*abs(Xxi))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dxa*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxa*abs(((Xxi*Xxi)*(Xxr*Xxr))))))))+((6*(sgn(Xxi)*(Xxi*(dya*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+(-1*(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dya*abs(Xxi))))))))))))))))))))))))))));
dxbn=(dab+(((dxb*abs(Xxr))*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))+((sgn(Xxr)*(Xxr*(dxb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-1*((abs(((Xxi*Xxi)*(Xxi*Xxi)))*(dyb*abs(Xxi)))+(sgn(Xxi)*(Xxi*(dyb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dyb*abs(Xxr))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dyb*abs(Xxr))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxb*abs(Xxi))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxb*abs(Xxi))))+((-4*(sgn(Xxi)*(Xxr*(dyb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxr*(dyb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))))+((4*(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-4*(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((6*(abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dyb*abs(Xxi))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dxb*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxb*abs(((Xxi*Xxi)*(Xxr*Xxr))))))))+((6*(sgn(Xxi)*(Xxi*(dyb*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+(-1*(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dyb*abs(Xxi))))))))))))))))))))))))))));
dyan=(dba+((abs(((Xxi*Xxi)*(Xxi*Xxi)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dya*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxa*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dya*abs(Xxi))))+((4*((abs((Xxi*((Xxi*Xxi)*Xxr)))*(dya*abs(Xxi)))+(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxa*abs(Xxr)))))+((-4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxa*abs(Xxr))))+((4*(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((-4*(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi))))))+((-4*(sgn(Xxi)*(Xxi*(dya*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxi*(dya*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*((((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-4*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dya*abs(((Xxi*Xxi)*(Xxr*Xxr))))))+(sgn(Xxr)*(Xxi*(dxa*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((12*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))))+(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dya*abs(Xxr)))))))))))))))))))))))));
dybn=(dbb+((abs(((Xxi*Xxi)*(Xxi*Xxi)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dyb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dyb*abs(Xxi))))+((4*((abs((Xxi*((Xxi*Xxi)*Xxr)))*(dyb*abs(Xxi)))+(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxb*abs(Xxr)))))+((-4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxb*abs(Xxr))))+((4*(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((-4*(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi))))))+((-4*(sgn(Xxi)*(Xxi*(dyb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxi*(dyb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*((((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-4*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dyb*abs(((Xxi*Xxi)*(Xxr*Xxr))))))+(sgn(Xxr)*(Xxi*(dxb*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((12*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))))+(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dyb*abs(Xxr)))))))))))))))))))))))));
}

{xrn=(cr+((abs(((Xi*Xi)*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs(((Xr*Xr)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((-1*((abs(Xi)*(Xi*(diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))+(((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi))))*(abs((((Xi*Xi)*(Xi*Xi))+((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi))))))+abs((((Xr*Xr)*(Xr*Xr))+((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xi+xi)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xr+xr)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xr+xr)))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xi,xi))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xi,xi))))+((-4*(abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xr,xr))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xr,xr))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xr+xr)))))))))))))))))))))))))))));
xin=(ci+((abs(((Xi*Xi)*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs(((Xr*Xr)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xi+xi)))+((4*(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((-4*(abs((Xr+xr))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xr+xr)))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xr+xr))))+(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xi+xi))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*((abs((Xi+xi))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr)))))))))))+((-4*(abs((Xr+xr))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xr,xr))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xi,xi)))))+((4*(abs((Xi+xi))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi+xi))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xi,xi))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xi+xi))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xi+xi)))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(daa+(((dxa*abs(Xxr))*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))+((sgn(Xxr)*(Xxr*(dxa*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-1*((abs(((Xxi*Xxi)*(Xxi*Xxi)))*(dya*abs(Xxi)))+(sgn(Xxi)*(Xxi*(dya*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dya*abs(Xxr))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dya*abs(Xxr))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxa*abs(Xxi))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxa*abs(Xxi))))+((-4*(sgn(Xxi)*(Xxr*(dya*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxr*(dya*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))))+((4*(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-4*(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxr)*(Xxi*(dxa*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((6*(abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dya*abs(Xxi))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dxa*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxa*abs(((Xxi*Xxi)*(Xxr*Xxr))))))))+((6*(sgn(Xxi)*(Xxi*(dya*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+(-1*(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dya*abs(Xxi))))))))))))))))))))))))))));
dxbn=(dab+(((dxb*abs(Xxr))*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))+((sgn(Xxr)*(Xxr*(dxb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-1*((abs(((Xxi*Xxi)*(Xxi*Xxi)))*(dyb*abs(Xxi)))+(sgn(Xxi)*(Xxi*(dyb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dyb*abs(Xxr))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dyb*abs(Xxr))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxb*abs(Xxi))))+((4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxb*abs(Xxi))))+((-4*(sgn(Xxi)*(Xxr*(dyb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxr*(dyb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))))+((4*(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-4*(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxr)*(Xxi*(dxb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))))+((-4*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((6*(abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dyb*abs(Xxi))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*(dxb*abs(Xxr)))+(sgn(Xxr)*(Xxr*(dxb*abs(((Xxi*Xxi)*(Xxr*Xxr))))))))+((6*(sgn(Xxi)*(Xxi*(dyb*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))))+((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+(-1*(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dyb*abs(Xxi))))))))))))))))))))))))))));
dyan=(dba+((abs(((Xxi*Xxi)*(Xxi*Xxi)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dxa*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dya*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxa*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dya*abs(Xxi))))+((4*((abs((Xxi*((Xxi*Xxi)*Xxr)))*(dya*abs(Xxi)))+(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxa*abs(Xxr)))))+((-4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxa*abs(Xxr))))+((4*(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((-4*(sgn(Xxr)*(Xxr*(dxa*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi))))))+((-4*(sgn(Xxi)*(Xxi*(dya*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxi*(dya*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*((((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-4*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*((dxa*abs(Xxi))+(dya*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dya*abs(((Xxi*Xxi)*(Xxr*Xxr))))))+(sgn(Xxr)*(Xxi*(dxa*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((12*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))))+(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dya*abs(Xxr)))))))))))))))))))))))));
dybn=(dbb+((abs(((Xxi*Xxi)*(Xxi*Xxi)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dxb*abs(Xxi)))+((sgn(Xxi)*(Xxr*(dyb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((sgn(Xxr)*(Xxi*(dxb*(abs(((Xxi*Xxi)*(Xxi*Xxi)))+abs(((Xxr*Xxr)*(Xxr*Xxr)))))))+((-4*(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dyb*abs(Xxi))))+((4*((abs((Xxi*((Xxi*Xxi)*Xxr)))*(dyb*abs(Xxi)))+(abs((Xxi*(Xxr*(Xxr*Xxr))))*(dxb*abs(Xxr)))))+((-4*(abs((Xxi*((Xxi*Xxi)*Xxr)))*(dxb*abs(Xxr))))+((4*(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((-4*(sgn(Xxr)*(Xxr*(dxb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((4*((sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi))))))+((-4*(sgn(Xxi)*(Xxi*(dyb*abs((Xxi*(Xxr*(Xxr*Xxr))))))))+((4*(sgn(Xxi)*(Xxi*(dyb*abs((Xxi*((Xxi*Xxi)*Xxr)))))))+((-4*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))))+((4*((((sgn(Xxi)*sgn(Xxi))*(sgn(Xxi)*sgn(Xxi)))*((((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi))))))+(((sgn(Xxr)*sgn(Xxr))*(sgn(Xxr)*sgn(Xxr)))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-4*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))))+((-6*((abs(((Xxi*Xxi)*(Xxr*Xxr)))*((dxb*abs(Xxi))+(dyb*abs(Xxr))))+((sgn(Xxi)*(Xxr*(dyb*abs(((Xxi*Xxi)*(Xxr*Xxr))))))+(sgn(Xxr)*(Xxi*(dxb*abs(((Xxi*Xxi)*(Xxr*Xxr)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-12*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+(sgn(Xxi)*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((12*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))))+((-12*((sgn(Xxi)*sgn(Xxi))*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))))+(abs(((Xxr*Xxr)*(Xxr*Xxr)))*(dyb*abs(Xxr)))))))))))))))))))))))));
}

{xrn=(cr+((abs(((Xi*Xi)*(Xi*Xi)))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))+((abs(((Xr*Xr)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((-1*((abs(Xi)*(Xi*(diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))+(((Xi*diffabs(Xi,xi))+(xi*abs((Xi+xi))))*(abs((((Xi*Xi)*(Xi*Xi))+((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi))))))+abs((((Xr*Xr)*(Xr*Xr))+((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xi+xi)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xr+xr)))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xr+xr)))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xi,xi))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xi,xi))))+((-4*(abs((Xi+xi))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi+xi))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xr+xr))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xr+xr))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xr,xr))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xr,xr))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(xr*abs((Xr+xr))))+(abs((Xr+xr))*(xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(xi*abs((Xi+xi))))+(abs((Xi+xi))*(xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xr+xr))*(Xr*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*(Xr*Xr)))*(Xi*diffabs(Xi,xi)))+(abs((Xi+xi))*(Xi*diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xr+xr)))))))))))))))))))))))))))));
xin=(ci+((abs(((Xi*Xi)*(Xi*Xi)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs(((Xr*Xr)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xr+xr)))+((abs((Xr+xr))*((diffabs(((Xi*Xi)*(Xi*Xi)),((4*(Xi*(xi*((Xi*Xi)+(xi*xi)))))+((6*((Xi*Xi)*(xi*xi)))+((xi*xi)*(xi*xi)))))+diffabs(((Xr*Xr)*(Xr*Xr)),((4*(Xr*(xr*((Xr*Xr)+(xr*xr)))))+((6*((Xr*Xr)*(xr*xr)))+((xr*xr)*(xr*xr))))))*(Xi+xi)))+((4*(abs((Xr+xr))*(xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((-4*(abs((Xr+xr))*(xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(xr*abs((Xr+xr)))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(xr*abs((Xr+xr))))+(abs((Xi*(Xr*(Xr*Xr))))*(xi*abs((Xi+xi))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(xi*abs((Xi+xi)))))+((-4*(abs((Xi+xi))*(xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*((abs((Xi+xi))*(xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr))))))))+(abs((Xr+xr))*(Xr*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr)))))))))))+((-4*(abs((Xr+xr))*(Xr*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((4*(abs((Xi*(Xr*(Xr*Xr))))*(Xr*diffabs(Xr,xr))))+((-4*((abs((Xi*((Xi*Xi)*Xr)))*(Xr*diffabs(Xr,xr)))+(abs((Xi*(Xr*(Xr*Xr))))*(Xi*diffabs(Xi,xi)))))+((4*(abs((Xi+xi))*(Xi*diffabs((Xi*((Xi*Xi)*Xr)),((Xi*((Xi*Xi)*xr))+((Xr*(xi*(xi*xi)))+((3*(((Xi*Xi)*(xi*(Xr+xr)))+(Xi*((xi*xi)*(Xr+xr)))))+(xi*((xi*xi)*xr)))))))))+((-4*(abs((Xi+xi))*(Xi*diffabs((Xi*(Xr*(Xr*Xr))),((Xi*(xr*(xr*xr)))+((Xr*((Xr*Xr)*xi))+((3*((Xi*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(((Xr*Xr)*(xi*xr))+(Xr*(xi*(xr*xr))))))+(xi*(xr*(xr*xr))))))))))+((4*(abs((Xi*((Xi*Xi)*Xr)))*(Xi*diffabs(Xi,xi))))+((-6*((abs(((Xi*Xi)*(Xr*Xr)))*((Xi*diffabs(Xr,xr))+((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xr+xr)))+(abs((Xr+xr))*(diffabs(((Xi*Xi)*(Xr*Xr)),(((Xi*Xi)*(xr*xr))+(((Xr*Xr)*(xi*xi))+((2*(((Xi*Xi)*(Xr*xr))+((Xi*(xi*((Xr*Xr)+(xr*xr))))+(Xr*((xi*xi)*xr)))))+((4*(Xi*(Xr*(xi*xr))))+((xi*xi)*(xr*xr)))))))*(Xi+xi))))))+(abs(((Xr*Xr)*(Xr*Xr)))*(xr*abs((Xi+xi)))))))))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,65,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 65 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((sgn(Xxi)*((Xxr*Xxr)*(dya*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxr*(Xxr*Xxr))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs((Xxi*(Xxi*Xxi))))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxr*(Xxr*Xxr))))))))+((-2*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxi)))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxr))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*(dya*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((2*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(dxa*abs(Xxr)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxr*(Xxr*Xxr))))))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((-3*((sgn(Xxi)*(((Xxr*Xxr)*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*(Xxr*Xxr)))))+(((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr))))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr))))))))+((-3*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxr)))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxr*(dya*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxa*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxi))))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dya*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxi))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxr)))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxa*abs(Xxi))))+(sgn(Xxi)*(Xxi*(Xxr*(dya*abs(((Xxi*Xxi)*Xxr))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+(sgn(Xxr)*((Xxi*(Xxr*(dxa*abs((Xxi*(Xxr*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))))+((12*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((-12*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+daa))))))))))))))))))))))));
dxbn=((sgn(Xxi)*((Xxr*Xxr)*(dyb*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxr*(Xxr*Xxr))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs((Xxi*(Xxi*Xxi))))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxr*(Xxr*Xxr))))))))+((-2*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxi)))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxr))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*(dyb*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((2*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(dxb*abs(Xxr)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxr*(Xxr*Xxr))))))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((-3*((sgn(Xxi)*(((Xxr*Xxr)*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*(Xxr*Xxr)))))+(((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr))))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr))))))))+((-3*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxr)))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxi))))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dyb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxi))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxr)))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxb*abs(Xxi))))+(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(((Xxi*Xxi)*Xxr))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+(sgn(Xxr)*((Xxi*(Xxr*(dxb*abs((Xxi*(Xxr*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))))+((12*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((-12*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+dab))))))))))))))))))))))));
dyan=((sgn(Xxi)*((Xxr*Xxr)*(dya*abs((Xxr*(Xxr*Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxi*(Xxi*Xxi))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs((Xxr*(Xxr*Xxr))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dya*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dxa*abs(Xxr))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxi))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((abs((Xxr*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxr))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*(Xxi*Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxr*(Xxr*Xxr)))))))))))+((-3*(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(((Xxi*Xxi)*Xxr))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr))))))+(sgn(Xxr)*(((Xxr*Xxr)*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi))))))))+((-3*((sgn(Xxi)*(((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr)))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((3*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr))))))+((-3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi))))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dya*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxi))))))+((6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxr)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxa*abs(Xxi))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxr))))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxi*(dya*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxa*abs(Xxr))))+((abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxi))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*(Xxr*Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(((Xxi*Xxi)*Xxr))))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+(((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))*(sgn(Xxi)+sgn(Xxr))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+dba))))))))))))))))))));
dybn=((sgn(Xxi)*((Xxr*Xxr)*(dyb*abs((Xxr*(Xxr*Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxi*(Xxi*Xxi))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs((Xxr*(Xxr*Xxr))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dyb*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dxb*abs(Xxr))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxi))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((abs((Xxr*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxr))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*(Xxi*Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxr*(Xxr*Xxr)))))))))))+((-3*(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(((Xxi*Xxi)*Xxr))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr))))))+(sgn(Xxr)*(((Xxr*Xxr)*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi))))))))+((-3*((sgn(Xxi)*(((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr)))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((3*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr))))))+((-3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi))))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dyb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxi))))))+((6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxr)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxb*abs(Xxi))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxr))))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxb*abs(Xxr))))+((abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxi))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*(Xxr*Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(((Xxi*Xxi)*Xxr))))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+(((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))*(sgn(Xxi)+sgn(Xxr))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+dbb))))))))))))))))))));
}

{xrn=(cr+((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))))))+((-2*(abs((Xr*(Xr*Xr)))*(xi*(xr*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xr*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xr*(Xr*Xr)))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xi*((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xi+xi))))+((abs((Xi+xi))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xi+xi))))+((abs((Xi+xi))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xr+xr)))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*(xr*abs((Xi+xi))))+(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((2*((abs((Xi*(Xi*Xi)))*((Xi*(xr*abs((Xi+xi))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xr*(Xr*Xr)))*((Xi*(xr*abs((Xr+xr))))+(Xr*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))))+(Xr*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))+(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xr*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xr+xr))))+(abs((Xr+xr))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xr+xr))))+((abs((Xi+xi))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi+xi))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((6*((abs((Xi*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*Xr))*((Xi*(xr*abs((Xr+xr))))+(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi*(Xr*Xr)))*((Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr+xr))*((Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((sgn(Xxi)*((Xxr*Xxr)*(dya*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxr*(Xxr*Xxr))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs((Xxi*(Xxi*Xxi))))))+(sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxr*(Xxr*Xxr))))))))+((-2*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxi)))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxr))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*(dya*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((2*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(dxa*abs(Xxr)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxr*(Xxr*Xxr))))))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((-3*((sgn(Xxi)*(((Xxr*Xxr)*(dya*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs((Xxi*(Xxr*Xxr)))))+(((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr))))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr))))))))+((-3*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxr)))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxr*(dya*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxa*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxi))))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dya*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxi))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxr)))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxa*abs(Xxi))))+(sgn(Xxi)*(Xxi*(Xxr*(dya*abs(((Xxi*Xxi)*Xxr))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+(sgn(Xxr)*((Xxi*(Xxr*(dxa*abs((Xxi*(Xxr*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr))))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi))))))))))+((12*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((-12*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+daa))))))))))))))))))))))));
dxbn=((sgn(Xxi)*((Xxr*Xxr)*(dyb*abs((Xxi*(Xxi*Xxi))))))+((sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxr*(Xxr*Xxr))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs((Xxi*(Xxi*Xxi))))))+(sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxr*(Xxr*Xxr))))))))+((-2*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxi)))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxr))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*(dyb*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((2*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(dxb*abs(Xxr)))))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxr*(Xxr*Xxr))))))))+((2*(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((-3*((sgn(Xxi)*(((Xxr*Xxr)*(dyb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs(((Xxi*Xxi)*Xxr)))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs((Xxi*(Xxr*Xxr)))))+(((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr))))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr))))))))+((-3*(sgn(Xxr)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr))))))+((-3*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxr)))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxr*(dyb*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxi))))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dyb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxi))))))+((-6*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxr)))))+((6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxb*abs(Xxi))))+(sgn(Xxi)*(Xxi*(Xxr*(dyb*abs(((Xxi*Xxi)*Xxr))))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+(sgn(Xxr)*((Xxi*(Xxr*(dxb*abs((Xxi*(Xxr*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi))))))))))+((12*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((-12*(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+dab))))))))))))))))))))))));
dyan=((sgn(Xxi)*((Xxr*Xxr)*(dya*abs((Xxr*(Xxr*Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxa*abs((Xxi*(Xxi*Xxi))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dya*abs((Xxr*(Xxr*Xxr))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxa*abs((Xxi*(Xxi*Xxi))))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dya*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dxa*abs(Xxr))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxi))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((abs((Xxr*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxr))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*(Xxi*Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs((Xxr*(Xxr*Xxr)))))))))))+((-3*(sgn(Xxi)*((Xxr*Xxr)*(dya*abs(((Xxi*Xxi)*Xxr))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dya*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr))))))+(sgn(Xxr)*(((Xxr*Xxr)*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi))))))))+((-3*((sgn(Xxi)*(((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr)))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxa*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((3*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr))))))+((-3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi))))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dya*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dya*abs(Xxi))))))+((6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxa*abs(Xxr)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxa*abs(Xxi))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dya*abs(Xxr))))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxi*(dya*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxa*abs(Xxr))))+((abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxa*abs(Xxi))))+((sgn(Xxi)*(Xxi*(Xxr*(dya*abs((Xxi*(Xxr*Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxa*abs(((Xxi*Xxi)*Xxr))))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+(((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))*(sgn(Xxi)+sgn(Xxr))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))+dba))))))))))))))))))));
dybn=((sgn(Xxi)*((Xxr*Xxr)*(dyb*abs((Xxr*(Xxr*Xxr))))))+((sgn(Xxr)*((Xxi*Xxi)*(dxb*abs((Xxi*(Xxi*Xxi))))))+((-1*((sgn(Xxi)*((Xxi*Xxi)*(dyb*abs((Xxr*(Xxr*Xxr))))))+(sgn(Xxr)*((Xxr*Xxr)*(dxb*abs((Xxi*(Xxi*Xxi))))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dyb*abs(Xxi))))+(abs((Xxr*(Xxr*Xxr)))*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-2*((abs((Xxi*(Xxi*Xxi)))*(Xxr*(dxb*abs(Xxr))))+(abs((Xxr*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxi))))))+((2*((abs((Xxi*(Xxi*Xxi)))*(Xxi*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((abs((Xxr*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxr))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*(Xxi*Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs((Xxr*(Xxr*Xxr)))))))))))+((-3*(sgn(Xxi)*((Xxr*Xxr)*(dyb*abs(((Xxi*Xxi)*Xxr))))))+((3*((sgn(Xxi)*(((Xxi*Xxi)*(dyb*abs(((Xxi*Xxi)*Xxr))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr))))))+(sgn(Xxr)*(((Xxr*Xxr)*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi))))))))+((-3*((sgn(Xxi)*(((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))*((sgn(Xxi)*sgn(Xxi))+(sgn(Xxr)*sgn(Xxr)))))+(sgn(Xxr)*(((Xxi*Xxi)*(dxb*abs((Xxi*(Xxr*Xxr)))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((3*(sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr))))))+((-3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((3*((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi))))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dyb*abs(Xxr))))+(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dyb*abs(Xxi))))))+((6*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(dxb*abs(Xxr)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxr*(dxb*abs(Xxi))))+(abs((Xxi*(Xxr*Xxr)))*(Xxi*(dyb*abs(Xxr))))))+((6*(abs(((Xxi*Xxi)*Xxr))*(Xxi*(dyb*abs(Xxi)))))+((-6*((abs(((Xxi*Xxi)*Xxr))*(Xxi*(dxb*abs(Xxr))))+((abs((Xxi*(Xxr*Xxr)))*(Xxi*(dxb*abs(Xxi))))+((sgn(Xxi)*(Xxi*(Xxr*(dyb*abs((Xxi*(Xxr*Xxr)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+(sgn(Xxr)*(Xxi*(Xxr*(dxb*abs(((Xxi*Xxi)*Xxr))))))))))))+((6*((sgn(Xxi)*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+(((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))*(sgn(Xxi)+sgn(Xxr))))))+((-6*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))))+((-12*(((sgn(Xxi)*sgn(Xxi))*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))+dbb))))))))))))))))))));
}

{xrn=(cr+((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))))))+((-2*(abs((Xr*(Xr*Xr)))*(xi*(xr*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xr*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xr*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xr*(Xr*Xr)))*(Xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*(Xi*((Xr*diffabs(Xi,xi))+(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xi+xi))))+((abs((Xi+xi))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xr+xr))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xi+xi))))+((abs((Xi+xi))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xi,xi)))+((abs((Xi+xi))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xr*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi+xi))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xr*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((abs((Xi*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi)))))+((abs((Xi+xi))*(Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+(abs((Xr+xr))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((-6*((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xr+xr)))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*(Xi*Xi)))*(((Xi*Xi)*diffabs(Xr,xr))+((xi*xi)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xr*Xr)+(xr*xr))))+((abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xi*Xi)+(xi*xi))))+((-1*((abs((Xi*(Xi*Xi)))*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr)))))+((abs((Xr*(Xr*Xr)))*(((Xi*Xi)*diffabs(Xi,xi))+((xi*xi)*abs((Xi+xi)))))+((abs((Xi+xi))*(diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))*((Xi*Xi)+(xi*xi))))+(abs((Xr+xr))*(diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))*((Xr*Xr)+(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xr*(Xr*Xr)))*((Xr*(xr*abs((Xi+xi))))+(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((-2*((abs((Xi*(Xi*Xi)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((2*((abs((Xi*(Xi*Xi)))*((Xi*(xr*abs((Xi+xi))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xr*(Xr*Xr)))*((Xi*(xr*abs((Xr+xr))))+(Xr*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi))))))+(Xr*((xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))+(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))+(abs((Xr+xr))*((Xi*(xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))+(Xr*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))))))+((-2*(abs((Xr*(Xr*Xr)))*(Xi*(xi*abs((Xi+xi))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(xi*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))))+((-2*(abs((Xi+xi))*(Xi*(xi*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr))))))))+((2*((abs((Xi*(Xi*Xi)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xr*(Xr*Xr)))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xi*Xi)),((3*(((Xi*Xi)*xi)+(Xi*(xi*xi))))+(xi*(xi*xi)))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs((Xr*(Xr*Xr)),((3*(((Xr*Xr)*xr)+(Xr*(xr*xr))))+(xr*(xr*xr)))))))))))+((3*((abs((Xi*(Xr*Xr)))*((xr*xr)*abs((Xr+xr))))+(abs((Xr+xr))*((xr*xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((xr*xr)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((xi*xi)*abs((Xr+xr))))+((abs((Xi+xi))*((xr*xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((xi*xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((xi*xi)*abs((Xi+xi))))+((abs((Xi*(Xr*Xr)))*((Xr*Xr)*diffabs(Xr,xr)))+((abs((Xi+xi))*((xi*xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xr*Xr)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((-3*((abs(((Xi*Xi)*Xr))*((Xr*Xr)*diffabs(Xi,xi)))+((abs((Xi*(Xr*Xr)))*((Xi*Xi)*diffabs(Xr,xr)))+((abs((Xi+xi))*((Xr*Xr)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))+(abs((Xr+xr))*((Xi*Xi)*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))))))+((3*((abs(((Xi*Xi)*Xr))*((Xi*Xi)*diffabs(Xi,xi)))+(abs((Xi+xi))*((Xi*Xi)*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))+((-6*((abs(((Xi*Xi)*Xr))*(xi*(xr*abs((Xr+xr)))))+((abs((Xi*(Xr*Xr)))*(xi*(xr*abs((Xi+xi)))))+((abs((Xi+xi))*(xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(xi*(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+((6*((abs((Xi*(Xr*Xr)))*(Xr*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))))+((-6*((abs(((Xi*Xi)*Xr))*((Xi*(xr*abs((Xr+xr))))+(Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi*(Xr*Xr)))*((Xi*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(Xr*(xi*abs((Xi+xi))))))+((abs((Xi+xi))*((Xi*(xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr))))))))+(Xr*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+(abs((Xr+xr))*((Xi*((xi*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))+(xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))+(Xr*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr)))))))))))))+((6*((abs(((Xi*Xi)*Xr))*(Xi*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*(xi*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))+((-6*((abs(((Xi*Xi)*Xr))*(Xi*(Xr*diffabs(Xr,xr))))+((abs((Xi*(Xr*Xr)))*(Xi*(Xr*diffabs(Xi,xi))))+((abs((Xi+xi))*(Xi*(Xr*diffabs((Xi*(Xr*Xr)),((Xi*(xr*xr))+(((Xr*Xr)*xi)+((2*((Xi*(Xr*xr))+(Xr*(xi*xr))))+(xi*(xr*xr)))))))))+(abs((Xr+xr))*(Xi*(Xr*diffabs(((Xi*Xi)*Xr),(((Xi*Xi)*xr)+((Xr*(xi*xi))+((2*(Xi*(xi*(Xr+xr))))+((xi*xi)*xr))))))))))))+(abs((Xr*(Xr*Xr)))*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,66,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 66 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxr*Xxr))))))+((-1*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxi*Xxi))))))))+((-2*(sgn(Xxi)*((Xxr*((Xxr*Xxr)*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))))+((2*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))+((-3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dya*abs(Xxi)))))+((3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dxa*abs(Xxr))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))))+((3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dya*abs(Xxi))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs((Xxi*Xxi))))))))+((-3*((abs((Xxi*Xxi))*((Xxi*Xxi)*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxa*abs(Xxr)))))+((-3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxr*Xxr)))))))+((3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxi*Xxi)))))))+((-6*((abs((Xxi*Xxr))*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dya*abs(Xxr)))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dya*abs(Xxr))))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxi))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dxa*abs(Xxi))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+((sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((6*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dya*abs(Xxi))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxr))))))+daa)))))))))))))))))))))))))));
dxbn=((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxr*Xxr))))))+((-1*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxi*Xxi))))))))+((-2*(sgn(Xxi)*((Xxr*((Xxr*Xxr)*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))))+((2*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))+((-3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dxb*abs(Xxr))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))))+((3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxi))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs((Xxi*Xxi))))))))+((-3*((abs((Xxi*Xxi))*((Xxi*Xxi)*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxb*abs(Xxr)))))+((-3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxr*Xxr)))))))+((3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxi*Xxi)))))))+((-6*((abs((Xxi*Xxr))*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxr)))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dyb*abs(Xxr))))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxi))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dxb*abs(Xxi))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+((sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((6*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dab)))))))))))))))))))))))))));
dyan=((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxi*Xxi))))))+((-1*((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxr*Xxr))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr)))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi)))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi)))+(Xxi*(((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dya*abs(Xxr)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dya*abs(Xxr)))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((3*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxr*Xxr)))))))+((-3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxi*Xxi))))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dya*abs(Xxr)))))+((-3*(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((-3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxr*Xxr)))))))+((3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxi*Xxi)))))))+((-6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dya*abs(Xxi)))))+((6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dya*abs(Xxi))))))+((6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dya*abs(Xxi)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxr)))))))+((-6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dxa*abs(Xxr)))))+(sgn(Xxi)*((Xxi*((Xxr*Xxr)*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dya*abs(Xxi))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxr))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+dba))))))))))))))))))))))))))));
dybn=((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxi*Xxi))))))+((-1*((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxr*Xxr))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr)))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi)))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi)))+(Xxi*(((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((3*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxr*Xxr)))))))+((-3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxi*Xxi))))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dyb*abs(Xxr)))))+((-3*(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((-3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxr*Xxr)))))))+((3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxi*Xxi)))))))+((-6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dyb*abs(Xxi)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxr)))))))+((-6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dxb*abs(Xxr)))))+(sgn(Xxi)*((Xxi*((Xxr*Xxr)*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxi))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxr))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+dbb))))))))))))))))))))))))))));
}

{xrn=(cr+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-1*((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-2*((abs((Xi*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-2*((abs((Xi*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(Xi*((Xi*Xi)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-3*(abs((Xr*Xr))*(xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((xi*xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*(abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-3*(abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*(abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xr*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xr+xr))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((6*((abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-6*(abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((6*((abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-6*((abs((Xi*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-1*((abs((Xi*Xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((2*((abs((Xi*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((3*((abs((Xr*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((xi*xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*((abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-6*((abs((Xi*Xr))*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((-6*((abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((6*((abs((Xi*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xi+xi))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((6*(abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((-6*((abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(((Xi*Xi)*(xr*abs((Xr+xr))))+(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-12*((abs((Xi*Xr))*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxr*Xxr))))))+((-1*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxi*Xxi))))))))+((-2*(sgn(Xxi)*((Xxr*((Xxr*Xxr)*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))))+((2*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))+((-3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dya*abs(Xxi)))))+((3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dxa*abs(Xxr))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))))+((3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dya*abs(Xxi))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs((Xxi*Xxi))))))))+((-3*((abs((Xxi*Xxi))*((Xxi*Xxi)*(dya*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxr))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxa*abs(Xxr)))))+((-3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxr*Xxr)))))))+((3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxi*Xxi)))))))+((-6*((abs((Xxi*Xxr))*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dya*abs(Xxr)))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dya*abs(Xxr))))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxi))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dxa*abs(Xxi))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))))+((sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi))))))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((6*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dya*abs(Xxi))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxr))))))+daa)))))))))))))))))))))))))));
dxbn=((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxr*Xxr))))))+((-1*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxi*Xxi))))))))+((-2*(sgn(Xxi)*((Xxr*((Xxr*Xxr)*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))))+((2*((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-2*(((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))+(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxi*Xxr))))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))+((-3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-3*((abs((Xxi*Xxi))*((Xxr*Xxr)*(dxb*abs(Xxr))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))))+((3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxi))))+(sgn(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs((Xxi*Xxi))))))))+((-3*((abs((Xxi*Xxi))*((Xxi*Xxi)*(dyb*abs(Xxi))))+(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxr))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxb*abs(Xxr)))))+((-3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxr*Xxr)))))))+((3*(sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxi*Xxi)))))))+((-6*((abs((Xxi*Xxr))*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxr)))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dyb*abs(Xxr))))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxi))))))+((6*(abs((Xxi*Xxi))*(Xxi*(Xxr*(dxb*abs(Xxi))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+((sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi))))))))))+((-6*((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((6*(((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxr))))))+dab)))))))))))))))))))))))))));
dyan=((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxi*Xxi))))))+((-1*((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs((Xxr*Xxr))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxr)))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxi)))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxi)))+(Xxi*(((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dya*abs(Xxr)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dya*abs(Xxr)))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dxa*abs(Xxi)))))+((3*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxr*Xxr)))))))+((-3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dya*abs(Xxr))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs((Xxi*Xxi))))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dya*abs(Xxr)))))+((-3*(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxa*abs(Xxi)))))+((-3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxr*Xxr)))))))+((3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs((Xxi*Xxi)))))))+((-6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dya*abs(Xxi)))))+((6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dxa*abs(Xxr)))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dya*abs(Xxi))))))+((6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dya*abs(Xxi)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxa*abs(Xxr)))))))+((-6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dxa*abs(Xxr)))))+(sgn(Xxi)*((Xxi*((Xxr*Xxr)*(dya*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dya*abs(Xxi))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))))+((-6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dxa*abs(Xxr))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi))))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi)))))))+((-6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+dba))))))))))))))))))))))))))));
dybn=((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs((Xxr*Xxr))))))+((sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxi*Xxi))))))+((-1*((sgn(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs((Xxi*Xxi))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs((Xxr*Xxr))))))))+((2*((sgn(Xxi)*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxr)))))+((sgn(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxi)))))))+((-2*((sgn(Xxi)*sgn(Xxi))*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((2*((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs((Xxi*Xxr))))))+(((sgn(Xxi)*sgn(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxr))))+(sgn(Xxi)*(sgn(Xxr)*((((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxi)))+(Xxi*(((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))))))+((-2*((sgn(Xxr)*sgn(Xxr))*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((3*(abs((Xxr*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((-3*(abs((Xxi*Xxi))*((Xxr*Xxr)*(dxb*abs(Xxi)))))+((3*(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxr*Xxr)))))))+((-3*((abs((Xxr*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxr))))+(sgn(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs((Xxi*Xxi))))))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dyb*abs(Xxr)))))+((-3*(abs((Xxr*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((3*(abs((Xxi*Xxi))*((Xxi*Xxi)*(dxb*abs(Xxi)))))+((-3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxr*Xxr)))))))+((3*(sgn(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs((Xxi*Xxi)))))))+((-6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((6*(abs((Xxi*Xxr))*((Xxr*Xxr)*(dxb*abs(Xxr)))))+((-6*(abs((Xxr*Xxr))*(Xxi*(Xxr*(dyb*abs(Xxi))))))+((6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dyb*abs(Xxi)))))+(abs((Xxr*Xxr))*(Xxi*(Xxr*(dxb*abs(Xxr)))))))+((-6*((abs((Xxi*Xxi))*(Xxi*(Xxr*(dxb*abs(Xxr)))))+(sgn(Xxi)*((Xxi*((Xxr*Xxr)*(dyb*abs((Xxi*Xxr)))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))))))+((6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dyb*abs(Xxi))))+((sgn(Xxr)*sgn(Xxr))*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))))+((-6*((abs((Xxi*Xxr))*((Xxi*Xxi)*(dxb*abs(Xxr))))+(((sgn(Xxi)*sgn(Xxi))*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((sgn(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs((Xxi*Xxr))))))+((sgn(Xxr)*sgn(Xxr))*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi))))))))))+((6*((sgn(Xxi)*sgn(Xxi))*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi)))))))+((-6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))))+((-12*(abs((Xxi*Xxr))*(Xxi*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+dbb))))))))))))))))))))))))))));
}

{xrn=(cr+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-1*((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-2*((abs((Xi*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-2*((abs((Xi*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((2*((abs((Xi*Xr))*(Xi*((Xi*Xi)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-3*(abs((Xr*Xr))*(xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((xi*xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*(((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*(abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xi,xi))))+(abs((Xi+xi))*(Xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xr+xr)))))+((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-3*(abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+((abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*(abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xr*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xr+xr))))+((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+((6*((abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((-6*(abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))+((6*((abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((-6*((abs((Xi*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))*(Xr+xr))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((-12*((abs((Xi*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((12*((abs((Xi*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xr+xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((abs((Xi*Xi))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xr*((Xr*Xr)*diffabs(Xi,xi))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xi*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-1*((abs((Xi*Xi))*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*abs((Xi+xi))))))+((abs((Xr*Xr))*((Xi*((Xi*Xi)*diffabs(Xr,xr)))+(xi*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))+(xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+(abs((Xr+xr))*((Xi*((Xi*Xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+(xi*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((2*((abs((Xi*Xr))*((Xi*((Xi*Xi)*diffabs(Xi,xi)))+((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))))+((abs((Xi+xi))*((Xi*((Xi*Xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))+(abs((Xr+xr))*((Xr*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xr*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((3*((abs((Xr*Xr))*(xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*((xi*xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(xi*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((xi*xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*(Xr*((xr*xr)*abs((Xi+xi)))))+(abs((Xi+xi))*((xi*xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*(Xr*((xr*xr)*abs((Xi+xi))))))+((3*(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*((abs((Xr*Xr))*(Xr*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*(abs((Xi*Xi))*(Xr*((xi*xi)*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xr*abs((Xi+xi)))))+(abs((Xi+xi))*(Xr*((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xi*Xi))*((Xr*Xr)*(xr*abs((Xi+xi))))))+((3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((-3*(abs((Xi+xi))*((Xr*Xr)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((3*((abs((Xr*Xr))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*((Xr*Xr)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((3*((abs((Xr*Xr))*(Xi*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*((xr*xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((-3*((abs((Xi*Xi))*(Xi*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xi*(((xi*xi)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xr*xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((3*((abs((Xi*Xi))*(Xi*((xi*xi)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*(Xi*(((Xr*Xr)*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))+((xi*xi)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((-3*((abs((Xi*Xi))*(Xi*((Xr*Xr)*diffabs(Xr,xr))))+((abs((Xr*Xr))*((Xi*Xi)*(xr*abs((Xi+xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(xr*abs((Xi+xi))))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-3*((abs((Xr*Xr))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((3*((abs((Xi*Xi))*((Xi*Xi)*(xi*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-3*(abs((Xr*Xr))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((3*(abs((Xi*Xi))*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))+((-3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))+((3*(abs((Xi+xi))*((Xi*Xi)*(Xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))+((-6*((abs((Xi*Xr))*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+((abs((Xi+xi))*(xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((xi*xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*(Xr*((xr*xr)*abs((Xr+xr)))))+((abs((Xr*Xr))*(Xr*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))+((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((-6*((abs((Xi*Xi))*(Xr*(xi*(xr*abs((Xr+xr))))))+((abs((Xi*Xr))*(Xr*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*(Xr*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi)))))))))))+((6*((abs((Xi*Xr))*((Xr*Xr)*(xr*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*((xr*xr)*abs((Xi+xi))))+((Xr*Xr)*(xi*abs((Xi+xi))))))+((abs((Xr*Xr))*(Xi*(xi*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*((xr*xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+((Xr*Xr)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))))+((6*(abs((Xi*Xi))*(Xi*(xi*(xr*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(xi*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*((abs((Xi*Xr))*(Xi*((xi*xi)*abs((Xi+xi)))))+((abs((Xr*Xr))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(((xi*xi)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))+(xi*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr)))))))))))+((-6*((abs((Xi*Xi))*(Xi*(Xr*(xr*abs((Xr+xr))))))+((abs((Xr*Xr))*(Xi*(Xr*(xi*abs((Xi+xi))))))+(abs((Xr+xr))*(Xi*(Xr*(xr*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))))+((6*(abs((Xi*Xi))*(Xi*(Xr*(xi*abs((Xi+xi)))))))+((-6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xr*Xr),((2*(Xr*xr))+(xr*xr))))))))+((6*(abs((Xi+xi))*(Xi*(Xr*(xi*diffabs((Xi*Xi),((2*(Xi*xi))+(xi*xi))))))))+((-6*((abs((Xi*Xr))*(((Xi*Xi)*(xr*abs((Xr+xr))))+(Xi*((Xr*Xr)*diffabs(Xi,xi)))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))+((6*((abs((Xi*Xr))*((Xi*Xi)*(xi*abs((Xi+xi)))))+(abs((Xi+xi))*((Xi*Xi)*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-6*((abs((Xi*Xr))*((Xi*Xi)*(Xr*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+((-12*((abs((Xi*Xr))*((Xi*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))+(Xr*(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*(Xr*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+(Xr*(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))))+(abs((Xr+xr))*(Xi*((Xr*(xi*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))+(xi*(xr*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr))))))))))))+(abs((Xr*Xr))*(xr*((xr*xr)*abs((Xi+xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,67,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 67 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((-2*(sgn(Xxi)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-2*(sgn(Xxi)*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-4*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*dxa))))+((4*(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr))))))+((-4*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*dya)))+((-8*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((-12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((12*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi))))))+((-12*(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((12*((abs(Xxi)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))+(sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((-12*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-24*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((24*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+daa)))))))))))))))));
dxbn=((-2*(sgn(Xxi)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-2*(sgn(Xxi)*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-4*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*dxb))))+((4*(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr))))))+((-4*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*dyb)))+((-8*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((-12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((12*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((-12*(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((12*((abs(Xxi)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))+(sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((-12*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-24*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((24*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+dab)))))))))))))))));
dyan=((2*((sgn(Xxi)*((dya*abs(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))+(sgn(Xxr)*((dxa*abs(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+((-4*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))+(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))))+((4*(abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))+((8*(abs(Xxi)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-8*(sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-8*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+((12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-12*((abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))+(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))))+((12*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+((-12*((sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-24*(abs(Xxi)*(((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dya*abs(Xxr)))))))+dba)))))))))))));
dybn=((2*((sgn(Xxi)*((dyb*abs(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))+(sgn(Xxr)*((dxb*abs(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((-4*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))))+((4*(abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))+((8*(abs(Xxi)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-8*(sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-8*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+((12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-12*((abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))+(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))))+((12*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+((-12*((sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-24*(abs(Xxi)*(((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+dbb)))))))))))));
}

{xrn=(cr+((((xi*xi)*(xi*xi))*abs((Xr*(Xr+xr))))+((abs(Xr)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-1*(((Xi*Xi)*((xr*xr)*(xr*xr)))+((xi*xi)*(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-2*(Xi*(xi*(((Xr*Xr)*(Xr*Xr))+((xr*xr)*(xr*xr))))))+((4*((abs(Xr)*(Xr*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*(Xr*((xi*xi)*(xr*(xr*xr)))))+((4*((abs(Xr)*(Xr*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))+((-4*(Xr*((Xr*Xr)*((xi*xi)*xr))))+((4*((abs(Xr)*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((-4*((Xi*Xi)*(Xr*(xr*((Xr*Xr)+(xr*xr))))))+((4*((abs(Xr)*(Xi*((Xi*Xi)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xi*diffabs(Xr,xr)))))))+((-6*((abs(Xr)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*((xr*xr)*diffabs(Xr,xr))))))))+((-6*((abs(Xr)*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*((xi*xi)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*((xi*xi)*diffabs(Xi,xi))))))+((-6*((Xi*(xi*((xi*xi)*(xi*xi))))+(((Xr*Xr)*((xi*xi)*(xr*xr)))+((abs(Xr)*((Xi*Xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*((xr*xr)*diffabs(Xr,xr))))))))+((6*((abs(Xi)*((Xi*Xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*((Xi*Xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xr,xr))))))))+((-6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi)))*(abs(Xi)+abs((Xi+xi)))))+((-6*((Xi*(((Xi*Xi)*(Xi*Xi))*xi))+((Xi*Xi)*((Xr*Xr)*(xr*xr)))))+((-8*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xr*(xi*((xi*xi)*abs((Xr+xr)))))+(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xr*(xi*((xi*xi)*diffabs(Xi,xi))))+(xi*((xi*xi)*(xr*diffabs(Xi,xi))))))))+((-8*((Xi*(Xr*(((Xr*Xr)*(xi*xr))+(xi*(xr*(xr*xr))))))+((abs(Xi)*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))))+((8*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xr)*(Xr*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*xi)*(xr*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*((Xr*Xr)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((-12*((Xi*((Xr*Xr)*(xi*(xr*xr))))+((abs(Xr)*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xr*diffabs(Xr,xr))))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi)))))))+((-15*((((Xi*Xi)*(Xi*Xi))*(xi*xi))+((Xi*Xi)*((xi*xi)*(xi*xi)))))+((-20*(Xi*((Xi*Xi)*(xi*(xi*xi)))))+((-24*((abs(Xi)*(((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))+(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+(abs((Xr+xr))*(((Xr*Xr)*(xi*(xr*diffabs(Xi,xi))))+(Xr*(xi*((xr*xr)*diffabs(Xi,xi))))))))+((24*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-24*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs(Xr)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((24*((abs(Xi)*(Xi*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))))+((abs((Xi+xi))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi))))))))+((-24*((abs(Xi)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))))+((24*((abs(Xi)*((Xi*Xi)*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(((xr*xr)*(xr*xr))*abs((Xr*(Xr+xr))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((2*((abs((Xi*(Xr+xr)))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))+((abs(Xi)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+((xi*xi)*(xi*xi)))))))))+((4*((abs(Xr)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(xi*((xi*xi)*(xr*diffabs(Xr,xr)))))))))+((4*((abs(Xi)*(xi*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-4*((abs(Xr)*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((4*((abs(Xi)*(Xr*(xi*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xr*((Xr*Xr)*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xr*(xi*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))))+((-4*((abs(Xi)*(Xr*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((4*((abs(Xr)*(Xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(Xi*(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((4*((Xi*(Xr*((Xr*Xr)*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((-4*((abs(Xi)*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((abs(Xr)*(Xi*((Xi*Xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xr*diffabs(Xr,xr)))))))))+((4*(abs((Xi+xi))*(Xi*((Xi*Xi)*(xr*diffabs(Xi,xi))))))+((-4*((Xi*((Xi*Xi)*(Xr*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((4*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+(abs((Xi+xi))*(Xi*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xi*(((Xi*Xi)*(xi*abs((Xr+xr))))+(xi*((xi*xi)*abs((Xr+xr))))))+(Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+(xr*((xr*xr)*abs((Xr+xr))))))))+(abs((Xr+xr))*((Xi*(((Xi*Xi)*(xi*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+(Xr*(((Xr*Xr)*(xr*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))))+((-12*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))))+((12*((abs(Xr)*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((-12*((abs(Xi)*(Xr*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((12*((abs(Xi)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xr*Xr)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-12*((abs(Xi)*((Xr*Xr)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs(Xr)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*((xi*xi)*(xr*diffabs(Xr,xr))))+((Xr*Xr)*((xi*xi)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xr*xr)*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xr,xr)))))))))+((12*((abs(Xi)*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(((Xi*Xi)*((xr*xr)*abs((Xr+xr))))+(Xi*((Xr*Xr)*(xr*abs((Xi+xi)))))))+((abs(Xr)*((Xi*Xi)*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*((Xi*Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*((Xi*Xi)*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xi*diffabs(Xi,xi)))))))+((-12*((abs(Xi)*((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi))))))+((-24*((abs(Xi)*(((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))+((Xi*(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr))))))+(Xr*((xi*xi)*(xr*abs((Xr+xr))))))))+(abs((Xr+xr))*(((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi))))+((Xi*(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))))+((-48*((abs(Xi)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(((xr*xr)*(xr*xr))*diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((-2*(sgn(Xxi)*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr)))))+((-2*(sgn(Xxi)*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*abs(Xxr)))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-4*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*dxa))))+((4*(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr))))))+((-4*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*dya)))+((-8*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxi)))))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))))))+((-12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxr))))))+((12*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dya*abs(Xxi))))))+((-12*(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((12*((abs(Xxi)*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxi)))))+(sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((-12*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-24*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((24*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr))))))+daa)))))))))))))))));
dxbn=((-2*(sgn(Xxi)*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr)))))+((-2*(sgn(Xxi)*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))))+((2*(sgn(Xxr)*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*abs(Xxr)))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-4*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*dxb))))+((4*(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr))))))+((-4*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*dyb)))+((-8*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxi)))))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))))))+((-12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((12*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((-12*(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((12*((abs(Xxi)*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxi)))))+(sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((-12*(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-24*(abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((24*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr))))))+dab)))))))))))))))));
dyan=((2*((sgn(Xxi)*((dya*abs(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))+(sgn(Xxr)*((dxa*abs(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxr))))))+((-4*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))+(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxr)))))))+((4*(abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxa*abs(Xxi))))))+((8*(abs(Xxi)*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-8*(sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi)))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dya*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))))+((-8*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr)))))))+((12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxr))))))+((-12*((abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxa*abs(Xxi)))))+(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxr)))))))+((12*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))))+((-12*((sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxi)))))))+((-24*(abs(Xxi)*(((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dya*abs(Xxr)))))))+dba)))))))))))));
dybn=((2*((sgn(Xxi)*((dyb*abs(Xxr))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))+(sgn(Xxr)*((dxb*abs(Xxi))*(((Xxi*Xxi)*(Xxi*Xxi))+((Xxr*Xxr)*(Xxr*Xxr)))))))+((4*(abs(Xxr)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxr))))))+((-4*((abs(Xxi)*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))+(abs(Xxr)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxr)))))))+((4*(abs(Xxi)*(Xxi*((Xxi*Xxi)*(dxb*abs(Xxi))))))+((8*(abs(Xxi)*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-8*(sgn(Xxi)*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi)))))))+((8*((abs(Xxi)*(Xxi*((Xxi*Xxi)*(dyb*abs(Xxr)))))+((sgn(Xxi)*(Xxi*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+(sgn(Xxr)*(Xxi*(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))))+((-8*(sgn(Xxr)*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr)))))))+((12*(abs(Xxr)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxr))))))+((-12*((abs(Xxi)*(Xxi*((Xxr*Xxr)*(dxb*abs(Xxi)))))+(abs(Xxr)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxr)))))))+((12*(abs(Xxi)*((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))))+((-12*((sgn(Xxi)*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxr)))))+(sgn(Xxr)*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxi)))))))+((-24*(abs(Xxi)*(((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))+(Xxi*((Xxr*Xxr)*(dyb*abs(Xxr)))))))+dbb)))))))))))));
}

{xrn=(cr+((((xi*xi)*(xi*xi))*abs((Xr*(Xr+xr))))+((abs(Xr)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+((abs((Xr+xr))*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-1*(((Xi*Xi)*((xr*xr)*(xr*xr)))+((xi*xi)*(((Xr*Xr)*(Xr*Xr))+(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))))+((-2*(Xi*(xi*(((Xr*Xr)*(Xr*Xr))+((xr*xr)*(xr*xr))))))+((4*((abs(Xr)*(Xr*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*(Xr*((xi*xi)*(xr*(xr*xr)))))+((4*((abs(Xr)*(Xr*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))+((-4*(Xr*((Xr*Xr)*((xi*xi)*xr))))+((4*((abs(Xr)*(Xi*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((-4*((Xi*Xi)*(Xr*(xr*((Xr*Xr)+(xr*xr))))))+((4*((abs(Xr)*(Xi*((Xi*Xi)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xi*diffabs(Xr,xr)))))))+((-6*((abs(Xr)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs((Xi+xi))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xr*Xr)*((xr*xr)*diffabs(Xr,xr))))))))+((-6*((abs(Xr)*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xr*Xr)*((xi*xi)*diffabs(Xr,xr))))))+((6*((abs(Xi)*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))+(abs((Xi+xi))*((Xr*Xr)*((xi*xi)*diffabs(Xi,xi))))))+((-6*((Xi*(xi*((xi*xi)*(xi*xi))))+(((Xr*Xr)*((xi*xi)*(xr*xr)))+((abs(Xr)*((Xi*Xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((Xi*Xi)*((xr*xr)*diffabs(Xr,xr))))))))+((6*((abs(Xi)*((Xi*Xi)*((xr*xr)*abs((Xi+xi)))))+((abs(Xr)*((Xi*Xi)*((xi*xi)*abs((Xr+xr)))))+((abs((Xi+xi))*((Xi*Xi)*((xr*xr)*diffabs(Xi,xi))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xr,xr))))))))+((-6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr)))*(abs(Xr)+abs((Xr+xr)))))+((6*(((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi)))*(abs(Xi)+abs((Xi+xi)))))+((-6*((Xi*(((Xi*Xi)*(Xi*Xi))*xi))+((Xi*Xi)*((Xr*Xr)*(xr*xr)))))+((-8*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xr*(xi*((xi*xi)*abs((Xr+xr)))))+(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xr*(xi*((xi*xi)*diffabs(Xi,xi))))+(xi*((xi*xi)*(xr*diffabs(Xi,xi))))))))+((-8*((Xi*(Xr*(((Xr*Xr)*(xi*xr))+(xi*(xr*(xr*xr))))))+((abs(Xi)*((Xi*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*((Xr*((Xr*Xr)*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))))+((8*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(diffabs(Xi,xi)*(Xr+xr)))))))+((-12*((abs(Xr)*(Xr*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*((xi*xi)*(xr*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xr*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*(Xi*((Xr*Xr)*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*(Xi*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((-12*((Xi*((Xr*Xr)*(xi*(xr*xr))))+((abs(Xr)*((Xi*Xi)*(Xr*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xr*diffabs(Xr,xr))))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi)))))))+((-15*((((Xi*Xi)*(Xi*Xi))*(xi*xi))+((Xi*Xi)*((xi*xi)*(xi*xi)))))+((-20*(Xi*((Xi*Xi)*(xi*(xi*xi)))))+((-24*((abs(Xi)*(((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))+(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+(abs((Xr+xr))*(((Xr*Xr)*(xi*(xr*diffabs(Xi,xi))))+(Xr*(xi*((xr*xr)*diffabs(Xi,xi))))))))+((24*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-24*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs(Xr)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((24*((abs(Xi)*(Xi*(Xr*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi))))))))+((abs((Xi+xi))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi))))))))+((-24*((abs(Xi)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))))+((24*((abs(Xi)*((Xi*Xi)*((Xr*(xi*abs((Xr+xr))))+(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*(xi*diffabs(Xi,xi)))+(xi*(xr*diffabs(Xi,xi))))))))+(((xr*xr)*(xr*xr))*abs((Xr*(Xr+xr))))))))))))))))))))))))))))))))))))))))))))));
xin=(ci+((2*((abs((Xi*(Xr+xr)))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))+((abs(Xi)*(diffabs(Xr,xr)*(((Xi*Xi)*(Xi*Xi))+((Xr*Xr)*(Xr*Xr)))))+(abs((Xr+xr))*(diffabs(Xi,xi)*(((Xi*Xi)*(Xi*Xi))+(((Xr*Xr)*(Xr*Xr))+((xi*xi)*(xi*xi)))))))))+((4*((abs(Xr)*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(xi*(xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(xi*(xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(xi*((xi*xi)*(xr*diffabs(Xr,xr)))))))))+((4*((abs(Xi)*(xi*((xi*xi)*(xr*abs((Xi+xi))))))+(abs((Xi+xi))*(xi*((xi*xi)*(xr*diffabs(Xi,xi)))))))+((-4*((abs(Xr)*(Xr*(xi*((xi*xi)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xi*xi)*diffabs(Xr,xr)))))))+((4*((abs(Xi)*(Xr*(xi*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xr*((Xr*Xr)*(xi*abs((Xr+xr))))))+((abs((Xi+xi))*(Xr*(xi*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xr*((Xr*Xr)*(xi*diffabs(Xr,xr)))))))))+((-4*((abs(Xi)*(Xr*((Xr*Xr)*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*((Xr*Xr)*(xi*diffabs(Xi,xi)))))))+((4*((abs(Xr)*(Xi*(xr*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xi*(xr*((xr*xr)*diffabs(Xr,xr)))))))+((-4*((abs(Xi)*(Xi*(xr*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xi*(xr*((xr*xr)*diffabs(Xi,xi)))))))+((4*((Xi*(Xr*((Xr*Xr)*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((-4*((abs(Xi)*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+((abs(Xr)*(Xi*((Xi*Xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((Xr*Xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xi*Xi)*(xr*diffabs(Xr,xr)))))))))+((4*(abs((Xi+xi))*(Xi*((Xi*Xi)*(xr*diffabs(Xi,xi))))))+((-4*((Xi*((Xi*Xi)*(Xr*diffabs(Xr,xr))))*(abs(Xr)+abs((Xr+xr)))))+((4*((abs(Xi)*(Xi*((Xi*Xi)*((Xr*diffabs(Xi,xi))+(xr*abs((Xi+xi)))))))+(abs((Xi+xi))*(Xi*((Xi*Xi)*(Xr*diffabs(Xi,xi)))))))+((8*((abs(Xi)*((Xi*(((Xi*Xi)*(xi*abs((Xr+xr))))+(xi*((xi*xi)*abs((Xr+xr))))))+(Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+(xr*((xr*xr)*abs((Xr+xr))))))))+(abs((Xr+xr))*((Xi*(((Xi*Xi)*(xi*diffabs(Xi,xi)))+(xi*((xi*xi)*diffabs(Xi,xi)))))+(Xr*(((Xr*Xr)*(xr*diffabs(Xi,xi)))+(xr*((xr*xr)*diffabs(Xi,xi)))))))))+((-12*((abs(Xi)*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+(abs((Xr+xr))*((xi*xi)*((xr*xr)*diffabs(Xi,xi))))))+((12*((abs(Xr)*(Xr*(xi*((xr*xr)*abs((Xr+xr))))))+(abs((Xr+xr))*(Xr*(xi*((xr*xr)*diffabs(Xr,xr)))))))+((-12*((abs(Xi)*(Xr*(xi*((xr*xr)*abs((Xi+xi))))))+(abs((Xi+xi))*(Xr*(xi*((xr*xr)*diffabs(Xi,xi)))))))+((12*((abs(Xi)*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+((abs(Xr)*((Xr*Xr)*(xi*(xr*abs((Xr+xr))))))+(abs((Xr+xr))*((Xr*Xr)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi))))))))+((-12*((abs(Xi)*((Xr*Xr)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs(Xr)*(Xi*((xi*xi)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*((Xr*Xr)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*((xi*xi)*(xr*diffabs(Xr,xr))))+((Xr*Xr)*((xi*xi)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*(Xi*((xi*xi)*(xr*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xr*xr)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((xi*xi)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xr*xr)*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(Xi*(Xr*((xr*xr)*abs((Xi+xi))))))+((abs(Xr)*(Xi*(Xr*((xi*xi)*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xr*xr)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*(Xr*((xi*xi)*diffabs(Xr,xr)))))))))+((12*((abs(Xi)*(Xi*(Xr*((xi*xi)*abs((Xi+xi))))))+((abs(Xr)*(Xi*((Xr*Xr)*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*(Xr*((xi*xi)*diffabs(Xi,xi)))))+(abs((Xr+xr))*(Xi*((Xr*Xr)*(xr*diffabs(Xr,xr)))))))))+((-12*((abs(Xi)*(((Xi*Xi)*((xr*xr)*abs((Xr+xr))))+(Xi*((Xr*Xr)*(xr*abs((Xi+xi)))))))+((abs(Xr)*((Xi*Xi)*(xi*(xr*abs((Xr+xr))))))+((abs((Xi+xi))*(Xi*((Xr*Xr)*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*(xr*diffabs(Xr,xr)))+((xr*xr)*diffabs(Xi,xi)))))))))+((12*((abs(Xi)*((Xi*Xi)*(((xi*xi)*abs((Xr+xr)))+(xi*(xr*abs((Xi+xi)))))))+((abs((Xi+xi))*((Xi*Xi)*(xi*(xr*diffabs(Xi,xi)))))+(abs((Xr+xr))*((Xi*Xi)*((xi*xi)*diffabs(Xi,xi)))))))+((-12*((abs(Xr)*((Xi*Xi)*(Xr*(xi*abs((Xr+xr))))))+(abs((Xr+xr))*((Xi*Xi)*(Xr*(xi*diffabs(Xr,xr)))))))+((12*((abs(Xi)*((Xi*Xi)*(Xr*(xi*abs((Xi+xi))))))+(abs((Xi+xi))*((Xi*Xi)*(Xr*(xi*diffabs(Xi,xi)))))))+((-12*((abs(Xi)*((Xi*Xi)*((Xr*Xr)*diffabs(Xr,xr))))+(abs((Xr+xr))*((Xi*Xi)*((Xr*Xr)*diffabs(Xi,xi))))))+((-24*((abs(Xi)*(((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))+((Xi*(((Xr*Xr)*(xi*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xr+xr))))))+(Xr*((xi*xi)*(xr*abs((Xr+xr))))))))+(abs((Xr+xr))*(((Xi*Xi)*(Xr*(xr*diffabs(Xi,xi))))+((Xi*(((Xr*Xr)*(xi*diffabs(Xi,xi)))+(xi*((xr*xr)*diffabs(Xi,xi)))))+(Xr*((xi*xi)*(xr*diffabs(Xi,xi)))))))))+((-48*((abs(Xi)*(Xi*(Xr*(xi*(xr*abs((Xr+xr)))))))+(abs((Xr+xr))*(Xi*(Xr*(xi*(xr*diffabs(Xi,xi))))))))+(2*(abs((Xr+xr))*(((xr*xr)*(xr*xr))*diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,68,6)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 68 && m_nPower == 6)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*sgn(Xxr))))+((-1*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*sgn(Xxi)))))+((-5*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi))))+((5*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr))))+((-5*((((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))+(Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*sgn(Xxi))))))+((5*(((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr)))))+((-10*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))))+((10*(Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((20*(Xxi*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((30*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+daa))))))))))));
dxbn=((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*sgn(Xxr))))+((-1*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*sgn(Xxi)))))+((-5*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi))))+((5*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr))))+((-5*((((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))+(Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*sgn(Xxi))))))+((5*(((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr)))))+((-10*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))))+((10*(Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((20*(Xxi*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((30*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+dab))))))))))));
dyan=((Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*sgn(Xxr))))+((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*sgn(Xxi))))+((5*((((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*sgn(Xxr))))+(((Xxr*Xxr)*(Xxr*Xxr))*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-10*((Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dya*sgn(Xxi)))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))+((20*(Xxi*(((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-20*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+dba))))))));
dybn=((Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*sgn(Xxr))))+((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*sgn(Xxi))))+((5*((((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*sgn(Xxr))))+(((Xxr*Xxr)*(Xxr*Xxr))*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-10*((Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi)))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((20*(Xxi*(((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-20*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dbb))))))));
}

{xrn=(cr+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr)))+((-1*((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xi,xi)))+(xi*(((xi*xi)*(xi*xi))*abs((Xi+xi))))))+((-5*(xi*(((xr*xr)*(xr*xr))*abs((Xi+xi)))))+((5*((((Xr*Xr)*(Xr*Xr))*(xr*abs((Xr+xr))))+((Xr*(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+(((xi*xi)*(xi*xi))*(xr*abs((Xr+xr)))))))+((-5*((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi))+(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+(((Xr*Xr)*(Xr*Xr))*(xi*abs((Xi+xi))))))+((5*(((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr))))))+((-5*(((Xi*Xi)*(Xi*Xi))*(xi*abs((Xi+xi)))))+((-10*((xi*xi)*(xr*((xr*xr)*abs((Xr+xr))))))+((10*((Xr*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))+(xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))))+((-10*(((Xi*Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((10*(Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))))+((-10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xi+xi))))))+((-20*(Xr*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xr*(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-20*((Xi*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*(xr*abs((Xi+xi))))))))+((20*(Xi*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((-20*(Xi*(Xr*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*(Xr*(xi*((xi*xi)*abs((Xr+xr)))))))+((-20*(Xi*(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((20*(Xi*((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))))+((-30*(((Xr*Xr)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xr*((xi*xi)*((xr*xr)*abs((Xr+xr)))))))+((30*(Xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((-30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((30*(((Xi*Xi)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xr+xr))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xr+xr))))))+((-30*((Xi*Xi)*((Xr*Xr)*(xr*abs((Xr+xr))))))+((30*((Xi*Xi)*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-60*(Xi*(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+((60*(Xi*(Xr*((xi*xi)*(xr*abs((Xi+xi)))))))+((-60*(Xi*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((60*((Xi*Xi)*(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))))))))))))))));
xin=(ci+((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xr,xr)))+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi)))+((xi*(((xi*xi)*(xi*xi))*abs((Xr+xr))))+((5*((((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr))+(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+((((Xr*Xr)*(Xr*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((Xr*(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+((((xi*xi)*(xi*xi))*(xr*abs((Xi+xi))))+(xi*(((xr*xr)*(xr*xr))*abs((Xr+xr))))))))))+((-10*((xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((xi*xi)*(xr*((xr*xr)*abs((Xi+xi)))))))+((10*((Xr*Xr)*(xr*((xr*xr)*abs((Xi+xi))))))+((-10*((Xr*Xr)*(xi*((xi*xi)*abs((Xr+xr))))))+((10*(Xr*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((-10*(((Xi*Xi)*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((10*((Xi*Xi)*(xi*((xi*xi)*abs((Xr+xr))))))+((-10*((Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr))))))+((Xi*Xi)*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xr+xr))))))+((20*(Xr*(xi*(xr*((xr*xr)*abs((Xr+xr)))))))+((-20*(Xr*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((20*(Xr*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((-20*(Xi*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi))))))))+((-20*(Xi*(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((20*(Xi*((Xi*Xi)*(xi*(xr*abs((Xi+xi)))))))+((-20*(Xi*((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))))+((20*(Xi*((Xi*Xi)*(Xr*(xi*abs((Xi+xi)))))))+((-30*(Xr*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((30*((Xr*Xr)*(xi*((xr*xr)*abs((Xr+xr))))))+((-30*((Xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*(xr*abs((Xi+xi)))))))+((30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xr+xr))))))+((-30*(((Xi*Xi)*(xi*((xr*xr)*abs((Xr+xr)))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((30*((Xi*Xi)*((xi*xi)*(xr*abs((Xi+xi))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xi+xi))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xi+xi))))))+((-30*((Xi*Xi)*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-60*(((Xi*Xi)*(Xr*(xi*(xr*abs((Xr+xr))))))+(Xi*(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))))))))))))));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*sgn(Xxr))))+((-1*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dya*sgn(Xxi)))))+((-5*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*abs(Xxi))))+((5*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*abs(Xxr))))+((-5*((((Xxi*Xxi)*(Xxi*Xxi))*(dya*abs(Xxi)))+(Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*sgn(Xxi))))))+((5*(((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dxa*sgn(Xxr)))+(dxa*abs(Xxr)))))+((-10*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dxa*sgn(Xxr))))))+((10*(Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dya*sgn(Xxi))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((20*(Xxi*((Xxi*Xxi)*(Xxr*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((30*((Xxi*Xxi)*((Xxr*Xxr)*(dya*abs(Xxi)))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*abs(Xxr)))))+daa))))))))))));
dxbn=((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*sgn(Xxr))))+((-1*(Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dyb*sgn(Xxi)))))+((-5*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*abs(Xxi))))+((5*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*abs(Xxr))))+((-5*((((Xxi*Xxi)*(Xxi*Xxi))*(dyb*abs(Xxi)))+(Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*sgn(Xxi))))))+((5*(((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dxb*sgn(Xxr)))+(dxb*abs(Xxr)))))+((-10*((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dxb*sgn(Xxr))))))+((10*(Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*sgn(Xxi))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((20*(Xxi*((Xxi*Xxi)*(Xxr*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((30*((Xxi*Xxi)*((Xxr*Xxr)*(dyb*abs(Xxi)))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*abs(Xxr)))))+dab))))))))))));
dyan=((Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dxa*sgn(Xxr))))+((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dya*sgn(Xxi))))+((5*((((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dya*sgn(Xxi)))+((dxa*abs(Xxi))+(dya*abs(Xxr)))))+((Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dxa*sgn(Xxr))))+(((Xxr*Xxr)*(Xxr*Xxr))*((dxa*abs(Xxi))+(dya*abs(Xxr)))))))+((-10*((Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dxa*sgn(Xxr)))))+((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dya*sgn(Xxi)))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*(dya*abs(Xxi))))))+((20*(Xxi*(((Xxi*Xxi)*(Xxr*(dya*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxa*abs(Xxr)))))))+((-20*(Xxi*((Xxi*Xxi)*(Xxr*(dxa*abs(Xxr))))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*((dxa*abs(Xxi))+(dya*abs(Xxr))))))+dba))))))));
dybn=((Xxi*(((Xxi*Xxi)*(Xxi*Xxi))*(dxb*sgn(Xxr))))+((Xxr*(((Xxr*Xxr)*(Xxr*Xxr))*(dyb*sgn(Xxi))))+((5*((((Xxi*Xxi)*(Xxi*Xxi))*((Xxr*(dyb*sgn(Xxi)))+((dxb*abs(Xxi))+(dyb*abs(Xxr)))))+((Xxi*(((Xxr*Xxr)*(Xxr*Xxr))*(dxb*sgn(Xxr))))+(((Xxr*Xxr)*(Xxr*Xxr))*((dxb*abs(Xxi))+(dyb*abs(Xxr)))))))+((-10*((Xxi*((Xxi*Xxi)*((Xxr*Xxr)*(dxb*sgn(Xxr)))))+((Xxi*Xxi)*(Xxr*((Xxr*Xxr)*(dyb*sgn(Xxi)))))))+((-20*(Xxi*(Xxr*((Xxr*Xxr)*(dyb*abs(Xxi))))))+((20*(Xxi*(((Xxi*Xxi)*(Xxr*(dyb*abs(Xxi))))+(Xxr*((Xxr*Xxr)*(dxb*abs(Xxr)))))))+((-20*(Xxi*((Xxi*Xxi)*(Xxr*(dxb*abs(Xxr))))))+((-30*((Xxi*Xxi)*((Xxr*Xxr)*((dxb*abs(Xxi))+(dyb*abs(Xxr))))))+dbb))))))));
}

{xrn=(cr+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr)))+((-1*((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xi,xi)))+(xi*(((xi*xi)*(xi*xi))*abs((Xi+xi))))))+((-5*(xi*(((xr*xr)*(xr*xr))*abs((Xi+xi)))))+((5*((((Xr*Xr)*(Xr*Xr))*(xr*abs((Xr+xr))))+((Xr*(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+(((xi*xi)*(xi*xi))*(xr*abs((Xr+xr)))))))+((-5*((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi))+(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+(((Xr*Xr)*(Xr*Xr))*(xi*abs((Xi+xi))))))+((5*(((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xr,xr))+(xr*abs((Xr+xr))))))+((-5*(((Xi*Xi)*(Xi*Xi))*(xi*abs((Xi+xi)))))+((-10*((xi*xi)*(xr*((xr*xr)*abs((Xr+xr))))))+((10*((Xr*((Xr*Xr)*((xr*xr)*abs((Xr+xr)))))+(((Xr*Xr)*((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr))))))+(xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))))+((-10*(((Xi*Xi)*((Xr*((Xr*Xr)*diffabs(Xr,xr)))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((10*(Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xi,xi))+((xr*xr)*abs((Xi+xi)))))))+((-10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xi+xi))))))+((-20*(Xr*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xr*(xi*((xi*xi)*(xr*abs((Xi+xi)))))))+((-20*((Xi*(xi*(xr*((xr*xr)*abs((Xr+xr))))))+(Xr*((Xr*Xr)*(xi*(xr*abs((Xi+xi))))))))+((20*(Xi*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((-20*(Xi*(Xr*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*(Xr*(xi*((xi*xi)*abs((Xr+xr)))))))+((-20*(Xi*(Xr*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))))+((20*(Xi*((Xi*Xi)*((Xr*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+(xi*(xr*abs((Xr+xr))))))))+((-30*(((Xr*Xr)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xr*((xi*xi)*((xr*xr)*abs((Xr+xr)))))))+((30*(Xi*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((-30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((30*(((Xi*Xi)*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xr+xr))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xr+xr))))))+((-30*((Xi*Xi)*((Xr*Xr)*(xr*abs((Xr+xr))))))+((30*((Xi*Xi)*((Xr*Xr)*(xi*abs((Xi+xi))))))+((-60*(Xi*(Xr*(xi*((xr*xr)*abs((Xr+xr)))))))+((60*(Xi*(Xr*((xi*xi)*(xr*abs((Xi+xi)))))))+((-60*(Xi*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((60*((Xi*Xi)*(Xr*(xi*(xr*abs((Xi+xi)))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xr+xr)))))))))))))))))))))))))))))))))))));
xin=(ci+((Xi*(((Xi*Xi)*(Xi*Xi))*diffabs(Xr,xr)))+((Xr*(((Xr*Xr)*(Xr*Xr))*diffabs(Xi,xi)))+((xi*(((xi*xi)*(xi*xi))*abs((Xr+xr))))+((5*((((Xi*Xi)*(Xi*Xi))*((Xr*diffabs(Xi,xi))+((xi*abs((Xr+xr)))+(xr*abs((Xi+xi))))))+((Xi*((((Xr*Xr)*(Xr*Xr))*diffabs(Xr,xr))+(abs((Xr+xr))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr))))))+((((Xr*Xr)*(Xr*Xr))*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))+((Xr*(abs((Xi+xi))*(((xi*xi)*(xi*xi))+((xr*xr)*(xr*xr)))))+((((xi*xi)*(xi*xi))*(xr*abs((Xi+xi))))+(xi*(((xr*xr)*(xr*xr))*abs((Xr+xr))))))))))+((-10*((xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((xi*xi)*(xr*((xr*xr)*abs((Xi+xi)))))))+((10*((Xr*Xr)*(xr*((xr*xr)*abs((Xi+xi))))))+((-10*((Xr*Xr)*(xi*((xi*xi)*abs((Xr+xr))))))+((10*(Xr*((Xr*Xr)*((xr*xr)*abs((Xi+xi))))))+((-10*(((Xi*Xi)*(xr*((xr*xr)*abs((Xi+xi)))))+(Xr*((Xr*Xr)*((xi*xi)*abs((Xi+xi)))))))+((10*((Xi*Xi)*(xi*((xi*xi)*abs((Xr+xr))))))+((-10*((Xi*((Xi*Xi)*(((Xr*Xr)*diffabs(Xr,xr))+((xr*xr)*abs((Xr+xr))))))+((Xi*Xi)*(Xr*((Xr*Xr)*diffabs(Xi,xi))))))+((10*(Xi*((Xi*Xi)*((xi*xi)*abs((Xr+xr))))))+((20*(Xr*(xi*(xr*((xr*xr)*abs((Xr+xr)))))))+((-20*(Xr*(xi*((xi*xi)*(xr*abs((Xr+xr)))))))+((20*(Xr*((Xr*Xr)*(xi*(xr*abs((Xr+xr)))))))+((-20*(Xi*(xi*(xr*((xr*xr)*abs((Xi+xi)))))))+((20*(Xi*((Xr*(((Xr*Xr)*(xr*abs((Xr+xr))))+((xi*((xi*xi)*abs((Xi+xi))))+(xr*((xr*xr)*abs((Xr+xr)))))))+(xi*((xi*xi)*(xr*abs((Xi+xi))))))))+((-20*(Xi*(Xr*((Xr*Xr)*(xi*abs((Xi+xi)))))))+((20*(Xi*((Xi*Xi)*(xi*(xr*abs((Xi+xi)))))))+((-20*(Xi*((Xi*Xi)*(Xr*(xr*abs((Xr+xr)))))))+((20*(Xi*((Xi*Xi)*(Xr*(xi*abs((Xi+xi)))))))+((-30*(Xr*((xi*xi)*((xr*xr)*abs((Xi+xi))))))+((30*((Xr*Xr)*(xi*((xr*xr)*abs((Xr+xr))))))+((-30*((Xi*((xi*xi)*((xr*xr)*abs((Xr+xr)))))+((Xr*Xr)*((xi*xi)*(xr*abs((Xi+xi)))))))+((30*(Xi*((Xr*Xr)*((xr*xr)*abs((Xr+xr))))))+((-30*(((Xi*Xi)*(xi*((xr*xr)*abs((Xr+xr)))))+(Xi*((Xr*Xr)*((xi*xi)*abs((Xr+xr)))))))+((30*((Xi*Xi)*((xi*xi)*(xr*abs((Xi+xi))))))+((-30*((Xi*Xi)*(Xr*((xr*xr)*abs((Xi+xi))))))+((30*((Xi*Xi)*(Xr*((xi*xi)*abs((Xi+xi))))))+((-30*((Xi*Xi)*((Xr*Xr)*((xi*abs((Xr+xr)))+(xr*abs((Xi+xi)))))))+((-60*(((Xi*Xi)*(Xr*(xi*(xr*abs((Xr+xr))))))+(Xi*(((Xr*Xr)*(xi*(xr*abs((Xi+xi)))))+(Xr*(((xi*xi)*(xr*abs((Xr+xr))))+(xi*((xr*xr)*abs((Xi+xi))))))))))+(xr*(((xr*xr)*(xr*xr))*abs((Xi+xi))))))))))))))))))))))))))))))))))));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,69,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 69 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((-2*(Xxi*dya))+((2*(Xxr*dxa))+daa));
dxbn=((-2*(Xxi*dyb))+((2*(Xxr*dxb))+dab));
dyan=((2*((g_FactorAI*(Xxr*dxa))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxa*sgn(Xxr)))+(Xxr*(dya*sgn(Xxr))))))))+dba);
dybn=((2*((g_FactorAI*(Xxr*dxb))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxb*sgn(Xxr)))+(Xxr*(dyb*sgn(Xxr))))))))+dbb);
}

{xrn=(cr+((-1*(xi*xi))+((2*(Xr*xr))+((-2*(Xi*xi))+(xr*xr)))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((-2*(Xxi*dya))+((2*(Xxr*dxa))+daa));
dxbn=((-2*(Xxi*dyb))+((2*(Xxr*dxb))+dab));
dyan=((2*((g_FactorAI*(Xxr*dxa))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxa*sgn(Xxr)))+(Xxr*(dya*sgn(Xxr))))))))+dba);
dybn=((2*((g_FactorAI*(Xxr*dxb))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxb*sgn(Xxr)))+(Xxr*(dyb*sgn(Xxr))))))))+dbb);
}

{xrn=(cr+((-1*(xi*xi))+((2*(Xr*xr))+((-2*(Xi*xi))+(xr*xr)))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,70,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 70 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dxa0 = Jxa0, dxb0 = Jxb0, dya0 = Jya0, dyb0 = Jyb0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dxa_saved = dxa0, dxb_saved = dxb0, dya_saved = dya0, dyb_saved = dyb0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN daa = daa0, dab = dab0, dba = dba0, dbb = dbb0;
      doubleN dxa = dxa0, dxb = dxb0, dya = dya0, dyb = dyb0;
      doubleN dxan, dxbn, dyan, dybn;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

{dxan=((2*((Xxi*dya)+(Xxr*dxa)))+daa);
dxbn=((2*((Xxi*dyb)+(Xxr*dxb)))+dab);
dyan=((2*((g_FactorAI*(Xxr*dxa))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxa*sgn(Xxr)))+(Xxr*(dya*sgn(Xxr))))))))+dba);
dybn=((2*((g_FactorAI*(Xxr*dxb))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxb*sgn(Xxr)))+(Xxr*(dyb*sgn(Xxr))))))))+dbb);
}

{xrn=(cr+((xi*xi)+((2*((Xi*xi)+(Xr*xr)))+(xr*xr))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}


          xr0 = xrn;
          xi0 = xin;

          dxa0 = dxan; dxb0 = dxbn; dya0 = dyan; dyb0 = dybn;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dxa0 = dxa_saved; dxb0 = dxb_saved; dya0 = dya_saved; dyb0 = dyb_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double daa = daa0[k], dab = dab0[k], dba = dba0[k], dbb = dbb0[k];
      double dxa = dxa0[k], dxb = dxb0[k], dya = dya0[k], dyb = dyb0[k];
      double dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*((Xxi*dya)+(Xxr*dxa)))+daa);
dxbn=((2*((Xxi*dyb)+(Xxr*dxb)))+dab);
dyan=((2*((g_FactorAI*(Xxr*dxa))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxa*sgn(Xxr)))+(Xxr*(dya*sgn(Xxr))))))))+dba);
dybn=((2*((g_FactorAI*(Xxr*dxb))+(sgn(Xxi)*(g_FactorAR*((Xxi*(dxb*sgn(Xxr)))+(Xxr*(dyb*sgn(Xxr))))))))+dbb);
}

{xrn=(cr+((xi*xi)+((2*((Xi*xi)+(Xr*xr)))+(xr*xr))));
xin=((Ai*(xr*xr))+((2*((Ai*(Xr*xr))+(Ar*diffabs((Xi*Xr),((Xi*xr)+(xi*(Xr+xr)))))))+ci));
}

      dxa0[k] = dxan; dxb0[k] = dxbn; dya0[k] = dyan; dyb0[k] = dybn;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dxa0[k];
    Jxb0[k] = dxb0[k];
    Jya0[k] = dya0[k];
    Jyb0[k] = dyb0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,71,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunksize
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa0; // -Wunused-parameter
  (void) dab0; // -Wunused-parameter
  (void) dba0; // -Wunused-parameter
  (void) dbb0; // -Wunused-parameter
  if (m_nFractalType == 71 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;

    doubleN dr_0 = Jxa0, di_0 = Jya0;

    // vectorized loop
    if (all(antal == antal[0]))
    {
      const doubleN dr0 = daa0, di0 = dba0;
      (void) dr0;
      (void) di0;
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;

        doubleN dr_saved = dr_0, di_saved = di_0;

        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0;
          doubleN Xxi = Xi + xi0;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
      doubleN xr = xr0, xi = xi0, cr = cr0, ci = ci0;
      doubleN xrn, xin;

      doubleN dr = dr_0, di = di_0;
      doubleN drn, din;


      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      const complex<double> X = {Xr, Xi};
      const complex<doubleN> x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<doubleN> xn;
      (void) X; (void) x; (void) Xx;

      const complex<doubleN> d = {dr, di}, d0 = {daa0, dba0}; 
      complex<doubleN> dn;
{dn=((((2*(Xx-A))*exp(((2*A)/Xx)))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((x+(2*X))*x)*exp(((2*A)/Xx)))+(((2*(X^2))*sinh(((-(A)*x)/(Xx*X))))*exp(((A*(x+(2*X)))/(Xx*X)))))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


          xr0 = xrn;
          xi0 = xin;

          dr_0 = drn; di_0 = din;

        }

        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;

          dr_0 = dr_saved; di_0 = di_saved;

          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    const int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      const double dr0 = daa0[k], di0 = dba0[k];
      (void) dr0;
      (void) di0;
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        const double cr = cr0[k], ci = ci0[k];
        double xr = xr0[k], xi = xi0[k];
        Xxr = Xr + xr;
        Xxi = Xi + xi;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {

        bGlitch[k] = true;
        if (! m_bNoGlitchDetection[k])
          break;

        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        double xrn = 0, xin = 0;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = double;
      V dummyV;
      (void) dummyV;

      double dr = dr_0[k], di = di_0[k];
      double drn = 0, din = 0;

      const complex<double> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi}, c = {cr, ci};
      complex<double> xn;
      (void) X; (void) x; (void) Xx;

      const complex<double> d = {dr, di}, d0 = {daa0[k], dba0[k]}; 
      complex<double> dn;
{dn=((((2*(Xx-A))*exp(((2*A)/Xx)))*d)+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((x+(2*X))*x)*exp(((2*A)/Xx)))+(((2*(X^2))*sinh(((-(A)*x)/(Xx*X))))*exp(((A*(x+(2*X)))/(Xx*X)))))+c);
}
      xrn = xn.m_r; xin = xn.m_i;

      dr_0[k] = drn; di_0[k] = din;


        xr0[k] = xrn;
        xi0[k] = xin;

      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;

    Jxa0[k] = dr_0[k];
    Jxb0[k] = -di_0[k];
    Jya0[k] = di_0[k];
    Jyb0[k] = dr_0[k];

    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool perturbation
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr0, doubleN &xi0
  , const doubleN &cr0, const doubleN &ci0
  , doubleN &Jxa0, doubleN &Jxb0, doubleN &Jya0, doubleN &Jyb0
  , const double e, const double h
  , const doubleN &daa0, const doubleN &dab0, const doubleN &dba0, const doubleN &dbb0
  , const int64_t chunk_size
  )
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 3:
          return FORMULA(perturbation,0,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 4:
          return FORMULA(perturbation,0,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 5:
          return FORMULA(perturbation,0,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 6:
          return FORMULA(perturbation,0,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 7:
          return FORMULA(perturbation,0,7)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 8:
          return FORMULA(perturbation,0,8)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 9:
          return FORMULA(perturbation,0,9)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 10:
          return FORMULA(perturbation,0,10)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 3:
          return FORMULA(perturbation,1,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 4:
          return FORMULA(perturbation,1,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 5:
          return FORMULA(perturbation,1,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 3:
          return FORMULA(perturbation,2,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 4:
          return FORMULA(perturbation,2,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 5:
          return FORMULA(perturbation,2,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 3:
          return FORMULA(perturbation,3,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 4:
          return FORMULA(perturbation,3,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 5:
          return FORMULA(perturbation,3,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 3:
          return FORMULA(perturbation,4,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 4:
          return FORMULA(perturbation,4,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
        case 5:
          return FORMULA(perturbation,4,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 1: a * z^2 + z^3 + c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 2: a * z^2 - z^3 + c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 3: 2 * z^2 - z^3 + c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 4: a * z^2 + z^4 + c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 5: a * z^2 - z^4 + c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 6: a * z^2 + z^5 + c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 7: a * z^2 - z^5 + c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 8: a * z^2 + z^6 + c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // TheRedshiftRider 9: a * z^2 - z^6 + c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // General Quadratic Minus
    case 52:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,52,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // General Quadratic Plus
    case 53:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,53,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 2nd 1x1
    case 54:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,54,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 3rd 1x2
    case 55:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,55,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 3rd 2x1
    case 56:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,56,3)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 4th 1x3
    case 57:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,57,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 4th 2x2 (aka SimonBrot 4th)
    case 58:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,58,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 4th 3x1
    case 59:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,59,4)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 5th 1x4
    case 60:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,60,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 5th 2x3
    case 61:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,61,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 5th 3x2
    case 62:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,62,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 5th 4x1
    case 63:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,63,5)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 6th 1x5
    case 64:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,64,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 6th 2x4 (Simon's Mothbrot)
    case 65:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,65,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 6th 3x3 (aka SimonBrot 6th)
    case 66:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,66,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 6th 4x2
    case 67:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,67,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // Mothbrot 6th 5x1
    case 68:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,68,6)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // General Abs Quadratic Minus
    case 69:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,69,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // General Abs Quadratic Plus
    case 70:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,70,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
    // z^2 exp(2 a / z) + c
    case 71:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,71,2)
            ( m_nFractalType, m_nPower
            , m_db_dxr, m_db_dxi, m_db_z
            , antal0, test10, test20, phase0, bGlitch0
            , m_nBailout2, nMaxIter
            , m_bNoGlitchDetection, g_real, g_imag, p
            , g_FactorAR, g_FactorAI
            , xr0, xi0
            , cr0, ci0
            , Jxa0, Jxb0, Jya0, Jyb0
            , e, h
            , daa0, dab0, dba0, dbb0
            , chunk_size
            );
      
      }
      break;
  
  }
  return false;
}

#if KF_SIMD >= 1
template bool perturbation<int2, double2>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int2 &antal0, double2 &test10, double2 &test20, double2 &phase0, int2 &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const int2 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double2 &xr0, double2 &xi0
  , const double2 &cr0, const double2 &ci0
  , double2 &Jxa0, double2 &Jxb0, double2 &Jya0, double2 &Jyb0
  , const double e, const double h
  , const double2 &daa0, const double2 &dab0, const double2 &dba0, const double2 &dbb0
  , const int64_t chunk_size
  );
#endif

#if KF_SIMD >= 2
template bool perturbation<int4, double4>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int4 &antal0, double4 &test10, double4 &test20, double4 &phase0, int4 &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const int4 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double4 &xr0, double4 &xi0
  , const double4 &cr0, const double4 &ci0
  , double4 &Jxa0, double4 &Jxb0, double4 &Jya0, double4 &Jyb0
  , const double e, const double h
  , const double4 &daa0, const double4 &dab0, const double4 &dba0, const double4 &dbb0
  , const int64_t chunk_size
  );
#endif

#if KF_SIMD >= 3
template bool perturbation<int8, double8>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int8 &antal0, double8 &test10, double8 &test20, double8 &phase0, int8 &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const int8 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double8 &xr0, double8 &xi0
  , const double8 &cr0, const double8 &ci0
  , double8 &Jxa0, double8 &Jxb0, double8 &Jya0, double8 &Jyb0
  , const double e, const double h
  , const double8 &daa0, const double8 &dab0, const double8 &dba0, const double8 &dbb0
  , const int64_t chunk_sizes
  );
#endif

#if KF_SIMD >= 4
template bool perturbation<int16, double16>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int16 &antal0, double16 &test10, double16 &test20, double16 &phase0, int16 &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const int16 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double16 &xr0, double16 &xi0
  , const double16 &cr0, const double16 &ci0
  , double16 &Jxa0, double16 &Jxb0, double16 &Jya0, double16 &Jyb0
  , const double e, const double h
  , const double16 &daa0, const double16 &dab0, const double16 &dba0, const double16 &dbb0
  , const int64_t chunk_size
  );
#endif

#endif

#ifdef PASS6 // perturbation with scaling



template <typename T>
bool FORMULA(perturbation,0,2)
  ( const int m_nFractalType, const int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch0
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr00, T &xi00
  , const T &cr0, const T &ci0
  , const T &s, const T &S
  )
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<T> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr0 = xr00;
    T xi0 = xi00;
    int64_t antal = antal0;
    bool bGlitch = bGlitch0;
    T Xxr = 0;
    T Xxi = 0;
      for (; antal < nMaxIter; antal = antal + 1)
      {
        const T Xr = m_db_dxr[antal];
        const T Xi = m_db_dxi[antal];
        const double Xz = m_db_z[antal];
        Xxr = Xr + xr0 * s;
        Xxi = Xi + xi0 * s;
        const T Xxr2 = Xxr * Xxr;
        const T Xxi2 = Xxi * Xxi;
        test2 = test1;
        test1 = double(Xxr2 + Xxi2);
        if (test1 < Xz)
        {
          bGlitch = true;
          if (! m_bNoGlitchDetection)
            break;
        }
        if (! no_g)
        {
          test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
        }
        if (test1 > m_nBailout2)
        {
          phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase -= floor(phase);
          break;
        }
        double xrn, xin;

      using V = T;
      V dummyV;
      (void) dummyV;

      T cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(((((2*Xr)+(xr*s))*xr)-(((2*Xi)+(xi*s))*xi))+cr);
xin=((2*(((Xr+(xr*s))*xi)+(Xi*xr)))+ci);
}


        xr0 = xrn;
        xi0 = xin;
      }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr00 = Xxr;
    xi00 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(perturbation,0,3)
  ( const int m_nFractalType, const int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch0
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr00, T &xi00
  , const T &cr0, const T &ci0
  , const T &s, const T &S
  )
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<T> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    T xr0 = xr00;
    T xi0 = xi00;
    int64_t antal = antal0;
    bool bGlitch = bGlitch0;
    T Xxr = 0;
    T Xxi = 0;
      for (; antal < nMaxIter; antal = antal + 1)
      {
        const T Xr = m_db_dxr[antal];
        const T Xi = m_db_dxi[antal];
        const double Xz = m_db_z[antal];
        Xxr = Xr + xr0 * s;
        Xxi = Xi + xi0 * s;
        const T Xxr2 = Xxr * Xxr;
        const T Xxi2 = Xxi * Xxi;
        test2 = test1;
        test1 = double(Xxr2 + Xxi2);
        if (test1 < Xz)
        {
          bGlitch = true;
          if (! m_bNoGlitchDetection)
            break;
        }
        if (! no_g)
        {
          test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
        }
        if (test1 > m_nBailout2)
        {
          phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase -= floor(phase);
          break;
        }
        double xrn, xin;

      using V = T;
      V dummyV;
      (void) dummyV;

      T cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((3*(Xr2-Xi2))*xr)-(((6*Xr)*Xi)*xi))+((3*((Xr*(xr2-xi2))-(((2*Xi)*xr)*xi)))*s))+((((xr2-(3*xi2))*xr)*s)*s))+cr);
xin=((((((3*(Xr2-Xi2))*xi)+(((6*Xr)*Xi)*xr))+((3*((((2*Xr)*xr)*xi)+(Xi*(xr2-xi2))))*s))+(((((3*xr2)-xi2)*xi)*s)*s))+ci);
}


        xr0 = xrn;
        xi0 = xin;
      }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr00 = Xxr;
    xi00 = Xxi;
    return true;
  }
  return false;
}



template <typename T>
bool perturbation
  ( const int m_nFractalType, const int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , T &xr00, T &xi00
  , const T &cr0, const T &ci0
  , const T &s, const T &S
  )
{

  if (m_nFractalType == 0 && m_nPower == 2)
    return FORMULA(perturbation,0,2)
      ( m_nFractalType, m_nPower
      , m_db_dxr, m_db_dxi, m_db_z
      , antal, test1, test2, phase, bGlitch
      , m_nBailout2, nMaxIter
      , m_bNoGlitchDetection, g_real, g_imag, p
      , g_FactorAR, g_FactorAI
      , xr00, xi00
      , cr0, ci0
      , s, S
      );

  if (m_nFractalType == 0 && m_nPower == 3)
    return FORMULA(perturbation,0,3)
      ( m_nFractalType, m_nPower
      , m_db_dxr, m_db_dxi, m_db_z
      , antal, test1, test2, phase, bGlitch
      , m_nBailout2, nMaxIter
      , m_bNoGlitchDetection, g_real, g_imag, p
      , g_FactorAR, g_FactorAI
      , xr00, xi00
      , cr0, ci0
      , s, S
      );

  return false;
}

template bool perturbation<double>
  ( const int m_nFractalType, const int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double &xr00, double &xi00
  , const double &cr0, const double &ci0
  , const double &s, const double &S
  );
template bool perturbation<long double>
  ( const int m_nFractalType, const int m_nPower
  , const long double *m_db_dxr, const long double *m_db_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , const double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , long double &xr00, long double &xi00
  , const long double &cr0, const long double &ci0
  , const long double &s, const long double &S
  );

#endif

#ifdef PASS7 // perturbation with SIMD and scaling



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,2)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  , const double s, const double S
  )
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0 * s;
          doubleN Xxi = Xi + xi0 * s;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{xrn=(((((2*Xr)+(xr*s))*xr)-(((2*Xi)+(xi*s))*xi))+cr);
xin=((2*(((Xr+(xr*s))*xi)+(Xi*xr)))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k] * s;
        Xxi = Xi + xi0[k] * s;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        using T = double;
        T dummy;
        (void) dummy;
        using V = double;
        V dummyV;
        (void) dummyV;
        double xrn, xin;


      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{xrn=(((((2*Xr)+(xr*s))*xr)-(((2*Xi)+(xi*s))*xi))+cr);
xin=((2*(((Xr+(xr*s))*xi)+(Xi*xr)))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool FORMULA(perturbation,0,3)
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  , const double s, const double S
  )
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const double Ar = g_FactorAR;
    const double Ai = g_FactorAI;
    const complex<double> A = { Ar, Ai };
    const complex<doubleN> c = { cr0, ci0 };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    doubleN test1 = test10;
    doubleN test2 = test20;
    doubleN phase = phase0;
    doubleN xr0 = xr00;
    doubleN xi0 = xi00;
    intN antal = antal0;
    intN bGlitch = bGlitch0;
    intN bBailed = test1 > m_nBailout2;
    // vectorized loop
    if (all(antal == antal[0]))
    {
      for (; antal[0] + chunksize - 1 < nMaxIter; antal = antal + chunksize)
      {
        doubleN xr_saved = xr0;
        doubleN xi_saved = xi0;
        doubleN test1_saved = test1;
        for (int64_t q = 0; q < chunksize; ++q)
        {
          const double Xr = m_db_dxr[antal[0] + q];
          const double Xi = m_db_dxi[antal[0] + q];
          const double Xz = m_db_z[antal[0] + q];
          doubleN Xxr = Xr + xr0 * s;
          doubleN Xxi = Xi + xi0 * s;
          const doubleN Xxr2 = Xxr * Xxr;
          const doubleN Xxi2 = Xxi * Xxi;
          test2 = test1;
          test1 = Xxr2 + Xxi2;
          bGlitch |= test1 < Xz;
          if (! no_g)
          {
            test1 = pnorm(g_real, g_imag, p, Xxr, Xxi);
          }
          bBailed |= test1 > m_nBailout2;
          doubleN xrn, xin;

      using T = double;
      T dummyT;
      (void) dummyT;
      using V = doubleN;
      V dummyV;
      (void) dummyV;

      doubleN cr = cr0, ci = ci0, xr = xr0, xi = xi0;
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((3*(Xr2-Xi2))*xr)-(((6*Xr)*Xi)*xi))+((3*((Xr*(xr2-xi2))-(((2*Xi)*xr)*xi)))*s))+((((xr2-(3*xi2))*xr)*s)*s))+cr);
xin=((((((3*(Xr2-Xi2))*xi)+(((6*Xr)*Xi)*xr))+((3*((((2*Xr)*xr)*xi)+(Xi*(xr2-xi2))))*s))+(((((3*xr2)-xi2)*xi)*s)*s))+ci);
}


          xr0 = xrn;
          xi0 = xin;
        }
        if (any(bGlitch) || any(bBailed))
        {
          // rollback last chunk
          xr0 = xr_saved;
          xi0 = xi_saved;
          test1 = test1_saved;
          bGlitch = bGlitch0;
          break;
        }
      }
    }

    // finish up unvectorized
    int64_t N = sizeof(doubleN) / sizeof(double);
    for (int64_t k = 0; k < N; ++k)
    {
      double Xxr = 0, Xxi = 0;
      for (; antal[k] < nMaxIter; antal[k] = antal[k] + 1)
      {
        const double Xr = m_db_dxr[antal[k]];
        const double Xi = m_db_dxi[antal[k]];
        const double Xz = m_db_z[antal[k]];
        Xxr = Xr + xr0[k] * s;
        Xxi = Xi + xi0[k] * s;
        const double Xxr2 = Xxr * Xxr;
        const double Xxi2 = Xxi * Xxi;
        test2[k] = test1[k];
        test1[k] = Xxr2 + Xxi2;
        if (test1[k] < Xz)
        {
          bGlitch[k] = true;
          if (! m_bNoGlitchDetection[k])
            break;
        }
        if (! no_g)
        {
          test1[k] = pnorm(g_real, g_imag, p, Xxr, Xxi);
        }
        if (test1[k] > m_nBailout2)
        {
          phase[k] = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
          phase[k] -= floor(phase[k]);
          break;
        }
        using T = double;
        T dummy;
        (void) dummy;
        using V = double;
        V dummyV;
        (void) dummyV;
        double xrn, xin;


      double cr = cr0[k], ci = ci0[k], xr = xr0[k], xi = xi0[k];
{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((3*(Xr2-Xi2))*xr)-(((6*Xr)*Xi)*xi))+((3*((Xr*(xr2-xi2))-(((2*Xi)*xr)*xi)))*s))+((((xr2-(3*xi2))*xr)*s)*s))+cr);
xin=((((((3*(Xr2-Xi2))*xi)+(((6*Xr)*Xi)*xr))+((3*((((2*Xr)*xr)*xi)+(Xi*(xr2-xi2))))*s))+(((((3*xr2)-xi2)*xi)*s)*s))+ci);
}


        xr0[k] = xrn;
        xi0[k] = xin;
      }
      xr00[k] = Xxr;
      xi00[k] = Xxi;
    }

    antal0 = antal;
    bGlitch0 = bGlitch;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    return true;
  }
  return false;
}



template <typename intN, typename doubleN>
bool perturbation
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , intN &antal0, doubleN &test10, doubleN &test20, doubleN &phase0, intN &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const intN &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , doubleN &xr00, doubleN &xi00
  , const doubleN &cr0, const doubleN &ci0
  , const int64_t chunksize
  , const double s, const double S
  )
{

  if (m_nFractalType == 0 && m_nPower == 2)
    return FORMULA(perturbation,0,2)
      ( m_nFractalType, m_nPower
      , m_db_dxr, m_db_dxi, m_db_z
      , antal0, test10, test20, phase0, bGlitch0
      , m_nBailout2, nMaxIter
      , m_bNoGlitchDetection, g_real, g_imag, p
      , g_FactorAR, g_FactorAI
      , xr00, xi00
      , cr0, ci0
      , chunksize
      , s, S
      );

  if (m_nFractalType == 0 && m_nPower == 3)
    return FORMULA(perturbation,0,3)
      ( m_nFractalType, m_nPower
      , m_db_dxr, m_db_dxi, m_db_z
      , antal0, test10, test20, phase0, bGlitch0
      , m_nBailout2, nMaxIter
      , m_bNoGlitchDetection, g_real, g_imag, p
      , g_FactorAR, g_FactorAI
      , xr00, xi00
      , cr0, ci0
      , chunksize
      , s, S
      );

  return false;
}

#if KF_SIMD >= 1
template bool perturbation<int2, double2>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int2 &antal0, double2 &test10, double2 &test20, double2 &phase0, int2 &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const int2 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double2 &xr00, double2 &xi00
  , const double2 &cr0, const double2 &ci0
  , const int64_t chunksize
  , const double s, const double S
  );
#endif

#if KF_SIMD >= 2
template bool perturbation<int4, double4>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int4 &antal0, double4 &test10, double4 &test20, double4 &phase0, int4 &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const int4 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double4 &xr00, double4 &xi00
  , const double4 &cr0, const double4 &ci0
  , const int64_t chunksize
  , const double s, const double S
  );
#endif

#if KF_SIMD >= 3
template bool perturbation<int8, double8>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int8 &antal0, double8 &test10, double8 &test20, double8 &phase0, int8 &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const int8 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double8 &xr00, double8 &xi00
  , const double8 &cr0, const double8 &ci0
  , const int64_t chunksize
  , const double s, const double S
  );
#endif

#if KF_SIMD >= 4
template bool perturbation<int16, double16>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int16 &antal0, double16 &test10, double16 &test20, double16 &phase0, int16 &bGlitch0
  , double m_nBailout2, const int64_t nMaxIter
  , const int16 &m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double16 &xr00, double16 &xi00
  , const double16 &cr0, const double16 &ci0
  , const int64_t chunksize
  , const double s, const double S
  );
#endif

#endif

#ifdef PASS8 // perturbation with derivatives and scaling



template <typename D, typename Z>
bool FORMULA(perturbation,0,2)
  ( int m_nFractalType, int m_nPower
  , const Z *m_db_dxr, const Z *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , Z &xr0, Z &xi0
  , const Z &cr, const Z &ci
  , D &Jxa0, D &Jxb0, D &Jya0, D &Jyb0
  , const D &e, const D &h
  , const D &daa, const D &dab, const D &dba, const D &dbb
  , const Z &s, const Z &S
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const Z Ar = g_FactorAR;
    const Z Ai = g_FactorAI;
    const complex<Z> A = { Ar, Ai };
    const complex<Z> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    Z xr = xr0;
    Z xi = xi0;

    D dr = Jxa0, di = Jya0;
    const D dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    Z Xxr = 0;
    Z Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const Z Xr = m_db_dxr[antal];
      const Z Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr * s;
      Xxi = Xi + xi * s;
      const Z Xxr2 = Xxr * Xxr;
      const Z Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

#ifdef KF_USE_TYPE_0_POWER_2_HAS_GLITCHED
        if (type_0_power_2_pixel_has_glitched(cr, ci, xr, xi, Xr, Xi, dxa / h, dya / h, e, h)) // FIXME matrix derivatives
        {
#endif

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

#ifdef KF_USE_TYPE_0_POWER_2_HAS_GLITCHED
        }
#endif

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      Z xrn, xin;


      D drn = 0, din = 0;

{
  using T = D;
  T dummyT;
  (void) dummyT;
  using V = D;
  V dummyV;
  (void) dummyV;

{drn=((2*((Xxr*dr)-(Xxi*di)))+dr0);
din=((2*((Xxi*dr)+(Xxr*di)))+di0);
}

}
  using T = Z;
  T dummyT;
  (void) dummyT;
  using V = Z;
  V dummyV;
  (void) dummyV;

{xrn=(((((2*Xr)+(xr*s))*xr)-(((2*Xi)+(xi*s))*xi))+cr);
xin=((2*(((Xr+(xr*s))*xi)+(Xi*xr)))+ci);
}


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename D, typename Z>
bool FORMULA(perturbation,0,3)
  ( int m_nFractalType, int m_nPower
  , const Z *m_db_dxr, const Z *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , Z &xr0, Z &xi0
  , const Z &cr, const Z &ci
  , D &Jxa0, D &Jxb0, D &Jya0, D &Jyb0
  , const D &e, const D &h
  , const D &daa, const D &dab, const D &dba, const D &dbb
  , const Z &s, const Z &S
  )
{
  (void) Jxa0; // -Wunused-parameter
  (void) Jxb0; // -Wunused-parameter
  (void) Jya0; // -Wunused-parameter
  (void) Jyb0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    bool no_g = g_real == 1.0 && g_imag == 1.0 && p == 2.0;
    const Z Ar = g_FactorAR;
    const Z Ai = g_FactorAI;
    const complex<Z> A = { Ar, Ai };
    const complex<Z> c = { cr, ci };
    (void) Ar; // -Wunused-variable
    (void) Ai; // -Wunused-variable
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int64_t antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double phase = phase0;
    Z xr = xr0;
    Z xi = xi0;

    D dr = Jxa0, di = Jya0;
    const D dr0 = daa, di0 = dba;
    (void) dr0;
    (void) di0;

    Z Xxr = 0;
    Z Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const Z Xr = m_db_dxr[antal];
      const Z Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr * s;
      Xxi = Xi + xi * s;
      const Z Xxr2 = Xxr * Xxr;
      const Z Xxi2 = Xxi * Xxi;
      test2 = test1;
      test1 = double(Xxr2 + Xxi2);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (! no_g)
      {
        test1 = double(pnorm(g_real, g_imag, p, Xxr, Xxi));
      }
      if (test1 > m_nBailout2)
      {
        phase = atan2(double(Xxi), double(Xxr)) / M_PI / 2;
        phase -= floor(phase);
        break;
      }
      Z xrn, xin;


      D drn = 0, din = 0;

{
  using T = D;
  T dummyT;
  (void) dummyT;
  using V = D;
  V dummyV;
  (void) dummyV;

{drn=((((3*(Xxr2-Xxi2))*dr)-((6*(Xxi*Xxr))*di))+dr0);
din=((((3*(Xxr2-Xxi2))*di)+((6*(Xxi*Xxr))*dr))+di0);
}

}
  using T = Z;
  T dummyT;
  (void) dummyT;
  using V = Z;
  V dummyV;
  (void) dummyV;

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const V xr2 = xr * xr;
const V xi2 = xi * xi;
xrn=((((((3*(Xr2-Xi2))*xr)-(((6*Xr)*Xi)*xi))+((3*((Xr*(xr2-xi2))-(((2*Xi)*xr)*xi)))*s))+((((xr2-(3*xi2))*xr)*s)*s))+cr);
xin=((((((3*(Xr2-Xi2))*xi)+(((6*Xr)*Xi)*xr))+((3*((((2*Xr)*xr)*xi)+(Xi*(xr2-xi2))))*s))+(((((3*xr2)-xi2)*xi)*s)*s))+ci);
}


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    phase0 = phase;
    xr0 = Xxr;
    xi0 = Xxi;

    Jxa0 = dr; Jxb0 = -di; Jya0 = di; Jyb0 = dr;

    return true;
  }
  return false;
}



template <typename D, typename Z>
bool perturbation
  ( int m_nFractalType, int m_nPower
  , const Z *m_db_dxr, const Z *m_db_dxi, const double *m_db_z
  , int64_t &antal, double &test1, double &test2, double &phase, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , Z &xr, Z &xi
  , const Z &cr, const Z &ci
  , D &Jxa0, D &Jxb0, D &Jya0, D &Jyb0
  , const D &e, const D &h
  , const D &daa, const D &dab, const D &dba, const D &dbb
  , const Z &s, const Z &S
  )
{

  if (m_nFractalType == 0 && m_nPower == 2)
    return FORMULA(perturbation,0,2)
      ( m_nFractalType, m_nPower
      , m_db_dxr, m_db_dxi, m_db_z
      , antal, test1, test2, phase, bGlitch
      , m_nBailout2, nMaxIter
      , m_bNoGlitchDetection, g_real, g_imag, p
      , g_FactorAR, g_FactorAI
      , xr, xi
      , cr, ci
      , Jxa0, Jxb0, Jya0, Jyb0
      , e, h
      , daa, dab, dba, dbb
      , s, S
      );

  if (m_nFractalType == 0 && m_nPower == 3)
    return FORMULA(perturbation,0,3)
      ( m_nFractalType, m_nPower
      , m_db_dxr, m_db_dxi, m_db_z
      , antal, test1, test2, phase, bGlitch
      , m_nBailout2, nMaxIter
      , m_bNoGlitchDetection, g_real, g_imag, p
      , g_FactorAR, g_FactorAI
      , xr, xi
      , cr, ci
      , Jxa0, Jxb0, Jya0, Jyb0
      , e, h
      , daa, dab, dba, dbb
      , s, S
      );

  return false;
}

template bool perturbation<long double, double>
  ( int m_nFractalType, int m_nPower
  , const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , double &xr0, double &xi0
  , const double &cr, const double &ci
  , long double &Jxa0, long double &Jxb0, long double &Jya0, long double &Jyb0
  , const long double &e, const long double &h
  , const long double &daa, const long double &dab, const long double &dba, const long double &dbb
  , const double &s, const double &S
  );
template bool perturbation<floatexp, long double>
  ( int m_nFractalType, int m_nPower
  , const long double *m_db_dxr, const long double *m_db_dxi, const double *m_db_z
  , int64_t &antal0, double &test10, double &test20, double &phase0, bool &bGlitch
  , double m_nBailout2, const int64_t nMaxIter
  , const bool m_bNoGlitchDetection, const double g_real, const double g_imag, const double p
  , const double g_FactorAR, const double g_FactorAI
  , long double &xr0, long double &xi0
  , const long double &cr, const long double &ci
  , floatexp &Jxa0, floatexp &Jxb0, floatexp &Jya0, floatexp &Jyb0
  , const floatexp &e, const floatexp &h
  , const floatexp &daa, const floatexp &dab, const floatexp &dba, const floatexp &dbb
  , const long double &s, const long double &S
  );

#endif

#ifdef PASS9 // miscellaneous

bool scaling_supported(const int m_nFractalType, const int m_nPower, const bool derivatives)
{
  
  if (m_nFractalType == 0 && m_nPower == 2)
    return true;
  
  if (m_nFractalType == 0 && m_nPower == 3)
    return true;
  
  return false;
}

void combo5_addstrings(HWND hWnd, const int IDC_COMBO5)
{
  SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"(Hybrid)");
  
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbrot"); // 0
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Burning Ship"); // 1
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Buffalo"); // 2
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Celtic"); // 3
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbar"); // 4
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbar Celtic"); // 5
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Mandelbrot"); // 6
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Burning Ship"); // 7
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Celtic"); // 8
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Buffalo"); // 9
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Quasi Burning Ship"); // 10
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Partial BS Real"); // 11
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Partial BS Imag"); // 12
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Flying Squirrel (Buffalo Imag)"); // 13
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Quasi Perpendicular"); // 14
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Imag"); // 15
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Real"); // 16
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Real Mbar"); // 17
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Imag"); // 18
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Real"); // 19
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Real Mbar"); // 20
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Buffalo Partial Imag"); // 21
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Mbar"); // 22
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th False Quasi Perpendicular"); // 23
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th False Quasi Heart"); // 24
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic False Quasi Perpendicular"); // 25
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic False Quasi Heart"); // 26
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Burning Ship Partial"); // 27
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Burning Ship Partial Mbar"); // 28
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Celtic Mbar"); // 29
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Burning Ship (BS/Buffalo Hybrid)"); // 30
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Perpendicular"); // 31
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Heart"); // 32
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot 4th"); // 33
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Imag Quasi Perpendicular / Heart"); // 34
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Real Quasi Perpendicular"); // 35
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Real Quasi Heart"); // 36
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Imag Quasi Perpendicular / Heart"); // 37
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Real Quasi Perpendicular"); // 38
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Real Quasi Heart"); // 39
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot 6th"); // 40
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"HPDZ Buffalo"); // 41
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 1: a * z^2 + z^3 + c"); // 42
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 2: a * z^2 - z^3 + c"); // 43
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 3: 2 * z^2 - z^3 + c"); // 44
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 4: a * z^2 + z^4 + c"); // 45
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 5: a * z^2 - z^4 + c"); // 46
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 6: a * z^2 + z^5 + c"); // 47
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 7: a * z^2 - z^5 + c"); // 48
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 8: a * z^2 + z^6 + c"); // 49
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 9: a * z^2 - z^6 + c"); // 50
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot2 4th"); // 51
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"General Quadratic Minus"); // 52
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"General Quadratic Plus"); // 53
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 2nd 1x1"); // 54
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 3rd 1x2"); // 55
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 3rd 2x1"); // 56
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 4th 1x3"); // 57
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 4th 2x2 (aka SimonBrot 4th)"); // 58
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 4th 3x1"); // 59
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 5th 1x4"); // 60
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 5th 2x3"); // 61
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 5th 3x2"); // 62
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 5th 4x1"); // 63
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 6th 1x5"); // 64
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 6th 2x4 (Simon's Mothbrot)"); // 65
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 6th 3x3 (aka SimonBrot 6th)"); // 66
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 6th 4x2"); // 67
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mothbrot 6th 5x1"); // 68
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"General Abs Quadratic Minus"); // 69
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"General Abs Quadratic Plus"); // 70
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"z^2 exp(2 a / z) + c"); // 71
}

int validate_power_for_fractal_type(const int m_nFractalType, const int m_nPower)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
        case 6: return 6;
      
        case 7: return 7;
      
        case 8: return 8;
      
        case 9: return 9;
      
        case 10: return 10;
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // TheRedshiftRider 1: a * z^2 + z^3 + c
    case 42:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 2: a * z^2 - z^3 + c
    case 43:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 3: 2 * z^2 - z^3 + c
    case 44:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 4: a * z^2 + z^4 + c
    case 45:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // TheRedshiftRider 5: a * z^2 - z^4 + c
    case 46:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // TheRedshiftRider 6: a * z^2 + z^5 + c
    case 47:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // TheRedshiftRider 7: a * z^2 - z^5 + c
    case 48:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // TheRedshiftRider 8: a * z^2 + z^6 + c
    case 49:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // TheRedshiftRider 9: a * z^2 - z^6 + c
    case 50:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // General Quadratic Minus
    case 52:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // General Quadratic Plus
    case 53:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Mothbrot 2nd 1x1
    case 54:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Mothbrot 3rd 1x2
    case 55:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Mothbrot 3rd 2x1
    case 56:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Mothbrot 4th 1x3
    case 57:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // Mothbrot 4th 2x2 (aka SimonBrot 4th)
    case 58:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // Mothbrot 4th 3x1
    case 59:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // Mothbrot 5th 1x4
    case 60:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // Mothbrot 5th 2x3
    case 61:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // Mothbrot 5th 3x2
    case 62:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // Mothbrot 5th 4x1
    case 63:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // Mothbrot 6th 1x5
    case 64:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // Mothbrot 6th 2x4 (Simon's Mothbrot)
    case 65:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // Mothbrot 6th 3x3 (aka SimonBrot 6th)
    case 66:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // Mothbrot 6th 4x2
    case 67:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // Mothbrot 6th 5x1
    case 68:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // General Abs Quadratic Minus
    case 69:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // General Abs Quadratic Plus
    case 70:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // z^2 exp(2 a / z) + c
    case 71:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    default:
      return 2;
  }
}

void update_power_dropdown_for_fractal_type(HWND hWnd, const int IDC_COMBO3, const int m_nFractalType, const int m_nPower)
{
  SendDlgItemMessage(hWnd,IDC_COMBO3,CB_RESETCONTENT,0,0);
  int selected = 0;
  int ix = 0;
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
        if (7 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"7");
        ix++;
      
        if (8 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"8");
        ix++;
      
        if (9 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"9");
        ix++;
      
        if (10 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"10");
        ix++;
      
      break;
    }
  
    // Burning Ship
    case 1:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Buffalo
    case 2:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Celtic
    case 3:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mandelbar
    case 4:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mandelbar Celtic
    case 5:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Mandelbrot
    case 6:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Burning Ship
    case 7:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Celtic
    case 8:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Buffalo
    case 9:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Cubic Quasi Burning Ship
    case 10:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Partial BS Real
    case 11:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Partial BS Imag
    case 12:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Quasi Perpendicular
    case 14:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Imag
    case 15:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Real
    case 16:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Buffalo Partial Imag
    case 21:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Mbar
    case 22:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th False Quasi Perpendicular
    case 23:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th False Quasi Heart
    case 24:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic False Quasi Heart
    case 26:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 5th Burning Ship Partial
    case 27:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Burning Ship Partial Mbar
    case 28:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Celtic Mbar
    case 29:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Perpendicular
    case 31:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Heart
    case 32:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // SimonBrot 4th
    case 33:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Real Quasi Perpendicular
    case 35:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Real Quasi Heart
    case 36:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Real Quasi Heart
    case 39:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // SimonBrot 6th
    case 40:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // HPDZ Buffalo
    case 41:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 1: a * z^2 + z^3 + c
    case 42:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 2: a * z^2 - z^3 + c
    case 43:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 3: 2 * z^2 - z^3 + c
    case 44:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 4: a * z^2 + z^4 + c
    case 45:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 5: a * z^2 - z^4 + c
    case 46:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 6: a * z^2 + z^5 + c
    case 47:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 7: a * z^2 - z^5 + c
    case 48:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 8: a * z^2 + z^6 + c
    case 49:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 9: a * z^2 - z^6 + c
    case 50:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // SimonBrot2 4th
    case 51:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // General Quadratic Minus
    case 52:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // General Quadratic Plus
    case 53:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Mothbrot 2nd 1x1
    case 54:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Mothbrot 3rd 1x2
    case 55:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Mothbrot 3rd 2x1
    case 56:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Mothbrot 4th 1x3
    case 57:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // Mothbrot 4th 2x2 (aka SimonBrot 4th)
    case 58:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // Mothbrot 4th 3x1
    case 59:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // Mothbrot 5th 1x4
    case 60:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mothbrot 5th 2x3
    case 61:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mothbrot 5th 3x2
    case 62:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mothbrot 5th 4x1
    case 63:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mothbrot 6th 1x5
    case 64:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // Mothbrot 6th 2x4 (Simon's Mothbrot)
    case 65:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // Mothbrot 6th 3x3 (aka SimonBrot 6th)
    case 66:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // Mothbrot 6th 4x2
    case 67:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // Mothbrot 6th 5x1
    case 68:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // General Abs Quadratic Minus
    case 69:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // General Abs Quadratic Plus
    case 70:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // z^2 exp(2 a / z) + c
    case 71:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
  }
  SendDlgItemMessage(hWnd,IDC_COMBO3,CB_SETCURSEL,selected,0);
  EnableWindow(GetDlgItem(hWnd,IDC_COMBO3), ix > 1);
}

#endif

// EOF
